/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],C=0,I=x.length;C<I;C++)i[C]=J[x[C]];return i};define(J[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function C(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=C}),define(J[46],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function C(R){return(w,l,v)=>{let y=null,T=null;if(typeof v.value=="function"?(y="value",T=v.value):typeof v.get=="function"&&(y="get",T=v.get),!T)throw new Error("not supported");v[y]=R(T,l)}}i.createDecorator=C;function I(R,w,l){let v=null,y=null;if(typeof l.value=="function"?(v="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(v="get",y=l.get),!y)throw new Error("not supported");const T=`$memoize$${w}`;l[v]=function(...c){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,c)}),this[T]}}i.memoize=I;function b(R,w,l){return C((v,y)=>{const T=`$debounce$${y}`,c=`$debounce$result$${y}`;return function(...E){this[c]||(this[c]=l?l():void 0),clearTimeout(this[T]),w&&(this[c]=w(this[c],...E),E=[this[c]]),this[T]=setTimeout(()=>{v.apply(this,E),this[c]=l?l():void 0},R)}})}i.debounce=b;function D(R,w,l){return C((v,y)=>{const T=`$throttle$timer$${y}`,c=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,f=`$throttle$pending$${y}`;return function(...d){if(this[c]||(this[c]=l?l():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[c]=w(this[c],...d)),this[f])return;const g=this[E]+R;g<=Date.now()?(this[E]=Date.now(),v.apply(this,[this[c]]),this[c]=l?l():void 0):(this[f]=!0,this[T]=setTimeout(()=>{this[f]=!1,this[E]=Date.now(),v.apply(this,[this[c]]),this[c]=l?l():void 0},g-Date.now()))}})}i.throttle=D}),define(J[57],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var C;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(C=i.ScanError||(i.ScanError={}));var I;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var D;(function(n){n.DEFAULT={allowTrailingComma:!0}})(D=i.ParseOptions||(i.ParseOptions={}));function R(n,r=!1){let e=0,t=n.length,s="",u=0,p=16,L=0;function P(te){let de=0,W=0;for(;de<te;){const $=n.charCodeAt(e);if($>=48&&$<=57)W=W*16+$-48;else if($>=65&&$<=70)W=W*16+$-65+10;else if($>=97&&$<=102)W=W*16+$-97+10;else break;e++,de++}return de<te&&(W=-1),W}function O(te){e=te,s="",u=0,p=16,L=0}function N(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&v(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&v(n.charCodeAt(e)))for(e++;e<n.length&&v(n.charCodeAt(e));)e++;else return L=3,n.substring(te,e);let de=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&v(n.charCodeAt(e))){for(e++;e<n.length&&v(n.charCodeAt(e));)e++;de=e}else L=3;return n.substring(te,de)}function G(){let te="",de=e;for(;;){if(e>=t){te+=n.substring(de,e),L=2;break}const W=n.charCodeAt(e);if(W===34){te+=n.substring(de,e),e++;break}if(W===92){if(te+=n.substring(de,e),e++,e>=t){L=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ne=P(4);ne>=0?te+=String.fromCharCode(ne):L=4;break;default:L=5}de=e;continue}if(W>=0&&W<=31)if(l(W)){te+=n.substring(de,e),L=2;break}else L=6;e++}return te}function ee(){if(s="",L=0,u=e,e>=t)return u=t,p=17;let te=n.charCodeAt(e);if(w(te)){do e++,s+=String.fromCharCode(te),te=n.charCodeAt(e);while(w(te));return p=15}if(l(te))return e++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,s+=`
`),p=14;switch(te){case 123:return e++,p=1;case 125:return e++,p=2;case 91:return e++,p=3;case 93:return e++,p=4;case 58:return e++,p=6;case 44:return e++,p=5;case 34:return e++,s=G(),p=10;case 47:const de=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<t&&!l(n.charCodeAt(e));)e++;return s=n.substring(de,e),p=12}if(n.charCodeAt(e+1)===42){e+=2;const W=t-1;let $=!1;for(;e<W;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,$=!0;break}e++}return $||(e++,L=1),s=n.substring(de,e),p=13}return s+=String.fromCharCode(te),e++,p=16;case 45:if(s+=String.fromCharCode(te),e++,e===t||!v(n.charCodeAt(e)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),p=11;default:for(;e<t&&me(te);)e++,te=n.charCodeAt(e);if(u!==e){switch(s=n.substring(u,e),s){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return s+=String.fromCharCode(te),e++,p=16}}function me(te){if(w(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let te;do te=ee();while(te>=12&&te<=15);return te}return{setPosition:O,getPosition:()=>e,scan:r?ae:ee,getToken:()=>p,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>e-u,getTokenError:()=>L}}i.createScanner=R;function w(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var y;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(y||(y={}));function T(n,r){const e=[],t=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function L(P,O,N,G){u.value=P,u.offset=O,u.length=N,u.type=G,u.colonOffset=void 0,s=u}try{h(n,{onObjectBegin:(P,O)=>{if(r<=P)throw t;s=void 0,p=r>P,e.push("")},onObjectProperty:(P,O,N)=>{if(r<O||(L(P,O,N,"property"),e[e.length-1]=P,r<=O+N))throw t},onObjectEnd:(P,O)=>{if(r<=P)throw t;s=void 0,e.pop()},onArrayBegin:(P,O)=>{if(r<=P)throw t;s=void 0,e.push(0)},onArrayEnd:(P,O)=>{if(r<=P)throw t;s=void 0,e.pop()},onLiteralValue:(P,O,N)=>{if(r<O||(L(P,O,N,a(P)),r<=O+N))throw t},onSeparator:(P,O,N)=>{if(r<=O)throw t;if(P===":"&&s&&s.type==="property")s.colonOffset=O,p=!1,s=void 0;else if(P===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(p=!0,e[e.length-1]=""),s=void 0}}})}catch(P){if(P!==t)throw P}return{path:e,previousNode:s,isAtPropertyKey:p,matches:P=>{let O=0;for(let N=0;O<P.length&&N<e.length;N++)if(P[O]===e[N]||P[O]==="*")O++;else if(P[O]!=="**")return!1;return O===P.length}}}i.getLocation=T;function c(n,r=[],e=D.DEFAULT){let t=null,s=[];const u=[];function p(P){Array.isArray(s)?s.push(P):t!==null&&(s[t]=P)}return h(n,{onObjectBegin:()=>{const P={};p(P),u.push(s),s=P,t=null},onObjectProperty:P=>{t=P},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const P=[];p(P),u.push(s),s=P,t=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:p,onError:(P,O,N)=>{r.push({error:P,offset:O,length:N})}},e),s[0]}i.parse=c;function E(n,r=[],e=D.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){t.type==="property"&&(t.length=P-t.offset,t=t.parent)}function u(P){return t.children.push(P),P}h(n,{onObjectBegin:P=>{t=u({type:"object",offset:P,length:-1,parent:t,children:[]})},onObjectProperty:(P,O,N)=>{t=u({type:"property",offset:O,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:P,offset:O,length:N,parent:t})},onObjectEnd:(P,O)=>{t.length=P+O-t.offset,t=t.parent,s(P+O)},onArrayBegin:(P,O)=>{t=u({type:"array",offset:P,length:-1,parent:t,children:[]})},onArrayEnd:(P,O)=>{t.length=P+O-t.offset,t=t.parent,s(P+O)},onLiteralValue:(P,O,N)=>{u({type:a(P),offset:O,length:N,parent:t,value:P}),s(O+N)},onSeparator:(P,O,N)=>{t.type==="property"&&(P===":"?t.colonOffset=O:P===","&&s(O))},onError:(P,O,N)=>{r.push({error:P,offset:O,length:N})}},e);const L=t.children[0];return L&&delete L.parent,L}i.parseTree=E;function f(n,r){if(!n)return;let e=n;for(let t of r)if(typeof t=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const u of e.children)if(Array.isArray(u.children)&&u.children[0].value===t){e=u.children[1],s=!0;break}if(!s)return}else{const s=t;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=f;function d(n){if(!n.parent||!n.parent.children)return[];const r=d(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;r.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&r.push(e)}return r}i.getNodePath=d;function g(n){switch(n.type){case"array":return n.children.map(g);case"object":const r=Object.create(null);for(let e of n.children){const t=e.children[1];t&&(r[e.children[0].value]=g(t))}return r;case"null":case"string":case"number":case"boolean":return n.value;default:return}}i.getNodeValue=g;function m(n,r,e=!1){return r>=n.offset&&r<n.offset+n.length||e&&r===n.offset+n.length}i.contains=m;function S(n,r,e=!1){if(m(n,r,e)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=r;s++){const u=S(t[s],r,e);if(u)return u}return n}}i.findNodeAtOffset=S;function h(n,r,e=D.DEFAULT){const t=R(n,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function u(K){return K?Z=>K(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=s(r.onObjectBegin),L=u(r.onObjectProperty),P=s(r.onObjectEnd),O=s(r.onArrayBegin),N=s(r.onArrayEnd),G=u(r.onLiteralValue),ee=u(r.onSeparator),me=s(r.onComment),ae=u(r.onError),te=e&&e.disallowComments,de=e&&e.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:te||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(K){case 12:case 13:te?$(10):me();break;case 16:$(1);break;case 15:case 14:break;default:return K}}}function $(K,Z=[],_=[]){if(ae(K),Z.length+_.length>0){let le=t.getToken();for(;le!==17;){if(Z.indexOf(le)!==-1){W();break}else if(_.indexOf(le)!==-1)break;le=W()}}}function ne(K){const Z=t.getTokenValue();return K?G(Z):L(Z),W(),!0}function M(){switch(t.getToken()){case 11:let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&($(2),K=0)}catch(Z){$(2)}G(K);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return W(),!0}function k(){return t.getToken()!==10?($(3,[],[2,5]),!1):(ne(!1),t.getToken()===6?(ee(":"),W(),ie()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function V(){p(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||$(4,[],[]),ee(","),W(),t.getToken()===2&&de)break}else K&&$(6,[],[]);k()||$(4,[],[2,5]),K=!0}return P(),t.getToken()!==2?$(7,[2],[]):W(),!0}function H(){O(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||$(4,[],[]),ee(","),W(),t.getToken()===4&&de)break}else K&&$(6,[],[]);ie()||$(4,[],[4,5]),K=!0}return N(),t.getToken()!==4?$(8,[4],[]):W(),!0}function ie(){switch(t.getToken()){case 3:return H();case 1:return V();case 10:return ne(!0);default:return M()}}return W(),t.getToken()===17?e.allowEmptyContent?!0:($(4,[],[]),!1):ie()?(t.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}i.visit=h;function o(n,r){let e=R(n),t=[],s,u=0,p;do switch(p=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:u!==p&&t.push(n.substring(u,p)),r!==void 0&&t.push(e.getTokenValue().replace(/[^\r\n]/g,r)),u=e.getPosition();break}while(s!==17);return t.join("")}i.stripComments=o;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function x(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function R(l){D.push(l,Date.now())}function w(){const l=[];for(let v=0;v<D.length;v+=2)l.push({name:D[v],startTime:D[v+1]});return l}return{mark:R,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(b+R.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function C(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),define(J[58],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var C;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(C=i.Source||(i.Source={}));var I;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(I=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(D,...R){const w=R.reduce((y,T)=>(y[T]=!0,y),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(y=>!w[y]).forEach(y=>{for(let T=0;T<l.length;T++)if(y.search(l[T])!==-1){delete D[y];break}})}i.sanitizeProcessEnvironment=b}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var C=i();for(var I in C)(typeof exports=="object"?exports:x)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function C(I){if(i[I])return i[I].exports;var b=i[I]={i:I,l:!1,exports:{}};return x[I].call(b.exports,b,b.exports,C),b.l=!0,b.exports}return C.m=x,C.c=i,C.d=function(I,b,D){C.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:D})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,b){if(1&b&&(I=C(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var D=Object.create(null);if(C.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var R in I)C.d(D,R,function(w){return I[w]}.bind(null,R));return D},C.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(b,"a",b),b},C.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},C.p="",C(C.s=0)}([function(x,i,C){(function(I){var b;i=x.exports=_,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var D=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],v=0,y=v++;l[y]="0|[1-9]\\d*";var T=v++;l[T]="[0-9]+";var c=v++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=v++;l[E]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var f=v++;l[f]="("+l[T]+")\\.("+l[T]+")\\.("+l[T]+")";var d=v++;l[d]="(?:"+l[y]+"|"+l[c]+")";var g=v++;l[g]="(?:"+l[T]+"|"+l[c]+")";var m=v++;l[m]="(?:-("+l[d]+"(?:\\."+l[d]+")*))";var S=v++;l[S]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var h=v++;l[h]="[0-9A-Za-z-]+";var o=v++;l[o]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var a=v++,n="v?"+l[E]+l[m]+"?"+l[o]+"?";l[a]="^"+n+"$";var r="[v=\\s]*"+l[f]+l[S]+"?"+l[o]+"?",e=v++;l[e]="^"+r+"$";var t=v++;l[t]="((?:<|>)?=?)";var s=v++;l[s]=l[T]+"|x|X|\\*";var u=v++;l[u]=l[y]+"|x|X|\\*";var p=v++;l[p]="[v=\\s]*("+l[u]+")(?:\\.("+l[u]+")(?:\\.("+l[u]+")(?:"+l[m]+")?"+l[o]+"?)?)?";var L=v++;l[L]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[S]+")?"+l[o]+"?)?)?";var P=v++;l[P]="^"+l[t]+"\\s*"+l[p]+"$";var O=v++;l[O]="^"+l[t]+"\\s*"+l[L]+"$";var N=v++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=v++;l[G]="(?:~>?)";var ee=v++;l[ee]="(\\s*)"+l[G]+"\\s+",w[ee]=new RegExp(l[ee],"g");var me=v++;l[me]="^"+l[G]+l[p]+"$";var ae=v++;l[ae]="^"+l[G]+l[L]+"$";var te=v++;l[te]="(?:\\^)";var de=v++;l[de]="(\\s*)"+l[te]+"\\s+",w[de]=new RegExp(l[de],"g");var W=v++;l[W]="^"+l[te]+l[p]+"$";var $=v++;l[$]="^"+l[te]+l[L]+"$";var ne=v++;l[ne]="^"+l[t]+"\\s*("+r+")$|^$";var M=v++;l[M]="^"+l[t]+"\\s*("+n+")$|^$";var k=v++;l[k]="(\\s*)"+l[t]+"\\s*("+r+"|"+l[p]+")",w[k]=new RegExp(l[k],"g");var V=v++;l[V]="^\\s*("+l[p]+")\\s+-\\s+("+l[p]+")\\s*$";var H=v++;l[H]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var ie=v++;l[ie]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,l[K]),w[K]||(w[K]=new RegExp(l[K]));function Z(F,z){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(z?w[e]:w[a]).test(F))return null;try{return new _(F,z)}catch(B){return null}}function _(F,z){if(F instanceof _){if(F.loose===z)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,z);b("SemVer",F,z),this.loose=z;var B=F.trim().match(z?w[e]:w[a]);if(!B)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+B[1],this.minor=+B[2],this.patch=+B[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");B[4]?this.prerelease=B[4].split(".").map(function(ce){if(/^[0-9]+$/.test(ce)){var ve=+ce;if(ve>=0&&ve<R)return ve}return ce}):this.prerelease=[],this.build=B[5]?B[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,z){var B=Z(F,z);return B?B.version:null},i.clean=function(F,z){var B=Z(F.trim().replace(/^[=v]+/,""),z);return B?B.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var z=0;do{var B=this.prerelease[z],ce=F.prerelease[z];if(b("prerelease compare",z,B,ce),B===void 0&&ce===void 0)return 0;if(ce===void 0)return 1;if(B===void 0)return-1;if(B!==ce)return U(B,ce)}while(++z)},_.prototype.inc=function(F,z){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",z),this.inc("pre",z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",z),this.inc("pre",z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var B=this.prerelease.length;--B>=0;)typeof this.prerelease[B]=="number"&&(this.prerelease[B]++,B=-2);B===-1&&this.prerelease.push(0)}z&&(this.prerelease[0]===z?isNaN(this.prerelease[1])&&(this.prerelease=[z,0]):this.prerelease=[z,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,z,B,ce){typeof B=="string"&&(ce=B,B=void 0);try{return new _(F,B).inc(z,ce).version}catch(ve){return null}},i.diff=function(F,z){if(Y(F,z))return null;var B=Z(F),ce=Z(z);if(B.prerelease.length||ce.prerelease.length){for(var ve in B)if((ve==="major"||ve==="minor"||ve==="patch")&&B[ve]!==ce[ve])return"pre"+ve;return"prerelease"}for(var ve in B)if((ve==="major"||ve==="minor"||ve==="patch")&&B[ve]!==ce[ve])return ve},i.compareIdentifiers=U;var le=/^[0-9]+$/;function U(F,z){var B=le.test(F),ce=le.test(z);return B&&ce&&(F=+F,z=+z),B&&!ce?-1:ce&&!B?1:F<z?-1:F>z?1:0}function A(F,z,B){return new _(F,B).compare(new _(z,B))}function q(F,z,B){return A(F,z,B)>0}function j(F,z,B){return A(F,z,B)<0}function Y(F,z,B){return A(F,z,B)===0}function X(F,z,B){return A(F,z,B)!==0}function ge(F,z,B){return A(F,z,B)>=0}function fe(F,z,B){return A(F,z,B)<=0}function ue(F,z,B,ce){var ve;switch(z){case"===":typeof F=="object"&&(F=F.version),typeof B=="object"&&(B=B.version),ve=F===B;break;case"!==":typeof F=="object"&&(F=F.version),typeof B=="object"&&(B=B.version),ve=F!==B;break;case"":case"=":case"==":ve=Y(F,B,ce);break;case"!=":ve=X(F,B,ce);break;case">":ve=q(F,B,ce);break;case">=":ve=ge(F,B,ce);break;case"<":ve=j(F,B,ce);break;case"<=":ve=fe(F,B,ce);break;default:throw new TypeError("Invalid operator: "+z)}return ve}function re(F,z){if(F instanceof re){if(F.loose===z)return F;F=F.value}if(!(this instanceof re))return new re(F,z);b("comparator",F,z),this.loose=z,this.parse(F),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,z){return U(z,F)},i.major=function(F,z){return new _(F,z).major},i.minor=function(F,z){return new _(F,z).minor},i.patch=function(F,z){return new _(F,z).patch},i.compare=A,i.compareLoose=function(F,z){return A(F,z,!0)},i.rcompare=function(F,z,B){return A(z,F,B)},i.sort=function(F,z){return F.sort(function(B,ce){return i.compare(B,ce,z)})},i.rsort=function(F,z){return F.sort(function(B,ce){return i.rcompare(B,ce,z)})},i.gt=q,i.lt=j,i.eq=Y,i.neq=X,i.gte=ge,i.lte=fe,i.cmp=ue,i.Comparator=re;var ye={};function oe(F,z){if(F instanceof oe)return F.loose===z?F:new oe(F.raw,z);if(F instanceof re)return new oe(F.value,z);if(!(this instanceof oe))return new oe(F,z);if(this.loose=z,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(B){return this.parseRange(B.trim())},this).filter(function(B){return B.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function he(F){return!F||F.toLowerCase()==="x"||F==="*"}function Re(F,z,B,ce,ve,Ce,Se,ke,Ie,Oe,Me,De,Te){return((z=he(B)?"":he(ce)?">="+B+".0.0":he(ve)?">="+B+"."+ce+".0":">="+z)+" "+(ke=he(Ie)?"":he(Oe)?"<"+(+Ie+1)+".0.0":he(Me)?"<"+Ie+"."+(+Oe+1)+".0":De?"<="+Ie+"."+Oe+"."+Me+"-"+De:"<="+ke)).trim()}function xe(F,z){for(var B=0;B<F.length;B++)if(!F[B].test(z))return!1;if(z.prerelease.length){for(B=0;B<F.length;B++)if(b(F[B].semver),F[B].semver!==ye&&F[B].semver.prerelease.length>0){var ce=F[B].semver;if(ce.major===z.major&&ce.minor===z.minor&&ce.patch===z.patch)return!0}return!1}return!0}function Ae(F,z,B){try{z=new oe(z,B)}catch(ce){return!1}return z.test(F)}function je(F,z,B,ce){var ve,Ce,Se,ke,Ie;switch(F=new _(F,ce),z=new oe(z,ce),B){case">":ve=q,Ce=fe,Se=j,ke=">",Ie=">=";break;case"<":ve=j,Ce=ge,Se=q,ke="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(F,z,ce))return!1;for(var Oe=0;Oe<z.set.length;++Oe){var Me=z.set[Oe],De=null,Te=null;if(Me.forEach(function(Fe){Fe.semver===ye&&(Fe=new re(">=0.0.0")),De=De||Fe,Te=Te||Fe,ve(Fe.semver,De.semver,ce)?De=Fe:Se(Fe.semver,Te.semver,ce)&&(Te=Fe)}),De.operator===ke||De.operator===Ie||(!Te.operator||Te.operator===ke)&&Ce(F,Te.semver)||Te.operator===Ie&&Se(F,Te.semver))return!1}return!0}re.prototype.parse=function(F){var z=this.loose?w[ne]:w[M],B=F.match(z);if(!B)throw new TypeError("Invalid comparator: "+F);this.operator=B[1],this.operator==="="&&(this.operator=""),B[2]?this.semver=new _(B[2],this.loose):this.semver=ye},re.prototype.toString=function(){return this.value},re.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===ye||(typeof F=="string"&&(F=new _(F,this.loose)),ue(F,this.operator,this.semver,this.loose))},re.prototype.intersects=function(F,z){if(!(F instanceof re))throw new TypeError("a Comparator is required");var B;if(this.operator==="")return B=new oe(F.value,z),Ae(this.value,B,z);if(F.operator==="")return B=new oe(this.value,z),Ae(F.semver,B,z);var ce=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=ue(this.semver,"<",F.semver,z)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Ie=ue(this.semver,">",F.semver,z)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ce||ve||Ce&&Se||ke||Ie},i.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(F){var z=this.loose;F=F.trim(),b("range",F,z);var B=z?w[H]:w[V];F=F.replace(B,Re),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[de],"$1^")).split(/\s+/).join(" ");var ce=z?w[ne]:w[M],ve=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(De,Te){b("caret",De,Te);var Fe=Te?w[$]:w[W];return De.replace(Fe,function(Ne,Ee,we,be,Pe){var Le;return b("caret",De,Ne,Ee,we,be,Pe),he(Ee)?Le="":he(we)?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":he(be)?Le=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Pe+" <"+(+Ee+1)+".0.0"):(b("no pr"),Le=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),b("caret return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(De,Te){var Fe=Te?w[ae]:w[me];return De.replace(Fe,function(Ne,Ee,we,be,Pe){var Le;return b("tilde",De,Ne,Ee,we,be,Pe),he(Ee)?Le="":he(we)?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":he(be)?Le=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+Ee+"."+we+"."+be+Pe+" <"+Ee+"."+(+we+1)+".0"):Le=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",b("tilde return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Ie,Oe){return b("replaceXRanges",Ie,Oe),Ie.split(/\s+/).map(function(Me){return function(De,Te){De=De.trim();var Fe=Te?w[O]:w[P];return De.replace(Fe,function(Ne,Ee,we,be,Pe,Le){b("xRange",De,Ne,Ee,we,be,Pe,Le);var We=he(we),ze=We||he(be),Ve=ze||he(Pe);return Ee==="="&&Ve&&(Ee=""),We?Ne=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(ze&&(be=0),Ve&&(Pe=0),Ee===">"?(Ee=">=",ze?(we=+we+1,be=0,Pe=0):Ve&&(be=+be+1,Pe=0)):Ee==="<="&&(Ee="<",ze?we=+we+1:be=+be+1),Ne=Ee+we+"."+be+"."+Pe):ze?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":Ve&&(Ne=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),b("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Ie,Oe){return b("replaceStars",Ie,Oe),Ie.trim().replace(w[ie],"")}(Se,ke),b("stars",Se),Se}(Ce,z)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Ce){return!!Ce.match(ce)})),ve=ve.map(function(Ce){return new re(Ce,z)})},oe.prototype.intersects=function(F,z){if(!(F instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(B){return B.every(function(ce){return F.set.some(function(ve){return ve.every(function(Ce){return ce.intersects(Ce,z)})})})})},i.toComparators=function(F,z){return new oe(F,z).set.map(function(B){return B.map(function(ce){return ce.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var z=0;z<this.set.length;z++)if(xe(this.set[z],F))return!0;return!1},i.satisfies=Ae,i.maxSatisfying=function(F,z,B){var ce=null,ve=null;try{var Ce=new oe(z,B)}catch(Se){return null}return F.forEach(function(Se){Ce.test(Se)&&(ce&&ve.compare(Se)!==-1||(ve=new _(ce=Se,B)))}),ce},i.minSatisfying=function(F,z,B){var ce=null,ve=null;try{var Ce=new oe(z,B)}catch(Se){return null}return F.forEach(function(Se){Ce.test(Se)&&(ce&&ve.compare(Se)!==1||(ve=new _(ce=Se,B)))}),ce},i.validRange=function(F,z){try{return new oe(F,z).range||"*"}catch(B){return null}},i.ltr=function(F,z,B){return je(F,z,"<",B)},i.gtr=function(F,z,B){return je(F,z,">",B)},i.outside=je,i.prerelease=function(F,z){var B=Z(F,z);return B&&B.prerelease.length?B.prerelease:null},i.intersects=function(F,z,B){return F=new oe(F,B),z=new oe(z,B),F.intersects(z)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var z=F.match(w[N]);return z==null?null:Z((z[1]||"0")+"."+(z[2]||"0")+"."+(z[3]||"0"))}}).call(this,C(1))},function(x,i){var C,I,b=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(g){if(C===setTimeout)return setTimeout(g,0);if((C===D||!C)&&setTimeout)return C=setTimeout,setTimeout(g,0);try{return C(g,0)}catch(m){try{return C.call(null,g,0)}catch(S){return C.call(this,g,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:D}catch(g){C=D}try{I=typeof clearTimeout=="function"?clearTimeout:R}catch(g){I=R}})();var l,v=[],y=!1,T=-1;function c(){y&&l&&(y=!1,l.length?v=l.concat(v):T=-1,v.length&&E())}function E(){if(!y){var g=w(c);y=!0;for(var m=v.length;m;){for(l=v,v=[];++T<m;)l&&l[T].run();T=-1,m=v.length}l=null,y=!1,function(S){if(I===clearTimeout)return clearTimeout(S);if((I===R||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(S);try{I(S)}catch(h){try{return I.call(null,S)}catch(o){return I.call(this,S)}}}(g)}}function f(g,m){this.fun=g,this.array=m}function d(){}b.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)m[S-1]=arguments[S];v.push(new f(g,m)),v.length!==1||y||w(E)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(g){return[]},b.binding=function(g){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(g){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Q([0,1]),function(x,i){"use strict";var C;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(w,l,v){this.level=w,this.key=l,this.value=v,this.forward=[]}}const b=void 0;class D{constructor(w,l=2**16){this.comparator=w,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(w){return Boolean(D._search(this,w,this.comparator))}get(w){return D._search(this,w,this.comparator)?.value}set(w,l){return D._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=D._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let v=this._header.forward[0];for(;v;)w.call(l,v.value,v.key,this),v=v.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,v){let y=w._header;for(let T=w._level-1;T>=0;T--)for(;y.forward[T]&&v(y.forward[T].key,l)<0;)y=y.forward[T];if(y=y.forward[0],y&&v(y.key,l)===0)return y}static _insert(w,l,v,y){let T=[],c=w._header;for(let E=w._level-1;E>=0;E--){for(;c.forward[E]&&y(c.forward[E].key,l)<0;)c=c.forward[E];T[E]=c}if(c=c.forward[0],c&&y(c.key,l)===0)return c.value=v,!1;{let E=D._randomLevel(w);if(E>w._level){for(let f=w._level;f<E;f++)T[f]=w._header;w._level=E}c=new I(E,l,v);for(let f=0;f<E;f++)c.forward[f]=T[f].forward[f],T[f].forward[f]=c;return!0}}static _randomLevel(w,l=.5){let v=1;for(;Math.random()<l&&v<w._maxLevel;)v+=1;return v}static _delete(w,l,v){let y=[],T=w._header;for(let c=w._level-1;c>=0;c--){for(;T.forward[c]&&v(T.forward[c].key,l)<0;)T=T.forward[c];y[c]=T}if(T=T.forward[0],!T||v(T.key,l)!==0)return!1;for(let c=0;c<w._level&&y[c].forward[c]===T;c++)y[c].forward[c]=T.forward[c];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}i.SkipList=D}),define(J[38],Q([0,1,7,2]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=b;function D(h){const o=h;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}i.isReadableBufferedStream=D;function R(h,o){return new w(h,o)}i.newWriteableStream=R;class w{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,C.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const r=n.indexOf(a);r>=0&&n.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(h,o){const a=[];let n;for(;(n=h.read())!==null;)a.push(n);return o(a)}i.consumeReadable=l;function v(h,o,a){const n=[];let r;for(;(r=h.read())!==null&&n.length<a;)n.push(r);return r===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return h.read()}}}i.peekReadable=v;function y(h,o){return new Promise((a,n)=>{const r=[];T(h,{onData:e=>{o&&r.push(e)},onError:e=>{o?n(e):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}i.consumeStream=y;function T(h,o){h.on("error",a=>o.onError(a)),h.on("end",()=>o.onEnd()),h.on("data",a=>o.onData(a))}i.listenStream=T;function c(h,o){return new Promise((a,n)=>{const r=new I.DisposableStore,e=[],t=p=>{if(e.push(p),e.length>o)return r.dispose(),h.pause(),a({stream:h,buffer:e,ended:!1})},s=p=>n(p),u=()=>a({stream:h,buffer:e,ended:!0});r.add((0,I.toDisposable)(()=>h.removeListener("error",s))),h.on("error",s),r.add((0,I.toDisposable)(()=>h.removeListener("end",u))),h.on("end",u),r.add((0,I.toDisposable)(()=>h.removeListener("data",t))),h.on("data",t)})}i.peekStream=c;function E(h,o){const a=R(o);return a.end(h),a}i.toStream=E;function f(){const h=R(()=>{throw new Error("not supported")});return h.end(),h}i.emptyStream=f;function d(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}i.toReadable=d;function g(h,o,a){const n=R(a);return T(h,{onData:r=>n.write(o.data(r)),onError:r=>n.error(o.error?o.error(r):r),onEnd:()=>n.end()}),n}i.transform=g;function m(h,o,a){let n=!1;return{read:()=>{const r=o.read();return n?r:(n=!0,r!==null?a([h,r]):h)}}}i.prefixedReadable=m;function S(h,o,a){let n=!1;const r=R(a);return T(o,{onData:e=>n?r.write(e):(n=!0,r.write(a([h,e]))),onError:e=>r.error(e),onEnd:()=>{n||(n=!0,r.write(h)),r.end()}}),r}i.prefixedStream=S}),define(J[17],Q([0,1,38]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,D;class R{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return I?new R(Buffer.allocUnsafe(t)):new R(new Uint8Array(t))}static wrap(t){return I&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new R(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&I?new R(Buffer.from(t)):(b||(b=new TextEncoder),new R(b.encode(t)))}static fromByteArray(t){const s=R.alloc(t.length);for(let u=0,p=t.length;u<p;u++)s.buffer[u]=t[u];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let L=0,P=t.length;L<P;L++)s+=t[L].byteLength}const u=R.alloc(s);let p=0;for(let L=0,P=t.length;L<P;L++){const O=t[L];u.set(O,p),p+=O.byteLength}return u}clone(){const t=R.alloc(this.byteLength);return t.set(this),t}toString(){return I?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(t,s){return new R(this.buffer.subarray(t,s))}set(t,s){if(t instanceof R)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return v(this.buffer,t)}writeUInt32BE(t,s){y(this.buffer,t,s)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,s){c(this.buffer,t,s)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,s){f(this.buffer,t,s)}}i.VSBuffer=R;function w(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0}i.readUInt16LE=w;function l(e,t,s){e[s+0]=t&255,t=t>>>8,e[s+1]=t&255}i.writeUInt16LE=l;function v(e,t){return e[t]*2**24+e[t+1]*2**16+e[t+2]*2**8+e[t+3]}i.readUInt32BE=v;function y(e,t,s){e[s+3]=t,t=t>>>8,e[s+2]=t,t=t>>>8,e[s+1]=t,t=t>>>8,e[s]=t}i.writeUInt32BE=y;function T(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}i.readUInt32LE=T;function c(e,t,s){e[s+0]=t&255,t=t>>>8,e[s+1]=t&255,t=t>>>8,e[s+2]=t&255,t=t>>>8,e[s+3]=t&255}i.writeUInt32LE=c;function E(e,t){return e[t]}i.readUInt8=E;function f(e,t,s){e[s]=t}i.writeUInt8=f;function d(e){return C.consumeReadable(e,t=>R.concat(t))}i.readableToBuffer=d;function g(e){return C.toReadable(e)}i.bufferToReadable=g;function m(e){return C.consumeStream(e,t=>R.concat(t))}i.streamToBuffer=m;async function S(e){return e.ended?R.concat(e.buffer):R.concat([...e.buffer,await m(e.stream)])}i.bufferedStreamToBuffer=S;function h(e){return C.toStream(e,t=>R.concat(t))}i.bufferToStream=h;function o(e){return C.transform(e,{data:t=>typeof t=="string"?R.fromString(t):R.wrap(t)},t=>R.concat(t))}i.streamToBufferReadableStream=o;function a(e){return C.newWriteableStream(t=>R.concat(t),e)}i.newWriteableBufferStream=a;function n(e,t){return C.prefixedReadable(e,t,s=>R.concat(s))}i.prefixedBufferReadable=n;function r(e,t){return C.prefixedStream(e,t,s=>R.concat(s))}i.prefixedBufferStream=r}),define(J[21],Q([0,1,8]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(m=>{d[m]&&typeof d[m]=="object"?g[m]=I(d[m]):g[m]=d[m]}),g}i.deepClone=I;function b(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const m=g.shift();Object.freeze(m);for(const S in m)if(D.call(m,S)){const h=m[S];typeof h=="object"&&!Object.isFrozen(h)&&g.push(h)}}return d}i.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function R(d,g){return w(d,g,new Set)}i.cloneAndChange=R;function w(d,g,m){if((0,C.isUndefinedOrNull)(d))return d;const S=g(d);if(typeof S!="undefined")return S;if((0,C.isArray)(d)){const h=[];for(const o of d)h.push(w(o,g,m));return h}if((0,C.isObject)(d)){if(m.has(d))throw new Error("Cannot clone recursive data-structure");m.add(d);const h={};for(let o in d)D.call(d,o)&&(h[o]=w(d[o],g,m));return m.delete(d),h}return d}function l(d,g,m=!0){return(0,C.isObject)(d)?((0,C.isObject)(g)&&Object.keys(g).forEach(S=>{S in d?m&&((0,C.isObject)(d[S])&&(0,C.isObject)(g[S])?l(d[S],g[S],m):d[S]=g[S]):d[S]=g[S]}),d):g}i.mixin=l;function v(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let m,S;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(m=0;m<d.length;m++)if(!v(d[m],g[m]))return!1}else{const h=[];for(S in d)h.push(S);h.sort();const o=[];for(S in g)o.push(S);if(o.sort(),!v(h,o))return!1;for(m=0;m<h.length;m++)if(!v(d[h[m]],g[h[m]]))return!1}return!0}i.equals=v;function y(d){const g=new Set;return JSON.stringify(d,(m,S)=>{if((0,C.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}i.safeStringify=y;function T(d,g,m){const S=g(d);return typeof S=="undefined"?m:S}i.getOrDefault=T;function c(d,g){const m=Object.create(null);return!d||!g||Object.keys(g).forEach(h=>{const o=d[h],a=g[h];v(o,a)||(m[h]=a)}),m}i.distinct=c;function E(d,g){const m=g.toLowerCase(),S=Object.keys(d).find(h=>h.toLowerCase()===m);return S?d[S]:d[g]}i.getCaseInsensitive=E;function f(d,g){const m=Object.create(null);for(const[S,h]of Object.entries(d))g(S,h)&&(m[S]=h);return m}i.filter=f}),define(J[60],Q([0,1,9]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(v){const y=v;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=I;function b(v){const y=[];let T;try{const c=JSON.parse(v.arguments),E=c[c.length-1];E&&E.__$stack&&(c.pop(),T=E.__$stack),y.push(...c)}catch(c){y.push("Unable to log remote console arguments",v.arguments)}return{args:y,stack:T}}i.parse=b;function D(v){if(typeof v!="string")return D(b(v).stack);const y=v;if(y){const T=R(y),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(c&&c.length===4)return{uri:C.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}i.getFirstFrame=D;function R(v){if(!v)return v;const y=v.indexOf(`
`);return y===-1?v:v.substring(0,y)}function w(v,y){const{args:T,stack:c}=b(v),E=typeof T[0]=="string"&&T.length===1;let f=R(c);f&&(f=`(${f.trim()})`);let d=[];if(typeof T[0]=="string"?f&&E?d=[`%c[${y}] %c${T[0]} %c${f}`,l("blue"),l(""),l("grey")]:d=[`%c[${y}] %c${T[0]}`,l("blue"),l(""),...T.slice(1)]:d=[`%c[${y}]%`,l("blue"),...T],f&&!E&&d.push(f),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,d)}i.log=w;function l(v){return`color: ${v}`}}),define(J[61],Q([0,1,17,26,9]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function D(y){return JSON.stringify(y,l)}i.stringify=D;function R(y){let T=JSON.parse(y);return T=v(T),T}i.parse=R;var w;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(y,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,I.regExpFlags)(T)}:T}function v(y,T=0){if(!y||T>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return b.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof C.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let c=0;c<y.length;++c)y[c]=v(y[c],T+1);else for(const c in y)Object.hasOwnProperty.call(y,c)&&(y[c]=v(y[c],T+1))}return y}i.revive=v}),define(J[62],Q([0,1,47,10,6,12,18,26,9]),function(x,i,C,I,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function v(t,s,u){if(typeof t=="string"&&(t=l.URI.file(t)),u){const L=u.getWorkspaceFolder(t);if(L){const P=u.getWorkspace().folders.length>1;let O;if((0,R.isEqual)(L.uri,t)?O="":O=(0,R.relativePath)(L.uri,t),P){const N=L.name?L.name:(0,R.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(t.scheme!==I.Schemas.file&&t.scheme!==I.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(t.fsPath))return(0,b.normalize)(T(t.fsPath));let p=(0,b.normalize)(t.fsPath);return!D.isWindows&&s?.userHome&&(p=E(p,s.userHome.fsPath)),p}i.getPathLabel=v;function y(t){if(!t)return;typeof t=="string"&&(t=l.URI.file(t));const s=(0,R.basename)(t)||(t.scheme===I.Schemas.file?t.fsPath:t.path);return D.isWindows&&(0,C.isRootOrDriveLetter)(s)?T(s):s}i.getBaseLabel=y;function T(t,s){return(0,C.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}i.normalizeDriveLetter=T;let c=Object.create(null);function E(t,s){if(D.isWindows||!t||!s)return t;let u=c.original===s?c.normalized:void 0;return u||(u=`${(0,w.rtrim)(s,b.posix.sep)}${b.posix.sep}`,c={original:s,normalized:u}),(D.isLinux?t.startsWith(u):(0,w.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}i.tildify=E;function f(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=f;const d="\u2026",g="\\\\",m="~";function S(t,s=b.sep){const u=new Array(t.length);let p=!1;for(let L=0;L<t.length;L++){let P=t[L];if(P===""){u[L]=`.${s}`;continue}if(!P){u[L]=P;continue}p=!0;let O="";P.indexOf(g)===0?(O=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length)):P.indexOf(s)===0?(O=P.substr(0,P.indexOf(s)+s.length),P=P.substr(P.indexOf(s)+s.length)):P.indexOf(m)===0&&(O=P.substr(0,P.indexOf(m)+m.length),P=P.substr(P.indexOf(m)+m.length));const N=P.split(s);for(let G=1;p&&G<=N.length;G++)for(let ee=N.length-G;p&&ee>=0;ee--){p=!1;let me=N.slice(ee,ee+G).join(s);for(let ae=0;!p&&ae<t.length;ae++)if(ae!==L&&t[ae]&&t[ae].indexOf(me)>-1){const te=ee+G===N.length,de=ee>0&&t[ae].indexOf(s)>-1?s+me:me,W=t[ae].endsWith(de);p=!te||W}if(!p){let ae="";(N[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,G++,me=N[0]+s+me),ee>0&&(ae=N[0]+s),ae=O+ae),ee>0&&(ae=ae+d+s),ae=ae+me,ee+G<N.length&&(ae=ae+s+d),u[L]=ae}}p&&(u[L]=P)}return u}i.shorten=S;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(t,s=Object.create(null)){const u=[];let p=!1,L="";for(const P of t)if(P==="$"||p&&P==="{")L&&u.push({value:L,type:h.TEXT}),L="",p=!0;else if(P==="}"&&p){const O=s[L];if(typeof O=="string")O.length&&u.push({value:O,type:h.VARIABLE});else if(O){const N=u[u.length-1];(!N||N.type!==h.SEPARATOR)&&u.push({value:O.label,type:h.SEPARATOR})}L="",p=!1}else L+=P;return L&&!p&&u.push({value:L,type:h.TEXT}),u.filter((P,O)=>{if(P.type===h.SEPARATOR){const N=u[O-1],G=u[O+1];return[N,G].every(ee=>ee&&(ee.type===h.VARIABLE||ee.type===h.TEXT)&&ee.value.length>0)}return!0}).map(P=>P.value).join("")}i.template=o;function a(t,s){return D.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function n(t,s){return D.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):D.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}i.mnemonicButtonLabel=n;function r(t){return t.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(t){const s=t.indexOf("/")!==-1?b.posix:b.win32,u=s.basename(t),p=s.dirname(t);return u.length?{name:u,parentPath:p}:{name:p,parentPath:""}}i.splitName=e}),define(J[63],Q([0,1,131]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(D="utf8"){this.stringDecoder=new C.StringDecoder(D),this.remaining=null}write(D){const R=[],w=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(w.length<1)return R;let l=0,v,y=l;for(;y<w.length;)if(v=w.charCodeAt(y),v===13||v===10){if(R.push(w.substring(l,y)),y++,y<w.length){const T=v;v=w.charCodeAt(y),(T===13&&v===10||T===10&&v===13)&&y++}l=y}else y++;return this.remaining=l<w.length?w.substr(l):null,R}end(){return this.remaining}}i.LineDecoder=I}),define(J[64],Q([0,1,48,6,26,13]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function R(y){const T=(0,I.dirname)(y);if(y===T)return y;const c=((0,I.basename)(y)||y).toLowerCase();try{const f=(0,D.readdirSync)(T).filter(d=>d.toLowerCase()===c);if(f.length===1){const d=R(T);if(d)return(0,I.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(c);if(d>=0){const g=R(T);if(g)return(0,I.join)(g,f[d])}}}catch(E){}return null}i.realcaseSync=R;async function w(y){try{return await D.Promises.realpath(y)}catch(T){const c=v(y);return await D.Promises.access(c,C.constants.R_OK),c}}i.realpath=w;function l(y){try{return C.realpathSync(y)}catch(T){const c=v(y);return C.accessSync(c,C.constants.R_OK),c}}i.realpathSync=l;function v(y){return(0,b.rtrim)((0,I.normalize)(y),I.sep)}}),define(J[65],Q([0,1,33,6,13]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class T{constructor(a,n,r){this.exePath=a,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:o=!1}={}){return o?v===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:o=!1,findPreview:a=!1}={}){const n=c({useAlternateBitness:o});if(!n)return null;const r=I.join(n,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,t=null;for(const p of await b.Promises.readdir(r)){let L=-1;if(a){const O=p.indexOf("-");if(O<0)continue;const N=p.substring(0,O);if(!D.test(N)||p.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!D.test(p))continue;L=parseInt(p,10)}if(L<=e)continue;const P=I.join(r,p,"pwsh.exe");!await b.SymlinkSupport.existsFile(P)||(t=P,e=L)}if(!t)return null;const s=n.includes("x86")?" (x86)":"",u=a?" Preview":"";return new T(t,`PowerShell${u}${s}`,!0)}async function f({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=o?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(a))if(n.test(e)){const t=I.join(a,e,"pwsh.exe");return new T(t,r)}return null}function d(){const o=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new T(o,".NET Core PowerShell Global Tool")}function g(){const o=I.join(process.env.windir,v===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(o,"Windows PowerShell",!0)}async function*m(){let o=await E();o&&(yield o),o=await E({useAlternateBitness:!0}),o&&(yield o),o=await f(),o&&(yield o),o=d(),o&&(yield o),o=await E({findPreview:!0}),o&&(yield o),o=await f({findPreview:!0}),o&&(yield o),o=await E({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*S(){for await(const o of m())await o.exists()&&(yield o)}i.enumeratePowerShellInstallations=S;async function h(){for await(const o of S())return o;return null}i.getFirstAvailablePowerShellInstallation=h});var pe=this&&this.__decorate||function(x,i,C,I){var b=arguments.length,D=b<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,C):I,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,i,C,I);else for(var w=x.length-1;w>=0;w--)(R=x[w])&&(D=(b<3?R(D):b>3?R(i,C,D):R(i,C))||D);return b>3&&D&&Object.defineProperty(i,C,D),D};define(J[39],Q([0,1,19,3,17,24,46,7,11,2,61,26,8]),function(x,i,C,I,b,D,R,w,l,v,y,T,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function f(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(d=i.ResponseType||(i.ResponseType={}));function g(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(m||(m={}));class S{constructor(k){this.buffer=k,this.pos=0}read(k){const V=this.buffer.slice(this.pos,this.pos+k);return this.pos+=V.byteLength,V}}class h{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function a(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function n(M){return M.read(4).readUInt32BE(0)}function r(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},t=typeof Buffer!="undefined";function s(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const V=b.VSBuffer.fromString(k);M.write(e.String),M.write(a(V.byteLength)),M.write(V)}else if(t&&Buffer.isBuffer(k)){const V=b.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(V.byteLength)),M.write(V)}else if(k instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const V of k)s(M,V)}else{const V=b.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(V.byteLength)),M.write(V)}}function u(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(n(M)).toString();case o.Buffer:return M.read(n(M)).buffer;case o.VSBuffer:return M.read(n(M));case o.Array:{const V=n(M),H=[];for(let ie=0;ie<V;ie++)H.push(u(M));return H}case o.Object:return JSON.parse(M.read(n(M)).toString())}}class p{constructor(k,V,H=null,ie=1e3){this.protocol=k,this.ctx=V,this.logger=H,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,V){this.channels.set(k,V),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const V=this.send([k.type]);this.logger&&this.logger.logOutgoing(V,0,1,g(k.type));return}case 201:case 202:case 204:case 203:{const V=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(V,k.id,1,g(k.type),k.data);return}}}send(k,V=void 0){const H=new h;return s(H,k),s(H,V),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(V){return 0}}onRawMessage(k){const V=new S(k),H=u(V),ie=u(V),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}: ${H[2]}.${H[3]}`,ie),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}: ${H[2]}.${H[3]}`,ie),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(k){const V=this.channels.get(k.channelName);if(!V){this.collectPendingRequest(k);return}const H=new D.CancellationTokenSource;let ie;try{ie=V.call(this.ctx,k.name,k.arg,H.token)}catch(_){ie=Promise.reject(_)}const K=k.id;ie.then(_=>{this.sendResponse({id:K,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:K,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:K,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,v.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const V=this.channels.get(k.channelName);if(!V){this.collectPendingRequest(k);return}const H=k.id,K=V.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const V=this.activeRequests.get(k.id);V&&(V.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let V=this.pendingRequests.get(k.channelName);V||(V=[],this.pendingRequests.set(k.channelName,V));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const V=this.pendingRequests.get(k);if(V){for(const H of V)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=p;var L;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class P{constructor(k,V=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=V}getChannel(k){const V=this;return{call(H,ie,K){return V.isDisposed?Promise.reject(w.canceled()):V.requestPromise(k,H,ie,K)},listen(H,ie){return V.isDisposed?Promise.reject(w.canceled()):V.requestEvent(k,H,ie)}}}requestPromise(k,V,H,ie=D.CancellationToken.None){const K=this.lastRequestId++,_={id:K,type:100,channelName:k,name:V,arg:H};if(ie.isCancellationRequested)return Promise.reject(w.canceled());let le;return new Promise((A,q)=>{if(ie.isCancellationRequested)return q(w.canceled());const j=()=>{const fe=ue=>{switch(ue.type){case 201:this.handlers.delete(K),A(ue.data);break;case 202:this.handlers.delete(K);const re=new Error(ue.data.message);re.stack=ue.data.stack,re.name=ue.data.name,q(re);break;case 203:this.handlers.delete(K),q(ue.data);break}};this.handlers.set(K,fe),this.sendRequest(_)};let Y=null;this.state===m.Idle?j():(Y=(0,I.createCancelablePromise)(fe=>this.whenInitialized()),Y.then(()=>{Y=null,j()}));const X=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:K,type:101}),q(w.canceled())},ge=ie.onCancellationRequested(X);le=(0,v.combinedDisposable)((0,v.toDisposable)(X),ge),this.activeRequests.add(le)}).finally(()=>{this.activeRequests.delete(le)})}requestEvent(k,V,H){const ie=this.lastRequestId++,Z={id:ie,type:102,channelName:k,name:V,arg:H};let _=null;const le=new l.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(le),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(le),this.sendRequest({id:ie,type:103}))}}),U=A=>le.fire(A.data);return this.handlers.set(ie,U),le.event}sendRequest(k){switch(k.type){case 100:case 102:{const V=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(V,k.id,0,`${f(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const V=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(V,k.id,0,f(k.type));return}}}send(k,V=void 0){const H=new h;return s(H,k),s(H,V),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(V){return 0}}onBuffer(k){const V=new S(k),H=u(V),ie=u(V),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,g(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,g(K),ie),this.onResponse({type:H[0],id:H[1],data:ie})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(k.id);V&&V(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}pe([R.memoize],P.prototype,"onDidInitializePromise",null),i.ChannelClient=P;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:V,onDidClientDisconnect:H})=>{l.Event.once(V.onMessage)(K=>{const Z=new S(K),_=u(Z),le=new p(V,_),U=new P(V);this.channels.forEach((q,j)=>le.registerChannel(j,q));const A={channelServer:le,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),H(()=>{le.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(V=>k.push(V)),k}getChannel(k,V){const H=this;return{call(ie,K,Z){let _;if((0,c.isFunction)(V)){let U=(0,C.getRandomElement)(H.connections.filter(V));_=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,V))}else _=V.routeCall(H,ie,K);const le=_.then(U=>U.channelClient.getChannel(k));return G(le).call(ie,K,Z)},listen(ie,K){if((0,c.isFunction)(V))return H.getMulticastEvent(k,V,ie,K);const Z=V.routeEvent(H,ie,K).then(_=>_.channelClient.getChannel(k));return G(Z).listen(ie,K)}}}getMulticastEvent(k,V,H,ie){const K=this;let Z=new v.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new v.DisposableStore;const le=new l.EventMultiplexer,U=new Map,A=j=>{const X=j.channelClient.getChannel(k).listen(H,ie),ge=le.add(X);U.set(j,ge)},q=j=>{const Y=U.get(j);!Y||(Y.dispose(),U.delete(j))};K.connections.filter(V).forEach(A),l.Event.filter(K.onDidAddConnection,V)(A,void 0,Z),K.onDidRemoveConnection(q,void 0,Z),le.event(_.fire,_,Z),Z.add(le)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,V){this.channels.set(k,V),this._connections.forEach(H=>{H.channelServer.registerChannel(k,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,V,H=null){const ie=new h;s(ie,V),k.send(ie.buffer),this.channelClient=new P(k,H),this.channelServer=new p(k,V,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,V){this.channelServer.registerChannel(k,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function G(M){return{call(k,V,H){return M.then(ie=>ie.call(k,V,H))},listen(k,V){const H=new l.Relay;return M.then(ie=>H.input=ie.listen(k,V)),H.event}}}i.getDelayedChannel=G;function ee(M){let k=!1;return{call(V,H,ie){return k?M.call(V,H,ie):(0,I.timeout)(0).then(()=>k=!0).then(()=>M.call(V,H,ie))},listen(V,H){if(k)return M.listen(V,H);const ie=new l.Relay;return(0,I.timeout)(0).then(()=>k=!0).then(()=>ie.input=M.listen(V,H)),ie.event}}}i.getNextTickChannel=ee;class me{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const V of k.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=me;var ae;(function(M){function k(K,Z){const _=K,le=Z&&Z.disableMarshalling,U=new Map;for(const A in _)H(A)&&U.set(A,l.Event.buffer(_[A],!0));return new class{listen(A,q,j){const Y=U.get(q);if(Y)return Y;if(ie(q)){const X=_[q];if(typeof X=="function")return X.call(_,j)}throw new Error(`Event not found: ${q}`)}call(A,q,j){const Y=_[q];if(typeof Y=="function"){if(!le&&Array.isArray(j))for(let X=0;X<j.length;X++)j[X]=(0,y.revive)(j[X]);return Y.apply(_,j)}throw new Error(`Method not found: ${q}`)}}}M.fromService=k;function V(K,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(le,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ie(U)?function(A){return K.listen(U,A)}:H(U)?K.listen(U):async function(...A){let q;Z&&!(0,c.isUndefinedOrNull)(Z.context)?q=[Z.context,...A]:q=A;const j=await K.call(U,q);return _?j:(0,y.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=V;function H(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function ie(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ae=i.ProxyChannel||(i.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function W(M){return Array.isArray(M)?M.map(de):de(M)}function $(M,k,V,H,ie,K,Z){Z=W(Z);const _=te[ie],le=_[H%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${le}`];/\($/.test(K)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=$;class ne{constructor(k,V){this._outgoingPrefix=k,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,V,H,ie,K){this._totalOutgoing+=k,$(this._outgoingPrefix,this._totalOutgoing,k,V,H,ie,K)}logIncoming(k,V,H,ie,K){this._totalIncoming+=k,$(this._incomingPrefix,this._totalIncoming,k,V,H,ie,K)}}i.IPCLogger=ne}),define(J[66],Q([0,1,3,11,2,8]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var R;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=i.StorageHint||(i.StorageHint={}));function w(T){const c=T;return c?.changed instanceof Map||c?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(l||(l={}));class v extends b.Disposable{constructor(c,E=Object.create(null)){super();this.database=c,this.options=E,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((E,f)=>this.accept(f,E)),c.deleted?.forEach(E=>this.accept(E,void 0))}accept(c,E){if(this.state===l.Closed)return;let f=!1;(0,D.isUndefinedOrNull)(E)?f=this.cache.delete(c):this.cache.get(c)!==E&&(this.cache.set(c,E),f=!0),f&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,E){const f=this.cache.get(c);return(0,D.isUndefinedOrNull)(f)?E:f}getBoolean(c,E){const f=this.get(c);return(0,D.isUndefinedOrNull)(f)?E:f==="true"}getNumber(c,E){const f=this.get(c);return(0,D.isUndefinedOrNull)(f)?E:parseInt(f,10)}async set(c,E){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(E))return this.delete(c);const f=String(E);if(this.cache.get(c)!==f)return this.cache.set(c,f),this.pendingInserts.set(c,f),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((E,f)=>this.items.set(f,E)),c.delete&&c.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(J[67],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(J[68],Q([0,1,67]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,b=I*60,D=b*24,R=D*7,w=D*30,l=D*365;function v(T,c){typeof T!="number"&&(T=T.getTime());const E=Math.round((new Date().getTime()-T)/1e3);if(E<-30)return(0,C.localize)(0,null,v(new Date().getTime()+E*1e3,!1));if(E<30)return(0,C.localize)(1,null);let f;return E<I?(f=E,c?f===1?(0,C.localize)(2,null,f):(0,C.localize)(3,null,f):f===1?(0,C.localize)(4,null,f):(0,C.localize)(5,null,f)):E<b?(f=Math.floor(E/I),c?f===1?(0,C.localize)(6,null,f):(0,C.localize)(7,null,f):f===1?(0,C.localize)(8,null,f):(0,C.localize)(9,null,f)):E<D?(f=Math.floor(E/b),c?f===1?(0,C.localize)(10,null,f):(0,C.localize)(11,null,f):f===1?(0,C.localize)(12,null,f):(0,C.localize)(13,null,f)):E<R?(f=Math.floor(E/D),c?f===1?(0,C.localize)(14,null,f):(0,C.localize)(15,null,f):f===1?(0,C.localize)(16,null,f):(0,C.localize)(17,null,f)):E<w?(f=Math.floor(E/R),c?f===1?(0,C.localize)(18,null,f):(0,C.localize)(19,null,f):f===1?(0,C.localize)(20,null,f):(0,C.localize)(21,null,f)):E<l?(f=Math.floor(E/w),c?f===1?(0,C.localize)(22,null,f):(0,C.localize)(23,null,f):f===1?(0,C.localize)(24,null,f):(0,C.localize)(25,null,f)):(f=Math.floor(E/l),c?f===1?(0,C.localize)(26,null,f):(0,C.localize)(27,null,f):f===1?(0,C.localize)(28,null,f):(0,C.localize)(29,null,f))}i.fromNow=v;function y(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(J[69],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(J[27],Q([0,1,19,8,69]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function D(v,y){return y&&(v.stack||v.stacktrace)?b.localize(0,null,w(v),R(v.stack)||R(v.stacktrace)):w(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function w(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?b.localize(1,null,v.message):v.message||b.localize(2,null)}function l(v=null,y=!1){if(!v)return b.localize(3,null);if(Array.isArray(v)){const T=C.coalesce(v),c=l(T[0],y);return T.length>1?b.localize(4,null,c,T.length):c}if(I.isString(v))return v;if(v.detail){const T=v.detail;if(T.error)return D(T.error,y);if(T.exception)return D(T.exception,y)}return v.stack?D(v,y):v.message?v.message:b.localize(5,null)}i.toErrorMessage=l}),define(J[70],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(J[49],Q([0,1,40,47,10,21,6,12,28,58,8,63,13,70]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function f(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(n,r){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const t=C.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(s=>{t.once("error",u=>{s({success:!1,error:u})}),t.once("exit",(u,p)=>{s(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(t=>{C.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(s,u,p)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function g(n){!n||(delete n.DEBUG,w.isMacintosh&&delete n.DYLD_LIBRARY_PATH,w.isLinux&&delete n.LD_PRELOAD)}i.removeDangerousEnvVariables=g;function m(n=l.env){return n.comspec||"cmd.exe"}i.getWindowsShell=m;class S{constructor(r,e,t,s){if(e!==void 0&&t!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=t,this.options=s;else{const u=r;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(l.env).forEach(p=>{u[p]=l.env[p]}),Object.keys(this.options.env).forEach(p=>{u[p]=this.options.env[p]}),this.options.env=u}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(R.sep);return e!==-1&&(r=r.substring(e+1)),S.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let t,s;const u=new Promise((p,L)=>{t=p,s=L});if(e){let p=this.cmd;this.args&&(p=p+" "+this.args.join(" ")),this.childProcess=C.exec(p,this.options,(L,P,O)=>{this.childProcess=null;const N=L;N&&N.killed?s({killed:this.terminateRequested,stdout:P.toString(),stderr:O.toString()}):this.handleExec(t,r,L,P,O)})}else{let p=null;const L=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,t,r,s);const O={terminated:this.terminateRequested};y.isNumber(P)&&(O.cmdCode=P),t(O)};if(this.shell&&w.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let O=!1,N=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(ae=>{ee=this.ensureQuotes(ae),G.push(ee.value),N=N&&ee.quoted});const me=["/s","/c"];O?N?me.push('"'+G.join(" ")+'"'):G.length>1?me.push('"'+G[0]+'" '+G.slice(1).join(" ")):me.push('"'+G[0]+'"'):me.push(G.join(" ")),p=C.spawn(m(),me,P)}else this.cmd&&(p=C.spawn(this.cmd,this.args,this.options));p&&(this.childProcess=p,this.childProcessPromise=Promise.resolve(p),this.pidResolve&&(this.pidResolve(y.isNumber(p.pid)?p.pid:-1),this.pidResolve=void 0),p.on("error",P=>{this.childProcess=null,s({terminated:this.terminateRequested,error:P})}),p.pid&&(this.childProcess.on("close",L),this.handleSpawn(p,t,r,s,!0)))}return u})}handleClose(r,e,t,s){}ensureQuotes(r){return S.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,d(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const e=C.spawn(m(),["/s","/c"]);e.on("error",t=>r(!0)),e.on("exit",t=>r(!1))})}}i.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class h extends S{constructor(r,e,t,s){super(r,e,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,t,s,u){[s,u].forEach((p,L)=>{const P=new T.LineDecoder;P.write(p).forEach(G=>{e({line:G,source:L===0?0:1})});const N=P.end();N&&e({line:N,source:L===0?0:1})}),r({terminated:this.terminateRequested,error:t})}handleSpawn(r,e,t,s,u){const p=new T.LineDecoder,L=new T.LineDecoder;r.stdout.on("data",P=>{p.write(P).forEach(N=>t({line:N,source:0}))}),r.stderr.on("data",P=>{L.write(P).forEach(N=>t({line:N,source:1}))}),this.stdoutLineDecoder=p,this.stderrLineDecoder=L}handleClose(r,e,t,s){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&t({line:u,source:0});const p=this.stderrLineDecoder?this.stderrLineDecoder.end():null;p&&t({line:p,source:1})}}i.LineProcess=h;function o(n){let r=[],e=!1;const t=function(s){if(e){r.push(s);return}(!n.send(s,p=>{if(p&&console.error(p),e=!1,r.length>0){const L=r.slice(0);r=[],L.forEach(P=>t(P))}})||w.isWindows)&&(e=!0)};return{send:t}}i.createQueuedSender=o;var a;(function(n){async function r(e,t,s){if(R.isAbsolute(e))return e;if(t===void 0&&(t=l.cwd()),R.dirname(e)!=="."||(s===void 0&&y.isString(l.env.PATH)&&(s=l.env.PATH.split(R.delimiter)),s===void 0||s.length===0))return R.join(t,e);async function p(L){if(await c.Promises.exists(L)){let P;try{P=await c.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(P=await c.Promises.lstat(L))}return P?!P.isDirectory():!1}return!1}for(let L of s){let P;if(R.isAbsolute(L)?P=R.join(L,e):P=R.join(t,L,e),await p(P))return P;let O=P+".com";if(await p(O)||(O=P+".exe",await p(O)))return O}return R.join(t,e)}n.findExecutable=r})(a=i.win32||(i.win32={}))}),define(J[71],Q([0,1,33,12,65,49]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function R(E,f){return E===1?I.isWindows?T():D.getWindowsShell(f):v(E,f)}i.getSystemShell=R;function w(E,f){return E===1?I.isWindows?c(f):D.getWindowsShell(f):v(E,f)}i.getSystemShellSync=w;let l=null;function v(E,f){if(I.isLinux&&E===2||I.isMacintosh&&E===3)return"/bin/bash";if(!l){let d;if(I.isWindows)d="/bin/bash";else{if(d=f.SHELL,!d)try{d=(0,C.userInfo)().shell}catch(g){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}l=d}return l}let y=null;async function T(){return y||(y=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),y}function c(E){if(y)return y;const f=I.isWindows&&parseFloat((0,C.release)())>=10,d=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${E.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?g:D.getWindowsShell(E)}}),define(J[50],Q([0,1,40,3,17,24,60,7,11,2,21,49,39]),function(x,i,C,I,b,D,R,w,l,v,y,T,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends c.ChannelServer{constructor(g){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(S){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},g);process.once("disconnect",()=>this.dispose())}}i.Server=E;class f{constructor(g,m){this.modulePath=g,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new I.Delayer(S),this.child=null,this._client=null}getChannel(g){const m=this;return{call(S,h,o){return m.requestPromise(g,S,h,o)},listen(S,h){return m.requestEvent(g,S,h)}}}requestPromise(g,m,S,h=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(g),a=(0,I.createCancelablePromise)(e=>o.call(m,S,e)),n=h.onCancellationRequested(()=>a.cancel()),r=(0,v.toDisposable)(()=>a.cancel());return this.activeRequests.add(r),a.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(g,m,S){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let h;const o=new l.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(g).listen(m,S)(o.fire,o),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,T.removeDangerousEnvVariables)(m.env),this.child=(0,C.fork)(this.modulePath,g,m);const S=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,R.isRemoteConsoleLog)(t)){(0,R.log)(t,`IPC Library: ${this.options.serverName}`);return}S.fire(b.VSBuffer.wrap(Buffer.from(t,"base64")))});const o=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,a=t=>this.child&&this.child.connected&&o.send(t.buffer.toString("base64")),n=S.event,r={send:a,onMessage:n};this._client=new c.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(u=>(0,v.dispose)(u)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(g){let m=this.channels.get(g);return m||(m=this.client.getChannel(g),this.channels.set(g,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=f}),define(J[72],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(J[73],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(J[74],Q([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(J[75],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(J[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(J[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(J[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(J[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(J[80],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(J[81],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(J[82],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(J[83],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(J[84],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(J[85],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(J[86],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(J[87],Q([0,1,68,46,10,6,28,18,9]),function(x,i,C,I,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class v{constructor(d,g,m){this._args=d,this.paths=g,this.productService=m}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?l.URI.file((0,D.join)(d,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const g=R.env.VSCODE_EXTENSIONS;if(g)return g;const m=R.env.VSCODE_PORTABLE;return m?(0,D.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?l.URI.parse(d):l.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([I.memoize],v.prototype,"appRoot",null),pe([I.memoize],v.prototype,"userHome",null),pe([I.memoize],v.prototype,"userDataPath",null),pe([I.memoize],v.prototype,"appSettingsHome",null),pe([I.memoize],v.prototype,"tmpDir",null),pe([I.memoize],v.prototype,"cacheHome",null),pe([I.memoize],v.prototype,"userRoamingDataHome",null),pe([I.memoize],v.prototype,"settingsResource",null),pe([I.memoize],v.prototype,"userDataSyncHome",null),pe([I.memoize],v.prototype,"userDataSyncLogResource",null),pe([I.memoize],v.prototype,"sync",null),pe([I.memoize],v.prototype,"machineSettingsResource",null),pe([I.memoize],v.prototype,"globalStorageHome",null),pe([I.memoize],v.prototype,"workspaceStorageHome",null),pe([I.memoize],v.prototype,"keybindingsResource",null),pe([I.memoize],v.prototype,"keyboardLayoutResource",null),pe([I.memoize],v.prototype,"argvResource",null),pe([I.memoize],v.prototype,"snippetsHome",null),pe([I.memoize],v.prototype,"isExtensionDevelopment",null),pe([I.memoize],v.prototype,"untitledWorkspacesHome",null),pe([I.memoize],v.prototype,"installSourcePath",null),pe([I.memoize],v.prototype,"builtinExtensionsPath",null),pe([I.memoize],v.prototype,"extensionsPath",null),pe([I.memoize],v.prototype,"extensionDevelopmentLocationURI",null),pe([I.memoize],v.prototype,"extensionDevelopmentKind",null),pe([I.memoize],v.prototype,"extensionTestsLocationURI",null),pe([I.memoize],v.prototype,"debugExtensionHost",null),pe([I.memoize],v.prototype,"serviceMachineIdResource",null),pe([I.memoize],v.prototype,"telemetryLogResource",null),pe([I.memoize],v.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=v;function y(f,d){return E(f["inspect-extensions"],f["inspect-brk-extensions"],5870,d,f.debugId,f.extensionEnvironment)}i.parseExtensionHostPort=y;function T(f,d){return E(f["inspect-search"],f["inspect-brk-search"],5876,d,f.extensionEnvironment)}i.parseSearchPort=T;function c(f,d){return E(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,d,f.extensionEnvironment)}i.parsePtyHostPort=c;function E(f,d,g,m,S,h){const a=Number(d||f)||(m?null:g),n=a?Boolean(!!d):!1;let r;if(h)try{r=JSON.parse(h)}catch{}return{port:a,break:n,debugId:S,env:r}}}),function(){"use strict";function x(i,C,I,b){function D(w){const l=R(w),v=[l];return i.isAbsolute(l)||v.unshift(b),i.resolve(...v)}function R(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return i.join(v,I);const y=w["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=i.join(T,"AppData","Roaming")}break;case"darwin":v=i.join(C.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||i.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(v,I)}return{getUserDataPath:D}}if(typeof define=="function")define(J[88],Q([0,132,33,10,18,28]),function(i,C,I,b,D,R){const w=D.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(D.joinPath(w,"package.json").fsPath);return x(C,I,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=x(C,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Q([0,1,33,87,88]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class D extends I.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=D}),define(J[90],Q([0,1,21]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function b(D,R){const w=l=>{if(typeof l!="string")return;const v=I.exec(l);if(!v)return;const y=R[v[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,C.cloneAndChange)(D,w)}i.localizeManifest=b}),define(J[51],Q([0,1,81]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(c){return c=c.trim(),c==="*"||I.test(c)}i.isValidVersionStr=D;function R(c){if(!D(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(I);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=R;function w(c){if(!c)return null;let E=c.majorBase,f=c.majorMustEqual,d=c.minorBase,g=c.minorMustEqual,m=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(E===0||(g=!1),S=!1);let h=0;if(c.preRelease){const o=b.exec(c.preRelease);if(o){const[,a,n,r]=o;h=Date.UTC(Number(a),Number(n)-1,Number(r))}}return{majorBase:E,majorMustEqual:f,minorBase:d,minorMustEqual:g,patchBase:m,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:h}}i.normalizeVersion=w;function l(c,E,f){let d;typeof c=="string"?d=w(R(c)):d=c;let g;E instanceof Date?g=E.getTime():typeof E=="string"&&(g=new Date(E).getTime());let m;if(typeof f=="string"?m=w(R(f)):m=f,!d||!m)return!1;let S=d.majorBase,h=d.minorBase,o=d.patchBase,a=m.majorBase,n=m.minorBase,r=m.patchBase,e=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,u=m.patchMustEqual;return m.isMinimum?S>a?!0:S<a?!1:h>n?!0:h<n||g&&g<e?!1:o>=r:(S===1&&a===0&&(!t||!s||!u)&&(a=1,n=0,r=0,t=!0,s=!1,u=!1),S<a?!1:S>a?!t:h<n?!1:h>n?!s:o<r?!1:o>r?!u:!(g&&g<e))}i.isValidVersion=l;function v(c,E,f,d){return f.isBuiltin||typeof f.main=="undefined"?!0:T(c,E,f.engines.vscode,d)}i.isValidExtensionVersion=v;function y(c,E,f){return c==="*"||T(E,f,c)}i.isEngineValid=y;function T(c,E,f,d=[]){let g=w(R(f));if(!g)return d.push(C.localize(0,null,f)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return d.push(C.localize(1,null,f)),!1}else if(!g.majorMustEqual)return d.push(C.localize(2,null,f)),!1;return l(c,E,g)?!0:(d.push(C.localize(3,null,c,f)),!1)}}),define(J[41],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class C{constructor(b,D=[],R=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=R}}i.SyncDescriptor=C}),define(J[91],Q([0,1,41]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function b(R,w,l){w instanceof C.SyncDescriptor||(w=new C.SyncDescriptor(w,[],l)),I.push([R,w])}i.registerSingleton=b;function D(){return I}i.getSingletonServiceDescriptors=D}),define(J[92],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class C{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}i.Node=C;class I{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let R of this._nodes.values())R.outgoing.size===0&&D.push(R);return D}insertEdge(D,R){const w=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(R);w.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(D),w)}removeNode(D){const R=this._hashFn(D);this._nodes.delete(R);for(let w of this._nodes.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(D){const R=this._hashFn(D);let w=this._nodes.get(R);return w||(w=new C(D),this._nodes.set(R,w)),w}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[R,w]of this._nodes)D.push(`${R}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,R]of this._nodes){const w=new Set([D]),l=this._findCycle(R,w);if(l)return l}}_findCycle(D,R){for(let[w,l]of D.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const v=this._findCycle(l,R);if(v)return v;R.delete(w)}}}i.Graph=I}),define(J[25],Q([0,1,8,9,14]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof I.URI)}i.isConfigurationOverrides=D;function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||C.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=R;var w;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(w=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function v(g,m){const S=Object.create(null);for(let h in g)y(S,h,g[h],m);return S}i.toValuesTree=v;function y(g,m,S,h){const o=m.split("."),a=o.pop();let n=g;for(let r=0;r<o.length;r++){let e=o[r],t=n[e];switch(typeof t){case"undefined":t=n[e]=Object.create(null);break;case"object":break;default:h(`Ignoring ${m} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[a]=S}catch(r){h(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(n)}`)}else h(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=y;function T(g,m){const S=m.split(".");c(g,S)}i.removeFromValueTree=T;function c(g,m){const S=m.shift();if(m.length===0){delete g[S];return}if(Object.keys(g).indexOf(S)!==-1){const h=g[S];typeof h=="object"&&!Array.isArray(h)&&(c(h,m),Object.keys(h).length===0&&delete g[S])}}function E(g,m,S){function h(n,r){let e=n;for(const t of r){if(typeof e!="object"||e===null)return;e=e[t]}return e}const o=m.split("."),a=h(g,o);return typeof a=="undefined"?S:a}i.getConfigurationValue=E;function f(g,m,S){Object.keys(m).forEach(h=>{h!=="__proto__"&&(h in g?C.isObject(g[h])&&C.isObject(m[h])?f(g[h],m[h],S):S&&(g[h]=m[h]):g[h]=m[h])})}i.merge=f;function d(g,m,S){const h=g.inspect(m),o=g.inspect(S);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:h.defaultValue}i.getMigratedSettingValue=d}),define(J[52],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,C.createDecorator)("downloadService")}),define(J[20],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,C.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,C.refineServiceDecorator)(i.IEnvironmentService)}),define(J[22],Q([0,1,10,76,14]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var D;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(D=i.TargetPlatform||(i.TargetPlatform={}));function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=R;function w(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(h,o){switch(h){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function v(h,o){return o==="web"&&!h.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function y(h,o,a){return v(o,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a?!0:T(a).includes(h)}i.isTargetPlatformCompatible=y;function T(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=T;function c(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}i.isIExtensionIdentifier=c;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var f;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(f=i.SortOrder||(i.SortOrder={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d=i.StatisticType||(i.StatisticType={}));var g;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(g=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.UnsupportedPreRelease="UnsupportedPreRelease",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(o,a){super(o);this.code=a,this.name=a}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,I.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,I.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Q([0,1,40,6,74,24,27,7,12,31,71,133,3]),function(x,i,C,I,b,D,R,w,l,v,y,T,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let f;async function d(m,S,h){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(h)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(h)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=c.Promises.withAsyncBody(async(o,a)=>{const n=new D.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),a(new Error((0,b.localize)(0,null)))},E);try{o(await g(m,n.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,b.localize)(1,null,(0,R.toErrorMessage)(e)))):o({})}finally{clearTimeout(r),n.dispose()}})),f)}i.getResolvedShellEnv=d;async function g(m,S){const h=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",o);const a=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const e=await(0,y.getSystemShell)(l.OS,r);return m.trace("getUnixShellEnvironment#shell",e),new Promise((t,s)=>{if(S.isCancellationRequested)return s((0,w.canceled)());const u=(0,I.basename)(e);let p,L;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(p=`& '${process.execPath}' ${P} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(p=`'${process.execPath}' ${P} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"?L=["-ic"]:L=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),p);const O=(0,C.spawn)(e,[...L,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(O.kill(),s((0,w.canceled)()))),O.on("error",ee=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(ee)),s(ee)});const N=[];O.stdout.on("data",ee=>N.push(ee));const G=[];O.stderr.on("data",ee=>G.push(ee)),O.on("close",(ee,me)=>{const ae=Buffer.concat(N).toString("utf8");m.trace("getUnixShellEnvironment#raw",ae);const te=Buffer.concat(G).toString("utf8");if(te.trim()&&m.trace("getUnixShellEnvironment#stderr",te),ee||me)return s(new Error((0,b.localize)(2,null,ee,me)));const de=n.exec(ae),W=de?de[1]:"{}";try{const $=JSON.parse(W);h?$.ELECTRON_RUN_AS_NODE=h:delete $.ELECTRON_RUN_AS_NODE,o?$.ELECTRON_NO_ATTACH_CONSOLE=o:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",$),t($)}catch($){m.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)($)),s($)}})})}}),define(J[53],Q([0,1,17,7,83,16]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function R(y,T,c,E,f,d){let g;try{await w(y,T,c,E,f,d)}catch(m){g=m}finally{g&&f.errorTransformer&&(g=f.errorTransformer(g)),typeof g!="undefined"&&c.error(g),c.end()}}i.readFileIntoStream=R;async function w(y,T,c,E,f,d){l(d);const g=await y.open(T,{create:!1});try{l(d);let m=0,S=0,h=f&&typeof f.length=="number"?f.length:void 0,o=C.VSBuffer.alloc(Math.min(f.bufferSize,typeof h=="number"?h:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,n=0;do S=await y.read(g,a,o.buffer,n,o.byteLength-n),a+=S,n+=S,m+=S,typeof h=="number"&&(h-=S),n===o.byteLength&&(await c.write(E(o)),o=C.VSBuffer.alloc(Math.min(f.bufferSize,typeof h=="number"?h:f.bufferSize)),n=0);while(S>0&&(typeof h!="number"||h>0)&&l(d)&&v(m,f));if(n>0){let r=n;typeof h=="number"&&(r=Math.min(n,h)),c.write(E(o.slice(0,r)))}}catch(m){throw(0,D.ensureFileSystemProviderError)(m)}finally{await y.close(g)}}function l(y){if(y.isCancellationRequested)throw(0,I.canceled)();return!0}function v(y,T){if(T?.limits){if(typeof T.limits.memory=="number"&&y>T.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&y>T.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[34],Q([0,1,2,12,9,16]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.WatcherService=i.AbstractWatcherService=void 0;class R extends C.Disposable{constructor(c,E,f){super();this.onFileChanges=c,this.onLogMessage=E,this.verboseLogging=f,this.serviceDisposables=this._register(new C.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new C.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),c.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),c.add(this.service.onDidError(E=>this.onError(E)))}onError(c){this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}i.AbstractWatcherService=R,R.MAX_RESTARTS=5;class w extends C.Disposable{}i.WatcherService=w;function l(T){return T.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}i.toFileChanges=l;function v(T){const c=new y;for(const E of T)c.processEvent(E);return c.coalesce()}i.coalesceEvents=v;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return I.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const E=this.mapPathToChange.get(this.toKey(c));let f=!1;if(E){const d=E.type,g=c.type;E.path!==c.path&&c.type===2?f=!0:d===1&&g===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(E)):d===2&&g===1?E.type=0:d===1&&g===0||(E.type=g)}else f=!0;f&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],E=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(c.push(f),!1):!0).sort((f,d)=>f.path.length-d.path.length).filter(f=>E.some(d=>(0,D.isParent)(f.path,d,!I.isLinux))?!1:(E.push(f.path),!0)).concat(c)}}}),define(J[94],Q([0,1,3,2,6,64,13,134,34]),function(x,i,C,I,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class v extends I.Disposable{constructor(T,c,E,f){super();this.path=T,this.onDidFilesChange=c,this.onLogMessage=E,this.verboseLogging=f,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(T){this.verboseLogging=T}async startWatching(){try{const{stat:T,symbolicLink:c}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(c)try{E=await(0,D.realpath)(E)}catch(f){if(this.onError(f),c.dangling)return}T.isDirectory()?this._register((0,w.watchFolder)(E,(f,d)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(d))})},f=>this.onError(f))):this._register((0,w.watchFile)(E,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(T){T.code!=="ENOENT"&&this.onError(T)}}onFileChange(T){this.fileChangesBuffer.push(T),this.verboseLogging&&this.onVerbose(`${T.type===1?"[ADDED]":T.type===2?"[DELETED]":"[CHANGED]"} ${T.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,l.coalesceEvents)(c);if(this.verboseLogging)for(const f of E)this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(T){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${T}`})}onVerbose(T){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${T}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=v}),define(J[95],Q([0,1,10,39,50,34]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends D.WatcherService{constructor(l,v,y){super();this.onDidFilesChange=l,this.onLogMessage=v,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(C.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=R}),define(J[96],Q([0,1,10,39,50,34]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends D.AbstractWatcherService{constructor(l,v,y){super(l,v,y);this.init()}createService(l){const v=l.add(new b.Client(C.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(v.onDidProcessExit(({code:y,signal:T})=>this.onError(`terminated by itself with code ${y}, signal: ${T}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(v.getChannel("watcher")))}}i.FileWatcher=R}),define(J[54],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class C{constructor(...b){this._entries=new Map;for(let[D,R]of b)this.set(D,R)}set(b,D){const R=this._entries.get(b);return this._entries.set(b,D),R}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=C}),define(J[97],Q([0,1,3,7,41,92,14,54]),function(x,i,C,I,b,D,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class v extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class y{constructor(f=new w.ServiceCollection,d=!1,g){this._activeInstantiations=new Set,this._services=f,this._strict=d,this._parent=g,this._services.set(R.IInstantiationService,this)}createChild(f){return new y(f,this._strict,this)}invokeFunction(f,...d){let g=c.traceInvocation(f),m=!1;try{return f({get:h=>{if(m)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(h,g);if(!o)throw new Error(`[invokeFunction] unknown service '${h}'`);return o}},...d)}finally{m=!0,g.stop()}}createInstance(f,...d){let g,m;return f instanceof b.SyncDescriptor?(g=c.traceCreation(f.ctor),m=this._createInstance(f.ctor,f.staticArguments.concat(d),g)):(g=c.traceCreation(f),m=this._createInstance(f,d,g)),g.stop(),m}_createInstance(f,d=[],g){let m=R._util.getServiceDependencies(f).sort((o,a)=>o.index-a.index),S=[];for(const o of m){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${o.id}.`);S.push(a)}let h=m.length>0?m[0].index:d.length;if(d.length!==h){console.warn(`[createInstance] First service dependency of ${f.name} at position ${h+1} conflicts with ${d.length} static arguments`);let o=h-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,h)}return new f(...[...d,...S])}_setServiceInstance(f,d){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,d);else if(this._parent)this._parent._setServiceInstance(f,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let d=this._services.get(f);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):d}_getOrCreateServiceInstance(f,d){let g=this._getServiceInstanceOrDescriptor(f);return g instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,g,d.branch(f,!0)):(d.branch(f,!1),g)}_safeCreateAndCacheServiceInstance(f,d,g){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,d,g)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,d,g){const m=new D.Graph(o=>o.id.toString());let S=0;const h=[{id:f,desc:d,_trace:g}];for(;h.length;){const o=h.pop();if(m.lookupOrInsertNode(o),S++>1e3)throw new v(m);for(let a of R._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`),n instanceof b.SyncDescriptor){const r={id:a.id,desc:n,_trace:o._trace.branch(a.id,!0)};m.insertEdge(o,r),h.push(r)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new v(m);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,d,g=[],m,S){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(d,g,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,d,g,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(f,d=[],g,m){if(g){const S=new C.IdleValue(()=>this._createInstance(f,d,m));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let a=S.value,n=a[o];return typeof n!="function"||(n=n.bind(a),h[o]=n),n},set(h,o,a){return S.value[o]=a,!0}})}else return this._createInstance(f,d,m)}}i.InstantiationService=y;var T;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(T||(T={}));class c{constructor(f,d){this.type=f,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return l?new c(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(f){return l?new c(0,f.name):c._None}branch(f,d){let g=new c(2,f.toString());return this._dep.push([f,d,g]),g}stop(){let f=Date.now()-this._start;c._totals+=f;let d=!1;function g(S,h){let o=[],a=new Array(S+1).join("	");for(const[n,r,e]of h._dep)if(r&&e){d=!0,o.push(`${a}CREATES -> ${n}`);let t=g(S+1,e);t&&o.push(t)}else o.push(`${a}uses -> ${n}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(f>2||d)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(J[55],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,C.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=I}),define(J[15],Q([0,1,27,11,2,12,14]),function(x,i,C,I,b,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,R.createDecorator)("logService"),i.ILoggerService=(0,R.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function v(r,e,t){switch(e){case l.Trace:r.trace(t);break;case l.Debug:r.debug(t);break;case l.Info:r.info(t);break;case l.Warning:r.warn(t);break;case l.Error:r.error(t);break;case l.Critical:r.critical(t);break;default:throw new Error("Invalid log level")}}i.log=v;function y(r){let e="";for(let t=0;t<r.length;t++){let s=r[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}e+=(t>0?" ":"")+s}return e}i.format=y;class T extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=T;class c extends T{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...t){this.checkLogLevel(l.Trace)&&this.log(l.Trace,y([e,...t]))}debug(e,...t){this.checkLogLevel(l.Debug)&&this.log(l.Debug,y([e,...t]))}info(e,...t){this.checkLogLevel(l.Info)&&this.log(l.Info,y([e,...t]))}warn(e,...t){this.checkLogLevel(l.Warning)&&this.log(l.Warning,y([e,...t]))}error(e,...t){if(this.checkLogLevel(l.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(l.Error,y(s))}else this.log(l.Error,y([e,...t]))}critical(e,...t){this.checkLogLevel(l.Critical)&&this.log(l.Critical,y([e,...t]))}flush(){}}i.AbstractMessageLogger=c;class E extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...t){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}debug(e,...t){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}info(e,...t){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}warn(e,...t){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...t):console.warn(`[main ${w()}]`,e,...t))}error(e,...t){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}critical(e,...t){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class f extends T{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...t){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}}i.ConsoleLogger=f;class d extends T{constructor(e,t=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(t)}trace(e,...t){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...t])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=d;class g extends T{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const s of this.logServices)s.trace(e,...t)}debug(e,...t){for(const s of this.logServices)s.debug(e,...t)}info(e,...t){for(const s of this.logServices)s.info(e,...t)}warn(e,...t){for(const s of this.logServices)s.warn(e,...t)}error(e,...t){for(const s of this.logServices)s.error(e,...t)}critical(e,...t){for(const s of this.logServices)s.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=g;class m extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}}i.LogService=m;class S extends b.Disposable{constructor(e,t){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,t){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,t?.always?l.Trace:this.logLevel,t),this.loggers.set(e.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=S;class h{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}}i.NullLogService=h;function o(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=a(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=o;function a(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function n(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=n});var se=this&&this.__param||function(x,i){return function(C,I){i(C,I,x)}};define(J[98],Q([0,1,40,3,27,11,2,10,6,13,20,15]),function(x,i,C,I,b,D,R,w,l,v,y,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let c=class extends R.Disposable{constructor(f,d){super();this.environmentService=f,this.logService=d,this.processesLimiter=new I.Limiter(5)}async postUninstall(f){const d=this.parseScript(f,"uninstall");return d&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${g}`)))),v.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(f,d){const g=`vscode:${d}`;if(f.location.scheme===w.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[g]=="string"){const m=f.manifest.scripts[g].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${g} should be a node script`),null):{script:(0,l.join)(f.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(f,d,g,m,S){return new Promise((h,o)=>{const a=this.start(f,d,g,S);let n;const r=e=>{n&&(clearTimeout(n),n=null),e?o(e):h(void 0)};a.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,t)=>{r(e?`post-${d} process exited with code ${e}`:void 0)}),m&&(n=setTimeout(()=>{n=null,a.kill(),o("timed out")},5e3))})}start(f,d,g,m){const S={silent:!0,execArgv:void 0},h=(0,C.fork)(f,[`--type=extension-post-${d}`,...g],S);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=D.Event.fromNodeEventEmitter(h.stdout,"data"),a=D.Event.fromNodeEventEmitter(h.stderr,"data");o(e=>this.logService.info(m.identifier.id,m.manifest.version,`post-${d}`,e)),a(e=>this.logService.error(m.identifier.id,m.manifest.version,`post-${d}`,e));const n=D.Event.any(D.Event.map(o,e=>({data:`%c${e}`,format:[""]})),D.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return D.Event.debounce(n,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(m.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),h}getExtensionStoragePath(f){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};c=pe([se(0,y.IEnvironmentService),se(1,T.ILogService)],c),i.ExtensionsLifecycle=c}),define(J[99],Q([0,1,19,3,7,11,2,6,34,15]),function(x,i,C,I,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends R.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(c,E){return E.recursive?this.watchRecursive(c,E):this.watchNonRecursive(c)}watchRecursive(c,E){const f={path:this.toFilePath(c),excludes:E.excludes},d=(0,C.insert)(this.recursiveFoldersToWatch,f);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,E){return c.watch(E)}watchNonRecursive(c){const E=this.createNonRecursiveWatcher(this.toFilePath(c),d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===v.LogLevel.Trace),f=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,R.combinedDisposable)(E,f)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,w.normalize)(c.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(J[100],Q([0,1,19,3,17,24,11,135,2,101,10,102,18,38,82,16,53,15]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!0)))),this.watchedResources=v.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const n=new l.DisposableStore;return n.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&n.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,l.dispose)(n)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(n){a.push(n)}}),!this.provider.has(o)&&await I.Promises.settled(a)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,a){const n=this.provider.get(o.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new d.FileOperationError((0,f.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,f.localize)(1,null,o.toString()),n}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a)||(0,d.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(n){throw(0,d.toFileSystemProviderErrorCode)(n)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,f.localize)(2,null,this.resourceForError(o)),1):(0,d.ensureFileSystemProviderError)(n)}}async doResolveFile(o,a){const n=await this.withProvider(o),r=this.isPathCaseSensitive(n),e=a?.resolveTo,t=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,u=await n.stat(o);let p;return this.toFileStat(n,o,u,void 0,!!s,(L,P)=>(p||(p=v.TernarySearchTree.forUris(()=>!r),p.set(o,!0),e&&p.fill(!0,e)),p.get(L.resource)||p.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&t?P===1:!1))}async toFileStat(o,a,n,r,e,t){const{providerExtUri:s}=this.getExtUri(o),u={resource:a,name:s.basename(a),isFile:(n.type&d.FileType.File)!=0,isDirectory:(n.type&d.FileType.Directory)!=0,isSymbolicLink:(n.type&d.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&d.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,d.etag)({mtime:n.mtime,size:n.size})};if(u.isDirectory&&t(u,r)){try{const p=await o.readdir(a),L=await I.Promises.settled(p.map(async([P,O])=>{try{const N=s.joinPath(a,P),G=e?await o.stat(N):{type:O};return await this.toFileStat(o,N,G,p.length,e,t)}catch(N){return this.logService.trace(N),null}}));u.children=(0,C.coalesce)(L)}catch(p){this.logService.trace(p),u.children=[]}return u}return u}async resolveAll(o){return I.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(n){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(n){return n}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new d.FileOperationError((0,f.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=b.VSBuffer.fromString(""),n){await this.doValidateCreateFile(o,n);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,r)),r}async writeFile(o,a,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:e}=this.getExtUri(r);try{await this.validateWriteFile(r,o,n)||await this.mkdirp(r,e.dirname(o));let s;if((0,d.hasReadWriteCapability)(r)&&!(a instanceof b.VSBuffer))if((0,E.isReadableStream)(a)){const u=await(0,E.peekStream)(a,3);u.ended?s=b.VSBuffer.concat(u.buffer):s=u}else s=(0,E.peekReadable)(a,u=>b.VSBuffer.concat(u),3);else s=a;!(0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)&&s instanceof b.VSBuffer?await this.doWriteUnbuffered(r,o,n,s):await this.doWriteBuffered(r,o,n,s instanceof b.VSBuffer?(0,b.bufferToReadable)(s):s)}catch(t){throw new d.FileOperationError((0,f.localize)(4,null,this.resourceForError(o),(0,d.ensureFileSystemProviderError)(t).toString()),(0,d.toFileOperationResult)(t),n)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(a)));let e;try{e=await o.stat(a)}catch(t){return}if((e.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,f.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==d.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,d.etag)({mtime:n.mtime,size:e.size}))throw new d.FileOperationError((0,f.localize)(7,null),3,n);return e}async readFile(o,a){const n=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(n,o,a):this.doReadFile(n,o,a)}async doReadFileAtomic(o,a,n){return new Promise((r,e)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(o,a,n);r(t)}catch(t){e(t)}})})}async doReadFile(o,a,n){const r=await this.doReadFileStream(o,a,{...n,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(o,a){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,a)}async doReadFileStream(o,a,n){const r=new D.CancellationTokenSource,e=this.validateReadFile(a,n).then(s=>s,s=>{throw r.cancel(),s});let t;try{return typeof n?.etag=="string"&&n.etag!==d.ETAG_DISABLED&&await e,!((0,d.hasOpenReadWriteCloseCapability)(o)||(0,d.hasFileReadStreamCapability)(o))||(0,d.hasReadWriteCapability)(o)&&n?.preferUnbuffered?t=this.readFileUnbuffered(o,a,n):(0,d.hasFileReadStreamCapability)(o)?t=this.readFileStreamed(o,a,r.token,n):t=this.readFileBuffered(o,a,r.token,n),{...await e,value:t}}catch(s){t&&await(0,E.consumeStream)(t);const u=(0,f.localize)(8,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(s).toString());throw s instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(u,s.stat,n):new d.FileOperationError(u,(0,d.toFileOperationResult)(s),n)}}readFileStreamed(o,a,n,r=Object.create(null)){const e=o.readFileStream(a,r,n);return(0,E.transform)(e,{data:t=>t instanceof b.VSBuffer?t:b.VSBuffer.wrap(t),error:t=>new d.FileOperationError((0,f.localize)(9,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(t).toString()),(0,d.toFileOperationResult)(t),r)},t=>b.VSBuffer.concat(t))}readFileBuffered(o,a,n,r=Object.create(null)){const e=(0,b.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,e,t=>t,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new d.FileOperationError((0,f.localize)(10,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(t).toString()),(0,d.toFileOperationResult)(t),r)},n),e}readFileUnbuffered(o,a,n){const r=(0,E.newWriteableStream)(e=>b.VSBuffer.concat(e));return(async()=>{try{let e=await o.readFile(a);typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),r.end(b.VSBuffer.wrap(e))}catch(e){r.error(e),r.end()}})(),r}async validateReadFile(o,a){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new d.FileOperationError((0,f.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&a.etag===n.etag)throw new d.NotModifiedSinceFileOperationError((0,f.localize)(12,null),n,a);return this.validateReadFileLimits(o,n.size,a),n}validateReadFileLimits(o,a,n){if(n?.limits){let r;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&a>n.limits.size&&(r=7),typeof r=="number")throw new d.FileOperationError((0,f.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,n){return this.doCanMoveCopy(o,a,"move",n)}async canCopy(o,a,n){return this.doCanMoveCopy(o,a,"copy",n)}async doCanMoveCopy(o,a,n,r){if(o.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,o,t,a,n,r)}catch(e){return e}return!0}async move(o,a,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(r,o,e,a,"move",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,t==="move"?2:3,s)),s}async copy(o,a,n){const r=await this.withReadProvider(o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(r,o,e,a,"copy",!!n),s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,t==="copy"?3:2,s)),s}async doMoveCopy(o,a,n,r,e,t){if(a.toString()===r.toString())return e;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,a,n,r,e,t);if(s&&!u&&t&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),e==="copy"){if(o===n&&(0,d.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:t});else{const p=await this.resolve(a);p.isDirectory?await this.doCopyFolder(o,p,n,r):await this.doCopyFile(o,a,n,r)}return e}else return o===n?(await o.rename(a,r,{overwrite:t}),e):(await this.doMoveCopy(o,a,n,r,"copy",t),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,n,r){if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(o,a,n,r);if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(o,a,n,r);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(o,a,n,r);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasReadWriteCapability)(n))return this.doPipeUnbuffered(o,a,n,r)}async doCopyFolder(o,a,n,r){await n.mkdir(r),Array.isArray(a.children)&&await I.Promises.settled(a.children.map(async e=>{const t=this.getExtUri(n).providerExtUri.joinPath(r,e.name);return e.isDirectory?this.doCopyFolder(o,await this.resolve(e.resource),n,t):this.doCopyFile(o,e.resource,n,t)}))}async doValidateMoveCopy(o,a,n,r,e,t){let s=!1;if(o===n){const{providerExtUri:p,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(s=p.isEqual(a,r)),s&&e==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!s&&p.isEqualOrParent(r,a))throw new Error((0,f.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const u=await this.exists(r);if(u&&!s){if(!t)throw new d.FileOperationError((0,f.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===n){const{providerExtUri:p}=this.getExtUri(o);if(p.isEqualOrParent(a,r))throw new Error((0,f.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const n=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,n)),n}async mkdirp(o,a){const n=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&d.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,d.toFileSystemProviderErrorCode)(e)!==d.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(r.basename(a)),a=r.dirname(a)}for(let e=n.length-1;e>=0;e--){a=r.joinPath(a,n[e]);try{await o.mkdir(a)}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(n){return n}return!0}async doValidateDelete(o,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(o)));let e;try{e=await n.stat(o)}catch(s){}if(e)this.throwIfFileIsReadonly(o,e);else throw new d.FileOperationError((0,f.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(o)))}return n}async del(o,a){const n=await this.doValidateDelete(o,a),r=!!a?.useTrash,e=!!a?.recursive;await n.delete(o,{recursive:e,useTrash:r}),this._onDidRunOperation.fire(new d.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let n,r;{for(const e of o)this.watchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(r||(r=[]),r.push(e));n&&this._onDidFilesChange.fire(new d.FileChangesEvent(n,!a))}if(r){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let r=!1,e=()=>{r=!0};return n.add((0,l.toDisposable)(()=>e())),this.doWatch(o,a).then(t=>{r?(0,l.dispose)(t):e=()=>(0,l.dispose)(t)},t=>this.logService.error(t)),a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),n.add((0,l.toDisposable)(()=>{const t=this.watchedResources.get(o);typeof t=="number"&&(t<=1?this.watchedResources.delete(o):this.watchedResources.set(o,t-1))}))),n}async doWatch(o,a){const n=await this.withProvider(o),r=this.toWatchKey(n,o,a);let e=this.activeWatchers.get(r);return e||(e={count:0,disposable:n.watch(o,a)},this.activeWatchers.set(r,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(r)))})}toWatchKey(o,a,n){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,n,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const e=await o.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,e,r):await this.doWriteReadableBufferedQueued(o,e,r)}catch(t){throw(0,d.ensureFileSystemProviderError)(t)}finally{await o.close(e)}})}async doWriteStreamBufferedQueued(o,a,n){let r=0,e;if((0,E.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=b.VSBuffer.concat(n.buffer);await this.doWriteBuffer(o,a,t,t.byteLength,r,0),r+=t.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((t,s)=>{(0,E.listenStream)(e,{onData:async u=>{e.pause();try{await this.doWriteBuffer(o,a,u,u.byteLength,r,0)}catch(p){return s(p)}r+=u.byteLength,setTimeout(()=>e.resume())},onError:u=>s(u),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(o,a,n){let r=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(o,a,e,e.byteLength,r,0),r+=e.byteLength}async doWriteBuffer(o,a,n,r,e,t){let s=0;for(;s<r;)s+=await o.write(a,e+s,n.buffer,t+s,r-s)}async doWriteUnbuffered(o,a,n,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,n,r))}async doWriteUnbufferedQueued(o,a,n,r){let e;r instanceof b.VSBuffer?e=r:(0,E.isReadableStream)(r)?e=await(0,b.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?e=await(0,b.bufferedStreamToBuffer)(r):e=(0,b.readableToBuffer)(r),await o.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,n,r))}async doPipeBufferedQueued(o,a,n,r){let e,t;try{e=await o.open(a,{create:!1}),t=await n.open(r,{create:!0,unlock:!1});const s=b.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,p=0,L=0;do L=await o.read(e,u,s.buffer,p,s.byteLength-p),await this.doWriteBuffer(n,t,s,L,u,p),u+=L,p+=L,p===s.byteLength&&(p=0);while(L>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await I.Promises.settled([typeof e=="number"?o.close(e):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,n,r))}async doPipeUnbufferedQueued(o,a,n,r){return n.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,n,r){return this.writeQueue.queueFor(r,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,n,r))}async doPipeUnbufferedToBufferedQueued(o,a,n,r){const e=await n.open(r,{create:!0,unlock:!1});try{const t=await o.readFile(a);await this.doWriteBuffer(n,e,b.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,d.ensureFileSystemProviderError)(t)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(o,a,n,r){const e=await(0,b.streamToBuffer)(this.readFileBuffered(o,a,D.CancellationToken.None));await this.doWriteUnbuffered(n,r,void 0,e)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new d.FileOperationError((0,f.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,f.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=pe([se(0,m.ILogService)],S),i.FileService=S}),define(J[103],Q([0,1,48,136,3,17,11,47,6,12,18,38,13,84,16,53,94,95,96,99,27]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m,S,h,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.toErrorMessage)(n)}`)}})();class a extends h.AbstractDiskFileSystemProvider{constructor(r,e){super(r);this.options=e,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,v.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:e,symbolicLink:t}=await c.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(e,t),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(r){try{const e=await c.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),t=[];return await Promise.all(e.map(async s=>{try{let u;s.isSymbolicLink()?u=(await this.stat((0,y.joinPath)(r,s.name))).type:u=this.toType(s),t.push([s.name,u])}catch(u){this.logService.trace(u)}})),t}catch(e){throw this.toFileSystemProviderError(e)}}toType(r,e){let t;return e?.dangling?t=f.FileType.Unknown:r.isFile()?t=f.FileType.File:r.isDirectory()?t=f.FileType.Directory:t=f.FileType.Unknown,e&&(t|=f.FileType.SymbolicLink),t}async readFile(r){try{const e=this.toFilePath(r);return await c.Promises.readFile(e)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(r,e,t){const s=(0,T.newWriteableStream)(u=>D.VSBuffer.concat(u.map(p=>D.VSBuffer.wrap(p))).buffer);return(0,d.readFileIntoStream)(this,r,s,u=>u.buffer,{...e,bufferSize:256*1024},t),s}async writeFile(r,e,t){let s;try{const u=this.toFilePath(r);if(!t.create||!t.overwrite){if(await c.Promises.exists(u)){if(!t.overwrite)throw(0,f.createFileSystemProviderError)((0,E.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,f.createFileSystemProviderError)((0,E.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:t.unlock}),await this.write(s,0,e,0,e.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(r,u)}finally{typeof s=="number"&&await this.close(s)}}async open(r,e){try{const t=this.toFilePath(r);if((0,f.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:p}=await c.SymlinkSupport.stat(t);p.mode&128||await c.Promises.chmod(t,p.mode|128)}catch(p){this.logService.trace(p)}let s;if((0,f.isFileOpenForWriteOptions)(e)){if(v.isWindows)try{await c.Promises.truncate(t,0),s="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}s||(s="w")}else s="r";const u=await c.Promises.open(t,s);return this.mapHandleToPos.set(u,0),(0,f.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(u,r),u}catch(t){throw(0,f.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(r,t):this.toFileSystemProviderError(t)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await c.Promises.fdatasync(r)}catch(e){this.canFlush=!1,this.logService.error(e)}return await c.Promises.close(r)}catch(e){throw this.toFileSystemProviderError(e)}}async read(r,e,t,s,u){const p=this.normalizePos(r,e);let L=null;try{const P=await c.Promises.read(r,t,s,u,p);return typeof P=="number"?L=P:L=P.bytesRead,L}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(r,p,L)}}normalizePos(r,e){return e===this.mapHandleToPos.get(r)?null:e}updatePos(r,e,t){const s=this.mapHandleToPos.get(r);typeof s=="number"&&(typeof e=="number"||(typeof t=="number"?this.mapHandleToPos.set(r,s+t):this.mapHandleToPos.delete(r)))}async write(r,e,t,s,u){return(0,b.retry)(()=>this.doWrite(r,e,t,s,u),100,3)}async doWrite(r,e,t,s,u){const p=this.normalizePos(r,e);let L=null;try{const P=await c.Promises.write(r,t,s,u,p);return typeof P=="number"?L=P:L=P.bytesWritten,L}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),P)}finally{this.updatePos(r,p,L)}}async mkdir(r){try{await c.Promises.mkdir(this.toFilePath(r))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(r,e){try{const t=this.toFilePath(r);await this.doDelete(t,e)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(r,e){e.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}async rename(r,e,t){const s=this.toFilePath(r),u=this.toFilePath(e);if(s!==u)try{await this.validateTargetDeleted(r,e,"move",t.overwrite),await c.Promises.move(s,u)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(2,null,(0,l.basename)(s),(0,l.basename)((0,l.dirname)(u)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,e,t){const s=this.toFilePath(r),u=this.toFilePath(e);if(s!==u)try{await this.validateTargetDeleted(r,e,"copy",t.overwrite),await c.Promises.copy(s,u,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,E.localize)(3,null,(0,l.basename)(s),(0,l.basename)((0,l.dirname)(u)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,e,t,s){const u=this.toFilePath(r),p=this.toFilePath(e);let L=!1;if(!!(this.capabilities&1024)||(L=(0,w.isEqual)(u,p,!0)),L&&t==="copy")throw(0,f.createFileSystemProviderError)((0,E.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!L&&await c.Promises.exists(p)){if(!s)throw(0,f.createFileSystemProviderError)((0,E.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(e,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,e,t){let s,u=!1;return this.options?.watcher?.usePolling?u=!1:u=this.options?.legacyWatcher==="on",u?s=m.FileWatcher:s=S.FileWatcher,new s(p=>r(p),p=>e(p),t,this.options?.watcher)}doWatch(r,e){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of e)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of e)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,e)}createNonRecursiveWatcher(r,e,t,s){return new g.FileWatcher(r,u=>e(u),u=>t(u),s)}toFileSystemProviderError(r){if(r instanceof f.FileSystemProviderError)return r;let e;switch(r.code){case"ENOENT":e=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":e=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":e=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":e=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":e=f.FileSystemProviderErrorCode.NoPermissions;break;default:e=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(r,e)}async toFileSystemProviderWriteError(r,e){let t=this.toFileSystemProviderError(e);if(r&&t.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await c.SymlinkSupport.stat(this.toFilePath(r));s.mode&128||(t=(0,f.createFileSystemProviderError)(e,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return t}}i.DiskFileSystemProvider=a}),define(J[104],Q([0,1,16,15]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(w,l,v,y,T){try{const c=await new Promise((f,d)=>{x(["spdlog"],f,d)});c.setFlushOn(I.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(w,l,v,y);return T&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function D(w,l,v){switch(l){case I.LogLevel.Trace:w.trace(v);break;case I.LogLevel.Debug:w.debug(v);break;case I.LogLevel.Info:w.info(v);break;case I.LogLevel.Warning:w.warn(v);break;case I.LogLevel.Error:w.error(v);break;case I.LogLevel.Critical:w.critical(v);break;default:throw new Error("Invalid log level")}}class R extends I.AbstractMessageLogger{constructor(l,v,y,T,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(l,v,y,T),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(l,v,y,T){const c=y?6:1,E=30/c*C.ByteSize.MB,f=await b(l,v,E,c,T);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:d,message:g}of this.buffer)D(this._logger,d,g);this.buffer=[]}}log(l,v){this._logger?D(this._logger,l,v):this.getLevel()<=l&&this.buffer.push({level:l,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=R}),define(J[32],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,C.createDecorator)("productService")}),define(J[29],Q([0,1,56,8]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(R,w){C.ok(I.isString(R)),C.ok(I.isObject(w)),C.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,w)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}i.Registry=new b}),define(J[105],Q([0,1,11,29]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,v){this.schemasById[b(l)]=v,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new D;I.Registry.add(i.Extensions.JSONContribution,R)}),define(J[35],Q([0,1,19,11,8,73,105,29]),function(x,i,C,I,b,D,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var v;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=w.Registry.as(R.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const r=this.doRegisterConfigurations(a,n);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const r=[];r.push(...this.doDeregisterConfigurations(n)),r.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(r)})}registerDefaultConfigurations(a){const n=[],r=[];for(const{overrides:e,source:t}of a)for(const s in e)if(n.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const u={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:u});const p={type:"object",default:u,description:D.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:b.isString(t)?void 0:t};r.push(...f(s)),this.configurationProperties[s]=p,this.defaultLanguageConfigurationOverridesNode.properties[s]=p}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:t});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:r,source:e}of a)for(const t in r){const s=this.configurationDefaultsOverrides.get(t),u=b.isString(e)?e:e?.id,p=b.isString(s?.source)?s?.source:s?.source?.id;if(u===p)if(n.push(t),this.configurationDefaultsOverrides.delete(t),i.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const L=this.configurationProperties[t];L&&(this.updatePropertyDefaultValue(t,L),this.updateSchema(t,L))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const r=[];return a.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(a){const n=[],r=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(t=>r(t))};for(const e of a){r(e);const t=this.configurationContributors.indexOf(e);t!==-1&&this.configurationContributors.splice(t,1)}return n}validateAndRegisterProperties(a,n=!0,r,e,t=3){t=b.isUndefinedOrNull(a.scope)?t:a.scope;let s=[],u=a.properties;if(u)for(let L in u){if(n&&S(L)){delete u[L];continue}const P=u[L];if(P.source=r,P.defaultDefaultValue=u[L].default,this.updatePropertyDefaultValue(L,P),i.OVERRIDE_PROPERTY_REGEX.test(L)?P.scope=void 0:(P.scope=b.isUndefinedOrNull(P.scope)?t:P.scope,P.restricted=b.isUndefinedOrNull(P.restricted)?!!e?.includes(L):P.restricted),u[L].hasOwnProperty("included")&&!u[L].included){this.excludedConfigurationProperties[L]=u[L],delete u[L];continue}else this.configurationProperties[L]=u[L];!u[L].deprecationMessage&&u[L].markdownDeprecationMessage&&(u[L].deprecationMessage=u[L].markdownDeprecationMessage),s.push(L)}let p=a.allOf;if(p)for(let L of p)s.push(...this.validateAndRegisterProperties(L,n,r,e,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let t=r.allOf;t&&t.forEach(n)};n(a)}updateSchema(a,n){switch(i.allSettings.properties[a]=n,n.scope){case 1:i.applicationSettings.properties[a]=n;break;case 2:i.machineSettings.properties[a]=n;break;case 6:i.machineOverridableSettings.properties[a]=n;break;case 3:i.windowSettings.properties[a]=n;break;case 4:i.resourceSettings.properties[a]=n;break;case 5:i.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete i.allSettings.properties[a],n.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),i.allSettings.properties[n]=r,i.applicationSettings.properties[n]=r,i.machineSettings.properties[n]=r,i.machineOverridableSettings.properties[n]=r,i.windowSettings.properties[n]=r,i.resourceSettings.properties[n]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const r=this.configurationDefaultsOverrides.get(a);let e=r?.value,t=r?.source;b.isUndefined(e)&&(e=n.defaultDefaultValue,t=void 0),b.isUndefined(e)&&(e=g(n.type)),n.default=e,n.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function f(o){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(o)){let n=E.exec(o);for(;n?.length;){const r=n[1].trim();r&&a.push(r),n=E.exec(o)}}return(0,C.distinct)(a)}i.overrideIdentifiersFromKey=f;function d(o){return o.reduce((a,n)=>`${a}[${n}]`,"")}i.keyFromOverrideIdentifiers=d;function g(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=g;const m=new T;w.Registry.add(i.Extensions.Configuration,m);function S(o){return o.trim()?i.OVERRIDE_PROPERTY_REGEX.test(o)?D.localize(7,null,o):m.getConfigurationProperties()[o]!==void 0?D.localize(8,null,o):null:D.localize(6,null)}i.validateProperty=S;function h(){const o=[],a=m.getConfigurationProperties();for(const n of Object.keys(a))o.push([n,a[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}i.getScopes=h}),define(J[106],Q([0,1,19,11,57,2,101,21,8,9,25,35,29]),function(x,i,C,I,b,D,R,w,l,v,y,T,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},t=[],s=[]){this._contents=e,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,t){const s=this.getContentsForOverrideIdentifer(t);return s?e?(0,y.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const t=[];for(const s of this.overrides)s.identifiers.includes(e)&&t.push(...s.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const e=[];for(const t of this.overrides)e.push(...t.identifiers);return C.distinct(e)}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...e){const t=w.deepClone(this.contents),s=w.deepClone(this.overrides),u=[...this.keys];for(const p of e){this.mergeContents(t,p.contents);for(const L of p.overrides){const[P]=s.filter(O=>C.equals(O.identifiers,L.identifiers));P?(this.mergeContents(P.contents,L.contents),P.keys.push(...L.keys),P.keys=C.distinct(P.keys)):s.push(w.deepClone(L))}for(const L of p.keys)u.indexOf(L)===-1&&u.push(L)}return new E(t,u,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const u of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[u],L=t[u];L&&(typeof p=="object"&&typeof L=="object"?(p=w.deepClone(p),this.mergeContents(p,L)):p=L),s[u]=p}return new E(s,this.keys,this.overrides)}mergeContents(e,t){for(const s of Object.keys(t)){if(s in e&&l.isObject(e[s])&&l.isObject(t[s])){this.mergeContents(e[s],t[s]);continue}e[s]=w.deepClone(t[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let t=null,s=null;const u=p=>{p&&(s?this.mergeContents(s,p):s=w.deepClone(p))};for(const p of this.overrides)C.equals(p.identifiers,[e])?t=p.contents:p.identifiers.includes(e)&&u(p.contents);return u(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),(0,y.addToValueTree)(this.contents,e,t,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let t=this.keys.length;for(let s=0;s<t;s++)e.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=E;class f extends E{constructor(e={}){const t=c.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),u=Object.create(null),p=[];for(const L in t){const P=e[L],O=P!==void 0?P:t[L].default;(0,y.addToValueTree)(u,L,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const L of Object.keys(u))T.OVERRIDE_PROPERTY_REGEX.test(L)&&p.push({identifiers:(0,T.overrideIdentifiersFromKey)(L),keys:Object.keys(u[L]),contents:(0,y.toValuesTree)(u[L],P=>console.error(`Conflict in default settings file: ${P}`))});super(u,s,p)}}i.DefaultConfigurationModel=f;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,t){if(!l.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,t)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,t){this._raw=e;const{contents:s,keys:u,overrides:p,restricted:L}=this.doParseRaw(e,t);this._configurationModel=new E(s,u,p),this._restrictedConfigurations=L||[]}doParseContent(e){let t={},s=null,u=[],p=[],L=[];function P(N){Array.isArray(u)?u.push(N):s!==null&&(u[s]=N)}let O={onObjectBegin:()=>{let N={};P(N),p.push(u),u=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{u=p.pop()},onArrayBegin:()=>{let N=[];P(N),p.push(u),u=N,s=null},onArrayEnd:()=>{u=p.pop()},onLiteralValue:P,onError:(N,G,ee)=>{L.push({error:N,offset:G,length:ee})}};if(e)try{b.visit(e,O),t=u[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return t}doParseRaw(e,t){const s=c.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=this.filter(e,s,!0,t);e=u.raw;const p=(0,y.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),P=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:p,keys:L,overrides:P,restricted:u.restricted}}filter(e,t,s,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:e,restricted:[]};const p={},L=[];for(let P in e)if(T.OVERRIDE_PROPERTY_REGEX.test(P)&&s){const O=this.filter(e[P],t,!1,u);p[P]=O.raw,L.push(...O.restricted)}else{const O=t[P],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(P),(N===void 0||u.scopes===void 0||u.scopes.includes(N))&&(u.skipRestricted&&O?.restricted||(p[P]=e[P]))}return{raw:p,restricted:L}}toOverrides(e,t){const s=[];for(const u of Object.keys(e))if(T.OVERRIDE_PROPERTY_REGEX.test(u)){const p={};for(const L in e[u])p[L]=e[u][L];s.push({identifiers:(0,T.overrideIdentifiersFromKey)(u),keys:Object.keys(p),contents:(0,y.toValuesTree)(p,t)})}return s}}i.ConfigurationModelParser=d;class g extends D.Disposable{constructor(e,t,s,u){super();this.userSettingsResource=e,this.scopes=t,this.fileService=u,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=g;class m{constructor(e,t,s=new E,u=new E,p=new R.ResourceMap,L=new E,P=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=p,this._memoryConfiguration=L,this._memoryConfigurationByResource=P,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(e)}updateValue(e,t,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new E,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,t===void 0?u.removeValue(e):u.setValue(e,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,s){const u=this.getConsolidateConfigurationModel(t,s),p=this.getFolderConfigurationModelForResource(t.resource,s),L=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,P=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),G=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ee=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,me=p?t.overrideIdentifier?p.freeze().override(t.overrideIdentifier).getValue(e):p.freeze().getValue(e):void 0,ae=t.overrideIdentifier?L.override(t.overrideIdentifier).getValue(e):L.getValue(e),te=u.getValue(e),de=C.distinct(C.flatten(u.overrides.map(W=>W.identifiers))).filter(W=>u.getOverrideValue(e,W)!==void 0);return{defaultValue:P,userValue:O,userLocalValue:N,userRemoteValue:G,workspaceValue:ee,workspaceFolderValue:me,memoryValue:ae,value:te,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:G!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:me!==void 0?{value:p?.freeze().getValue(e),override:t.overrideIdentifier?p?.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:L.getValue(e),override:t.overrideIdentifier?L.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e){const{added:t,updated:s,removed:u,overrides:p}=a(this._defaultConfiguration,e),L=[...t,...s,...u];return L.length&&this.updateDefaultConfiguration(e),{keys:L,overrides:p}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:s,removed:u,overrides:p}=a(this.localUserConfiguration,e),L=[...t,...s,...u];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:p}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:s,removed:u,overrides:p}=a(this.remoteUserConfiguration,e);let L=[...t,...s,...u];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:p}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:s,removed:u,overrides:p}=a(this.workspaceConfiguration,e);let L=[...t,...s,...u];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:p}}compareAndUpdateFolderConfiguration(e,t){const s=this.folderConfigurations.get(e),{added:u,updated:p,removed:L,overrides:P}=a(s,t);let O=[...u,...p,...L];return(O.length||!s)&&this.updateFolderConfiguration(e,t),{keys:O,overrides:P}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:u,removed:p,overrides:L}=a(t,void 0);return{keys:[...s,...u,...p],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let s=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const u=t.getFolder(e);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const p=this._memoryConfigurationByResource.get(e);p&&(s=s.merge(p))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(e);u?(t=s.merge(u),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=s}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const s=t.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:s,overrides:u,keys:p}=this._folderConfigurations.get(t);return e.push([t,{contents:s,overrides:u,keys:p}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(u=>t.add(u))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),u=this.parseConfigurationModel(e.workspace),p=e.folders.reduce((L,P)=>(L.set(v.URI.revive(P[0]),this.parseConfigurationModel(P[1])),L),new R.ResourceMap);return new m(t,s,new E,u,p,new E,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=m;function S(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,t=new Map;for(const u of r)u.keys.forEach(p=>e.add(p)),u.overrides.forEach(([p,L])=>{const P=(0,R.getOrSet)(t,p,new Set);L.forEach(O=>P.add(O))});const s=[];return t.forEach((u,p)=>s.push([p,[...u.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=S;class h{constructor(e,t,s,u){this.change=e,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const p=new Set;e.keys.forEach(P=>p.add(P)),e.overrides.forEach(([,P])=>P.forEach(O=>p.add(O))),this.affectedKeys=[...p.values()];const L=new E;this.affectedKeys.forEach(P=>L.setValue(P,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!w.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let s=(0,y.toValuesTree)({[t]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(e=e[u],!e)return!1;s=s[u]}return!0}}i.ConfigurationChangeEvent=h;class o extends h{constructor(e,t,s,u){super({keys:e.allKeys(),overrides:[]},void 0,e,t);this.source=s,this.sourceConfig=u}}i.AllKeysConfigurationChangeEvent=o;function a(r,e){const{added:t,removed:s,updated:u}=n(e,r),p=[],L=r?.getAllOverrideIdentifiers()||[],P=e?.getAllOverrideIdentifiers()||[];if(e){const O=P.filter(N=>!L.includes(N));for(const N of O)p.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=L.filter(N=>!P.includes(N));for(const N of O)p.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of L)if(P.includes(O)){const N=n({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});p.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:s,updated:u,overrides:p}}function n(r,e){const t=r?e?r.keys.filter(p=>e.keys.indexOf(p)===-1):[...r.keys]:[],s=e?r?e.keys.filter(p=>r.keys.indexOf(p)===-1):[...e.keys]:[],u=[];if(r&&e){for(const p of e.keys)if(r.keys.indexOf(p)!==-1){const L=(0,y.getConfigurationValue)(e.contents,p),P=(0,y.getConfigurationValue)(r.contents,p);w.equals(L,P)||u.push(p)}}return{added:t,removed:s,updated:u}}}),define(J[107],Q([0,1,3,11,2,18,25,106,35,29]),function(x,i,C,I,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends b.Disposable{constructor(c,E){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(()=>this.onDidDefaultConfigurationChange())),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,E){const f=typeof c=="string"?c:void 0,d=(0,R.isConfigurationOverrides)(c)?c:(0,R.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(f,d,void 0)}updateValue(c,E,f,d){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const E=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(f,E,1)}onDidDefaultConfigurationChange(){const c=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel);this.trigger(E,c,6)}trigger(c,E,f){const d=new w.ConfigurationChangeEvent(c,{data:E},this.configuration);d.source=f,d.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(J[108],Q([0,1,10]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function I(v){return v.scheme===C.Schemas.vscodeRemote?v.authority:void 0}i.getRemoteAuthority=I;function b(v){if(!v)return;const y=v.indexOf("+");return y<0?v:v.substr(0,y)}i.getRemoteName=b;function D(v){return v.scheme!==C.Schemas.file&&v.scheme!==C.Schemas.vscodeRemote}i.isVirtualResource=D;function R(v){if(v.folders.length)return v.folders.every(y=>D(y.uri))?v.folders[0].uri:void 0;if(v.configuration&&D(v.configuration))return v.configuration}i.getVirtualWorkspaceLocation=R;function w(v){return R(v)?.scheme}i.getVirtualWorkspaceScheme=w;function l(v){return R(v)!==void 0}i.isVirtualWorkspace=l}),define(J[42],Q([0,1,26,14,108]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}i.getWorkspaceSupportTypeMessage=D;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=R,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,f){if(typeof E=="undefined"||E===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof E=="string"||typeof f=="string"){let d=typeof E=="string"?E:E.value,g=typeof f=="string"?f:f.value;return C.equalsIgnoreCase(d,g)}return E._lower===f._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=l;function v(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}i.isLanguagePackExtension=v;function y(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function T(c,E){if(E){const f=`onResolveRemoteAuthority:${(0,b.getRemoteName)(E)}`;return c.activationEvents?.indexOf(f)!==-1}return!1}i.isResolverExtension=T,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Q([0,1,26,42]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(f,d){return f.uuid&&d.uuid?f.uuid===d.uuid:f.id===d.id?!0:(0,C.compareIgnoreCase)(f.id,d.id)===0}i.areSameExtensions=b;class D{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof D?b(this,d)&&this.version===d.version:!1}}i.ExtensionIdentifierWithVersion=D;function R(f,d){return`${f}.${d}`}i.getExtensionId=R;function w(f){return f.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(f,d){return w(R(f,d))}i.getGalleryExtensionId=l;function v(f,d){const g=[],m=S=>{for(const h of g)if(h.some(o=>b(d(o),d(S))))return h;return null};for(const S of f){const h=m(S);h?h.push(S):g.push([S])}return g}i.groupByExtension=v;function y(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function T(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}i.getGalleryExtensionTelemetryData=T,i.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(f){const d=new Set;if(f.malicious)for(const g of f.malicious)d.add(g.id);return d}i.getMaliciousExtensionsSet=c;function E(f,d){const g=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&g.every(h=>!b(h.identifier,{id:S}))){const h=f.filter(o=>b(o.identifier,{id:S}));h.length===1&&(g.push(h[0]),m.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}i.getExtensionDependencies=E}),define(J[109],Q([0,1,24,7,62,10,43,9,77,22,23,42]),function(x,i,C,I,b,D,R,w,l,v,y,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const c=S=>(0,l.localize)(0,null,S),E=(0,l.localize)(1,null,"ms-dotnettools.csharp");function f(S,h){return h?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function g(S){const h=d.exec(S);return h&&h[1]?[(0,y.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,y.adoptToGalleryExtensionId)(S),void 0]}i.getIdAndVersion=g;let m=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,a=console){let n=await this.extensionManagementService.getInstalled(1);const r=T.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(o&&o!==""){if(r.indexOf(o.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(t=>t.manifest.categories?t.manifest.categories.map(u=>u.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){a.log("Possible Categories: "),r.forEach(t=>{a.log(t)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),n=n.sort((t,s)=>t.identifier.id.localeCompare(s.identifier.id));let e;for(let t of n)e!==t.identifier.id&&(e=t.identifier.id,a.log(f(t.manifest,h)))}async installExtensions(h,o,a,n,r=console){const e=[],t=[];h.length&&r.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),u=(P,O)=>{const N=s.find(G=>(0,y.areSameExtensions)(G.identifier,{id:P}));if(N){if(!O&&!n)return r.log((0,l.localize)(5,null,P,N.manifest.version,P)),!1;if(O&&N.manifest.version===O)return r.log((0,l.localize)(6,null,`${P}@${O}`)),!1}return!0},p=[],L=[];for(const P of h)if(P instanceof w.URI)p.push(P);else{const[O,N]=g(P);u(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!1}})}for(const P of o){const[O,N]=g(P);u(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!0}})}if(p.length&&await Promise.all(p.map(async P=>{try{const O=await this.installVSIX(P,{...a,isBuiltin:!1},n,r);O&&t.push(O)}catch(O){r.error(O.message||O.stack||O),e.push(P.toString())}})),L.length){const P=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=P.get(O.id.toLowerCase());if(N)try{const G=await this.installFromGallery(O,N,s,n,r);G&&t.push(G)}catch(G){r.error(G.message||G.stack||G),e.push(O.id)}else r.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),e.push(O.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(h,o,a,n){const r=await this.extensionManagementService.getManifest(h);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,n))try{return await this.extensionManagementService.install(h,o),n.log((0,l.localize)(8,null,(0,b.getBaseLabel)(h))),r}catch(t){if((0,I.isPromiseCanceledError)(t))return n.log((0,l.localize)(9,null,(0,b.getBaseLabel)(h))),null;throw t}return null}async getGalleryExtensions(h){const o=new Map,a=await this.extensionGalleryService.getExtensions(h,h.some(n=>n.installOptions.installPreReleaseVersion),C.CancellationToken.None);for(const n of a)o.set(n.identifier.id.toLowerCase(),n);return o}async installFromGallery({id:h,version:o,installOptions:a},n,r,e,t){const s=await this.extensionGalleryService.getManifest(n,C.CancellationToken.None);if(s&&!this.validateExtensionKind(s,t))return null;const u=r.find(p=>(0,y.areSameExtensions)(p.identifier,n.identifier));if(u){if(n.version===u.manifest.version)return t.log((0,l.localize)(10,null,o?`${h}@${o}`:h)),null;t.log((0,l.localize)(11,null,h,n.version))}try{return a.isBuiltin?t.log(o?(0,l.localize)(12,null,h,o):(0,l.localize)(13,null,h)):t.log(o?(0,l.localize)(14,null,h,o):(0,l.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!o}),t.log((0,l.localize)(16,null,h,n.version)),s}catch(p){if((0,I.isPromiseCanceledError)(p))return t.log((0,l.localize)(17,null,h)),null;throw p}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,a){const n={id:(0,y.getGalleryExtensionId)(h.publisher,h.name)},e=(await this.extensionManagementService.getInstalled(1)).find(t=>(0,y.areSameExtensions)(n,t.identifier)&&(0,R.gt)(t.manifest.version,h.version));return e&&!o?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,h.version)),!1):this.validateExtensionKind(h,a)}async uninstallExtensions(h,o,a=console){const n=async e=>{if(e instanceof w.URI){const t=await this.extensionManagementService.getManifest(e);return f(t)}return e},r=[];for(const e of h){const t=await n(e),u=(await this.extensionManagementService.getInstalled()).filter(p=>(0,y.areSameExtensions)(p.identifier,{id:t}));if(!u.length)throw new Error(`${this.notInstalled(t)}
${E}`);if(u.some(p=>p.type===0)){a.log((0,l.localize)(19,null,t));return}if(!o&&u.some(p=>p.isBuiltin)){a.log((0,l.localize)(20,null,t));return}a.log((0,l.localize)(21,null,t));for(const p of u)await this.extensionManagementService.uninstall(p),r.push(p);this.location?a.log((0,l.localize)(22,null,t,this.location)):a.log((0,l.localize)(23,null,t))}}async locateExtension(h,o=console){const a=await this.extensionManagementService.getInstalled();h.forEach(n=>{a.forEach(r=>{if(r.identifier.id===n&&r.location.scheme===D.Schemas.file){o.log(r.location.fsPath);return}})})}notInstalled(h){return this.location?(0,l.localize)(24,null,h,this.location):(0,l.localize)(25,null,h)}};m=pe([se(0,v.IExtensionManagementService),se(1,v.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(J[110],Q([0,1,3,7,2,12,18,43,9,31,13,20,22,23,16,15]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(h,o,a,n){super();this.fileService=o,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=l.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const a=this.getName(h),n=(0,R.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const r=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(h,r,o);try{await this.rename(r,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch(t){}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return n}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,o,a){try{await y.Promises.rename(h.fsPath,o.fsPath)}catch(n){if(D.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],a=[];for(const e of h.children){const t=this.parse(e.name);t&&a.push([t,e])}const n=(0,E.groupByExtension)(a,([e])=>e),r=[];for(const e of n)e.sort((t,s)=>w.rcompare(t[0].version,s[0].version)),o.push(...e.slice(1).map(t=>t[1].resource)),r.push(e[0][1]);r.sort((e,t)=>e.mtime-t.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await C.Promises.settled(o.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new E.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(h){const o=g.exec(h);return o&&o[1]&&o[2]?new E.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};m=pe([se(0,T.INativeEnvironmentService),se(1,f.IFileService),se(2,c.IExtensionGalleryService),se(3,d.ILogService)],m),i.ExtensionsDownloader=m}),define(J[111],Q([0,1,2,6,13,42]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class R extends C.Disposable{constructor(l,v){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(v.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=R}),define(J[112],Q([0,1,137,19,3,2,10,6,13,20,22,23,55,15]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let f=class extends D.Disposable{constructor(m,S,h){super();this.extensionManagementService=m,this.logService=h,this.cache=this._register(new d(S,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),S=["en",...Object.keys(m)];return(0,I.distinct)(S)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const S=await this.cache.getLanguagePacks();Object.keys(S).some(h=>S[h]&&S[h].extensions.some(o=>(0,T.areSameExtensions)(o.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(S);return!(0,I.equals)(Object.keys(m),Object.keys(h))}};f=pe([se(0,y.IExtensionManagementService),se(1,v.INativeEnvironmentService),se(2,E.ILogService)],f),i.LocalizationsService=f;let d=class extends D.Disposable{constructor(m,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(S=>{Object.keys(S).forEach(h=>delete S[h]),this.createLanguagePacksFromExtensions(S,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...S){for(const h of S)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,h);Object.keys(m).forEach(h=>this.updateHash(m[h]))}createLanguagePacksFromExtension(m,S){const h=S.identifier,o=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const a of o)if(S.location.scheme===R.Schemas.file&&(0,c.isValidLocalization)(a)){let n=m[a.languageId];n||(n={hash:"",extensions:[],translations:{}},m[a.languageId]=n);let r=n.extensions.filter(e=>(0,T.areSameExtensions)(e.extensionIdentifier,h))[0];r?r.version=S.manifest.version:n.extensions.push({extensionIdentifier:h,version:S.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,w.join)(S.location.fsPath,e.path)}}updateHash(m){if(m){const S=(0,C.createHash)("md5");for(const h of m.extensions)S.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=S.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(S=m(h),h)).then(h=>{for(const a of Object.keys(h))h[a]||delete h[a];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>S,h=>this.logService.error(h))})}};d=pe([se(0,v.INativeEnvironmentService),se(1,E.ILogService)],d)}),define(J[44],Q([0,1,17,85,35,14,29]),function(x,i,C,I,b,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,D.createDecorator)("requestService");function w(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}i.isSuccess=w;function l(f){return f.res.statusCode===204}async function v(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);return l(f)?null:(await(0,C.streamToBuffer)(f.stream)).toString()}i.asText=v;async function y(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);if(l(f))return null;const g=(await(0,C.streamToBuffer)(f.stream)).toString();try{return JSON.parse(g)}catch(m){throw m.message+=`:
`+g,m}}i.asJson=y;function T(f){E(f)}i.updateProxyConfigurationsScope=T;let c;function E(f){const d=R.Registry.as(b.Extensions.Configuration),g=c;c={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[c],remove:g?[g]:[]})}E(2)}),define(J[113],Q([0,1,24,10,16,44]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let R=class{constructor(l,v){this.requestService=l,this.fileService=v}async download(l,v,y=C.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,v);return}const T={type:"GET",url:l.toString()},c=await this.requestService.request(T,y);if(c.res.statusCode===200)await this.fileService.writeFile(v,c.stream);else{const E=await(0,D.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${E}`)}}};R=pe([se(0,D.IRequestService),se(1,b.IFileService)],R),i.DownloadService=R}),define(J[114],Q([0,1,115,8]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(R,w){return R.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:R.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(R,w,l={}){const v=(0,C.parse)(R),y=l.proxyUrl||b(v,w);if(!y)return null;const T=(0,C.parse)(y);if(!/^https?:$/.test(T.protocol||""))return null;const c={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((E,f)=>{x(["http-proxy-agent"],E,f)}))(c):new(await new Promise((E,f)=>{x(["https-proxy-agent"],E,f)}))(c)}i.getProxyAgent=D}),define(J[116],Q([0,1,17,31]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(D,R,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await R.readFile(D.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(y)?y:null}catch(v){l=null}if(!l){l=(0,I.generateUuid)();try{await R.writeFile(D.serviceMachineIdResource,C.VSBuffer.fromString(l))}catch(v){}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(J[117],Q([0,1,3,11,2,102,8,66,14]),function(x,i,C,I,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var T;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(T=i.StorageScope||(i.StorageScope={}));var c;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(c=i.StorageTarget||(i.StorageTarget={}));class E extends b.Disposable{constructor(m={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,S){S===v?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:S,target:this.getKeyTargets(m)[S]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,S,h){return this.getStorage(S)?.get(m,h)}getBoolean(m,S,h){return this.getStorage(S)?.getBoolean(m,h)}getNumber(m,S,h){return this.getStorage(S)?.getNumber(m,h)}store(m,S,h,o){if((0,R.isUndefinedOrNull)(S)){this.remove(m,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,h,o),this.getStorage(h)?.set(m,S)})}remove(m,S){this.withPausedEmitters(()=>{this.updateKeyTarget(m,S,void 0),this.getStorage(S)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,S){const h=[],o=this.getKeyTargets(m);for(const a of Object.keys(o))o[a]===S&&h.push(a);return h}updateKeyTarget(m,S,h){const o=this.getKeyTargets(S);typeof h=="number"?o[m]!==h&&(o[m]=h,this.getStorage(S)?.set(v,JSON.stringify(o))):typeof o[m]=="number"&&(delete o[m],this.getStorage(S)?.set(v,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const S=this.get(v,m);if(S)try{return JSON.parse(S)}catch(h){}return Object.create(null)}isNew(m){return this.getBoolean(i.IS_NEW_KEY,m)===!0}async flush(m=y.NONE){this._onWillSaveState.fire({reason:m});const S=this.getStorage(0),h=this.getStorage(1);switch(m){case y.NONE:await C.Promises.settled([S?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await C.Promises.settled([S?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(m,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class f extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}i.InMemoryStorageService=f;async function d(g,m,S,h){const o=u=>{try{return JSON.parse(u)}catch(p){return u}},a=new Map,n=new Map;g.forEach((u,p)=>{a.set(p,u),n.set(p,o(u))});const r=new Map,e=new Map;m.forEach((u,p)=>{r.set(p,u),e.set(p,o(u))}),console.group(`Storage: Global (path: ${S})`);let t=[];a.forEach((u,p)=>{t.push({key:p,value:u})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${h})`);let s=[];r.forEach((u,p)=>{s.push({key:p,value:u})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=d}),define(J[118],Q([0,1,12,28,9,31]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function R(v){if(C.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function w(v,y,T,c,E,f,d,g,m,S){const h=Object.create(null);h["common.machineId"]=d,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=E,h.version=f,h["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,C.PlatformToString)(C.platform),h["common.nodePlatform"]=I.platform,h["common.nodeArch"]=c,h["common.product"]=S||"desktop";const o=l(g||[]);o&&(h["common.msftInternal"]=o);let a=0;const n=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),C.isLinuxSnap&&(h["common.snap"]="true");const r=R(T);r&&(h["common.platformDetail"]=r);try{const e=await v.readFile(b.URI.file(m));h["common.source"]=e.value.toString().slice(0,30)}catch(e){}return h}i.resolveCommonProperties=w;function l(v){const y=I.env.USERDNSDOMAIN;if(!y)return!1;const T=y.toLowerCase();return v.some(c=>T===c)}i.verifyMicrosoftInternalDomain=l}),define(J[30],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,C.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(J[119],Q([0,1,19,3,24,7,11,2,12,8,9,75,22,23,15,32,30]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let m=class extends w.Disposable{constructor(r,e,t,s){super();this.galleryService=r,this.telemetryService=e,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(u=>u.cancel()),this.uninstallingExtensions.forEach(u=>u.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(t=>(0,c.isTargetPlatformCompatible)(t,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new c.ExtensionManagementError(T.localize(0,null),c.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,e)}catch(t){throw o(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(r),void 0,t),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(t),h(t)}}async migrateUnsupportedExtensions(){try{const r=await this.getExtensionsControlManifest();if(!r.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[t,s]of Object.entries(r.unsupportedPreReleaseExtensions)){const u=e.find(P=>(0,E.areSameExtensions)(P.identifier,{id:t}));if(!u)continue;const p=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!p){this.logService.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const L=await this.galleryService.getManifest(p,b.CancellationToken.None);if(!L){this.logService.info(`Skipping migrating '${u.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${u.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(u),this.installExtension(L,p,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${u.identifier.id}' extension to '${s.id}' extension.`)}catch(P){this.logService.error(P)}}}catch(r){this.logService.error(r)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,t){if(!y.URI.isUri(e)){let P=this.installingExtensions.get(new E.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],u=[],p=this.createInstallExtensionTask(r,e,t);y.URI.isUri(e)||this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(p.identifier,r.version).key(),p),this._onInstallExtension.fire({identifier:p.identifier,source:e}),this.logService.info("Installing extension:",p.identifier.id),s.push({task:p,manifest:r});let L=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",p.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(p.identifier,r,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:N,manifest:G}of O)if(L=L||!!G.extensionDependencies?.some(ee=>(0,E.areSameExtensions)({id:ee},p.identifier)),this.installingExtensions.has(new E.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const ee=this.createInstallExtensionTask(G,N,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new E.ExtensionIdentifierWithVersion(ee.identifier,G.version).key(),ee),this._onInstallExtension.fire({identifier:ee.identifier,source:N}),this.logService.info("Installing extension:",ee.identifier.id),s.push({task:ee,manifest:G})}}catch(O){if(y.URI.isUri(p.source))(0,C.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",p.identifier.id,O.message),(0,C.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",p.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",p.identifier.id),O}const P=s.reduce((O,{task:N,manifest:G})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:G}),O),new Map);for(;P.size;){let O;const N=[...P.values()].filter(({manifest:G})=>!G.extensionDependencies?.some(ee=>P.has(ee.toLowerCase())));N.length?O=P.size===1?N:N.filter(({task:G})=>!(G===p&&!L)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:G})=>G.identifier.id)),O=[...P.values()]),await this.joinAllSettled(O.map(async({task:G})=>{const ee=new Date().getTime(),me=(0,v.isUndefined)(t.operation)?G.operation:t.operation;try{const ae=await G.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ae,G.source,t,b.CancellationToken.None))),!y.URI.isUri(G.source)&&(o(this.telemetryService,me===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,void 0),l.isWeb&&me!==3))try{await this.galleryService.reportStatistic(ae.manifest.publisher,ae.manifest.name,ae.manifest.version,"install")}catch(te){}u.push({local:ae,identifier:G.identifier,operation:me,source:G.source})}catch(ae){throw y.URI.isUri(G.source)||o(this.telemetryService,me===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,ae),this.logService.error("Error while installing the extension:",G.identifier.id),ae}finally{P.delete(G.identifier.id.toLowerCase())}}))}return u.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(u),u.filter(({identifier:O})=>(0,E.areSameExtensions)(O,p.identifier))[0].local}catch(P){if(s.forEach(({task:O})=>O.cancel()),u.length)try{const O=await Promise.allSettled(u.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const G=O[N],{identifier:ee}=u[N];G.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ee.id):this.logService.warn("Rollback: Error while uninstalling extension",ee.id,(0,D.getErrorMessage)(G.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(O),u.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),P}finally{for(const{task:P,manifest:O}of s)if(!y.URI.isUri(P.source)){const N=new E.ExtensionIdentifierWithVersion(P.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const e=[],t=[],s=await Promise.allSettled(r);for(const u of s)u.status==="fulfilled"?e.push(u.value):t.push(u.reason);if(t.length)throw S(t);return e}async getAllDepsAndPackExtensionsToInstall(r,e,t,s){if(!this.galleryService.isEnabled())return[];let u=await this.getInstalled();const p=[r,...u.map(O=>O.identifier)],L=[],P=async(O,N)=>{const G=N.extensionDependencies||[],ee=[...G];if(N.extensionPack){const me=t?u.find(ae=>(0,E.areSameExtensions)(ae.identifier,O)):void 0;for(const ae of N.extensionPack)me&&me.manifest.extensionPack&&me.manifest.extensionPack.some(te=>(0,E.areSameExtensions)({id:te},{id:ae}))||ee.every(te=>!(0,E.areSameExtensions)({id:te},{id:ae}))&&ee.push(ae)}if(ee.length){const me=[...p,...L.map(te=>te.gallery.identifier)],ae=ee.filter(te=>me.every(de=>!(0,E.areSameExtensions)(de,{id:te})));if(ae.length){const te=await this.galleryService.query({names:ae,pageSize:ee.length},b.CancellationToken.None);for(const de of te.firstPage){if(me.find(ne=>(0,E.areSameExtensions)(ne,de.identifier)))continue;const W=G.some(ne=>(0,E.areSameExtensions)({id:ne},de.identifier));let $;try{$=await this.checkAndGetCompatibleVersion(de,!0,s)}catch(ne){if(ne instanceof c.ExtensionManagementError&&ne.code===c.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",de.identifier.id);continue}else throw ne}L.push({gallery:$.extension,manifest:$.manifest}),await P($.extension.identifier,N)}}}};return await P(r,e),u=await this.getInstalled(),L.filter(O=>!u.some(N=>(0,E.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,t){const s=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new c.ExtensionManagementError(T.localize(3,null,r.identifier.id),c.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new c.ExtensionManagementError(T.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),c.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const L=await this.getTargetPlatform();throw new c.ExtensionManagementError(T.localize(5,null,r.identifier.id,this.productService.nameLong,(0,c.TargetPlatformToString)(L)),c.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.getCompatibleVersion(r,e,t);if(u){if(t&&r.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new c.ExtensionManagementError(T.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),c.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new c.ExtensionManagementError(T.localize(7,null,r.identifier.id,this.productService.nameLong,this.productService.version),c.ExtensionManagementErrorCode.Incompatible);const p=await this.galleryService.getManifest(u,b.CancellationToken.None);if(p===null)throw new c.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,c.ExtensionManagementErrorCode.Invalid);if(p.version!==u.version)throw new c.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,c.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:p}}async getCompatibleVersion(r,e,t){const s=await this.getTargetPlatform();let u=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==t&&(u=await this.galleryService.getCompatibleExtension(r.identifier,t,s)),!u&&await this.galleryService.isExtensionCompatible(r,t,s)&&(u=r),!u&&e&&(u=await this.galleryService.getCompatibleExtension(r,t,s)),u}async unininstallExtension(r,e){const t=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),t.waitUntilTaskIsFinished();const s=(P,O)=>{const N=this.createUninstallExtensionTask(P,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),N},u=(P,O)=>{O?this.logService.error("Failed to uninstall extension:",P.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),o(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(P),void 0,O),this._onDidUninstallExtension.fire({identifier:P.identifier,error:O?.code})},p=[],L=[];try{p.push(s(r,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(r,P);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):p.push(s(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(p.map(O=>O.extension),P,r),await this.joinAllSettled(p.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,e,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch(N){}u(O.extension)}catch(N){const G=N instanceof c.ExtensionManagementError?N:new c.ExtensionManagementError((0,D.getErrorMessage)(N),c.ExtensionManagementErrorCode.Internal);throw u(O.extension,G),G}finally{L.push(O)}}))}catch(P){const O=P instanceof c.ExtensionManagementError?P:new c.ExtensionManagementError((0,D.getErrorMessage)(P),c.ExtensionManagementErrorCode.Internal);for(const N of p){try{N.cancel()}catch(G){}L.includes(N)||u(N.extension,O)}throw O}finally{for(const P of p)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(r,e,t){for(const s of r){const u=this.getDependents(s,e);if(u.length){const p=u.filter(L=>!r.some(P=>(0,E.areSameExtensions)(P.identifier,L.identifier)));if(p.length)throw new Error(this.getDependentsErrorMessage(s,p,t))}}}getDependentsErrorMessage(r,e,t){return t===r?e.length===1?T.localize(8,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(9,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(10,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?T.localize(11,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?T.localize(12,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):T.localize(13,null,t.manifest.displayName||t.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,t=[]){if(t.indexOf(r)!==-1)return[];t.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const u=e.filter(L=>!L.isBuiltin&&s.some(P=>(0,E.areSameExtensions)({id:P},L.identifier))),p=[];for(const L of u)p.push(...this.getAllPackExtensionsToUninstall(L,e,t));return[...u,...p]}return[]}getDependents(r,e){return e.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,E.areSameExtensions)({id:s},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=pe([se(0,c.IExtensionGalleryService),se(1,g.ITelemetryService),se(2,f.ILogService),se(3,d.IProductService)],m),i.AbstractExtensionManagementService=m;function S(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=S;function h(n){if(n instanceof c.ExtensionManagementError)return n;const r=new c.ExtensionManagementError(n.message,c.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function o(n,r,e,t,s){const u=s?s instanceof c.ExtensionManagementError?s.code:c.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(r,{...e,success:!s,duration:t,errorcode:u})}i.reportTelemetry=o;class a{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(r=>new Promise((e,t)=>{const s=r.onCancellationRequested(()=>{s.dispose(),t((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=a}),define(J[36],Q([0,1,21,8,25,30]),function(x,i,C,I,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,S){return Promise.resolve(void 0)}publicLog2(m,S){return this.publicLog(m,S)}publicLogError(m,S){return Promise.resolve(void 0)}publicLogError2(m,S){return this.publicLogError(m,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=R,i.NullTelemetryService=new R;class w{async publicLog(m,S,h){}async publicLogError(m,S,h){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(g,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(S.source),configurationKeys:f(S.sourceConfig)})})}i.configurationTelemetry=l;function v(g,m){return!(m.disableTelemetry||!g.enableTelemetry)}i.supportsTelemetry=v;function y(g){const m=g.getValue(D.TELEMETRY_SETTING_ID),S=g.getValue("telemetry.enableCrashReporter");if(g.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function T(g){const m=Object.create(null),S=Object.create(null),h=Object.create(null);E(g,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const a=h[o];typeof a=="number"?S[o]=a:typeof a=="boolean"?S[o]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${a.length}`),m[o]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(m[o]=a)}return{properties:m,measurements:S}}i.validateTelemetryData=T;function c(g){if(!g)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{g.indexOf(`${h}+`)===0&&(m=h)}),m}i.cleanRemoteAuthority=c;function E(g,m,S=0,h){if(!!g)for(let o of Object.getOwnPropertyNames(g)){const a=g[o],n=h?h+o:o;Array.isArray(a)?m[n]=(0,C.safeStringify)(a):a instanceof Date?m[n]=a.toISOString():(0,I.isObject)(a)?S<2?E(a,m,S+1,n+"."):m[n]=(0,C.safeStringify)(a):m[n]=a}}function f(g){if(!g)return[];const m=[];return d(m,"",g),m}function d(g,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(h=>d(g,m?`${m}.${h}`:h,S[h])):g.push(m)}}),define(J[120],Q([0,1,19,24,7,21,12,28,8,9,25,20,22,23,51,16,15,32,44,116,117,30,36]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m,S,h,o,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const r=R.isWeb?"web":(0,c.getTargetPlatform)(R.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function t(...U){return String(U.reduce((A,q)=>A|q,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},p={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(A=P){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,q=this.state.pageSize){return new O({...this.state,pageNumber:A,pageSize:q})}withFilter(A,...q){const j=[...this.state.criteria,...q.length?q.map(Y=>({filterType:A,value:Y})):[{filterType:A}]];return new O({...this.state,criteria:j})}withSortBy(A){return new O({...this.state,sortBy:A})}withSortOrder(A){return new O({...this.state,sortOrder:A})}withFlags(...A){return new O({...this.state,flags:A.reduce((q,j)=>q|j,0)})}withAssetTypes(...A){return new O({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:q,pageSize:j,sortBy:Y,sortOrder:X,flags:ge,assetTypes:fe}=this.state;return{filters:[{criteria:A,pageNumber:q,pageSize:j,sortBy:Y,sortOrder:X}],assetTypes:fe,flags:ge}}get searchText(){const A=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const q=(U||[]).filter(j=>j.statisticName===A)[0];return q?q.value:0}function G(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(j=>j.assetType.indexOf(A)===0).reduce((j,Y)=>{const X=te(U,Y.assetType);return X&&j.push([Y.assetType.substring(A.length),X]),j},[])}function ee(U){if(U.properties){const A=U.properties.filter(Y=>Y.key===u.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=A.filter(Y=>q.test(Y.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return te(U,u.Repository)}function me(U){return{uri:`${U.fallbackAssetUri}/${u.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${u.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ae(U){const A=te(U,u.Icon);if(A)return A;const q=c.DefaultIconPath;return{uri:q,fallbackUri:q}}function te(U,A){return U.files.filter(j=>j.assetType===A)[0]?{uri:`${U.assetUri}/${A}`,fallbackUri:`${U.fallbackAssetUri}/${A}`}:null}function de(U,A){const q=U.properties?U.properties.filter(Y=>Y.key===A):[],j=q.length>0&&q[0].value;return j?j.split(",").map(Y=>(0,E.adoptToGalleryExtensionId)(Y)):[]}function W(U){const A=U.properties?U.properties.filter(q=>q.key===p.Engine):[];return A.length>0&&A[0].value||""}function $(U){const A=U.properties?U.properties.filter(q=>q.key===p.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(j=>j.key===p.LocalizedLanguages):[],q=A.length>0&&A[0].value||"";return q?q.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,c.toTargetPlatform)(U.targetPlatform):"undefined"}function V(U){const A=(0,C.distinct)(U.versions.map(k)),q=!!U.tags?.includes(c.WEB_EXTENSION_TAG),j=A.indexOf("web");return q?j===-1&&A.push("web"):j!==-1&&A.splice(j,1),A}function H(U,A){const q=(0,c.getFallbackTargetPlarforms)(A);for(let j=0;j<U.length;j++){const Y=U[j];if(Y.version===U[j-1]?.version){let X=j;const ge=k(Y);if(ge===A)for(;X>0&&U[X-1].version===Y.version;)X--;else if(q.includes(ge))for(;X>0&&U[X-1].version===Y.version&&k(U[X-1])!==A;)X--;X!==j&&(U.splice(j,1),U.splice(X,0,Y))}}return U}i.sortExtensionVersions=H;function ie(U,A,q,j){const Y=U.versions[0],X={manifest:te(A,u.Manifest),readme:te(A,u.Details),changelog:te(A,u.Changelog),license:te(A,u.License),repository:ee(A),download:me(A),icon:ae(A),coreTranslations:G(A)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:X,properties:{dependencies:de(A,p.Dependency),extensionPack:de(A,p.ExtensionPack),engine:W(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:$(A)},hasPreReleaseVersion:$(Y),preview:M(U.flags),telemetryData:j}}let K=class{constructor(A,q,j,Y,X,ge,fe,ue){this.requestService=q,this.logService=j,this.environmentService=Y,this.telemetryService=X,this.fileService=ge,this.productService=fe,this.configurationService=ue;const re=fe.extensionsGallery;this.extensionsGalleryUrl=re&&re.serviceUrl,this.extensionsControlUrl=re&&re.controlUrl,this.commonHeadersPromise=le(fe.version,fe,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,q,j){const Y=(0,l.isBoolean)(q)?q:!1,X=(0,l.isBoolean)(q)?j:q;let ge=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...A.map(({id:re})=>re.toLowerCase()));A.every(re=>!re.version)&&(ge=ge.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:fe}=await this.queryGallery(ge,r,I.CancellationToken.None),ue=fe.map(re=>{const ye=(0,E.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName);return{rawGalleryExtension:re,version:A.find(oe=>(0,E.areSameExtensions)(oe,{id:ye}))?.version}});return this.converToGalleryExtensions(ue,Y,r,()=>{},X)}async getCompatibleExtension(A,q,j){const Y=(0,c.isIExtensionIdentifier)(A)?null:A;if(Y){if((0,c.isNotWebExtensionInWebTargetPlatform)(Y.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(Y,q,j))return Y}const{id:X,uuid:ge}=Y?Y.identifier:A;let fe=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ge?fe=fe.withFilter(s.ExtensionId,ge):fe=fe.withFilter(s.ExtensionName,X);const{galleryExtensions:ue}=await this.queryGallery(fe,j,I.CancellationToken.None),[re]=ue;if(!re||!re.versions.length)return null;const ye=V(re);if((0,c.isNotWebExtensionInWebTargetPlatform)(ye,j))return null;for(let oe of re.versions){if(!W(oe)){const he=await this.getEngine(oe);oe={...oe,properties:[...oe.properties||[],{key:p.Engine,value:he}]}}if(await this.isRawExtensionVersionCompatible(oe,q,ye,j))return ie(re,oe,ye)}return null}async isExtensionCompatible(A,q,j){if(!(0,c.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,j)||!q&&A.properties.isPreReleaseVersion)return!1;let Y=A.properties.engine;if(!Y){const X=await this.getManifest(A,I.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Y=X.engines.vscode}return(0,f.isEngineValid)(Y,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,q,j,Y){if(!(0,c.isTargetPlatformCompatible)(k(A),j,Y)||!q&&$(A))return!1;const X=await this.getEngine(A);return(0,f.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=A.text||"";const Y=(0,D.getOrDefault)(A,oe=>oe.pageSize,50);let X=new O().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,Y).withFilter(s.Target,"Microsoft.VisualStudio.Code");j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Re)=>(X=X.withFilter(s.Category,Re||he),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Re)=>(X=X.withFilter(s.Tag,Re||he),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(s.SearchText,j)),X=X.withSortBy(0)):A.ids?X=X.withFilter(s.ExtensionId,...A.ids):A.names?X=X.withFilter(s.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const{galleryExtensions:ge,total:fe}=await this.queryGallery(X,r,q),ue=oe=>({index:(X.pageNumber-1)*X.pageSize+oe,querySource:A.source}),re=await this.converToGalleryExtensions(ge.map(oe=>({rawGalleryExtension:oe})),!!A.includePreRelease,r,ue,q),ye=async(oe,he)=>{if(he.isCancellationRequested)throw(0,b.canceled)();const Re=X.withPage(oe+1),{galleryExtensions:xe}=await this.queryGallery(Re,r,he);return await this.converToGalleryExtensions(xe.map(Ae=>({rawGalleryExtension:Ae})),!!A.includePreRelease,r,ue,q)};return{firstPage:re,total:fe,pageSize:X.pageSize,getPage:ye}}async converToGalleryExtensions(A,q,j,Y,X){const ge=(re,ye)=>{const oe=V(re);let he=re.versions[0];return he=re.versions.find(Re=>Re.version===he.version&&(0,c.isTargetPlatformCompatible)(k(Re),oe,j))||he,!q&&$(he)&&(he=re.versions.find(Re=>Re.version!==he.version&&!$(Re))||he),ie(re,he,oe,Y(ye))},fe=[],ue=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:ye,version:oe}=A[re];if(oe){const he=ye.versions.find(Re=>Re.version===oe);he&&fe.push([re,ie(ye,he,V(ye))])}else{const he=ge(ye,re);he.properties.isPreReleaseVersion&&!q?ue.set(he.identifier.uuid,re):fe.push([re,he])}}if(ue.size){const re=new O().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,ue.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...ue.keys()),{galleryExtensions:ye}=await this.queryGallery(re,j,X);if(ye.length!==ue.size)throw new Error("Not all extensions with latest versions are returned");for(const oe of ye){const he=ue.get(oe.extensionId),Re=ge(oe,he);fe.push([he,Re])}}return fe.sort((re,ye)=>re[0]-ye[0]).map(([,re])=>re)}async queryGallery(A,q,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(e.Unpublished));const Y=await this.commonHeadersPromise,X=JSON.stringify(A.raw),ge={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},fe=new Date().getTime();let ue,re,ye=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:X,headers:ge},j),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const oe=await(0,S.asJson)(ue);if(oe){const he=oe.results[0],Re=he.extensions;Re.forEach(Ae=>H(Ae.versions,q));const xe=he.resultMetadata&&he.resultMetadata.filter(Ae=>Ae.metadataType==="ResultCount")[0];return ye=xe&&xe.metadataItems.filter(Ae=>Ae.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:ye}}return{galleryExtensions:[],total:ye}}catch(oe){throw re=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-fe,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:re?(0,b.isPromiseCanceledError)(re)?"canceled":(0,b.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(A,q,j,Y){if(!this.isEnabled())return;const X=R.isWeb?this.api(`/itemName/${A}.${q}/version/${j}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${q}/${j}/stats?statType=${Y}`),ge=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ge};try{await this.requestService.request({type:"POST",url:X,headers:ue},I.CancellationToken.None)}catch(re){}}async download(A,q,j){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const Y=(0,E.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),ge=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Y,duration:ye}),fe=j===2?"install":j===3?"update":"",ue=fe?{uri:`${A.assets.download.uri}${v.URI.parse(A.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${A.assets.download.fallbackUri}${v.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:A.assets.download,re=await this.getAsset(ue);await this.fileService.writeFile(q,re.stream),ge(new Date().getTime()-X)}async getReadme(A,q){if(A.assets.readme){const j=await this.getAsset(A.assets.readme,{},q);return await(0,S.asText)(j)||""}return""}async getManifest(A,q){if(A.assets.manifest){const j=await this.getAsset(A.assets.manifest,{},q),Y=await(0,S.asText)(j);return Y?JSON.parse(Y):null}return null}async getManifestFromRawExtensionVersion(A,q){const j=te(A,u.Manifest);if(!j)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:Y});return await(0,S.asJson)(X)}async getCoreTranslation(A,q){const j=A.assets.coreTranslations.filter(Y=>Y[0]===q.toUpperCase())[0];if(j){const Y=await this.getAsset(j[1]),X=await(0,S.asText)(Y);return X?JSON.parse(X):null}return null}async getChangelog(A,q){if(A.assets.changelog){const j=await this.getAsset(A.assets.changelog,{},q);return await(0,S.asText)(j)||""}return""}async getAllCompatibleVersions(A,q,j){let Y=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?Y=Y.withFilter(s.ExtensionId,A.identifier.uuid):Y=Y.withFilter(s.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(Y,j,I.CancellationToken.None);if(!X.length)return[];const ge=V(X[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(ge,j))return[];const fe=[];for(const ue of X[0].versions)try{fe[fe.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,q,ge,j)&&fe.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)})}catch(re){}return fe}async getAsset(A,q={},j=I.CancellationToken.None){const Y=await this.commonHeadersPromise,X={type:"GET"},ge={...Y,...q.headers||{}};q={...q,...X,headers:ge};const fe=A.uri,ue=A.fallbackUri,re={...q,url:fe};try{const ye=await this.requestService.request(re,j);if(ye.res.statusCode===200)return ye;const oe=await(0,S.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${oe}`)}catch(ye){if((0,b.isPromiseCanceledError)(ye))throw ye;const oe=(0,b.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:oe});const he={...q,url:ue};return this.requestService.request(he,j)}}async getEngine(A){let q=W(A);if(!q){const j=await this.getManifestFromRawExtensionVersion(A,I.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,S.asJson)(A),j=[],Y={};if(q){for(const X of q.malicious)j.push({id:X});if(q.unsupported)for(const X of Object.keys(q.unsupported)){const ge=q.unsupported[X];(0,l.isBoolean)(ge)||(Y[X.toLowerCase()]=ge.preReleaseExtension)}}return{malicious:j,unsupportedPreReleaseExtensions:Y}}};K=pe([se(1,S.IRequestService),se(2,g.ILogService),se(3,T.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,m.IProductService),se(7,y.IConfigurationService)],K);let Z=class extends K{constructor(A,q,j,Y,X,ge,fe,ue){super(A,q,j,Y,X,ge,fe,ue)}};Z=pe([se(0,o.IStorageService),se(1,S.IRequestService),se(2,g.ILogService),se(3,T.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,m.IProductService),se(7,y.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends K{constructor(A,q,j,Y,X,ge,fe){super(void 0,A,q,j,Y,X,ge,fe)}};_=pe([se(0,S.IRequestService),se(1,g.ILogService),se(2,T.IEnvironmentService),se(3,a.ITelemetryService),se(4,d.IFileService),se(5,m.IProductService),se(6,y.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function le(U,A,q,j,Y,X){const ge={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},fe=await(0,h.getServiceMachineId)(q,Y,X);return(0,n.supportsTelemetry)(A,q)&&(0,n.getTelemetryLevel)(j)===3&&(ge["X-Market-User-Id"]=fe),ge}i.resolveMarketplaceHeaders=le}),define(J[121],Q([0,1,2,21,12,26,86,25,35,122,29,30,36]),function(x,i,C,I,b,D,R,w,l,v,y,T,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(g,m){this._configurationService=m,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const h=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(g,m){this._experimentProperties[g]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let m=g.sessionID,S=g["common.machineId"],h=g["common.firstSessionDate"],o=g["common.msftInternal"];return{sessionId:m,machineId:S,firstSessionDate:h,msftInternal:o}}dispose(){this._disposables.dispose()}_log(g,m,S,h){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(o=>{S=(0,I.mixin)(S,o),S=(0,I.mixin)(S,this._experimentProperties),S=(0,I.cloneAndChange)(S,a=>{if(typeof a=="string")return this._cleanupInfo(a,h)}),this._appenders.forEach(a=>a.log(g,S))},o=>{console.error(o)})}publicLog(g,m,S){return this._log(g,3,m,S)}publicLog2(g,m,S){return this.publicLog(g,m,S)}publicLogError(g,m){return this.sendErrorTelemetry?this._log(g,2,m,!0):Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}_anonymizeFilePaths(g){let m=g;const S=[];for(let n of this._cleanupPatterns)for(;;){const r=n.exec(g);if(!r)break;S.push([r.index,n.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(m="";;){const n=o.exec(g);if(!n)break;!h.test(n[0])&&S.every(([r,e])=>n.index<r||n.index>=e)&&(m+=g.substring(a,n.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<g.length&&(m+=g.substr(a)),m}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const m=g.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":S.test(m)?"<REDACTED: email>":g}_cleanupInfo(g,m){let S=g;m&&(S=this._anonymizeFilePaths(S));for(let h of this._cleanupPatterns)S=S.replace(h,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=pe([se(1,w.IConfigurationService)],E),i.TelemetryService=E;function f(){const d=(0,R.localize)(0,null,v.default.nameLong),g=v.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=b.isWeb?"":(0,R.localize)(3,null),S=(0,R.localize)(4,null),h=(0,R.localize)(5,null),o=(0,R.localize)(6,null),a=(0,R.localize)(7,null),n=`
|       | ${S} | ${h} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,R.localize)(8,null);return`
${d} ${g} ${m}

&nbsp;

${a}
${n}

&nbsp;

${r}
`}y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[T.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[T.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,R.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,R.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${T.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Q([0,1,7,21,36]),function(x,i,C,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function D(w,l){const v=await new Promise((T,c)=>{x(["applicationinsights"],T,c)});let y;return v.defaultClient?(y=new v.TelemetryClient(w),y.channel.setUseDiskRetryCaching(!0)):(v.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=v.defaultClient),w.indexOf("AIF-")===0&&(y.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class R{constructor(l,v,y,T,c){this._eventPrefix=l,this._defaultData=v,this.testCollector=T,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{l(v)},v=>{(0,C.onUnexpectedError)(v),console.error(v)})}}log(l,v){!this._aiClient||(v=(0,I.mixin)(v,this._defaultData),v=(0,b.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=R}),define(J[124],Q([0,1,6,13]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(D,R){const w=Object.create(null),l=(y,T)=>{const c=JSON.parse(y);w[T]=c};if(R){const y=[],T=await I.Promises.readdir(R);for(const E of T)try{(await I.Promises.stat((0,C.join)(R,E))).isDirectory()&&y.push(E)}catch{}const c=[];for(const E of y)(await I.Promises.readdir((0,C.join)(R,E))).filter(d=>d==="telemetry.json").length===1&&c.push(E);for(const E of c){const f=(await I.Promises.readFile((0,C.join)(R,E,"telemetry.json"))).toString();l(f,E)}}let v=(await I.Promises.readFile((0,C.join)(D,"telemetry-core.json"))).toString();return l(v,"vscode-core"),v=(await I.Promises.readFile((0,C.join)(D,"telemetry-extensions.json"))).toString(),l(v,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=b}),define(J[37],Q([0,1,14]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(J[125],Q([0,1,11,2,9,20,23,16,15,37]),function(x,i,C,I,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends I.Disposable{constructor(c,E,f,d,g){super();this.extensionsManagementService=c,this.logService=d,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(S=>this.onInstallExtension(S))),this._register(c.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(c.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const m=b.URI.file(f.extensionsPath);this._register(E.watch(m)),this._register(C.Event.filter(E.onDidChangeFilesRaw,S=>S.changes.some(h=>this.doesChangeAffects(h,m)))(()=>this.onDidChange()))}doesChangeAffects(c,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),E)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const E of c)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(E=>!(0,R.areSameExtensions)(E,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,R.areSameExtensions)(E,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),E=c.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,R.areSameExtensions)(g,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),f=this.installedExtensions.filter(d=>this.installingExtensions.some(g=>(0,R.areSameExtensions)(g,d))?!1:c.every(g=>!(0,R.areSameExtensions)(g.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=c.map(d=>d.identifier),(E.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:f})}}};y=pe([se(1,w.IFileService),se(2,D.INativeEnvironmentService),se(3,l.ILogService),se(4,v.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(J[126],Q([0,1,37,91,16,18,59,11,2]),function(x,i,C,I,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class v{constructor(c){this.uri=c,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let y=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const E=new Map,f=d=>{let g=E.get(d.scheme);return g===void 0&&(g=c.hasProvider(d)&&!this._fileService.hasCapability(d,1024),E.set(d.scheme,g)),g};this._dispooables.add(w.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(d=>{E.delete(d.scheme)})),this.extUri=new D.ExtUri(f),this._canonicalUris=new R.SkipList((d,g)=>this.extUri.compare(d,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,D.normalizePath)(c));let E=this._canonicalUris.get(c);return E?E.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new v(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((f,d)=>f[1].touch<d[1].touch?1:f[1].touch>d[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let f=0;f<E;f++)this._canonicalUris.set(c[f][0],c[f][1].touch())}};y=pe([se(0,b.IFileService)],y),i.UriIdentityService=y,(0,I.registerSingleton)(C.IUriIdentityService,y,!0)}),define(J[45],Q([0,1,48,3,6,8,13,72,138,139]),function(x,i,C,I,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(n,r){let e=r.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=r}}i.ExtractError=y;function T(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,e)=>r+e,n&61440)}function c(a){if(a instanceof y)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new y(n,a)}function E(a,n,r,e,t,s){const u=b.dirname(n),p=b.join(e,u);if(!p.startsWith(e))return Promise.reject(new Error(w.localize(0,null,n)));const L=b.join(e,n);let P;return s.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(R.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!s.isCancellationRequested)try{P=(0,C.createWriteStream)(L,{mode:r}),P.once("close",()=>O()),P.once("error",N),a.once("error",N),a.pipe(P)}catch(G){N(G)}}))}function f(a,n,r,e){let t=(0,I.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{t.cancel(),a.close()}),new Promise((u,p)=>{const L=new I.Sequencer,P=O=>{O.isCancellationRequested||(s++,a.readEntry())};a.once("error",p),a.once("close",()=>t.then(()=>{e.isCancellationRequested||a.entryCount===s?u():p(new y("Incomplete",new Error(w.localize(1,null,s,a.entryCount))))},p)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){P(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const me=b.join(n,N);t=(0,I.createCancelablePromise)(ae=>R.Promises.mkdir(me,{recursive:!0}).then(()=>P(ae)).then(void 0,p));return}const G=g(a,O),ee=T(O);t=(0,I.createCancelablePromise)(me=>L.queue(()=>G.then(ae=>E(ae,N,ee,n,r,me).then(()=>P(me)))).then(null,p))})})}function d(a,n=!1){return new Promise((r,e)=>{(0,l.open)(a,n?{lazyEntries:!0}:void 0,(t,s)=>{t?e(c(t)):r((0,D.assertIsDefined)(s))})})}function g(a,n){return new Promise((r,e)=>{a.openReadStream(n,(t,s)=>{t?e(c(t)):r((0,D.assertIsDefined)(s))})})}function m(a,n){return new Promise((r,e)=>{const t=new v.ZipFile;n.forEach(u=>{u.contents?t.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&t.addFile(u.localPath,u.path)}),t.end();const s=(0,C.createWriteStream)(a);t.outputStream.pipe(s),t.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(a))})}i.zip=m;function S(a,n,r={},e){const t=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=d(a,!0);return r.overwrite&&(s=s.then(u=>R.Promises.rm(n).then(()=>u))),s.then(u=>f(u,n,{sourcePathRegex:t},e))}i.extract=S;function h(a,n){return d(a).then(r=>new Promise((e,t)=>{r.on("entry",s=>{s.fileName===n&&g(r,s).then(u=>e(u),u=>t(u))}),r.once("close",()=>t(new Error(w.localize(2,null,n))))}))}function o(a,n){return h(a,n).then(r=>new Promise((e,t)=>{const s=[];r.once("error",t),r.on("data",u=>s.push(u)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=o}),define(J[127],Q([0,1,45,79]),function(x,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(D){return(0,C.buffer)(D,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(w){throw new Error((0,I.localize)(0,null))}})}i.getManifest=b}),define(J[128],Q([0,1,19,3,7,2,10,6,12,18,43,9,31,13,45,80,20,22,23,90,16,15,32]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m,S,h,o,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let r=class extends D.Disposable{constructor(t,s,u,p,L){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=u,this.environmentService=p,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=p.builtinExtensionsPath,this.extensionsPath=p.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(u).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(u).message,m.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(s);return(0,C.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(p=>!s[new S.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),t&&(u=(0,S.groupByExtension)(u,L=>L.identifier).map(L=>L.sort((P,O)=>y.rcompare(P.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,u,p){const L=t.key(),P=w.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await E.Promises.rm(O)}catch(G){try{await E.Promises.rm(O)}catch(ee){}throw new m.ExtensionManagementError((0,d.localize)(0,null,O,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,P,p);let N=await this.scanExtension(T.URI.file(P),1);if(!N)throw new Error((0,d.localize)(1,null,P));await this.storeMetadata(N,{...u,installedTimestamp:Date.now()});try{await this.rename(t,P,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await E.Promises.rm(P)}catch(ee){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(G)}. Deleted from extracted location`,P),G}try{N=await this.scanExtension(T.URI.file(O),1)}catch(G){}if(N)return N;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const u=w.join(t.location.fsPath,"package.json"),p=await E.Promises.readFile(u,"utf8"),{manifest:L}=await this.parseManifest(p);return L.__metadata=s,await E.Promises.writeFile(u,JSON.stringify(L,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(u=>new S.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{s.forEach(p=>u[p.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(p=>delete p[t.key()]);const u=(await this.scanExtensions(1)).find(p=>new S.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(t))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(p){if(p.code!=="ENOENT")throw p}let u={};if(s)try{u=JSON.parse(s)}catch(p){}return t&&(t(u),Object.keys(u).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await E.Promises.rm(this.uninstalledPath)),u})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await E.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new S.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,u,p){this.logService.trace(`Started extracting the extension from ${s} to ${u}`);try{await E.Promises.rm(u)}catch(L){throw new m.ExtensionManagementError(this.joinErrors(L).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(s,u,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${u}:`,t.id)}catch(L){try{await E.Promises.rm(u)}catch(O){}let P=m.ExtensionManagementErrorCode.Extract;throw L instanceof f.ExtractError&&(L.type==="CorruptZip"?P=m.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(P=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(L.message,P)}}async rename(t,s,u,p){try{await E.Promises.rename(s,u)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${s} to ${u} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,u,p);throw new m.ExtensionManagementError(L.message||(0,d.localize)(3,null,s,u),L.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[u,p]=await Promise.all([t,s]);return[...u,...p]}async scanExtensionsInDir(t,s){const u=new I.Limiter(10),p=await this.fileService.resolve(T.URI.file(t));return p.children?(await Promise.all(p.children.filter(P=>P.isDirectory).map(P=>u.queue(async()=>s===1&&(0,v.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,s))))).filter(P=>P&&P.identifier):[]}async scanExtension(t,s){try{const u=await this.fileService.resolve(t);if(u.children){const{manifest:p,metadata:L}=await this.readManifest(t.fsPath),P=u.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=u.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,N={id:(0,S.getGalleryExtensionId)(p.publisher,p.name)},G={type:s,identifier:N,manifest:p,location:t,readmeUrl:P,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(G,L),G}}catch(u){s!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(u=>t.some(p=>(0,S.areSameExtensions)(u.identifier,{id:p})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),u=new Set;for(const P of s)t[new S.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||u.add(P.identifier.id.toLowerCase());const p=(0,S.groupByExtension)(s,P=>P.identifier);await I.Promises.settled(p.map(async P=>{const O=P.sort((N,G)=>y.rcompare(N.manifest.version,G.manifest.version))[0];u.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=s.filter(P=>t[new S.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await I.Promises.settled(L.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],u=(0,S.groupByExtension)(t,p=>p.identifier);s.push(...(0,C.flatten)(u.map(p=>p.sort((L,P)=>y.rcompare(L.manifest.version,P.manifest.version)).slice(1)))),await I.Promises.settled(s.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((u,p)=>new Error(`${u.message}${u.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(R.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[E.Promises.readFile(w.join(t,"package.json"),"utf8").then(P=>this.parseManifest(P)),E.Promises.readFile(w.join(t,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:u,metadata:p},L]=await Promise.all(s);return{manifest:(0,h.localizeManifest)(u,L),metadata:p}}parseManifest(t){return new Promise((s,u)=>{try{const p=JSON.parse(t),L=p.__metadata||null;s({manifest:p,metadata:L})}catch(p){u(new Error((0,d.localize)(4,null)))}})}};r=pe([se(1,o.IFileService),se(2,a.ILogService),se(3,g.INativeEnvironmentService),se(4,n.IProductService)],r),i.ExtensionsScanner=r}),define(J[129],Q([0,1,27,7,10,6,12,28,18,43,9,31,13,45,78,52,20,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m,S,h,o,a,n,r,e,t,s,u,p,L,P,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let G=class extends m.AbstractExtensionManagementService{constructor(W,$,ne,M,k,V,H,ie,K){super(W,$,ne,ie);this.environmentService=M,this.downloadService=k,this.fileService=H;const Z=this._register(V.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(e.ExtensionsScanner,le=>Z.postUninstall(le))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(V.createInstance(o.ExtensionsDownloader));const _=this._register(new t.ExtensionsWatcher(this,H,M,ne,K));this._register(_.onDidChangeExtensionsByAnotherSource(({added:le,removed:U})=>{le.length&&this._onDidInstallExtensions.fire(le.map(A=>({identifier:A.identifier,operation:1,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),$=(0,S.getTargetPlatform)(W?"alpine":R.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",$),$})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let W;try{W=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch($){try{W=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const $=await this.collectFiles(W),ne=await(0,E.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)()).fsPath,$);return y.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const $=await this.downloadVsix(W),ne=D.resolve($.fsPath);return(0,n.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,$={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),M=await(0,n.getManifest)(D.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,h.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,$)}async updateMetadata(W,$){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===b.Schemas.file)return W;const $=(0,l.joinPath)(this.environmentService.tmpDir,(0,T.generateUuid)());return await this.downloadService.download(W,$),$}createInstallExtensionTask(W,$,ne){return y.URI.isUri($)?new ae(W,$,ne,this.galleryService,this.extensionsScanner,this.logService):new me($,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,$){return new te(W,$,this.extensionsScanner)}async collectFiles(W){const $=async M=>{let k=await c.Promises.readdir(M);k=k.map(ie=>D.join(M,ie));const V=await Promise.all(k.map(ie=>c.Promises.stat(ie)));let H=Promise.resolve([]);return V.forEach((ie,K)=>{const Z=k[K];ie.isFile()&&(H=H.then(_=>[..._,Z])),ie.isDirectory()&&(H=H.then(_=>$(Z).then(le=>[..._,...le])))}),H};return(await $(W.location.fsPath)).map(M=>({path:`extension/${D.relative(W.location.fsPath,M)}`,localPath:M}))}};G=pe([se(0,S.IExtensionGalleryService),se(1,O.ITelemetryService),se(2,L.ILogService),se(3,g.INativeEnvironmentService),se(4,d.IDownloadService),se(5,p.IInstantiationService),se(6,u.IFileService),se(7,P.IProductService),se(8,N.IUriIdentityService)],G),i.ExtensionManagementService=G;class ee extends m.AbstractExtensionTask{constructor(W,$,ne,M){super();this.identifier=W,this.source=$,this.extensionsScanner=ne,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(W,$){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...W.metadata}):ne}catch(ne){throw R.isMacintosh?new S.ExtensionManagementError(f.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(f.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(W,$)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:$,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension($,W,ne,M);return this.logService.info("Extracting completed.",$.id),k}}class me extends ee{constructor(W,$,ne,M,k){super(W.identifier,W,M,k);this.gallery=W,this.options=$,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,h.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease;try{const k=await this.installExtension(M,W);return ne&&v.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(y.URI.file(W))}catch($){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,I.getErrorMessage)($))}}async downloadInstallableExtension(W,$){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",W.identifier.id),M=(await this.extensionsDownloader.downloadExtension(W,$)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,M)}catch(k){throw new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Download)}try{const k=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new h.ExtensionIdentifierWithVersion(W.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Invalid)}}}class ae extends ee{constructor(W,$,ne,M,k,V){super({id:(0,h.getGalleryExtensionId)(W.publisher,W.name)},$,k,V);this.manifest=W,this.location=$,this.options=ne,this.galleryService=M}async doRun(W){const $=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(V=>(0,h.areSameExtensions)(this.identifier,V.identifier)),k=await this.getMetadata(this.identifier.id,W);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,$.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(V){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const V=await this.unsetUninstalledAndGetLocal($);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch(H){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:$,metadata:k},W)}async getMetadata(W,$){try{const ne=(await this.galleryService.query({names:[W],pageSize:1},$)).firstPage[0];if(ne)return{id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId}}catch(ne){}return{}}}class te extends m.AbstractExtensionTask{constructor(W,$,ne){super();this.extension=W,this.options=$,this.extensionsScanner=ne}async doRun(W){const $=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...ne.filter(k=>M.equals(new h.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else $.push(...ne.filter(M=>(0,h.areSameExtensions)(M.identifier,this.extension.identifier)));if(!$.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const M of $)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(f.localize(6,null,(0,C.toErrorMessage)(k)))}}}}),define(J[130],Q([0,1,115,3,17,7,2,8,25,20,93,15,114,140]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let f=class extends R.Disposable{constructor(g,m,S){super();this.environmentService=m,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,m){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:h}=this;let o;try{o=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const a={...process.env,...o},n=g.agent?g.agent:await(0,c.getProxyAgent)(g.url||"",a,{proxyUrl:S,strictSSL:h});return g.agent=n,g.strictSSL=h,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,m)}async getNodeRequest(g){return((0,C.parse)(g.url).protocol==="https:"?await new Promise((h,o)=>{x(["https"],h,o)}):await new Promise((h,o)=>{x(["http"],h,o)})).request}_request(g,m){return I.Promises.withAsyncBody(async(S,h)=>{let o;const a=(0,C.parse)(g.url),n=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,w.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(r.auth=g.user+":"+g.password),o=n(r,e=>{const t=(0,w.isNumber)(g.followRedirects)?g.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&t>0&&e.headers.location)this._request({...g,url:e.headers.location,followRedirects:t-1},m).then(S,h);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,E.createGunzip)())),S({res:e,stream:(0,b.streamToBufferReadableStream)(s)})}}),o.on("error",h),g.timeout&&o.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&o.write(g.data),o.end(),m.onCancellationRequested(()=>{o.abort(),h((0,D.canceled)())})})}async resolveProxy(g){}};f=pe([se(0,l.IConfigurationService),se(1,v.INativeEnvironmentService),se(2,T.ILogService)],f),i.RequestService=f}),define(J[141],Q([0,1,33,3,17,27,7,2,10,6,28,9,13,25,107,52,113,20,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(x,i,C,I,b,D,R,w,l,v,y,T,c,E,f,d,g,m,S,h,o,a,n,r,e,t,s,u,p,L,P,O,N,G,ee,me,ae,te,de,W,$,ne,M,k,V){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async le=>{const U=le.get(O.ILogService),A=le.get(r.IFileService),q=le.get(m.INativeEnvironmentService),j=le.get(o.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(q,j,A),await Promise.all(_.map(Y=>{(0,I.raceTimeout)(Y.flush(),1e3)}))})}async initServices(){const Z=new p.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const le=new S.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,le),await Promise.all([le.appSettingsHome.fsPath,le.extensionsPath].map(fe=>fe?c.Promises.mkdir(fe,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(le),A=[];A.push(new N.SpdLogLogger("cli",(0,v.join)(le.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&A.push(new O.ConsoleLogger(U));const q=this._register(new O.MultiplexLogService(A));Z.set(O.ILogService,q);const j=this._register(new e.FileService(q));Z.set(r.IFileService,j);const Y=this._register(new t.DiskFileSystemProvider(q));j.registerProvider(l.Schemas.file,Y);const X=this._register(new f.ConfigurationService(le.settingsResource,j));Z.set(E.IConfigurationService,X),await X.initialize(),Z.set(k.IUriIdentityService,new V.UriIdentityService(j)),Z.set(me.IRequestService,new s.SyncDescriptor(ae.RequestService)),Z.set(d.IDownloadService,new s.SyncDescriptor(g.DownloadService)),Z.set(o.IExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService)),Z.set(o.IExtensionGalleryService,new s.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService)),Z.set(o.IExtensionManagementCLIService,new s.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new s.SyncDescriptor(P.LocalizationsService));const ge=[];if((0,$.supportsTelemetry)(_,le)){_.aiConfig&&_.aiConfig.asimovKey&&ge.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:fe,extensionsPath:ue,installSourcePath:re}=le,ye={appenders:ge,sendErrorTelemetry:!1,commonProperties:(async()=>{let oe;try{const he=await c.Promises.readFile((0,v.join)(le.userDataPath,"storage.json"));oe=JSON.parse(he.toString())[de.machineIdKey]}catch(he){he.code!=="ENOENT"&&q.error(he)}return(0,te.resolveCommonProperties)(j,(0,C.release)(),(0,C.hostname)(),process.arch,_.commit,_.version,oe,_.msftInternalDomains,re)})(),piiPaths:[fe,ue]};Z.set(de.ITelemetryService,new s.SyncDescriptor(W.TelemetryService,[ye]))}else Z.set(de.ITelemetryService,$.NullTelemetryService);return[new u.InstantiationService(Z),ge]}registerErrorHandler(Z){(0,R.setUnexpectedErrorHandler)(_=>{const le=(0,D.toErrorMessage)(_,!0);!le||Z.error(`[uncaught exception in CLI]: ${le}`)}),process.on("uncaughtException",_=>(0,R.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,R.onUnexpectedError)(_))}async doRun(Z,_,le){if(this.argv["install-source"])return this.setInstallSource(Z,le,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?T.URI.file((0,v.isAbsolute)(_)?_:(0,v.join)((0,y.cwd)(),_)):_)}async setInstallSource(Z,_,le){await _.writeFile(T.URI.file(Z.installSourcePath),b.VSBuffer.fromString(le.slice(0,30)))}}async function ie(K){const Z=new H(K);try{await Z.run()}finally{Z.dispose()}}i.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c56f0cae849839138fbd83fe4d5c7219c7ff806/core/vs/code/node/cliProcessMain.js.map
