/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(oe){for(var e=[],c=0,F=oe.length;c<F;c++)e[c]=Ee[oe[c]];return e};define(Ee[41],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(F,w){if(!F)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=c}),define(Ee[74],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function F(A){const _=[];for(let n in A)c.call(A,n)&&_.push(A[n]);return _}e.values=F;function w(A,_){for(let n in A)if(c.call(A,n)&&_({key:n,value:A[n]},function(){delete A[n]})===!1)return}e.forEach=w;function P(A,_){const n=Object.create(null);for(const f of A){const o=_(f);let u=n[o];u||(u=n[o]=[]),u.push(f)}return n}e.groupBy=P;function t(A){const _=Object.create(null);return A&&A.forEach((n,f)=>{_[f]=n}),_}e.fromMap=t;function T(A,_){const n=[],f=[];for(let o of A)_.has(o)||n.push(o);for(let o of _)A.has(o)||f.push(o);return{removed:n,added:f}}e.diffSets=T;function S(A,_){const n=[],f=[];for(let[o,u]of A)_.has(o)||n.push(u);for(let[o,u]of _)A.has(o)||f.push(u);return{removed:n,added:f}}e.diffMaps=S;class D{constructor(){this.map=new Map}add(_,n){let f=this.map.get(_);f||(f=new Set,this.map.set(_,f)),f.add(n)}delete(_,n){const f=this.map.get(_);!f||(f.delete(n),f.size===0&&this.map.delete(_))}forEach(_,n){const f=this.map.get(_);!f||f.forEach(n)}}e.SetMap=D}),define(Ee[51],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(t){return(T,S,D)=>{let A=null,_=null;if(typeof D.value=="function"?(A="value",_=D.value):typeof D.get=="function"&&(A="get",_=D.get),!_)throw new Error("not supported");D[A]=t(_,S)}}e.createDecorator=c;function F(t,T,S){let D=null,A=null;if(typeof S.value=="function"?(D="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",A=S.get),!A)throw new Error("not supported");const _=`$memoize$${T}`;S[D]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,n)}),this[_]}}e.memoize=F;function w(t,T,S){return c((D,A)=>{const _=`$debounce$${A}`,n=`$debounce$result$${A}`;return function(...f){this[n]||(this[n]=S?S():void 0),clearTimeout(this[_]),T&&(this[n]=T(this[n],...f),f=[this[n]]),this[_]=setTimeout(()=>{D.apply(this,f),this[n]=S?S():void 0},t)}})}e.debounce=w;function P(t,T,S){return c((D,A)=>{const _=`$throttle$timer$${A}`,n=`$throttle$result$${A}`,f=`$throttle$lastRun$${A}`,o=`$throttle$pending$${A}`;return function(...u){if(this[n]||(this[n]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),T&&(this[n]=T(this[n],...u)),this[o])return;const h=this[f]+t;h<=Date.now()?(this[f]=Date.now(),D.apply(this,[this[n]]),this[n]=S?S():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),D.apply(this,[this[n]]),this[n]=S?S():void 0},h-Date.now()))}})}e.throttle=P}),define(Ee[52],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Ee[100],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var F;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(l){l.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function t(l,M=!1){let r=0,i=l.length,g="",d=0,s=16,v=0;function a(x){let N=0,z=0;for(;N<x;){const H=l.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,N++}return N<x&&(z=-1),z}function E(x){r=x,g="",d=0,s=16,v=0}function I(){const x=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&D(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&D(l.charCodeAt(r)))for(r++;r<l.length&&D(l.charCodeAt(r));)r++;else return v=3,l.substring(x,r);let N=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&D(l.charCodeAt(r))){for(r++;r<l.length&&D(l.charCodeAt(r));)r++;N=r}else v=3;return l.substring(x,N)}function k(){let x="",N=r;for(;;){if(r>=i){x+=l.substring(N,r),v=2;break}const z=l.charCodeAt(r);if(z===34){x+=l.substring(N,r),r++;break}if(z===92){if(x+=l.substring(N,r),r++,r>=i){v=2;break}switch(l.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const q=a(4);q>=0?x+=String.fromCharCode(q):v=4;break;default:v=5}N=r;continue}if(z>=0&&z<=31)if(S(z)){x+=l.substring(N,r),v=2;break}else v=6;r++}return x}function B(){if(g="",v=0,d=r,r>=i)return d=i,s=17;let x=l.charCodeAt(r);if(T(x)){do r++,g+=String.fromCharCode(x),x=l.charCodeAt(r);while(T(x));return s=15}if(S(x))return r++,g+=String.fromCharCode(x),x===13&&l.charCodeAt(r)===10&&(r++,g+=`
`),s=14;switch(x){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,g=k(),s=10;case 47:const N=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(l.charCodeAt(r));)r++;return g=l.substring(N,r),s=12}if(l.charCodeAt(r+1)===42){r+=2;const z=i-1;let H=!1;for(;r<z;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,v=1),g=l.substring(N,r),s=13}return g+=String.fromCharCode(x),r++,s=16;case 45:if(g+=String.fromCharCode(x),r++,r===i||!D(l.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=I(),s=11;default:for(;r<i&&L(x);)r++,x=l.charCodeAt(r);if(d!==r){switch(g=l.substring(d,r),g){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return g+=String.fromCharCode(x),r++,s=16}}function L(x){if(T(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:M?y:B,getToken:()=>s,getTokenValue:()=>g,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>v}}e.createScanner=t;function T(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function S(l){return l===10||l===13||l===8232||l===8233}function D(l){return l>=48&&l<=57}var A;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(A||(A={}));function _(l,M){const r=[],i=new Object;let g;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function v(a,E,I,k){d.value=a,d.offset=E,d.length=I,d.type=k,d.colonOffset=void 0,g=d}try{m(l,{onObjectBegin:(a,E)=>{if(M<=a)throw i;g=void 0,s=M>a,r.push("")},onObjectProperty:(a,E,I)=>{if(M<E||(v(a,E,I,"property"),r[r.length-1]=a,M<=E+I))throw i},onObjectEnd:(a,E)=>{if(M<=a)throw i;g=void 0,r.pop()},onArrayBegin:(a,E)=>{if(M<=a)throw i;g=void 0,r.push(0)},onArrayEnd:(a,E)=>{if(M<=a)throw i;g=void 0,r.pop()},onLiteralValue:(a,E,I)=>{if(M<E||(v(a,E,I,R(a)),M<=E+I))throw i},onSeparator:(a,E,I)=>{if(M<=E)throw i;if(a===":"&&g&&g.type==="property")g.colonOffset=E,s=!1,g=void 0;else if(a===","){const k=r[r.length-1];typeof k=="number"?r[r.length-1]=k+1:(s=!0,r[r.length-1]=""),g=void 0}}})}catch(a){if(a!==i)throw a}return{path:r,previousNode:g,isAtPropertyKey:s,matches:a=>{let E=0;for(let I=0;E<a.length&&I<r.length;I++)if(a[E]===r[I]||a[E]==="*")E++;else if(a[E]!=="**")return!1;return E===a.length}}}e.getLocation=_;function n(l,M=[],r=P.DEFAULT){let i=null,g=[];const d=[];function s(a){Array.isArray(g)?g.push(a):i!==null&&(g[i]=a)}return m(l,{onObjectBegin:()=>{const a={};s(a),d.push(g),g=a,i=null},onObjectProperty:a=>{i=a},onObjectEnd:()=>{g=d.pop()},onArrayBegin:()=>{const a=[];s(a),d.push(g),g=a,i=null},onArrayEnd:()=>{g=d.pop()},onLiteralValue:s,onError:(a,E,I)=>{M.push({error:a,offset:E,length:I})}},r),g[0]}e.parse=n;function f(l,M=[],r=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(a){i.type==="property"&&(i.length=a-i.offset,i=i.parent)}function d(a){return i.children.push(a),a}m(l,{onObjectBegin:a=>{i=d({type:"object",offset:a,length:-1,parent:i,children:[]})},onObjectProperty:(a,E,I)=>{i=d({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:a,offset:E,length:I,parent:i})},onObjectEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,g(a+E)},onArrayBegin:(a,E)=>{i=d({type:"array",offset:a,length:-1,parent:i,children:[]})},onArrayEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,g(a+E)},onLiteralValue:(a,E,I)=>{d({type:R(a),offset:E,length:I,parent:i,value:a}),g(E+I)},onSeparator:(a,E,I)=>{i.type==="property"&&(a===":"?i.colonOffset=E:a===","&&g(E))},onError:(a,E,I)=>{M.push({error:a,offset:E,length:I})}},r);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=f;function o(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let g=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===i){r=d.children[1],g=!0;break}if(!g)return}else{const g=i;if(r.type!=="array"||g<0||!Array.isArray(r.children)||g>=r.children.length)return;r=r.children[g]}return r}e.findNodeAtLocation=o;function u(l){if(!l.parent||!l.parent.children)return[];const M=u(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=u;function h(l){switch(l.type){case"array":return l.children.map(h);case"object":const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=h(i))}return M;case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=h;function C(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=C;function b(l,M,r=!1){if(C(l,M,r)){const i=l.children;if(Array.isArray(i))for(let g=0;g<i.length&&i[g].offset<=M;g++){const d=b(i[g],M,r);if(d)return d}return l}}e.findNodeAtOffset=b;function m(l,M,r=P.DEFAULT){const i=t(l,!1);function g(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=g(M.onObjectBegin),v=d(M.onObjectProperty),a=g(M.onObjectEnd),E=g(M.onArrayBegin),I=g(M.onArrayEnd),k=d(M.onLiteralValue),B=d(M.onSeparator),L=g(M.onComment),y=d(M.onError),x=r&&r.disallowComments,N=r&&r.allowTrailingComma;function z(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:x||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ie){case 12:case 13:x?H(10):L();break;case 16:H(1);break;case 15:case 14:break;default:return ie}}}function H(ie,we=[],Me=[]){if(y(ie),we.length+Me.length>0){let Fe=i.getToken();for(;Fe!==17;){if(we.indexOf(Fe)!==-1){z();break}else if(Me.indexOf(Fe)!==-1)break;Fe=z()}}}function q(ie){const we=i.getTokenValue();return ie?k(we):v(we),z(),!0}function ue(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(H(2),ie=0)}catch(we){H(2)}k(ie);break;case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return z(),!0}function K(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(B(":"),z(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ce(){s(),z();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===2&&N)break}else ie&&H(6,[],[]);K()||H(4,[],[2,5]),ie=!0}return a(),i.getToken()!==2?H(7,[2],[]):z(),!0}function de(){E(),z();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===4&&N)break}else ie&&H(6,[],[]);Q()||H(4,[],[4,5]),ie=!0}return I(),i.getToken()!==4?H(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return de();case 1:return ce();case 10:return q(!0);default:return ue()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=m;function p(l,M){let r=t(l),i=[],g,d=0,s;do switch(s=r.getPosition(),g=r.scan(),g){case 12:case 13:case 17:d!==s&&i.push(l.substring(d,s)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),d=r.getPosition();break}while(g!==17);return i.join("")}e.stripComments=p;function R(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(Ee[101],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new c(()=>w(this.getValue()))}}e.Lazy=c}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var ve=0;ve<Se.length;ve++){var re=Se[ve];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Pe,re.key,re)}}function e(Pe,Se,ve){return Se&&oe(Pe.prototype,Se),ve&&oe(Pe,ve),Pe}function c(Pe,Se){if(!!Pe){if(typeof Pe=="string")return F(Pe,Se);var ve=Object.prototype.toString.call(Pe).slice(8,-1);if(ve==="Object"&&Pe.constructor&&(ve=Pe.constructor.name),ve==="Map"||ve==="Set")return Array.from(Pe);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return F(Pe,Se)}}function F(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var ve=0,re=new Array(Se);ve<Se;ve++)re[ve]=Pe[ve];return re}function w(Pe,Se){var ve=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ve)return(ve=ve.call(Pe)).next.bind(ve);if(Array.isArray(Pe)||(ve=c(Pe))||Se&&Pe&&typeof Pe.length=="number"){ve&&(Pe=ve);var re=0;return function(){return re>=Pe.length?{done:!0}:{done:!1,value:Pe[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Pe){P.exports.defaults=Pe}P.exports={defaults:t(),getDefaults:t,changeDefaults:T};var S=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Se){return n[Se]};function o(Pe,Se){if(Se){if(S.test(Pe))return Pe.replace(D,f)}else if(A.test(Pe))return Pe.replace(_,f);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Pe){return Pe.replace(u,function(Se,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var C=/(^|[^\[])\^/g;function b(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var ve={replace:function(ae,he){return he=he.source||he,he=he.replace(C,"$1"),Pe=Pe.replace(ae,he),ve},getRegex:function(){return new RegExp(Pe,Se)}};return ve}var m=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function R(Pe,Se,ve){if(Pe){var re;try{re=decodeURIComponent(h(ve)).replace(m,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!p.test(ve)&&(ve=g(Se,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch(ae){return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(Pe,Se){l[" "+Pe]||(M.test(Pe)?l[" "+Pe]=Pe+"/":l[" "+Pe]=a(Pe,"/",!0)),Pe=l[" "+Pe];var ve=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?ve?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?ve?Se:Pe.replace(i,"$1")+Se:Pe+Se}var d={exec:function(){}};function s(Pe){for(var Se=1,ve,re;Se<arguments.length;Se++){ve=arguments[Se];for(re in ve)Object.prototype.hasOwnProperty.call(ve,re)&&(Pe[re]=ve[re])}return Pe}function v(Pe,Se){var ve=Pe.replace(/\|/g,function(he,me,Ie){for(var ze=!1,Oe=me;--Oe>=0&&Ie[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),re=ve.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function a(Pe,Se,ve){var re=Pe.length;if(re===0)return"";for(var ae=0;ae<re;){var he=Pe.charAt(re-ae-1);if(he===Se&&!ve)ae++;else if(he!==Se&&ve)ae++;else break}return Pe.substr(0,re-ae)}function E(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var ve=Pe.length,re=0,ae=0;ae<ve;ae++)if(Pe[ae]==="\\")ae++;else if(Pe[ae]===Se[0])re++;else if(Pe[ae]===Se[1]&&(re--,re<0))return ae;return-1}function I(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Pe,Se){if(Se<1)return"";for(var ve="";Se>1;)Se&1&&(ve+=Pe),Se>>=1,Pe+=Pe;return ve+Pe}var B={escape:o,unescape:h,edit:b,cleanUrl:R,resolveUrl:g,noopTest:d,merge:s,splitCells:v,rtrim:a,findClosingBracket:E,checkSanitizeDeprecation:I,repeatString:k},L=P.exports.defaults,y=B.rtrim,x=B.splitCells,N=B.escape,z=B.findClosingBracket;function H(Pe,Se,ve,re){var ae=Se.href,he=Se.title?N(Se.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){re.state.inLink=!0;var Ie={type:"link",raw:ve,href:ae,title:he,text:me,tokens:re.inlineTokens(me,[])};return re.state.inLink=!1,Ie}else return{type:"image",raw:ve,href:ae,title:he,text:N(me)}}function q(Pe,Se){var ve=Pe.match(/^(\s+)(?:```)/);if(ve===null)return Se;var re=ve[1];return Se.split(`
`).map(function(ae){var he=ae.match(/^\s+/);if(he===null)return ae;var me=he[0];return me.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var ue=function(){function Pe(ve){this.options=ve||L}var Se=Pe.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var he=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?he:y(he,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var he=ae[0],me=q(he,ae[3]||"");return{type:"code",raw:he,lang:ae[2]?ae[2].trim():ae[2],text:me}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var he=ae[2].trim();if(/#$/.test(he)){var me=y(he,"#");(this.options.pedantic||!me||/ $/.test(me))&&(he=me.trim())}var Ie={type:"heading",raw:ae[0],depth:ae[1].length,text:he,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var he=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var he,me,Ie,ze,Oe,We,it,ot,ne,ge,te=ae[1].trim(),W=te.length>1,be={type:"list",raw:"",ordered:W,start:W?+te.slice(0,-1):"",loose:!1,items:[]};te=W?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=W?te:"[*+-]");for(var ke=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");re&&!(this.rules.block.hr.test(re)||!(ae=ke.exec(re)));){ne=ae[2].split(`
`),this.options.pedantic?(ze=2,ge=ne[0].trimLeft()):(ze=ae[2].search(/[^ ]/),ze=ae[1].length+(ze>4?1:ze),ge=ne[0].slice(ze-ae[1].length)),We=!1,he=ae[0],!ne[0]&&/^ *$/.test(ne[1])&&(he=ae[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(ot=ne[Oe],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(ot)){he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!We){ot.trim()||(We=!0),ot.search(/[^ ]/)>=ze?ge+=`
`+ot.slice(ze):ge+=`
`+ot;continue}if(ot.search(/[^ ]/)>=ze||!ot.trim()){ge+=`
`+ot.slice(ze);continue}else{he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Ie=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:he,task:!!me,checked:Ie,loose:!1,text:ge}),be.raw+=he,re=re.slice(he.length)}be.items[be.items.length-1].raw=he.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var Le=be.items.length;for(Oe=0;Oe<Le;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(dt){return dt.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var he={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var he=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var he={type:"table",header:x(ae[1]).map(function(it){return{text:it}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=ae[0];var me=he.align.length,Ie,ze,Oe,We;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(he.align[Ie])?he.align[Ie]="right":/^ *:-+: *$/.test(he.align[Ie])?he.align[Ie]="center":/^ *:-+ *$/.test(he.align[Ie])?he.align[Ie]="left":he.align[Ie]=null;for(me=he.rows.length,Ie=0;Ie<me;Ie++)he.rows[Ie]=x(he.rows[Ie],he.header.length).map(function(it){return{text:it}});for(me=he.header.length,ze=0;ze<me;ze++)he.header[ze].tokens=[],this.lexer.inlineTokens(he.header[ze].text,he.header[ze].tokens);for(me=he.rows.length,ze=0;ze<me;ze++)for(We=he.rows[ze],Oe=0;Oe<We.length;Oe++)We[Oe].tokens=[],this.lexer.inlineTokens(We[Oe].text,We[Oe].tokens);return he}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae){var he={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var he={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae){var he={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:N(ae[1])}},Se.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]):ae[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var he=ae[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var me=y(he.slice(0,-1),"\\");if((he.length-me.length)%2==0)return}else{var Ie=z(ae[2],"()");if(Ie>-1){var ze=ae[0].indexOf("!")===0?5:4,Oe=ze+ae[1].length+Ie;ae[2]=ae[2].substring(0,Ie),ae[0]=ae[0].substring(0,Oe).trim(),ae[3]=""}}var We=ae[2],it="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);ot&&(We=ot[1],it=ot[3])}else it=ae[3]?ae[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(he)?We=We.slice(1):We=We.slice(1,-1)),H(ae,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(re,ae){var he;if((he=this.rules.inline.reflink.exec(re))||(he=this.rules.inline.nolink.exec(re))){var me=(he[2]||he[1]).replace(/\s+/g," ");if(me=ae[me.toLowerCase()],!me||!me.href){var Ie=he[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(he,me,he[0],this.lexer)}},Se.emStrong=function(re,ae,he){he===void 0&&(he="");var me=this.rules.inline.emStrong.lDelim.exec(re);if(!!me&&!(me[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(he===""||this.rules.inline.punctuation.exec(he))){var ze=me[0].length-1,Oe,We,it=ze,ot=0,ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,ae=ae.slice(-1*re.length+ze);(me=ne.exec(ae))!=null;)if(Oe=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Oe){if(We=Oe.length,me[3]||me[4]){it+=We;continue}else if((me[5]||me[6])&&ze%3&&!((ze+We)%3)){ot+=We;continue}if(it-=We,!(it>0)){if(We=Math.min(We,We+it+ot),Math.min(ze,We)%2){var ge=re.slice(1,ze+me.index+We);return{type:"em",raw:re.slice(0,ze+me.index+We+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var te=re.slice(2,ze+me.index+We-1);return{type:"strong",raw:re.slice(0,ze+me.index+We+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var he=ae[2].replace(/\n/g," "),me=/[^ ]/.test(he),Ie=/^ /.test(he)&&/ $/.test(he);return me&&Ie&&(he=he.substring(1,he.length-1)),he=N(he,!0),{type:"codespan",raw:ae[0],text:he}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(re,ae){var he=this.rules.inline.autolink.exec(re);if(he){var me,Ie;return he[2]==="@"?(me=N(this.options.mangle?ae(he[1]):he[1]),Ie="mailto:"+me):(me=N(he[1]),Ie=me),{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(re,ae){var he;if(he=this.rules.inline.url.exec(re)){var me,Ie;if(he[2]==="@")me=N(this.options.mangle?ae(he[0]):he[0]),Ie="mailto:"+me;else{var ze;do ze=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(ze!==he[0]);me=N(he[0]),he[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(re,ae){var he=this.rules.inline.text.exec(re);if(he){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):N(he[0]):he[0]:me=N(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:me}}},Pe}(),K=B.noopTest,ce=B.edit,de=B.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=ce(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=ce(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=ce(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=ce(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=ce(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=ce(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=de({},Q),Q.gfm=de({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=ce(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=de({},Q.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:ce(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=ce(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=ce(Q._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=ce(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=ce(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=ce(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=ce(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=ce(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=ce(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=ce(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=ce(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=de({},ie),ie.pedantic=de({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=de({},ie.normal,{escape:ce(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=ce(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=de({},ie.gfm,{br:ce(ie.br).replace("{2,}","*").getRegex(),text:ce(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Q,inline:ie},Me=ue,Fe=P.exports.defaults,Be=we.block,Ge=we.inline,je=B.repeatString;function Qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Pe){var Se="",ve,re,ae=Pe.length;for(ve=0;ve<ae;ve++)re=Pe.charCodeAt(ve),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var G=function(){function Pe(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Fe,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:Be.normal,inline:Ge.normal};this.options.pedantic?(re.block=Be.pedantic,re.inline=Ge.pedantic):this.options.gfm&&(re.block=Be.gfm,this.options.breaks?re.inline=Ge.breaks:re.inline=Ge.gfm),this.tokenizer.rules=re}Pe.lex=function(re,ae){var he=new Pe(ae);return he.lex(re)},Pe.lexInline=function(re,ae){var he=new Pe(ae);return he.inlineTokens(re)};var Se=Pe.prototype;return Se.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var me,Ie,ze,Oe;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.space(re)){re=re.substring(me.raw.length),me.type&&ae.push(me);continue}if(me=this.tokenizer.code(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(me=this.tokenizer.fences(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.heading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.hr(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.blockquote(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.list(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.html(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.def(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.lheading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,ot=re.slice(1),ne=void 0;he.options.extensions.startBlock.forEach(function(ge){ne=ge.call({lexer:this},ot),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<Infinity&&it>=0&&(ze=re.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(ze))){Ie=ae[ae.length-1],Oe&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me),Oe=ze.length!==re.length,re=re.substring(me.raw.length);continue}if(me=this.tokenizer.text(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(re){var We="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return this.state.top=!0,ae},Se.inline=function(re,ae){this.inlineQueue.push({src:re,tokens:ae})},Se.inlineTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]);var me,Ie,ze,Oe=re,We,it,ot;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(it||(ot=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(me=te.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.escape(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.tag(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.link(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.emStrong(re,Oe,ot)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.codespan(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.br(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.del(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.autolink(re,$)){re=re.substring(me.raw.length),ae.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(re,$))){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startInline&&function(){var te=Infinity,W=re.slice(1),be=void 0;he.options.extensions.startInline.forEach(function(ke){be=ke.call({lexer:this},W),typeof be=="number"&&be>=0&&(te=Math.min(te,be))}),te<Infinity&&te>=0&&(ze=re.substring(0,te+1))}(),me=this.tokenizer.inlineText(ze,Qe)){re=re.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ot=me.raw.slice(-1)),it=!0,Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ae},e(Pe,null,[{key:"rules",get:function(){return{block:Be,inline:Ge}}}]),Pe}(),X=P.exports.defaults,se=B.cleanUrl,j=B.escape,Z=function(){function Pe(ve){this.options=ve||X}var Se=Pe.prototype;return Se.code=function(re,ae,he){var me=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(re,me);Ie!=null&&Ie!==re&&(he=!0,re=Ie)}return re=re.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(he?re:j(re,!0))+`</code></pre>
`:"<pre><code>"+(he?re:j(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,he,me){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+me.slug(he)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,he){var me=ae?"ol":"ul",Ie=ae&&he!==1?' start="'+he+'"':"";return"<"+me+Ie+`>
`+re+"</"+me+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var he=ae.header?"th":"td",me=ae.align?"<"+he+' align="'+ae.align+'">':"<"+he+">";return me+re+"</"+he+`>
`},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<a href="'+j(re)+'"';return ae&&(me+=' title="'+ae+'"'),me+=">"+he+"</a>",me},Se.image=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<img src="'+re+'" alt="'+he+'"';return ae&&(me+=' title="'+ae+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(re){return re},Pe}(),fe=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,he){return""+he},Se.image=function(re,ae,he){return""+he},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var he=re,me=0;if(this.seen.hasOwnProperty(he)){me=this.seen[re];do me++,he=re+"-"+me;while(this.seen.hasOwnProperty(he))}return ae||(this.seen[re]=me,this.seen[he]=0),he},Se.slug=function(re,ae){ae===void 0&&(ae={});var he=this.serialize(re);return this.getNextSafeSlug(he,ae.dryrun)},Pe}(),Ne=Z,He=fe,Ke=Te,tt=P.exports.defaults,st=B.unescape,Xe=function(){function Pe(ve){this.options=ve||tt,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ke}Pe.parse=function(re,ae){var he=new Pe(ae);return he.parse(re)},Pe.parseInline=function(re,ae){var he=new Pe(ae);return he.parseInline(re)};var Se=Pe.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var he="",me,Ie,ze,Oe,We,it,ot,ne,ge,te,W,be,ke,qe,Le,dt,bt,Ct,pt,ht=re.length;for(me=0;me<ht;me++){if(te=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(pt=this.options.extensions.renderers[te.type].call({parser:this},te),pt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){he+=pt||"";continue}switch(te.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(te.tokens),te.depth,st(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ne="",ot="",Oe=te.header.length,Ie=0;Ie<Oe;Ie++)ot+=this.renderer.tablecell(this.parseInline(te.header[Ie].tokens),{header:!0,align:te.align[Ie]});for(ne+=this.renderer.tablerow(ot),ge="",Oe=te.rows.length,Ie=0;Ie<Oe;Ie++){for(it=te.rows[Ie],ot="",We=it.length,ze=0;ze<We;ze++)ot+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:te.align[ze]});ge+=this.renderer.tablerow(ot)}he+=this.renderer.table(ne,ge);continue}case"blockquote":{ge=this.parse(te.tokens),he+=this.renderer.blockquote(ge);continue}case"list":{for(W=te.ordered,be=te.start,ke=te.loose,Oe=te.items.length,ge="",Ie=0;Ie<Oe;Ie++)Le=te.items[Ie],dt=Le.checked,bt=Le.task,qe="",Le.task&&(Ct=this.renderer.checkbox(dt),ke?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=Ct+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=Ct+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:Ct}):qe+=Ct),qe+=this.parse(Le.tokens,ke),ge+=this.renderer.listitem(qe,bt,dt);he+=this.renderer.list(ge,W,be);continue}case"html":{he+=this.renderer.html(te.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(ge=te.tokens?this.parseInline(te.tokens):te.text;me+1<ht&&re[me+1].type==="text";)te=re[++me],ge+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);he+=ae?this.renderer.paragraph(ge):ge;continue}default:{var vt='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return he},Se.parseInline=function(re,ae){ae=ae||this.renderer;var he="",me,Ie,ze,Oe=re.length;for(me=0;me<Oe;me++){if(Ie=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(ze=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){he+=ze||"";continue}switch(Ie.type){case"escape":{he+=ae.text(Ie.text);break}case"html":{he+=ae.html(Ie.text);break}case"link":{he+=ae.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ae));break}case"image":{he+=ae.image(Ie.href,Ie.title,Ie.text);break}case"strong":{he+=ae.strong(this.parseInline(Ie.tokens,ae));break}case"em":{he+=ae.em(this.parseInline(Ie.tokens,ae));break}case"codespan":{he+=ae.codespan(Ie.text);break}case"br":{he+=ae.br();break}case"del":{he+=ae.del(this.parseInline(Ie.tokens,ae));break}case"text":{he+=ae.text(Ie.text);break}default:{var We='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return he},Pe}(),rt=G,De=Xe,gt=ue,V=Z,J=fe,pe=Te,Ue=B.merge,Ye=B.checkSanitizeDeprecation,Je=B.escape,lt=P.exports.getDefaults,Et=P.exports.changeDefaults,It=P.exports.defaults;function et(Pe,Se,ve){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(ve=Se,Se=null),Se=Ue({},et.defaults,Se||{}),Ye(Se),ve){var re=Se.highlight,ae;try{ae=rt.lex(Pe,Se)}catch(ze){return ve(ze)}var he=function(Oe){var We;if(!Oe)try{Se.walkTokens&&et.walkTokens(ae,Se.walkTokens),We=De.parse(ae,Se)}catch(it){Oe=it}return Se.highlight=re,Oe?ve(Oe):ve(null,We)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return he();var me=0;et.walkTokens(ae,function(ze){ze.type==="code"&&(me++,setTimeout(function(){re(ze.text,ze.lang,function(Oe,We){if(Oe)return he(Oe);We!=null&&We!==ze.text&&(ze.text=We,ze.escaped=!0),me--,me===0&&he()})},0))}),me===0&&he();return}try{var Ie=rt.lex(Pe,Se);return Se.walkTokens&&et.walkTokens(Ie,Se.walkTokens),De.parse(Ie,Se)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(ze.message+"",!0)+"</pre>";throw ze}}et.options=et.setOptions=function(Pe){return Ue(et.defaults,Pe),Et(et.defaults),et},et.getDefaults=lt,et.defaults=It,et.use=function(){for(var Pe=this,Se=arguments.length,ve=new Array(Se),re=0;re<Se;re++)ve[re]=arguments[re];var ae=Ue.apply(void 0,[{}].concat(ve)),he=et.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var We=he.renderers?he.renderers[Oe.name]:null;We?he.renderers[Oe.name]=function(){for(var it=arguments.length,ot=new Array(it),ne=0;ne<it;ne++)ot[ne]=arguments[ne];var ge=Oe.renderer.apply(this,ot);return ge===!1&&(ge=We.apply(this,ot)),ge}:he.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Oe.level]?he[Oe.level].unshift(Oe.tokenizer):he[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?he.startBlock?he.startBlock.push(Oe.start):he.startBlock=[Oe.start]:Oe.level==="inline"&&(he.startInline?he.startInline.push(Oe.start):he.startInline=[Oe.start]))}Oe.childTokens&&(he.childTokens[Oe.name]=Oe.childTokens)})),Ie.renderer&&function(){var Oe=et.defaults.renderer||new V,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.renderer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.renderer)We(it);ae.renderer=Oe}(),Ie.tokenizer&&function(){var Oe=et.defaults.tokenizer||new gt,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.tokenizer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.tokenizer)We(it);ae.tokenizer=Oe}(),Ie.walkTokens){var ze=et.defaults.walkTokens;ae.walkTokens=function(Oe){Ie.walkTokens.call(Pe,Oe),ze&&ze(Oe)}}me&&(ae.extensions=he),et.setOptions(ae)})},et.walkTokens=function(Pe,Se){for(var ve=function(){var me=ae.value;switch(Se(me),me.type){case"table":{for(var Ie=w(me.header),ze;!(ze=Ie()).done;){var Oe=ze.value;et.walkTokens(Oe.tokens,Se)}for(var We=w(me.rows),it;!(it=We()).done;)for(var ot=it.value,ne=w(ot),ge;!(ge=ne()).done;){var te=ge.value;et.walkTokens(te.tokens,Se)}break}case"list":{et.walkTokens(me.items,Se);break}default:et.defaults.extensions&&et.defaults.extensions.childTokens&&et.defaults.extensions.childTokens[me.type]?et.defaults.extensions.childTokens[me.type].forEach(function(W){et.walkTokens(me[W],Se)}):me.tokens&&et.walkTokens(me.tokens,Se)}},re=w(Pe),ae;!(ae=re()).done;)ve()},et.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=Ue({},et.defaults,Se||{}),Ye(Se);try{var ve=rt.lexInline(Pe,Se);return Se.walkTokens&&et.walkTokens(ve,Se.walkTokens),De.parseInline(ve,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(re.message+"",!0)+"</pre>";throw re}},et.Parser=De,et.parser=De.parse,et.Renderer=V,et.TextRenderer=J,et.Lexer=rt,et.lexer=rt.lex,et.Tokenizer=gt,et.Slugger=pe,et.parse=et;var Tt=et;return Tt}),define(Ee[75],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(t,T,S){return Math.min(Math.max(t,T),S)}e.clamp=c;function F(t,T){return(T+t%T)%T}e.rot=F;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class P{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P}),function(){function oe(w){const P=[];typeof w=="number"&&P.push("code/timeOrigin",w);function t(S){P.push(S,Date.now())}function T(){const S=[];for(let D=0;D<P.length;D+=2)S.push({name:P[D],startTime:P[D+1]});return S}return{mark:t,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))P.push({name:t.name,startTime:Math.round(w+t.startTime)});return P}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function c(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=c(F))}(),define(Ee[53],_e([0,1,3]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(A){const _=this._icons.get(A.id);_?A.description?_.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new F;e.iconRegistry=w;function P(D){return D?D.replace(/\$\((.*?)\)/g,(A,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=P;class t{constructor(A,_,n){this.id=A,this.definition=_,this.description=n,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(D,A){const _=["codicon","codicon-"+D];return A&&_.push("codicon-modifier-"+A),_}e.getClassNamesArray=T;var S;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function _(o){if(o instanceof t)return["codicon","codicon-"+o.id];const u=A.exec(o.id);if(!u)return _(t.error);let[,h,C]=u;const b=["codicon","codicon-"+h];return C&&b.push("codicon-modifier-"+C.substr(1)),b}D.asClassNameArray=_;function n(o){return _(o).join(" ")}D.asClassName=n;function f(o){return"."+_(o).join(".")}D.asCSSSelector=f})(S=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[102],_e([0,1,15,6]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(m){const p=m;return p?[p.on,p.pause,p.resume,p.destroy].every(R=>typeof R=="function"):!1}e.isReadableStream=w;function P(m){const p=m;return p?w(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=P;function t(m,p){return new T(m,p)}e.newWriteableStream=t;class T{constructor(p,R){this.reducer=p,this.options=R,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(R=>this.pendingWritePromises.push(R))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(R=>R(p))}emitError(p){this.listeners.error.length===0?(0,c.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(R=>R(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,R){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(R),this.resume();break;case"end":this.listeners.end.push(R),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(R),this.state.flowing&&this.flowErrors();break}}removeListener(p,R){if(this.state.destroyed)return;let l;switch(p){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(R);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const R=[...this.pendingWritePromises];this.pendingWritePromises.length=0,R.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(m,p){const R=[];let l;for(;(l=m.read())!==null;)R.push(l);return p(R)}e.consumeReadable=S;function D(m,p,R){const l=[];let M;for(;(M=m.read())!==null&&l.length<R;)l.push(M);return M===null&&l.length>0?p(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return m.read()}}}e.peekReadable=D;function A(m,p){return new Promise((R,l)=>{const M=[];_(m,{onData:r=>{p&&M.push(r)},onError:r=>{p?l(r):R(void 0)},onEnd:()=>{R(p?p(M):void 0)}})})}e.consumeStream=A;function _(m,p){m.on("error",R=>p.onError(R)),m.on("end",()=>p.onEnd()),m.on("data",R=>p.onData(R))}e.listenStream=_;function n(m,p){return new Promise((R,l)=>{const M=new F.DisposableStore,r=[],i=s=>{if(r.push(s),r.length>p)return M.dispose(),m.pause(),R({stream:m,buffer:r,ended:!1})},g=s=>l(s),d=()=>R({stream:m,buffer:r,ended:!0});M.add((0,F.toDisposable)(()=>m.removeListener("error",g))),m.on("error",g),M.add((0,F.toDisposable)(()=>m.removeListener("end",d))),m.on("end",d),M.add((0,F.toDisposable)(()=>m.removeListener("data",i))),m.on("data",i)})}e.peekStream=n;function f(m,p){const R=t(p);return R.end(m),R}e.toStream=f;function o(){const m=t(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=o;function u(m){let p=!1;return{read:()=>p?null:(p=!0,m)}}e.toReadable=u;function h(m,p,R){const l=t(R);return _(m,{onData:M=>l.write(p.data(M)),onError:M=>l.error(p.error?p.error(M):M),onEnd:()=>l.end()}),l}e.transform=h;function C(m,p,R){let l=!1;return{read:()=>{const M=p.read();return l?M:(l=!0,M!==null?R([m,M]):m)}}}e.prefixedReadable=C;function b(m,p,R){let l=!1;const M=t(R);return _(p,{onData:r=>l?M.write(r):(l=!0,M.write(R([m,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(m)),M.end()}}),M}e.prefixedStream=b}),define(Ee[22],_e([0,1,102]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let w,P;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return F?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return F&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,g){return!(g?.dontUseNodeBuffer||!1)&&F?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static fromByteArray(i){const g=t.alloc(i.length);for(let d=0,s=i.length;d<s;d++)g.buffer[d]=i[d];return g}static concat(i,g){if(typeof g=="undefined"){g=0;for(let v=0,a=i.length;v<a;v++)g+=i[v].byteLength}const d=t.alloc(g);let s=0;for(let v=0,a=i.length;v<a;v++){const E=i[v];d.set(E,s),s+=E.byteLength}return d}clone(){const i=t.alloc(this.byteLength);return i.set(this),i}toString(){return F?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(i,g){return new t(this.buffer.subarray(i,g))}set(i,g){if(i instanceof t)this.buffer.set(i.buffer,g);else if(i instanceof Uint8Array)this.buffer.set(i,g);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),g);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),g);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return D(this.buffer,i)}writeUInt32BE(i,g){A(this.buffer,i,g)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,g){n(this.buffer,i,g)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,g){o(this.buffer,i,g)}}e.VSBuffer=t;function T(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=T;function S(r,i,g){r[g+0]=i&255,i=i>>>8,r[g+1]=i&255}e.writeUInt16LE=S;function D(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=D;function A(r,i,g){r[g+3]=i,i=i>>>8,r[g+2]=i,i=i>>>8,r[g+1]=i,i=i>>>8,r[g]=i}e.writeUInt32BE=A;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,g){r[g+0]=i&255,i=i>>>8,r[g+1]=i&255,i=i>>>8,r[g+2]=i&255,i=i>>>8,r[g+3]=i&255}e.writeUInt32LE=n;function f(r,i){return r[i]}e.readUInt8=f;function o(r,i,g){r[g]=i}e.writeUInt8=o;function u(r){return c.consumeReadable(r,i=>t.concat(i))}e.readableToBuffer=u;function h(r){return c.toReadable(r)}e.bufferToReadable=h;function C(r){return c.consumeStream(r,i=>t.concat(i))}e.streamToBuffer=C;async function b(r){return r.ended?t.concat(r.buffer):t.concat([...r.buffer,await C(r.stream)])}e.bufferedStreamToBuffer=b;function m(r){return c.toStream(r,i=>t.concat(i))}e.bufferToStream=m;function p(r){return c.transform(r,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=p;function R(r){return c.newWriteableStream(i=>t.concat(i),r)}e.newWriteableBufferStream=R;function l(r,i){return c.prefixedReadable(r,i,g=>t.concat(g))}e.prefixedBufferReadable=l;function M(r,i){return c.prefixedStream(r,i,g=>t.concat(g))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[21],_e([0,1,16,9]),function(oe,e,c,F){"use strict";var w,P,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(r,i,g){let d=r.get(i);return d===void 0&&(d=g,r.set(i,d)),d}e.getOrSet=T;function S(r){const i=[];return r.forEach((g,d)=>{i.push(`${d} => ${g}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=S;function D(r){const i=[];return r.forEach(g=>{i.push(g)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=D;class A{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const g=i.charCodeAt(0),d=this._value.charCodeAt(this._pos);return g-d}value(){return this._value[this._pos]}}e.StringIterator=A;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,g=!0){this._splitOnBackslash=i,this._caseSensitive=g}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var f;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(f||(f={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,F.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(h||(h={}));class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new o(i))}static forPaths(){return new C(new n)}static forStrings(){return new C(new A)}static forConfigKeys(){return new C(new _)}clear(){this._root=void 0}fill(i,g){if(g){const d=g.slice(0);(0,c.shuffle)(d);for(let s of d)this.set(s,i)}else{const d=i.slice(0);(0,c.shuffle)(d);for(let s of d)this.set(s[0],s[1])}}set(i,g){const d=this._iter.reset(i);let s;this._root||(this._root=new u,this._root.segment=d.value());const v=[];for(s=this._root;;){const E=d.cmp(s.segment);if(E>0)s.left||(s.left=new u,s.left.segment=d.value()),v.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new u,s.right.segment=d.value()),v.push([1,s]),s=s.right;else if(d.hasNext())d.next(),s.mid||(s.mid=new u,s.mid.segment=d.value()),v.push([0,s]),s=s.mid;else break}const a=s.value;s.value=g,s.key=i;for(let E=v.length-1;E>=0;E--){const I=v[E][1];I.updateHeight();const k=I.balanceFactor();if(k<-1||k>1){const B=v[E][0],L=v[E+1][0];if(B===1&&L===1)v[E][1]=I.rotateLeft();else if(B===-1&&L===-1)v[E][1]=I.rotateRight();else if(B===1&&L===-1)I.right=v[E+1][1]=v[E+1][1].rotateRight(),v[E][1]=I.rotateLeft();else if(B===-1&&L===1)I.left=v[E+1][1]=v[E+1][1].rotateLeft(),v[E][1]=I.rotateRight();else throw new Error;if(E>0)switch(v[E-1][0]){case-1:v[E-1][1].left=v[E][1];break;case 1:v[E-1][1].right=v[E][1];break;case 0:v[E-1][1].mid=v[E][1];break}else this._root=v[0][1]}}return a}get(i){return this._getNode(i)?.value}_getNode(i){const g=this._iter.reset(i);let d=this._root;for(;d;){const s=g.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(i){const g=this._getNode(i);return!(g?.value===void 0&&g?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,g){const d=this._iter.reset(i),s=[];let v=this._root;for(;v;){const a=d.cmp(v.segment);if(a>0)s.push([-1,v]),v=v.left;else if(a<0)s.push([1,v]),v=v.right;else if(d.hasNext())d.next(),s.push([0,v]),v=v.mid;else break}if(!!v){if(g?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const a=this._min(v.right),{key:E,value:I,segment:k}=a;this._delete(a.key,!1),v.key=E,v.value=I,v.segment=k}else{const a=v.left??v.right;if(s.length>0){const[E,I]=s[s.length-1];switch(E){case-1:I.left=a;break;case 0:I.mid=a;break;case 1:I.right=a;break}}else this._root=a}for(let a=s.length-1;a>=0;a--){const E=s[a][1];E.updateHeight();const I=E.balanceFactor();if(I>1?(E.right.balanceFactor()>=0||(E.right=s[a+1][1]=s[a+1][1].rotateRight()),s[a][1]=E.rotateLeft()):I<-1&&(E.left.balanceFactor()<=0||(E.left=s[a+1][1]=s[a+1][1].rotateLeft()),s[a][1]=E.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const g=this._iter.reset(i);let d=this._root,s;for(;d;){const v=g.cmp(d.segment);if(v>0)d=d.left;else if(v<0)d=d.right;else if(g.hasNext())g.next(),s=d.value||s,d=d.mid;else break}return d&&d.value||s}findSuperstr(i){const g=this._iter.reset(i);let d=this._root;for(;d;){const s=g.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(i){for(const[g,d]of this)i(d,g)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:i(g.left)&&i(g.right)};return i(this._root)}}e.TernarySearchTree=C;class b{constructor(i,g){this.uri=i,this.value=g}}class m{constructor(i,g){this[w]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=g??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,g){return this.map.set(this.toKey(i),new b(i,g)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,g){typeof g!="undefined"&&(i=i.bind(g));for(let[d,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=r=>r.toString();var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class R{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,g=0){const d=this._map.get(i);if(!!d)return g!==0&&this.touch(d,g),d.value}set(i,g,d=0){let s=this._map.get(i);if(s)s.value=g,d!==0&&this.touch(s,d);else{switch(s={key:i,value:g,next:void 0,previous:void 0},d){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const g=this._map.get(i);if(!!g)return this._map.delete(i),this.removeItem(g),this._size--,g.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,g){const d=this._state;let s=this._head;for(;s;){if(g?i.bind(g)(s.value,s.key,this):i(s.value,s.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,g=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:d.key,done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}values(){const i=this,g=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:d.value,done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}entries(){const i=this,g=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==g)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:[d.key,d.value],done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let g=this._head,d=this.size;for(;g&&d>i;)this._map.delete(g.key),g=g.next,d--;this._head=g,this._size=d,g&&(g.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const g=i.next,d=i.previous;if(!g||!d)throw new Error("Invalid list");g.previous=d,d.next=g}i.next=void 0,i.previous=void 0,this._state++}touch(i,g){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(i===this._head)return;const d=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(d.previous=s,s.next=d),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(g===2){if(i===this._tail)return;const d=i.next,s=i.previous;i===this._head?(d.previous=void 0,this._head=d):(d.previous=s,s.next=d),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((g,d)=>{i.push([d,g])}),i}fromJSON(i){this.clear();for(const[g,d]of i)this.set(g,d)}}e.LinkedMap=R;class l extends R{constructor(i,g=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,g),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,g=2){return super.get(i,g)}peek(i){return super.get(i,0)}set(i,g){return super.set(i,g,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){t.set(this,void 0),Ze(this,t,i,"f")}get size(){return Ae(this,t,"f").size}forEach(i,g){Ae(this,t,"f").forEach(i,g)}get(i){return Ae(this,t,"f").get(i)}has(i){return Ae(this,t,"f").has(i)}entries(){return Ae(this,t,"f").entries()}keys(){return Ae(this,t,"f").keys()}values(){return Ae(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Ae(this,t,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],_e([0,1,21,9]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...j){return function(Z,fe){for(let Te=0,Ne=j.length;Te<Ne;Te++){const He=j[Te](Z,fe);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(j,Z,fe){if(!fe||fe.length<Z.length)return null;let Te;return j?Te=F.startsWithIgnoreCase(fe,Z):Te=fe.indexOf(Z)===0,Te?Z.length>0?[{start:0,end:Z.length}]:[]:null}function t(j,Z){const fe=Z.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=t;function T(j,Z){return S(j.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=T;function S(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]===Z[Te]){let Ne=null;return(Ne=S(j,Z,fe+1,Te+1))?C({start:Te,end:Te+1},Ne):null}return S(j,Z,fe,Te+1)}function D(j){return 97<=j&&j<=122}function A(j){return 65<=j&&j<=90}e.isUpper=A;function _(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>f.add(j.charCodeAt(0)));function o(j){return n(j)||f.has(j)}function u(j,Z){return j===Z||o(j)&&o(Z)}function h(j){return D(j)||A(j)||_(j)}function C(j,Z){return Z.length===0?Z=[j]:j.end===Z[0].start?Z[0].start=j.start:Z.unshift(j),Z}function b(j,Z){for(let fe=Z;fe<j.length;fe++){const Te=j.charCodeAt(fe);if(A(Te)||_(Te)||fe>0&&!h(j.charCodeAt(fe-1)))return fe}return j.length}function m(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]!==Z[Te].toLowerCase())return null;{let Ne=null,He=Te+1;for(Ne=m(j,Z,fe+1,Te+1);!Ne&&(He=b(Z,He))<Z.length;)Ne=m(j,Z,fe+1,He),He++;return Ne===null?null:C({start:Te,end:Te+1},Ne)}}function p(j){let Z=0,fe=0,Te=0,Ne=0,He=0;for(let rt=0;rt<j.length;rt++)He=j.charCodeAt(rt),A(He)&&Z++,D(He)&&fe++,h(He)&&Te++,_(He)&&Ne++;const Ke=Z/j.length,tt=fe/j.length,st=Te/j.length,Xe=Ne/j.length;return{upperPercent:Ke,lowerPercent:tt,alphaPercent:st,numericPercent:Xe}}function R(j){const{upperPercent:Z,lowerPercent:fe}=j;return fe===0&&Z>.6}function l(j){const{upperPercent:Z,lowerPercent:fe,alphaPercent:Te,numericPercent:Ne}=j;return fe>.2&&Z<.8&&Te>.6&&Ne<.2}function M(j){let Z=0,fe=0,Te=0,Ne=0;for(let He=0;He<j.length;He++)Te=j.charCodeAt(He),A(Te)&&Z++,D(Te)&&fe++,n(Te)&&Ne++;return(Z===0||fe===0)&&Ne===0?j.length<=30:Z<=5}function r(j,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!M(j)||Z.length>60)return null;const fe=p(Z);if(!l(fe)){if(!R(fe))return null;Z=Z.toLowerCase()}let Te=null,Ne=0;for(j=j.toLowerCase();Ne<Z.length&&(Te=m(j,Z,0,Ne))===null;)Ne=b(Z,Ne+1);return Te}e.matchesCamelCase=r;function i(j,Z,fe=!1){if(!Z||Z.length===0)return null;let Te=null,Ne=0;for(j=j.toLowerCase(),Z=Z.toLowerCase();Ne<Z.length&&(Te=g(j,Z,0,Ne,fe))===null;)Ne=d(Z,Ne+1);return Te}e.matchesWords=i;function g(j,Z,fe,Te,Ne){if(fe===j.length)return[];if(Te===Z.length)return null;if(u(j.charCodeAt(fe),Z.charCodeAt(Te))){let He=null,Ke=Te+1;if(He=g(j,Z,fe+1,Te+1,Ne),!Ne)for(;!He&&(Ke=d(Z,Ke))<Z.length;)He=g(j,Z,fe+1,Ke,Ne),Ke++;return He===null?null:C({start:Te,end:Te+1},He)}else return null}function d(j,Z){for(let fe=Z;fe<j.length;fe++)if(o(j.charCodeAt(fe))||fe>0&&o(j.charCodeAt(fe-1)))return fe;return j.length}const s=w(e.matchesPrefix,r,t),v=w(e.matchesPrefix,r,T),a=new c.LRUCache(1e4);function E(j,Z,fe=!1){if(typeof j!="string"||typeof Z!="string")return null;let Te=a.get(j);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(j),"i"),a.set(j,Te));const Ne=Te.exec(Z);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:fe?v(j,Z):s(j,Z)}e.matchesFuzzy=E;function I(j,Z){const fe=Ge(j,j.toLowerCase(),0,Z,Z.toLowerCase(),0,!0);return fe?B(fe):null}e.matchesFuzzy2=I;function k(j,Z,fe,Te,Ne,He){const Ke=Math.min(13,j.length);for(;fe<Ke;fe++){const tt=Ge(j,Z,fe,Te,Ne,He,!1);if(tt)return tt}return[0,He]}e.anyScore=k;function B(j){if(typeof j=="undefined")return[];const Z=[],fe=j[1];for(let Te=j.length-1;Te>1;Te--){const Ne=j[Te]+fe,He=Z[Z.length-1];He&&He.end===Ne?He.end=Ne+1:Z.push({start:Ne,end:Ne+1})}return Z}e.createMatches=B;const L=128;function y(){const j=[],Z=[];for(let fe=0;fe<=L;fe++)Z[fe]=0;for(let fe=0;fe<=L;fe++)j.push(Z.slice(0));return j}function x(j){const Z=[];for(let fe=0;fe<=j;fe++)Z[fe]=0;return Z}const N=x(2*L),z=x(2*L),H=y(),q=y(),ue=y(),K=!1;function ce(j,Z,fe,Te,Ne){function He(tt,st,Xe=" "){for(;tt.length<st;)tt=Xe+tt;return tt}let Ke=` |   |${Te.split("").map(tt=>He(tt,3)).join("|")}
`;for(let tt=0;tt<=fe;tt++)tt===0?Ke+=" |":Ke+=`${Z[tt-1]}|`,Ke+=j[tt].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ke}function de(j,Z,fe,Te){j=j.substr(Z),fe=fe.substr(Te),console.log(ce(q,j,j.length,fe,fe.length)),console.log(ce(ue,j,j.length,fe,fe.length)),console.log(ce(H,j,j.length,fe,fe.length))}function Q(j,Z){if(Z<0||Z>=j.length)return!1;const fe=j.codePointAt(Z);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(fe)}}function ie(j,Z){if(Z<0||Z>=j.length)return!1;switch(j.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function we(j,Z,fe){return Z[j]!==fe[j]}function Me(j,Z,fe,Te,Ne,He,Ke=!1){for(;Z<fe&&Ne<He;)j[Z]===Te[Ne]&&(Ke&&(N[Z]=Ne),Z+=1),Ne+=1;return Z===fe}e.isPatternInWord=Me;var Fe;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Be;(function(j){j.Default=[-100,0];function Z(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=Z})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Ge(j,Z,fe,Te,Ne,He,Ke){const tt=j.length>L?L:j.length,st=Te.length>L?L:Te.length;if(fe>=tt||He>=st||tt-fe>st-He||!Me(Z,fe,tt,Ne,He,st,!0))return;je(tt,st,fe,He,Z,Ne);let Xe=1,rt=1,De=fe,gt=He;const V=[!1];for(Xe=1,De=fe;De<tt;Xe++,De++){const Je=N[De],lt=z[De],Et=De+1<tt?z[De+1]:st;for(rt=Je-He+1,gt=Je;gt<Et;rt++,gt++){let It=Number.MIN_SAFE_INTEGER,et=!1;gt<=lt&&(It=Qe(j,Z,De,fe,Te,Ne,gt,st,He,H[Xe-1][rt-1]===0,V));let Tt=0;It!==Number.MAX_SAFE_INTEGER&&(et=!0,Tt=It+q[Xe-1][rt-1]);const Pe=gt>Je,Se=Pe?q[Xe][rt-1]+(H[Xe][rt-1]>0?-5:0):0,ve=gt>Je+1&&H[Xe][rt-1]>0,re=ve?q[Xe][rt-2]+(H[Xe][rt-2]>0?-5:0):0;if(ve&&(!Pe||re>=Se)&&(!et||re>=Tt))q[Xe][rt]=re,ue[Xe][rt]=3,H[Xe][rt]=0;else if(Pe&&(!et||Se>=Tt))q[Xe][rt]=Se,ue[Xe][rt]=2,H[Xe][rt]=0;else if(et)q[Xe][rt]=Tt,ue[Xe][rt]=1,H[Xe][rt]=H[Xe-1][rt-1]+1;else throw new Error("not possible")}}if(K&&de(j,fe,Te,He),!V[0]&&!Ke)return;Xe--,rt--;const J=[q[Xe][rt],He];let pe=0,Ue=0;for(;Xe>=1;){let Je=rt;do{const lt=ue[Xe][Je];if(lt===3)Je=Je-2;else if(lt===2)Je=Je-1;else break}while(Je>=1);pe>1&&Z[fe+Xe-1]===Ne[He+rt-1]&&!we(Je+He-1,Te,Ne)&&pe+1>H[Xe][Je]&&(Je=rt),Je===rt?pe++:pe=1,Ue||(Ue=Je),Xe--,rt=Je-1,J.push(rt)}st===tt&&(J[0]+=2);const Ye=Ue-tt;return J[0]-=Ye,J}e.fuzzyScore=Ge;function je(j,Z,fe,Te,Ne,He){let Ke=j-1,tt=Z-1;for(;Ke>=fe&&tt>=Te;)Ne[Ke]===He[tt]&&(z[Ke]=tt,Ke--),tt--}function Qe(j,Z,fe,Te,Ne,He,Ke,tt,st,Xe,rt){if(Z[fe]!==He[Ke])return Number.MIN_SAFE_INTEGER;let De=1,gt=!1;return Ke===fe-Te?De=j[fe]===Ne[Ke]?7:5:we(Ke,Ne,He)&&(Ke===0||!we(Ke-1,Ne,He))?(De=j[fe]===Ne[Ke]?7:5,gt=!0):Q(He,Ke)&&(Ke===0||!Q(He,Ke-1))?De=5:(Q(He,Ke-1)||ie(He,Ke-1))&&(De=5,gt=!0),De>1&&fe===Te&&(rt[0]=!0),gt||(gt=we(Ke,Ne,He)||Q(He,Ke-1)||ie(He,Ke-1)),fe===Te?Ke>st&&(De-=gt?3:5):Xe?De+=gt?2:0:De+=gt?0:1,Ke+1===tt&&(De-=gt?3:5),De}function $(j,Z,fe,Te,Ne,He,Ke){return X(j,Z,fe,Te,Ne,He,!0,Ke)}e.fuzzyScoreGracefulAggressive=$;function G(j,Z,fe,Te,Ne,He,Ke){return X(j,Z,fe,Te,Ne,He,!1,Ke)}e.fuzzyScoreGraceful=G;function X(j,Z,fe,Te,Ne,He,Ke,tt){let st=Ge(j,Z,fe,Te,Ne,He,tt);if(st&&!Ke)return st;if(j.length>=3){const Xe=Math.min(7,j.length-1);for(let rt=fe+1;rt<Xe;rt++){const De=se(j,rt);if(De){const gt=Ge(De,De.toLowerCase(),fe,Te,Ne,He,tt);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function se(j,Z){if(Z+1>=j.length)return;const fe=j[Z],Te=j[Z+1];if(fe!==Te)return j.slice(0,Z)+Te+fe+j.slice(Z+2)}}),define(Ee[104],_e([0,1,53,103,9]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(c.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function S(h){return h.replace(T,(C,b)=>b?C:`\\${C}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${P.source}`,"g");function A(h){return h.replace(D,C=>`\\${C}`)}e.markdownEscapeEscapedIcons=A;const _=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function n(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(_,(C,b,m,p)=>m?C:b||p||"")}e.stripIcons=n;function f(h){const C=h.indexOf(e.iconStartMarker);return C===-1?{text:h}:o(h,C)}e.parseLabelWithIcons=f;function o(h,C){const b=[];let m="";function p(s){if(s){m+=s;for(const v of s)b.push(M)}}let R=-1,l="",M=0,r,i,g=C;const d=h.length;for(p(h.substr(0,C));g<d;)r=h[g],i=h[g+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(R=g,p(l),l=e.iconStartMarker,g++):r===")"&&R!==-1?(M+=g-R+1,R=-1,l=""):R!==-1?t.test(r)?l+=r:(p(l),R=-1,l=""):p(r),g++;return p(l),{text:m,iconOffsets:b}}function u(h,C,b=!1){const{text:m,iconOffsets:p}=C;if(!p||p.length===0)return(0,F.matchesFuzzy)(h,m,b);const R=(0,w.ltrim)(m," "),l=m.length-R.length,M=(0,F.matchesFuzzy)(h,R,b);if(M)for(const r of M){const i=p[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=u}),define(Ee[76],_e([0,1,15,104]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=D(this.supportThemeIcons?(0,F.escapeIcons)(f):f).replace(/([ \t]+)/g,(u,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=P;function t(n){return T(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function T(n){return n instanceof P?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function S(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function D(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function A(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=A;function _(n){const f=[],o=n.split("|").map(h=>h.trim());n=o[0];const u=o[1];if(u){const h=/height=(\d+)/.exec(u),C=/width=(\d+)/.exec(u),b=h?h[1]:"",m=C?C[1]:"",p=isFinite(parseInt(m)),R=isFinite(parseInt(b));p&&f.push(`width="${m}"`),R&&f.push(`height="${b}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=_}),define(Ee[34],_e([0,1,9]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(F||(F={})),function(w){const P="error",t="warning",T="warn",S="info",D="ignore";function A(n){return n?c.equalsIgnoreCase(P,n)?w.Error:c.equalsIgnoreCase(t,n)||c.equalsIgnoreCase(T,n)?w.Warning:c.equalsIgnoreCase(S,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=A;function _(n){switch(n){case w.Error:return P;case w.Warning:return t;case w.Info:return S;default:return D}}w.toString=_}(F||(F={})),e.default=F}),define(Ee[42],_e([0,1,17,23,9,11]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(r){return r===47||r===92}e.isPathSeparator=t;function T(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function D(r,i=c.posix.sep){if(!r)return"";const g=r.length,d=r.charCodeAt(0);if(t(d)){if(t(r.charCodeAt(1))&&!t(r.charCodeAt(2))){let v=3;const a=v;for(;v<g&&!t(r.charCodeAt(v));v++);if(a!==v&&!t(r.charCodeAt(v+1))){for(v+=1;v<g;v++)if(t(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,i)}}return i}else if(C(d)&&r.charCodeAt(1)===58)return t(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let s=r.indexOf("://");if(s!==-1){for(s+=3;s<g;s++)if(t(r.charCodeAt(s)))return r.slice(0,s+1)}return""}e.getRoot=D;function A(r){if(!F.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let g=2;const d=g;for(;g<r.length&&(i=r.charCodeAt(g),i!==92);g++);return!(d===g||(i=r.charCodeAt(g+1),isNaN(i)||i===92))}e.isUNC=A;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,i=F.isWindows){const g=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(g.lastIndex=0,g.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function u(r,i,g){const d=r===i;return!g||d?d:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=u;function h(r,i,g,d=c.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(g){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let v=i.length;return i.charAt(i.length-1)===d&&v--,r.charAt(v)===d}return i.charAt(i.length-1)!==d&&(i+=d),r.indexOf(i)===0}e.isEqualOrParent=h;function C(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=C;function b(r,i){return F.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(i,r)),r=(0,c.normalize)(r),F.isWindows?(r=(0,w.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,w.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=b;function m(r){const i=(0,c.normalize)(r);return F.isWindows?r.length>3?!1:p(i)&&(r.length===2||i.charCodeAt(2)===92):i===c.posix.sep}e.isRootOrDriveLetter=m;function p(r,i){return(i!==void 0?i:F.isWindows)?C(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function R(r){return p(r)?r[0]:void 0}e.getDriveLetter=R;function l(r,i,g){return i.length>r.length?-1:r===i?0:(g&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function M(r){const i=r.split(":");let g,d,s;if(i.forEach(v=>{const a=Number(v);(0,P.isNumber)(a)?d===void 0?d=a:s===void 0&&(s=a):g=g?[g,v].join(":"):v}),!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:d!==void 0?d:void 0,column:s!==void 0?s:d!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],_e([0,1,22,9,2]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(A){return JSON.stringify(A,S)}e.stringify=P;function t(A){let _=JSON.parse(A);return _=D(_),_}e.parse=t;var T;(function(A){A[A.Uri=1]="Uri",A[A.Regexp=2]="Regexp",A[A.ScmResource=3]="ScmResource",A[A.ScmResourceGroup=4]="ScmResourceGroup",A[A.ScmProvider=5]="ScmProvider",A[A.CommentController=6]="CommentController",A[A.CommentThread=7]="CommentThread",A[A.CommentThreadReply=8]="CommentThreadReply",A[A.CommentNode=9]="CommentNode",A[A.CommentThreadNode=10]="CommentThreadNode",A[A.TimelineActionContext=11]="TimelineActionContext",A[A.NotebookCellActionContext=12]="NotebookCellActionContext",A[A.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function S(A,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function D(A,_=0){if(!A||_>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return w.URI.revive(A);case 2:return new RegExp(A.source,A.flags)}if(A instanceof c.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let n=0;n<A.length;++n)A[n]=D(A[n],_+1);else for(const n in A)Object.hasOwnProperty.call(A,n)&&(A[n]=D(A[n],_+1))}return A}e.revive=D}),define(Ee[10],_e([0,1,23,2]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,D,A){this._hosts[S]=D,this._ports[S]=A}setConnectionToken(S,D){this._connectionTokens[S]=D}rewrite(S){if(this._delegate)return this._delegate(S);const D=S.authority;let A=this._hosts[D];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const _=this._ports[D],n=this._connectionTokens[D];let f=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),F.URI.from({scheme:c.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${A}:${_}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new P;class t{asBrowserUri(S,D){const A=this.toUri(S,D);return A.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===w.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${w.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?A.with({scheme:w.vscodeFileResource,authority:A.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(S,D){const A=this.toUri(S,D);return A.scheme===w.vscodeFileResource?A.with({scheme:w.file,authority:A.authority!==t.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(S,D){return F.URI.isUri(S)?S:F.URI.parse(D.toUrl(S))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(Ee[24],_e([0,1,42,10,17,23,9,2]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,T.uriToFsPath)(f,!0)}e.originalFSPath=S;class D{constructor(o){this._ignorePathCasing=o}compare(o,u,h=!1){return o===u?0:(0,t.compare)(this.getComparisonKey(o,h),this.getComparisonKey(u,h))}isEqual(o,u,h=!1){return o===u?!0:!o||!u?!1:this.getComparisonKey(o,h)===this.getComparisonKey(u,h)}getComparisonKey(o,u=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,u,h=!1){if(o.scheme===u.scheme){if(o.scheme===F.Schemas.file)return c.isEqualOrParent(S(o),S(u),this._ignorePathCasing(o))&&o.query===u.query&&(h||o.fragment===u.fragment);if((0,e.isEqualAuthority)(o.authority,u.authority))return c.isEqualOrParent(o.path,u.path,this._ignorePathCasing(o),"/")&&o.query===u.query&&(h||o.fragment===u.fragment)}return!1}joinPath(o,...u){return T.URI.joinPath(o,...u)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let u;return o.scheme===F.Schemas.file?u=T.URI.file(w.dirname(S(o))).path:(u=w.posix.dirname(o.path),o.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),u="/")),o.with({path:u})}normalizePath(o){if(!o.path.length)return o;let u;return o.scheme===F.Schemas.file?u=T.URI.file(w.normalize(S(o))).path:u=w.posix.normalize(o.path),o.with({path:u})}relativePath(o,u){if(o.scheme!==u.scheme||!(0,e.isEqualAuthority)(o.authority,u.authority))return;if(o.scheme===F.Schemas.file){const b=w.relative(S(o),S(u));return P.isWindows?c.toSlashes(b):b}let h=o.path||"/",C=u.path||"/";if(this._ignorePathCasing(o)){let b=0;for(const m=Math.min(h.length,C.length);b<m&&!(h.charCodeAt(b)!==C.charCodeAt(b)&&h.charAt(b).toLowerCase()!==C.charAt(b).toLowerCase());b++);h=C.substr(0,b)+h.substr(b)}return w.posix.relative(h,C)}resolvePath(o,u){if(o.scheme===F.Schemas.file){const h=T.URI.file(w.resolve(S(o),u));return o.with({authority:h.authority,path:h.path})}return u=c.toPosixPath(u),o.with({path:w.posix.resolve(o.path,u)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,u){return o===u||o!==void 0&&u!==void 0&&(0,t.equalsIgnoreCase)(o,u)}hasTrailingPathSeparator(o,u=w.sep){if(o.scheme===F.Schemas.file){const h=S(o);return h.length>c.getRoot(h).length&&h[h.length-1]===u}else{const h=o.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,u=w.sep){return(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,u=w.sep){let h=!1;if(o.scheme===F.Schemas.file){const C=S(o);h=C!==void 0&&C.length===c.getRoot(C).length&&C[C.length-1]===u}else{u="/";const C=o.path;h=C.length===1&&C.charCodeAt(C.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(o,u)?o.with({path:o.path+"/"}):o}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(f=>f.scheme===F.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(f,o){const u=[];for(let h=0;h<f.length;h++){const C=o(f[h]);f.some((b,m)=>m===h?!1:(0,e.isEqualOrParent)(C,o(b)))||u.push(f[h])}return u}e.distinctParents=A;var _;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(u){const h=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(m=>{const[p,R]=m.split(":");p&&R&&h.set(p,R)});const b=u.path.substring(0,u.path.indexOf(";"));return b&&h.set(f.META_DATA_MIME,b),h}f.parseMetaData=o})(_=e.DataUri||(e.DataUri={}));function n(f,o,u){if(o){let h=f.path;return h&&h[0]!==w.posix.sep&&(h=w.posix.sep+h),f.with({scheme:u,authority:o,path:h})}return f.with({scheme:u})}e.toLocalResource=n}),define(Ee[14],_e([0,1,20,15,3,6,24,23]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function D(de){const Q=new c.CancellationTokenSource,ie=de(Q.token),we=new Promise((Me,Fe)=>{const Be=Q.token.onCancellationRequested(()=>{Be.dispose(),Q.dispose(),Fe((0,F.canceled)())});Promise.resolve(ie).then(Ge=>{Be.dispose(),Q.dispose(),Me(Ge)},Ge=>{Be.dispose(),Q.dispose(),Fe(Ge)})});return new class{cancel(){Q.cancel()}then(Me,Fe){return we.then(Me,Fe)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=D;function A(de,Q,ie){return Promise.race([de,new Promise(we=>Q.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=A;async function _(de){let Q=-1;const ie=de.map((Me,Fe)=>Me.then(Be=>(Q=Fe,Be))),we=await Promise.race(ie);return de.forEach((Me,Fe)=>{Fe!==Q&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(de,Q,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Q);return Promise.race([de.finally(()=>clearTimeout(Me)),new Promise(Fe=>we=Fe)])}e.raceTimeout=n;function f(de){return new Promise((Q,ie)=>{const we=de();S(we)?we.then(Q,ie):Q(we)})}e.asPromise=f;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Q(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=o;class u{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=u;class h{constructor(){this.promiseMap=new Map}queue(Q,ie){const Me=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Q)===Me&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Me),Me}}e.SequencerByKey=h;class C{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ie=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=C;class b{constructor(Q){this.delayer=new C(Q),this.throttler=new o}trigger(Q,ie){return this.delayer.trigger(()=>this.throttler.queue(Q),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class m{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ie)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class p extends m{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function R(de,Q){return Q?new Promise((ie,we)=>{const Me=setTimeout(()=>{Fe.dispose(),ie()},de),Fe=Q.onCancellationRequested(()=>{clearTimeout(Me),Fe.dispose(),we((0,F.canceled)())})}):D(ie=>R(de,ie))}e.timeout=R;function l(de,Q=0){const ie=setTimeout(de,Q);return(0,P.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=l;function M(de){const Q=[];let ie=0;const we=de.length;function Me(){return ie<we?de[ie++]():null}function Fe(Be){Be!=null&&Q.push(Be);const Ge=Me();return Ge?Ge.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}e.sequence=M;function r(de,Q=we=>!!we,ie=null){let we=0;const Me=de.length,Fe=()=>{if(we>=Me)return Promise.resolve(ie);const Be=de[we++];return Promise.resolve(Be()).then(je=>Q(je)?Promise.resolve(je):Fe())};return Fe()}e.first=r;function i(de,Q=we=>!!we,ie=null){if(de.length===0)return Promise.resolve(ie);let we=de.length;const Me=()=>{we=-1;for(const Fe of de)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const Ge of de)Ge.then(je=>{--we>=0&&Q(je)?(Me(),Fe(je)):we===0&&Fe(ie)}).catch(je=>{--we>=0&&(Me(),Be(je))})})}e.firstParallel=i;class g{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Q,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ie=Q.factory();ie.then(Q.c,Q.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class d extends g{constructor(){super(1)}}e.Queue=d;class s{constructor(){this.queues=new Map}queueFor(Q,ie=t.extUri){const we=ie.getComparisonKey(Q);let Me=this.queues.get(we);return Me||(Me=new d,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we)}),this.queues.set(we,Me)),Me}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=s;class v{constructor(Q,ie){this._token=-1,typeof Q=="function"&&typeof ie=="number"&&this.setIfNotSet(Q,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ie)}setIfNotSet(Q,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ie))}}e.TimeoutTimer=v;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setInterval(()=>{Q()},ie)}}e.IntervalTimer=a;class E{constructor(Q,ie){this.timeoutToken=-1,this.runner=Q,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class I{constructor(Q,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=I;class k extends E{constructor(Q,ie){super(Q,ie);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class B extends P.Disposable{constructor(Q,ie,we,Me){super();this.maxWorkChunkSize=Q,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.maxPendingWork)return!1}else if(this.pending+Q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,T.setTimeout0)(()=>{if(Q)return;const ie=Date.now()+3;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(de,Q)=>{const ie=requestIdleCallback(de,typeof Q=="number"?{timeout:Q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class L{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function y(de,Q,ie){let we;for(let Me=0;Me<ie;Me++)try{return await de()}catch(Fe){we=Fe,await R(Q)}throw we}e.retry=y;class x{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,ie,we){return this._pending={taskId:Q,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Q),()=>this.donePending(Q)),ie}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ie,we;const Me=new Promise((Fe,Be)=>{ie=Fe,we=Be});this._next={run:Q,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=x;class N{constructor(Q,ie=()=>Date.now()){this.interval=Q,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ie)=>{this.completeCallback=Q,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(ie=>{this.completeCallback(Q),this.resolved=!0,ie()})}error(Q){return new Promise(ie=>{this.errorCallback(Q),this.rejected=!0,ie()})}cancel(){new Promise(Q=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=z;var H;(function(de){async function Q(we){let Me;const Fe=await Promise.all(we.map(Be=>Be.then(Ge=>Ge,Ge=>{Me||(Me=Ge)})));if(typeof Me!="undefined")throw Me;return Fe}de.settled=Q;function ie(we){return new Promise(async(Me,Fe)=>{try{await we(Me,Fe)}catch(Be){Fe(Be)}})}de.withAsyncBody=ie})(H=e.Promises||(e.Promises={}));var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ue{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Q(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Q){return new ue(ie=>{ie.emitMany(Q)})}static fromPromise(Q){return new ue(async ie=>{ie.emitMany(await Q)})}static fromPromises(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>ie.emitOne(await we)))})}static merge(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ie){return new ue(async we=>{for await(const Me of Q)we.emitOne(ie(Me))})}map(Q){return ue.map(this,Q)}static filter(Q,ie){return new ue(async we=>{for await(const Me of Q)ie(Me)&&we.emitOne(Me)})}filter(Q){return ue.filter(this,Q)}static coalesce(Q){return ue.filter(Q,ie=>!!ie)}coalesce(){return ue.coalesce(this)}static async toPromise(Q){const ie=[];for await(const we of Q)ie.push(we);return ie}toPromise(){return ue.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class K extends ue{constructor(Q,ie){super(ie);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function ce(de){const Q=new c.CancellationTokenSource,ie=de(Q.token);return new K(Q,async we=>{const Me=Q.token.onCancellationRequested(()=>{Me.dispose(),Q.dispose(),we.reject((0,F.canceled)())});try{for await(const Fe of ie){if(Q.token.isCancellationRequested)return;we.emitOne(Fe)}Me.dispose(),Q.dispose()}catch(Fe){Me.dispose(),Q.dispose(),we.reject(Fe)}})}e.createCancelableAsyncIterable=ce}),define(Ee[105],_e([0,1,14,17]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new c.IdleValue(()=>{const a=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:a,collatorIsNumeric:a.resolvedOptions().numeric}}),P=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(a,E,I=!1){const k=a||"",B=E||"",L=w.value.collator.compare(k,B);return w.value.collatorIsNumeric&&L===0&&k!==B?k<B?-1:1:L}e.compareFileNames=T;function S(a,E){const I=P.value.collator;return a=a||"",E=E||"",R(I,a,E)}e.compareFileNamesDefault=S;function D(a,E){const I=P.value.collator;return a=a||"",E=E||"",i(a,E)||R(I,a,E)}e.compareFileNamesUpper=D;function A(a,E){const I=P.value.collator;return a=a||"",E=E||"",r(a,E)||R(I,a,E)}e.compareFileNamesLower=A;function _(a,E){return a=a||"",E=E||"",a===E?0:a<E?-1:1}e.compareFileNamesUnicode=_;function n(a,E,I=!1){I||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase());const[k,B]=m(a),[L,y]=m(E);return k!==L?k<L?-1:1:B===y?0:B<y?-1:1}e.noIntlCompareFileNames=n;function f(a,E){const[I,k]=m(a),[B,L]=m(E);let y=w.value.collator.compare(k,L);if(y===0){if(w.value.collatorIsNumeric&&k!==L)return k<L?-1:1;if(y=w.value.collator.compare(I,B),w.value.collatorIsNumeric&&y===0&&I!==B)return I<B?-1:1}return y}e.compareFileExtensions=f;function o(a,E){a=a||"",E=E||"";const I=p(a),k=p(E),B=P.value.collator,L=t.value.collator;return R(L,I,k)||R(B,a,E)}e.compareFileExtensionsDefault=o;function u(a,E){a=a||"",E=E||"";const I=p(a),k=p(E),B=P.value.collator,L=t.value.collator;return R(L,I,k)||i(a,E)||R(B,a,E)}e.compareFileExtensionsUpper=u;function h(a,E){a=a||"",E=E||"";const I=p(a),k=p(E),B=P.value.collator,L=t.value.collator;return R(L,I,k)||r(a,E)||R(B,a,E)}e.compareFileExtensionsLower=h;function C(a,E){a=a||"",E=E||"";const I=p(a).toLowerCase(),k=p(E).toLowerCase();return I!==k?I<k?-1:1:a!==E?a<E?-1:1:0}e.compareFileExtensionsUnicode=C;const b=/^(.*?)(\.([^.]*))?$/;function m(a,E=!1){const I=a?b.exec(a):[];let k=[I&&I[1]||"",I&&I[3]||""];return E&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function p(a){const E=a?b.exec(a):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function R(a,E,I){let k=a.compare(E,I);return k!==0?k:E.length!==I.length?E.length<I.length?-1:1:0}function l(a){const E=a.charAt(0);return E.toLocaleUpperCase()!==E}function M(a){const E=a.charAt(0);return E.toLocaleLowerCase()!==E}function r(a,E){return l(a)&&M(E)?-1:M(a)&&l(E)?1:0}function i(a,E){return M(a)&&l(E)?-1:l(a)&&M(E)?1:0}function g(a,E,I=!1){return I||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase()),a===E?0:a<E?-1:1}function d(a,E,I=!1){const k=a.split(F.sep),B=E.split(F.sep),L=k.length-1,y=B.length-1;let x,N;for(let z=0;;z++){if(x=L===z,N=y===z,x&&N)return T(k[z],B[z],I);if(x)return-1;if(N)return 1;const H=g(k[z],B[z],I);if(H!==0)return H}}e.comparePaths=d;function s(a,E,I){const k=a.toLowerCase(),B=E.toLowerCase(),L=v(a,E,I);if(L)return L;const y=k.endsWith(I),x=B.endsWith(I);if(y!==x)return y?-1:1;const N=T(k,B);return N!==0?N:k.localeCompare(B)}e.compareAnything=s;function v(a,E,I){const k=a.toLowerCase(),B=E.toLowerCase(),L=k.startsWith(I),y=B.startsWith(I);if(L!==y)return L?-1:1;if(L&&y){if(k.length<B.length)return-1;if(k.length>B.length)return 1}return 0}e.compareByPrefix=v}),define(Ee[29],_e([0,1,14,42,21,17,9]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const S="**",D="/",A="[/\\\\]",_="[^/\\\\]",n=/\//g;function f(K){switch(K){case 0:return"";case 1:return`${_}*?`;default:return`(?:${A}|${_}+${A}|${A}${_}+)*?`}}function o(K,ce){if(!K)return[];const de=[];let Q=!1,ie=!1,we="";for(const Me of K){switch(Me){case ce:if(!Q&&!ie){de.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&de.push(we),de}e.splitGlobAware=o;function u(K){if(!K)return"";let ce="";const de=o(K,D);if(de.every(Q=>Q===S))ce=".*";else{let Q=!1;de.forEach((ie,we)=>{if(ie===S){Q||(ce+=f(2),Q=!0);return}let Me=!1,Fe="",Be=!1,Ge="";for(const je of ie){if(je!=="}"&&Me){Fe+=je;continue}if(Be&&(je!=="]"||!Ge)){let Qe;je==="-"?Qe=je:(je==="^"||je==="!")&&!Ge?Qe="^":je===D?Qe="":Qe=t.escapeRegExpCharacters(je),Ge+=Qe;continue}switch(je){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":ce+=`(?:${o(Fe,",").map(G=>u(G)).join("|")})`,Me=!1,Fe="";break;case"]":ce+="["+Ge+"]",Be=!1,Ge="";break;case"?":ce+=_;continue;case"*":ce+=f(1);continue;default:ce+=t.escapeRegExpCharacters(je)}}we<de.length-1&&(de[we+1]!==S||we+2<de.length)&&(ce+=A),Q=!1})}return ce}const h=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(K,ce){if(!K)return r;let de;typeof K!="string"?de=K.pattern:de=K,de=de.trim();const Q=`${de}_${!!ce.trimForExclusions}`;let ie=l.get(Q);if(ie)return g(ie,K);let we;if(h.test(de)){const Me=de.substr(4);ie=function(Fe,Be){return typeof Fe=="string"&&Fe.endsWith(Me)?de:null}}else(we=C.exec(d(de,ce)))?ie=s(we[1],de):(ce.trimForExclusions?m:b).test(de)?ie=v(de,ce):(we=p.exec(d(de,ce)))?ie=a(we[1].substr(1),de,!0):(we=R.exec(d(de,ce)))?ie=a(we[1],de,!1):ie=E(de);return l.set(Q,ie),g(ie,K)}function g(K,ce){return typeof ce=="string"?K:function(de,Q){return F.isEqualOrParent(de,ce.base)?K(P.relative(ce.base,de),Q):null}}function d(K,ce){return ce.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function s(K,ce){const de=`/${K}`,Q=`\\${K}`,ie=function(Me,Fe){return typeof Me!="string"?null:Fe?Fe===K?ce:null:Me===K||Me.endsWith(de)||Me.endsWith(Q)?ce:null},we=[K];return ie.basenames=we,ie.patterns=[ce],ie.allBasenames=we,ie}function v(K,ce){const de=ue(K.slice(1,-1).split(",").map(Fe=>i(Fe,ce)).filter(Fe=>Fe!==r),K),Q=de.length;if(!Q)return r;if(Q===1)return de[0];const ie=function(Fe,Be){for(let Ge=0,je=de.length;Ge<je;Ge++)if(de[Ge](Fe,Be))return K;return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function a(K,ce,de){const Q=P.sep===P.posix.sep,ie=Q?K:K.replace(n,P.sep),we=P.sep+ie,Me=P.posix.sep+K,Fe=de?function(Be,Ge){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Q&&(Be===K||Be.endsWith(Me)))?ce:null}:function(Be,Ge){return typeof Be=="string"&&(Be===ie||!Q&&Be===K)?ce:null};return Fe.allPaths=[(de?"*/":"./")+K],Fe}function E(K){try{const ce=new RegExp(`^${u(K)}$`);return function(de){return ce.lastIndex=0,typeof de=="string"&&ce.test(de)?K:null}}catch(ce){return r}}function I(K,ce,de){return!K||typeof ce!="string"?!1:k(K)(ce,void 0,de)}e.match=I;function k(K,ce={}){if(!K)return M;if(typeof K=="string"||x(K)){const de=i(K,ce);if(de===r)return M;const Q=function(ie,we){return!!de(ie,we)};return de.allBasenames&&(Q.allBasenames=de.allBasenames),de.allPaths&&(Q.allPaths=de.allPaths),Q}return H(K,ce)}e.parse=k;function B(K){if(!K)return;let ce;return de=>(ce||(ce=(K()||Promise.resolve([])).then(Q=>Q?y(Q):{})),ce.then(Q=>!!Q[de]))}e.hasSiblingPromiseFn=B;function L(K){if(!K)return;let ce;return de=>{if(!ce){const Q=K();ce=Q?y(Q):{}}return!!ce[de]}}e.hasSiblingFn=L;function y(K){const ce={};for(const de of K)ce[de]=!0;return ce}function x(K){const ce=K;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=x;function N(K){return K.allBasenames||[]}e.getBasenameTerms=N;function z(K){return K.allPaths||[]}e.getPathTerms=z;function H(K,ce){const de=ue(Object.getOwnPropertyNames(K).map(Fe=>q(Fe,K[Fe],ce)).filter(Fe=>Fe!==r)),Q=de.length;if(!Q)return r;if(!de.some(Fe=>!!Fe.requiresSiblings)){if(Q===1)return de[0];const Fe=function(je,Qe){for(let $=0,G=de.length;$<G;$++){const X=de[$](je,Qe);if(X)return X}return null},Be=de.find(je=>!!je.allBasenames);Be&&(Fe.allBasenames=Be.allBasenames);const Ge=de.reduce((je,Qe)=>Qe.allPaths?je.concat(Qe.allPaths):je,[]);return Ge.length&&(Fe.allPaths=Ge),Fe}const ie=function(Fe,Be,Ge){let je;for(let Qe=0,$=de.length;Qe<$;Qe++){const G=de[Qe];G.requiresSiblings&&Ge&&(Be||(Be=P.basename(Fe)),je||(je=Be.substr(0,Be.length-P.extname(Fe).length)));const X=G(Fe,Be,je,Ge);if(X)return X}return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function q(K,ce,de){if(ce===!1)return r;const Q=i(K,de);if(Q===r)return r;if(typeof ce=="boolean")return Q;if(ce){const ie=ce.when;if(typeof ie=="string"){const we=(Me,Fe,Be,Ge)=>{if(!Ge||!Q(Me,Fe))return null;const je=ie.replace("$(basename)",Be),Qe=Ge(je);return(0,c.isThenable)(Qe)?Qe.then($=>$?K:null):Qe?K:null};return we.requiresSiblings=!0,we}}return Q}function ue(K,ce){const de=K.filter(Fe=>!!Fe.basenames);if(de.length<2)return K;const Q=de.reduce((Fe,Be)=>{const Ge=Be.basenames;return Ge?Fe.concat(Ge):Fe},[]);let ie;if(ce){ie=[];for(let Fe=0,Be=Q.length;Fe<Be;Fe++)ie.push(ce)}else ie=de.reduce((Fe,Be)=>{const Ge=Be.patterns;return Ge?Fe.concat(Ge):Fe},[]);const we=function(Fe,Be){if(typeof Fe!="string")return null;if(!Be){let je;for(je=Fe.length;je>0;je--){const Qe=Fe.charCodeAt(je-1);if(Qe===47||Qe===92)break}Be=Fe.substr(je)}const Ge=Q.indexOf(Be);return Ge!==-1?ie[Ge]:null};we.basenames=Q,we.patterns=ie,we.allBasenames=Q;const Me=K.filter(Fe=>!Fe.basenames);return Me.push(we),Me}}),define(Ee[77],_e([0,1,42,10,17,23,24,9,2]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(i,g,d){if(typeof i=="string"&&(i=S.URI.file(i)),d){const v=d.getWorkspaceFolder(i);if(v){const a=d.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(v.uri,i)?E="":E=(0,t.relativePath)(v.uri,i),a){const I=v.name?v.name:(0,t.basename)(v.uri);E=E?I+" \u2022 "+E:I}return E}}if(i.scheme!==F.Schemas.file&&i.scheme!==F.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!P.isWindows&&g?.userHome&&(s=f(s,g.userHome.fsPath)),s}e.getPathLabel=D;function A(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const g=(0,t.basename)(i)||(i.scheme===F.Schemas.file?i.fsPath:i.path);return P.isWindows&&(0,c.isRootOrDriveLetter)(g)?_(g):g}e.getBaseLabel=A;function _(i,g){return(0,c.hasDriveLetter)(i,g)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function f(i,g){if(P.isWindows||!i||!g)return i;let d=n.original===g?n.normalized:void 0;return d||(d=`${(0,T.rtrim)(g,w.posix.sep)}${w.posix.sep}`,n={original:g,normalized:d}),(P.isLinux?i.startsWith(d):(0,T.startsWithIgnoreCase)(i,d))&&(i=`~/${i.substr(d.length)}`),i}e.tildify=f;function o(i,g){return i.replace(/^~($|\/|\\)/,`${g}$1`)}e.untildify=o;const u="\u2026",h="\\\\",C="~";function b(i,g=w.sep){const d=new Array(i.length);let s=!1;for(let v=0;v<i.length;v++){let a=i[v];if(a===""){d[v]=`.${g}`;continue}if(!a){d[v]=a;continue}s=!0;let E="";a.indexOf(h)===0?(E=a.substr(0,a.indexOf(h)+h.length),a=a.substr(a.indexOf(h)+h.length)):a.indexOf(g)===0?(E=a.substr(0,a.indexOf(g)+g.length),a=a.substr(a.indexOf(g)+g.length)):a.indexOf(C)===0&&(E=a.substr(0,a.indexOf(C)+C.length),a=a.substr(a.indexOf(C)+C.length));const I=a.split(g);for(let k=1;s&&k<=I.length;k++)for(let B=I.length-k;s&&B>=0;B--){s=!1;let L=I.slice(B,B+k).join(g);for(let y=0;!s&&y<i.length;y++)if(y!==v&&i[y]&&i[y].indexOf(L)>-1){const x=B+k===I.length,N=B>0&&i[y].indexOf(g)>-1?g+L:L,z=i[y].endsWith(N);s=!x||z}if(!s){let y="";(I[0].endsWith(":")||E!=="")&&(B===1&&(B=0,k++,L=I[0]+g+L),B>0&&(y=I[0]+g),y=E+y),B>0&&(y=y+u+g),y=y+L,B+k<I.length&&(y=y+g+u),d[v]=y}}s&&(d[v]=a)}return d}e.shorten=b;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function p(i,g=Object.create(null)){const d=[];let s=!1,v="";for(const a of i)if(a==="$"||s&&a==="{")v&&d.push({value:v,type:m.TEXT}),v="",s=!0;else if(a==="}"&&s){const E=g[v];if(typeof E=="string")E.length&&d.push({value:E,type:m.VARIABLE});else if(E){const I=d[d.length-1];(!I||I.type!==m.SEPARATOR)&&d.push({value:E.label,type:m.SEPARATOR})}v="",s=!1}else v+=a;return v&&!s&&d.push({value:v,type:m.TEXT}),d.filter((a,E)=>{if(a.type===m.SEPARATOR){const I=d[E-1],k=d[E+1];return[I,k].every(B=>B&&(B.type===m.VARIABLE||B.type===m.TEXT)&&B.value.length>0)}return!0}).map(a=>a.value).join("")}e.template=p;function R(i,g){return P.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=R;function l(i,g){return P.isMacintosh||g?i.replace(/\(&&\w\)|&&/g,""):P.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const g=i.indexOf("/")!==-1?w.posix:w.win32,d=g.basename(i),s=g.dirname(i);return d.length?{name:d,parentPath:s}:{name:s,parentPath:""}}e.splitName=r}),define(Ee[78],_e([0,1,29,10,17,24,9]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let S=[],D=[],A=[];function _(i,g=!1){const d=n(i);S.push(d),d.userConfigured?A.push(d):D.push(d),g&&!d.userConfigured&&S.forEach(s=>{s.mime===d.mime||s.userConfigured||(d.extension&&s.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&s.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&s.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&s.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,c.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function f(i){i?(S=S.filter(g=>!g.userConfigured),A=[]):(S=[],D=[],A=[])}e.clearTextMimes=f;function o(i,g){let d;if(i)switch(i.scheme){case F.Schemas.file:d=i.fsPath;break;case F.Schemas.data:d=P.DataUri.parseMetaData(i).get(P.DataUri.META_DATA_LABEL);break;default:d=i.path}if(!d)return[T.unknown];d=d.toLowerCase();const s=(0,w.basename)(d),v=u(d,s,A);if(v)return[v,T.text];const a=u(d,s,D);if(a)return[a,T.text];if(g){const E=h(g);if(E)return[E,T.text]}return[T.unknown]}e.guessMimeTypes=o;function u(i,g,d){let s=null,v=null,a=null;for(let E=d.length-1;E>=0;E--){const I=d[E];if(g===I.filenameLowercase){s=I;break}if(I.filepattern&&(!v||I.filepattern.length>v.filepattern.length)){const k=I.filepatternOnPath?i:g;I.filepatternLowercase?.(k)&&(v=I)}I.extension&&(!a||I.extension.length>a.extension.length)&&g.endsWith(I.extensionLowercase)&&(a=I)}return s?s.mime:v?v.mime:a?a.mime:null}function h(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let g=S.length-1;g>=0;g--){const d=S[g];if(!d.firstline)continue;const s=i.match(d.firstline);if(s&&s.length>0)return d.mime}return null}function C(i){return i?typeof i=="string"?i===T.binary||i===T.text||i===T.unknown:i.length===1&&C(i[0]):!0}e.isUnspecific=C;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(i){const g=(0,w.extname)(i),d=b[g.toLowerCase()];return d!==void 0?d:R(i)}e.getMediaOrTextMime=p;function R(i){const g=(0,w.extname)(i);return m[g.toLowerCase()]}e.getMediaMime=R;function l(i){for(const g in m)if(m[g]===i)return g}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,g){const d=M.exec(i);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:g?void 0:i}e.normalizeMimeType=r}),define(Ee[106],_e([0,1,2]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(A){return A.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:F(c.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:F(c.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:c.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,_,n){if(!A||n>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return _.transformOutgoing(A);for(let f in A)if(Object.hasOwnProperty.call(A,f)){const o=P(A[f],_,n+1);o!==null&&(A[f]=o)}}return null}function t(A,_){const n=P(A,_,0);return n===null?A:n}e.transformOutgoingURIs=t;function T(A,_,n,f){if(!A||f>200)return null;if(typeof A=="object"){if(A.$mid===1)return n?c.URI.revive(_.transformIncoming(A)):_.transformIncoming(A);for(let o in A)if(Object.hasOwnProperty.call(A,o)){const u=T(A[o],_,n,f+1);u!==null&&(A[o]=u)}}return null}function S(A,_){const n=T(A,_,!1,0);return n===null?A:n}e.transformIncomingURIs=S;function D(A,_){const n=T(A,_,!0,0);return n===null?A:n}e.transformAndReviveIncomingURIs=D}),define(Ee[35],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return c.test(S)}e.isUUID=F;const w=new Uint8Array(16),P=[];for(let S=0;S<256;S++)P.push(S.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(S){for(let D=0;D<S.length;D++)S[D]=Math.floor(Math.random()*256);return S};function T(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let S=0,D="";return D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D+="-",D+=P[w[S++]],D+=P[w[S++]],D+="-",D+=P[w[S++]],D+=P[w[S++]],D+="-",D+=P[w[S++]],D+=P[w[S++]],D+="-",D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D+=P[w[S++]],D}e.generateUuid=T}),define(Ee[107],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class F{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._standardTokenMask=0,Array.isArray(T.notIn))for(let S=0,D=T.notIn.length;S<D;S++)switch(T.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(T){return(this._standardTokenMask&T)==0}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const D=T.findTokenIndexAtOffset(S-2),A=T.getStandardTokenType(D);return this.isOK(A)}_findNeutralCharacterInRange(T,S){for(let D=T;D<=S;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class w{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=w;function P(t,T,S){t.has(T)?t.get(T).push(S):t.set(T,[S])}}),define(Ee[55],_e([0,1,29,17]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(P,t,T,S){if(Array.isArray(P)){let D=0;for(const A of P){const _=w(A,t,T,S);if(_===10)return _;_>D&&(D=_)}return D}else{if(typeof P=="string")return S?P==="*"?5:P===T?10:0:0;if(P){const{language:D,pattern:A,scheme:_,hasAccessToAllModels:n}=P;if(!S&&!n)return 0;let f=0;if(_)if(_===t.scheme)f=10;else if(_==="*")f=5;else return 0;if(D)if(D===T)f=10;else if(D==="*")f=Math.max(f,5);else return 0;if(A){let o;if(typeof A=="string"?o=A:o={...A,base:(0,F.normalize)(A.base)},o===t.fsPath||(0,c.match)(o,t.fsPath))f=10;else return 0}return f}else return 0}}e.score=w}),define(Ee[108],_e([0,1,3,6]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,T){return this._map.set(t,T),this.fire([t]),(0,F.toDisposable)(()=>{this._map.get(t)===T&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,T){let S=null,D=!1;return this._promises.set(t,T.then(A=>{this._promises.delete(t),!(D||!A)&&(S=this.register(t,A))})),(0,F.toDisposable)(()=>{D=!0,S&&S.dispose()})}getPromise(t){const T=this.get(t);if(T)return Promise.resolve(T);const S=this._promises.get(t);return S?S.then(D=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],_e([0,1,22,23]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function P(_){for(let n=0,f=_.length;n<f;n+=4){const o=_[n+0],u=_[n+1],h=_[n+2],C=_[n+3];_[n+0]=C,_[n+1]=h,_[n+2]=u,_[n+3]=o}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||P(n),c.VSBuffer.wrap(n)}function T(_){const n=_.buffer;if(F.isLittleEndian()||P(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(_){const n=new Uint32Array(D(_));let f=0;if(n[f++]=_.id,_.type==="full")n[f++]=1,n[f++]=_.data.length,n.set(_.data,f),f+=_.data.length;else{n[f++]=2,n[f++]=_.deltas.length;for(const o of _.deltas)n[f++]=o.start,n[f++]=o.deleteCount,o.data?(n[f++]=o.data.length,n.set(o.data,f),f+=o.data.length):n[f++]=0}return t(n)}e.encodeSemanticTokensDto=S;function D(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const f of _.deltas)f.data&&(n+=f.data.length)}return n}function A(_){const n=T(_);let f=0;const o=n[f++];if(n[f++]===1){const b=n[f++],m=n.subarray(f,f+b);return f+=b,{id:o,type:"full",data:m}}const h=n[f++];let C=[];for(let b=0;b<h;b++){const m=n[f++],p=n[f++],R=n[f++];let l;R>0&&(l=n.subarray(f,f+R),f+=R),C[b]={start:m,deleteCount:p,data:l}}return{id:o,type:"delta",deltas:C}}e.decodeSemanticTokensDto=A}),define(Ee[109],_e([18,19]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ee[110],_e([0,1,109]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,w=F*60,P=w*24,t=P*7,T=P*30,S=P*365;function D(_,n){typeof _!="number"&&(_=_.getTime());const f=Math.round((new Date().getTime()-_)/1e3);if(f<-30)return(0,c.localize)(0,null,D(new Date().getTime()+f*1e3,!1));if(f<30)return(0,c.localize)(1,null);let o;return f<F?(o=f,n?o===1?(0,c.localize)(2,null,o):(0,c.localize)(3,null,o):o===1?(0,c.localize)(4,null,o):(0,c.localize)(5,null,o)):f<w?(o=Math.floor(f/F),n?o===1?(0,c.localize)(6,null,o):(0,c.localize)(7,null,o):o===1?(0,c.localize)(8,null,o):(0,c.localize)(9,null,o)):f<P?(o=Math.floor(f/w),n?o===1?(0,c.localize)(10,null,o):(0,c.localize)(11,null,o):o===1?(0,c.localize)(12,null,o):(0,c.localize)(13,null,o)):f<t?(o=Math.floor(f/P),n?o===1?(0,c.localize)(14,null,o):(0,c.localize)(15,null,o):o===1?(0,c.localize)(16,null,o):(0,c.localize)(17,null,o)):f<T?(o=Math.floor(f/t),n?o===1?(0,c.localize)(18,null,o):(0,c.localize)(19,null,o):o===1?(0,c.localize)(20,null,o):(0,c.localize)(21,null,o)):f<S?(o=Math.floor(f/T),n?o===1?(0,c.localize)(22,null,o):(0,c.localize)(23,null,o):o===1?(0,c.localize)(24,null,o):(0,c.localize)(25,null,o)):(o=Math.floor(f/S),n?o===1?(0,c.localize)(26,null,o):(0,c.localize)(27,null,o):o===1?(0,c.localize)(28,null,o):(0,c.localize)(29,null,o))}e.fromNow=D;function A(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Ee[111],_e([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ee[43],_e([0,1,16,11,111]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(D,A){return A&&(D.stack||D.stacktrace)?w.localize(0,null,T(D),t(D.stack)||t(D.stacktrace)):T(D)}function t(D){return Array.isArray(D)?D.join(`
`):D}function T(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?w.localize(1,null,D.message):D.message||w.localize(2,null)}function S(D=null,A=!1){if(!D)return w.localize(3,null);if(Array.isArray(D)){const _=c.coalesce(D),n=S(_[0],A);return _.length>1?w.localize(4,null,n,_.length):n}if(F.isString(D))return D;if(D.detail){const _=D.detail;if(_.error)return P(_.error,A);if(_.exception)return P(_.exception,A)}return D.stack?P(D,A):D.message?D.message:w.localize(5,null)}e.toErrorMessage=S}),define(Ee[112],_e([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],_e([0,1,112,23,114]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=t;class T{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,pe){this._values[J]=pe}}e.ValidatedEditorOptions=T;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class D{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}compute(J,pe,Ue){return Ue}}class A{constructor(J,pe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(J){return this.defaultValue}}class _{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,pe,Ue){return Ue}}function n(V,J){return typeof V=="undefined"?J:V==="false"?!1:Boolean(V)}e.boolean=n;class f extends _{constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return n(J,this.defaultValue)}}function o(V,J,pe,Ue){if(typeof V=="undefined")return J;let Ye=parseInt(V,10);return isNaN(Ye)?J:(Ye=Math.max(pe,Ye),Ye=Math.min(Ue,Ye),Ye|0)}e.clampedInt=o;class u extends _{constructor(J,pe,Ue,Ye,Je,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=Ue,lt.minimum=Ye,lt.maximum=Je),super(J,pe,Ue,lt),this.minimum=Ye,this.maximum=Je}static clampedInt(J,pe,Ue,Ye){return o(J,pe,Ue,Ye)}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class h extends _{constructor(J,pe,Ue,Ye,Je){typeof Je!="undefined"&&(Je.type="number",Je.default=Ue),super(J,pe,Ue,Je),this.validationFn=Ye}static clamp(J,pe,Ue){return J<pe?pe:J>Ue?Ue:J}static float(J,pe){if(typeof J=="number")return J;if(typeof J=="undefined")return pe;const Ue=parseFloat(J);return isNaN(Ue)?pe:Ue}validate(J){return this.validationFn(h.float(J,this.defaultValue))}}class C extends _{static string(J,pe){return typeof J!="string"?pe:J}constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return C.string(J,this.defaultValue)}}function b(V,J,pe){return typeof V!="string"||pe.indexOf(V)===-1?J:V}e.stringSet=b;class m extends _{constructor(J,pe,Ue,Ye,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=Ye,Je.default=Ue),super(J,pe,Ue,Je),this._allowedValues=Ye}validate(J){return b(J,this.defaultValue,this._allowedValues)}}class p extends D{constructor(J,pe,Ue,Ye,Je,lt,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=Je,Et.default=Ye),super(J,pe,Ue,Et),this._allowedValues=Je,this._convert=lt}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function R(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,pe,Ue){return Ue===0?J.accessibilitySupport:Ue}}class M extends D{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(V){switch(V){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function s(V){switch(V){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class v extends A{constructor(){super(127,[65,33])}compute(J,pe,Ue){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class a extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,pe,Ue){return Ue&&J.emptySelectionClipboard}}class E extends D{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":b(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":b(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class I extends D{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?I.OFF:J==="true"?I.ON:J:Boolean(J)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class k extends A{constructor(){super(43)}compute(J,pe,Ue){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let pe=h.float(J,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(J,pe,Ue){return J.fontInfo.fontSize}}class L extends D{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class y extends D{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ue,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ue,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ue,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ue,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ue,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{multiple:b(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??b(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??b(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??b(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??b(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??b(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:C.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:C.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:C.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:C.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:C.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends D{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:c.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky),above:n(pe.above,this.defaultValue.above)}}}var N;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class z extends A{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(J,pe,Ue){return z.computeLayout(pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const pe=J.height/J.lineHeight,Ue=J.scrollBeyondLastLine?pe-1:0,Ye=(J.viewLineCount+Ue)/(J.pixelRatio*J.height),Je=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:Je}}static _computeMinimapLayout(J,pe){const Ue=J.outerWidth,Ye=J.outerHeight,Je=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Je*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const lt=pe.stableMinimapLayoutInput,Et=lt&&J.outerHeight===lt.outerHeight&&J.lineHeight===lt.lineHeight&&J.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&J.pixelRatio===lt.pixelRatio&&J.scrollBeyondLastLine===lt.scrollBeyondLastLine&&J.minimap.enabled===lt.minimap.enabled&&J.minimap.side===lt.minimap.side&&J.minimap.size===lt.minimap.size&&J.minimap.showSlider===lt.minimap.showSlider&&J.minimap.renderCharacters===lt.minimap.renderCharacters&&J.minimap.maxColumn===lt.minimap.maxColumn&&J.minimap.scale===lt.minimap.scale&&J.verticalScrollbarWidth===lt.verticalScrollbarWidth&&J.isViewportWrapping===lt.isViewportWrapping,It=J.lineHeight,et=J.typicalHalfwidthCharacterWidth,Tt=J.scrollBeyondLastLine,Pe=J.minimap.renderCharacters;let Se=Je>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const ve=J.minimap.maxColumn,re=J.minimap.size,ae=J.minimap.side,he=J.verticalScrollbarWidth,me=J.viewLineCount,Ie=J.remainingWidth,ze=J.isViewportWrapping,Oe=Pe?2:3;let We=Math.floor(Je*Ye);const it=We/Je;let ot=!1,ne=!1,ge=Oe*Se,te=Se/Je,W=1;if(re==="fill"||re==="fit"){const{typicalViewportLineCount:Ct,extraLinesBeyondLastLine:pt,desiredRatio:ht,minimapLineCount:vt}=z.computeContainedMinimapLineCount({viewLineCount:me,scrollBeyondLastLine:Tt,height:Ye,lineHeight:It,pixelRatio:Je});if(me/vt>1)ot=!0,ne=!0,Se=1,ge=1,te=Se/Je;else{let Ft=!1,yt=Se+1;if(re==="fit"){const At=Math.ceil((me+pt)*ge);ze&&Et&&Ie<=pe.stableFitRemainingWidth?(Ft=!0,yt=pe.stableFitMaxMinimapScale):Ft=At>We}if(re==="fill"||Ft){ot=!0;const At=Se;ge=Math.min(It*Je,Math.max(1,Math.floor(1/ht))),ze&&Et&&Ie<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),Se=Math.min(yt,Math.max(1,Math.floor(ge/Oe))),Se>At&&(W=Math.min(2,Se/At)),te=Se/Je/W,We=Math.ceil(Math.max(Ct,me+pt)*ge),ze?(pe.stableMinimapLayoutInput=J,pe.stableFitRemainingWidth=Ie,pe.stableFitMaxMinimapScale=Se):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const be=Math.floor(ve*te),ke=Math.min(be,Math.max(0,Math.floor((Ie-he-2)*te/(et+te)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(Je*ke);const Le=qe/Je;qe=Math.floor(qe*W);const dt=Pe?1:2,bt=ae==="left"?0:Ue-ke-he;return{renderMinimap:dt,minimapLeft:bt,minimapWidth:ke,minimapHeightIsEditorHeight:ot,minimapIsSampling:ne,minimapScale:Se,minimapLineHeight:ge,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:We,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:it}}static computeLayout(J,pe){const Ue=pe.outerWidth|0,Ye=pe.outerHeight|0,Je=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,Et=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,et=pe.pixelRatio,Tt=pe.viewLineCount,Pe=J.get(122),Se=Pe==="inherit"?J.get(121):Pe,ve=Se==="inherit"?J.get(117):Se,re=J.get(120),ae=J.get(2),he=pe.isDominatedByLongLines,me=J.get(49),Ie=J.get(59).renderType!==0,ze=J.get(60),Oe=J.get(93),We=J.get(64),it=J.get(91),ot=it.verticalScrollbarSize,ne=it.verticalHasArrows,ge=it.arrowSize,te=it.horizontalScrollbarSize,W=J.get(57),be=J.get(37);let ke;if(typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)){const Bt=parseFloat(W.substr(0,W.length-2));ke=u.clampedInt(Bt*Et,0,0,1e3)}else ke=u.clampedInt(W,0,0,1e3);be&&(ke+=16);let qe=0;if(Ie){const Bt=Math.max(lt,ze);qe=Math.round(Bt*It)}let Le=0;me&&(Le=Je);let dt=0,bt=dt+Le,Ct=bt+qe,pt=Ct+ke;const ht=Ue-Le-qe-ke;let vt=!1,_t=!1,Ft=-1;ae!==2&&(Se==="inherit"&&he?(vt=!0,_t=!0):ve==="on"||ve==="bounded"?_t=!0:ve==="wordWrapColumn"&&(Ft=re));const yt=z._computeMinimapLayout({outerWidth:Ue,outerHeight:Ye,lineHeight:Je,typicalHalfwidthCharacterWidth:Et,pixelRatio:et,scrollBeyondLastLine:Oe,minimap:We,verticalScrollbarWidth:ot,viewLineCount:Tt,remainingWidth:ht,isViewportWrapping:_t},pe.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(dt+=yt.minimapWidth,bt+=yt.minimapWidth,Ct+=yt.minimapWidth,pt+=yt.minimapWidth);const At=ht-yt.minimapWidth,Ut=Math.max(1,Math.floor((At-ot-2)/Et)),Pt=ne?ge:0;return _t&&(Ft=Math.max(1,Ut),ve==="bounded"&&(Ft=Math.min(Ft,re))),{width:Ue,height:Ye,glyphMarginLeft:dt,glyphMarginWidth:Le,lineNumbersLeft:bt,lineNumbersWidth:qe,decorationsLeft:Ct,decorationsWidth:ke,contentLeft:pt,contentWidth:At,minimap:yt,viewportColumn:Ut,isWordWrapMinified:vt,isViewportWrapping:_t,wrappingColumn:Ft,verticalScrollbarWidth:ot,horizontalScrollbarHeight:te,overviewRuler:{top:Pt,width:ot,height:Ye-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=z;class H extends D{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class q extends D{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:C.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ue extends h{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>h.clamp(J,0,150),{markdownDescription:c.localize(47,null)})}compute(J,pe,Ue){return J.fontInfo.lineHeight}}class K extends D{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(49,null),c.localize(50,null),c.localize(51,null)],default:J.size,description:c.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:b(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(pe.side,this.defaultValue.side,["right","left"]),showSlider:b(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(V){return V==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends D{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends D{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class ie extends A{constructor(){super(128)}compute(J,pe,Ue){return J.pixelRatio}}class we extends D{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(62,null)},comments:{type:"boolean",default:J.comments,description:c.localize(63,null)},other:{type:"boolean",default:J.other,description:c.localize(64,null)}}}],default:J,description:c.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const pe=J,Ue={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Me;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends D{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null),c.localize(69,null)],default:"on",description:c.localize(70,null)})}validate(J){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(pe=4,Ue=J):J==="interval"?pe=3:J==="relative"?pe=2:J==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function Be(V){const J=V.get(86);return J==="editable"?V.get(80):J!=="on"}e.filterValidationDecorations=Be;class Ge extends D{constructor(){const J=[],pe={type:"number",description:c.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:c.localize(72,null),format:"color-hex"}}}]},default:J,description:c.localize(73,null)})}validate(J){if(Array.isArray(J)){let pe=[];for(let Ue of J)if(typeof Ue=="number")pe.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ye=Ue;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ue,Ye)=>Ue.column-Ye.column),pe}return this.defaultValue}}function je(V,J){if(typeof V!="string")return J;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends D{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(74,null),c.localize(75,null),c.localize(76,null)],default:"auto",description:c.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(78,null),c.localize(79,null),c.localize(80,null)],default:"auto",description:c.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J,Ue=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class $ extends D{constructor(){const J={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.nonBasicASCII,description:c.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.invisibleCharacters,description:c.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.ambiguousCharacters,description:c.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.includeComments,description:c.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:J.allowedCharacters,description:c.localize(89,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{nonBasicASCII:Z(pe.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:Z(pe.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:Z(pe.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:Z(pe.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:G(pe.allowedCharacters,"")}}}function G(V,J){return typeof V!="string"?J:V}class X extends D{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(90,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:b(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class se extends D{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(91,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class j extends D{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:J.bracketPairs,description:c.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(96,null),c.localize(97,null),c.localize(98,null)],default:J.bracketPairsHorizontal,description:c.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:c.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:c.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Z(V,J,pe){const Ue=pe.indexOf(V);return Ue===-1?J:pe[Ue]}class fe extends D{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(103,null),c.localize(104,null)],default:J.insertMode,description:c.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertMode:b(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:b(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends D{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(145,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ne extends A{constructor(){super(129,[80])}compute(J,pe,Ue){return pe.get(80)?!0:J.tabFocusMode}}var He;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(He=e.WrappingIndent||(e.WrappingIndent={}));function Ke(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class tt extends A{constructor(){super(131,[130])}compute(J,pe,Ue){const Ye=pe.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const st="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Xe:F.isLinux?rt:st,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function De(V){return e.editorOptionsRegistry[V.id]=V,V}var gt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(gt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:De(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(146,null)})),acceptSuggestionOnEnter:De(new m(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(147,null),""],markdownDescription:c.localize(148,null)})),accessibilitySupport:De(new l),accessibilityPageSize:De(new u(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(149,null)})),ariaLabel:De(new C(4,"ariaLabel",c.localize(150,null))),autoClosingBrackets:De(new m(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(151,null),c.localize(152,null),""],description:c.localize(153,null)})),autoClosingDelete:De(new m(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(154,null),""],description:c.localize(155,null)})),autoClosingOvertype:De(new m(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(156,null),""],description:c.localize(157,null)})),autoClosingQuotes:De(new m(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(158,null),c.localize(159,null),""],description:c.localize(160,null)})),autoIndent:De(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],R,{enumDescriptions:[c.localize(161,null),c.localize(162,null),c.localize(163,null),c.localize(164,null),c.localize(165,null)],description:c.localize(166,null)})),automaticLayout:De(new f(10,"automaticLayout",!1)),autoSurround:De(new m(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),""],description:c.localize(170,null)})),bracketPairColorization:De(new se),bracketPairGuides:De(new j),stickyTabStops:De(new f(103,"stickyTabStops",!1,{description:c.localize(171,null)})),codeLens:De(new f(14,"codeLens",!0,{description:c.localize(172,null)})),codeLensFontFamily:De(new C(15,"codeLensFontFamily","",{description:c.localize(173,null)})),codeLensFontSize:De(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(174,null)})),colorDecorators:De(new f(17,"colorDecorators",!0,{description:c.localize(175,null)})),columnSelection:De(new f(18,"columnSelection",!1,{description:c.localize(176,null)})),comments:De(new M),contextmenu:De(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:De(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(177,null)})),cursorBlinking:De(new p(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(178,null)})),cursorSmoothCaretAnimation:De(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(179,null)})),cursorStyle:De(new p(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],s,{description:c.localize(180,null)})),cursorSurroundingLines:De(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(181,null)})),cursorSurroundingLinesStyle:De(new m(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(182,null),c.localize(183,null)],description:c.localize(184,null)})),cursorWidth:De(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(185,null)})),disableLayerHinting:De(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:De(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:De(new f(30,"domReadOnly",!1)),dragAndDrop:De(new f(31,"dragAndDrop",!0,{description:c.localize(186,null)})),emptySelectionClipboard:De(new a),extraEditorClassName:De(new C(33,"extraEditorClassName","")),fastScrollSensitivity:De(new h(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:c.localize(187,null)})),find:De(new E),fixedOverflowWidgets:De(new f(36,"fixedOverflowWidgets",!1)),folding:De(new f(37,"folding",!0,{description:c.localize(188,null)})),foldingStrategy:De(new m(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(189,null),c.localize(190,null)],description:c.localize(191,null)})),foldingHighlight:De(new f(39,"foldingHighlight",!0,{description:c.localize(192,null)})),foldingImportsByDefault:De(new f(40,"foldingImportsByDefault",!1,{description:c.localize(193,null)})),unfoldOnClickAfterEndOfLine:De(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(194,null)})),fontFamily:De(new C(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(195,null)})),fontInfo:De(new k),fontLigatures2:De(new I),fontSize:De(new B),fontWeight:De(new L),formatOnPaste:De(new f(47,"formatOnPaste",!1,{description:c.localize(196,null)})),formatOnType:De(new f(48,"formatOnType",!1,{description:c.localize(197,null)})),glyphMargin:De(new f(49,"glyphMargin",!0,{description:c.localize(198,null)})),gotoLocation:De(new y),hideCursorInOverviewRuler:De(new f(51,"hideCursorInOverviewRuler",!1,{description:c.localize(199,null)})),hover:De(new x),inDiffEditor:De(new f(53,"inDiffEditor",!1)),letterSpacing:De(new h(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>h.clamp(V,-5,20),{description:c.localize(200,null)})),lightbulb:De(new H),lineDecorationsWidth:De(new _(57,"lineDecorationsWidth",10)),lineHeight:De(new ue),lineNumbers:De(new Fe),lineNumbersMinChars:De(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:De(new f(61,"linkedEditing",!1,{description:c.localize(201,null)})),links:De(new f(62,"links",!0,{description:c.localize(202,null)})),matchBrackets:De(new m(63,"matchBrackets","always",["always","near","never"],{description:c.localize(203,null)})),minimap:De(new K),mouseStyle:De(new m(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:De(new h(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:c.localize(204,null)})),mouseWheelZoom:De(new f(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(205,null)})),multiCursorMergeOverlapping:De(new f(68,"multiCursorMergeOverlapping",!0,{description:c.localize(206,null)})),multiCursorModifier:De(new p(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[c.localize(207,null),c.localize(208,null)],markdownDescription:c.localize(209,null)})),multiCursorPaste:De(new m(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(210,null),c.localize(211,null)],markdownDescription:c.localize(212,null)})),occurrencesHighlight:De(new f(71,"occurrencesHighlight",!0,{description:c.localize(213,null)})),overviewRulerBorder:De(new f(72,"overviewRulerBorder",!0,{description:c.localize(214,null)})),overviewRulerLanes:De(new u(73,"overviewRulerLanes",3,0,3)),padding:De(new de),parameterHints:De(new Q),peekWidgetDefaultFocus:De(new m(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(215,null),c.localize(216,null)],description:c.localize(217,null)})),definitionLinkOpensInPeek:De(new f(77,"definitionLinkOpensInPeek",!1,{description:c.localize(218,null)})),quickSuggestions:De(new we),quickSuggestionsDelay:De(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(219,null)})),readOnly:De(new f(80,"readOnly",!1)),renameOnType:De(new f(81,"renameOnType",!1,{description:c.localize(220,null),markdownDeprecationMessage:c.localize(221,null)})),renderControlCharacters:De(new f(82,"renderControlCharacters",!0,{description:c.localize(222,null),restricted:!0})),renderFinalNewline:De(new f(83,"renderFinalNewline",!0,{description:c.localize(223,null)})),renderLineHighlight:De(new m(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(224,null)],description:c.localize(225,null)})),renderLineHighlightOnlyWhenFocus:De(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(226,null)})),renderValidationDecorations:De(new m(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:De(new m(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(227,null),c.localize(228,null),c.localize(229,null),""],description:c.localize(230,null)})),revealHorizontalRightPadding:De(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:De(new f(89,"roundedSelection",!0,{description:c.localize(231,null)})),rulers:De(new Ge),scrollbar:De(new Qe),scrollBeyondLastColumn:De(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(232,null)})),scrollBeyondLastLine:De(new f(93,"scrollBeyondLastLine",!0,{description:c.localize(233,null)})),scrollPredominantAxis:De(new f(94,"scrollPredominantAxis",!0,{description:c.localize(234,null)})),selectionClipboard:De(new f(95,"selectionClipboard",!0,{description:c.localize(235,null),included:F.isLinux})),selectionHighlight:De(new f(96,"selectionHighlight",!0,{description:c.localize(236,null)})),selectOnLineNumbers:De(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:De(new m(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),showUnused:De(new f(99,"showUnused",!0,{description:c.localize(240,null)})),showDeprecated:De(new f(125,"showDeprecated",!0,{description:c.localize(241,null)})),inlayHints:De(new q),snippetSuggestions:De(new m(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(242,null),c.localize(243,null),c.localize(244,null),c.localize(245,null)],description:c.localize(246,null)})),smartSelect:De(new Te),smoothScrolling:De(new f(102,"smoothScrolling",!1,{description:c.localize(247,null)})),stopRenderingLineAfter:De(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:De(new fe),inlineSuggest:De(new X),suggestFontSize:De(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(248,null)})),suggestLineHeight:De(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(249,null)})),suggestOnTriggerCharacters:De(new f(108,"suggestOnTriggerCharacters",!0,{description:c.localize(250,null)})),suggestSelection:De(new m(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null),c.localize(253,null)],description:c.localize(254,null)})),tabCompletion:De(new m(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(255,null),c.localize(256,null),c.localize(257,null)],description:c.localize(258,null)})),tabIndex:De(new u(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:De(new $),unusualLineTerminators:De(new m(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),useShadowDOM:De(new f(114,"useShadowDOM",!0)),useTabStops:De(new f(115,"useTabStops",!0,{description:c.localize(263,null)})),wordSeparators:De(new C(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:c.localize(264,null)})),wordWrap:De(new m(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null),c.localize(268,null)],description:c.localize(269,null)})),wordWrapBreakAfterCharacters:De(new C(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:De(new C(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:De(new u(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(270,null)})),wordWrapOverride1:De(new m(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:De(new m(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:De(new p(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ke,{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),wrappingStrategy:De(new m(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(276,null),c.localize(277,null)],description:c.localize(278,null)})),editorClassName:De(new v),pixelRatio:De(new ie),tabFocusMode:De(new Ne),layoutInfo:De(new z),wrappingInfo:De(new tt)}}),define(Ee[115],_e([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],_e([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],_e([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ee[118],_e([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ee[119],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],_e([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ee[127],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],_e([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var F;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],_e([0,1,116]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function P(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=P;function t(n){if(!P(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(F);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=t;function T(n){if(!n)return null;let f=n.majorBase,o=n.majorMustEqual,u=n.minorBase,h=n.minorMustEqual,C=n.patchBase,b=n.patchMustEqual;n.hasCaret&&(f===0||(h=!1),b=!1);let m=0;if(n.preRelease){const p=w.exec(n.preRelease);if(p){const[,R,l,M]=p;m=Date.UTC(Number(R),Number(l)-1,Number(M))}}return{majorBase:f,majorMustEqual:o,minorBase:u,minorMustEqual:h,patchBase:C,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:m}}e.normalizeVersion=T;function S(n,f,o){let u;typeof n=="string"?u=T(t(n)):u=n;let h;f instanceof Date?h=f.getTime():typeof f=="string"&&(h=new Date(f).getTime());let C;if(typeof o=="string"?C=T(t(o)):C=o,!u||!C)return!1;let b=u.majorBase,m=u.minorBase,p=u.patchBase,R=C.majorBase,l=C.minorBase,M=C.patchBase,r=C.notBefore,i=C.majorMustEqual,g=C.minorMustEqual,d=C.patchMustEqual;return C.isMinimum?b>R?!0:b<R?!1:m>l?!0:m<l||h&&h<r?!1:p>=M:(b===1&&R===0&&(!i||!g||!d)&&(R=1,l=0,M=0,i=!0,g=!1,d=!1),b<R?!1:b>R?!i:m<l?!1:m>l?!g:p<M?!1:p>M?!d:!(h&&h<r))}e.isValidVersion=S;function D(n,f,o,u){return o.isBuiltin||typeof o.main=="undefined"?!0:_(n,f,o.engines.vscode,u)}e.isValidExtensionVersion=D;function A(n,f,o){return n==="*"||_(f,o,n)}e.isEngineValid=A;function _(n,f,o,u=[]){let h=T(t(o));if(!h)return u.push(c.localize(0,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return u.push(c.localize(1,null,o)),!1}else if(!h.majorMustEqual)return u.push(c.localize(2,null,o)),!1;return S(n,f,h)?!0:(u.push(c.localize(3,null,n,o)),!1)}}),define(Ee[80],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(w,P=[],t=!1){this.ctor=w,this.staticArguments=P,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=c}),define(Ee[56],_e([0,1,80]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function w(t,T,S){T instanceof c.SyncDescriptor||(T=new c.SyncDescriptor(T,[],S)),F.push([t,T])}e.registerSingleton=w;function P(){return F}e.getSingletonServiceDescriptors=P}),define(Ee[133],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=c;class F{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let t of this._nodes.values())t.outgoing.size===0&&P.push(t);return P}insertEdge(P,t){const T=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(t);T.outgoing.set(this._hashFn(t),S),S.incoming.set(this._hashFn(P),T)}removeNode(P){const t=this._hashFn(P);this._nodes.delete(t);for(let T of this._nodes.values())T.outgoing.delete(t),T.incoming.delete(t)}lookupOrInsertNode(P){const t=this._hashFn(P);let T=this._nodes.get(t);return T||(T=new c(P),this._nodes.set(t,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[t,T]of this._nodes)P.push(`${t}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,t]of this._nodes){const T=new Set([P]),S=this._findCycle(t,T);if(S)return S}}_findCycle(P,t){for(let[T,S]of P.outgoing){if(t.has(T))return[...t,T].join(" -> ");t.add(T);const D=this._findCycle(S,t);if(D)return D;t.delete(T)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function F(t,T,S,D){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:t,index:S,optional:D}):(T[c.DI_DEPENDENCIES]=[{id:t,index:S,optional:D}],T[c.DI_TARGET]=T)}function w(t){if(c.serviceIds.has(t))return c.serviceIds.get(t);const T=function(S,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(T,S,A,!1)};return T.toString=()=>t,c.serviceIds.set(t,T),T}e.createDecorator=w;function P(t){return t}e.refineServiceDecorator=P}),define(Ee[134],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function F(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[135],_e([0,1,3,57,6,21,75,55,134]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(D):!!u.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(h,C){let b={selector:h,provider:C,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(b){let m=this._entries.indexOf(b);m>=0&&(this._entries.splice(m,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const C=[];for(let b of this._entries)b._score>0&&C.push(b.provider);return C}ordered(h){const C=[];return this._orderedForEach(h,b=>C.push(b.provider)),C}orderedGroups(h){const C=[];let b,m;return this._orderedForEach(h,p=>{b&&m===p._score?b.push(p.provider):(m=p._score,b=[p.provider],C.push(b))}),C}_orderedForEach(h,C){if(!!h){this._updateScores(h);for(const b of this._entries)b._score>0&&C(b)}}_updateScores(h){let C={uri:h.uri.toString(),language:h.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===C.language&&this._lastCandidate.uri===C.uri)){this._lastCandidate=C;for(let b of this._entries)if(b._score=(0,T.score)(b.selector,h.uri,h.getLanguageId(),(0,S.shouldSynchronizeModel)(h)),D(b.selector)&&b._score>0){for(let m of this._entries)m._score=0;b._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(h,C){return h._score<C._score?1:h._score>C._score?-1:h._time<C._time?1:h._time>C._time?-1:0}}e.LanguageFeatureRegistry=A;const _=new WeakMap;let n=0;function f(u){let h=_.get(u);return h===void 0&&(h=++n,_.set(u,h)),h}class o{constructor(h,C,b=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=C,this.max=b,this._cache=new P.LRUCache(50,.7)}_key(h){return h.id+this._registry.all(h).reduce((C,b)=>(0,F.doHash)(f(b),C),0)}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const C=this._key(h),b=this._cache.get(C);return this._clamp(b?.value)}update(h,C){const b=this._key(h);let m=this._cache.get(b);return m||(m=new t.MovingAverage,this._cache.set(b,m)),m.update(C),this.get(h)}}e.LanguageFeatureRequestDelays=o}),define(Ee[58],_e([0,1,2,59,135,108,53]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var S;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var D;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var A;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let I=this.getForeground(E),k="mtk"+I,B=this.getFontStyle(E);return B&1&&(k+=" mtki"),B&2&&(k+=" mtkb"),B&4&&(k+=" mtku"),k}static getInlineStyleFromMetadata(E,I){const k=this.getForeground(E),B=this.getFontStyle(E);let L=`color: ${I[k]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var f;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(f=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(E){const I=a[E];let k=I&&t.iconRegistry.get(I);return k||(console.info("No codicon found for CompletionItemKind "+E),k=t.Codicon.symbolProperty),k.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(E,I){let k=a[E];return typeof k=="undefined"&&!I&&(k=9),k}}();var o;(function(a){a[a.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function R(a){return a&&c.URI.isUri(a.uri)&&F.Range.isIRange(a.range)&&(F.Range.isIRange(a.originSelectionRange)||F.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=R;var l;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var M;(function(a){a[a.Deprecated=1]="Deprecated"})(M=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function k(y){return E.get(y)}a.fromString=k;function B(y){return I.get(y)}a.toString=B;function L(y,x){const N=I.get(y);let z=N&&t.iconRegistry.get("symbol-"+N);return z||(console.info("No codicon found for SymbolKind "+y),z=t.Codicon.symbolProperty),`${x?"inline":"block"} ${z.classNames}`}a.toCssClassName=L})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var g;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var s;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var v;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],_e([0,1,11,2,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function P(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof F.URI)}e.isConfigurationOverrides=P;function t(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||c.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=t;var T;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(h,C){const b=Object.create(null);for(let m in h)A(b,m,h[m],C);return b}e.toValuesTree=D;function A(h,C,b,m){const p=C.split("."),R=p.pop();let l=h;for(let M=0;M<p.length;M++){let r=p[M],i=l[r];switch(typeof i){case"undefined":i=l[r]=Object.create(null);break;case"object":break;default:m(`Ignoring ${C} as ${p.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[R]=b}catch(M){m(`Ignoring ${C} as ${p.join(".")} is ${JSON.stringify(l)}`)}else m(`Ignoring ${C} as ${p.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=A;function _(h,C){const b=C.split(".");n(h,b)}e.removeFromValueTree=_;function n(h,C){const b=C.shift();if(C.length===0){delete h[b];return}if(Object.keys(h).indexOf(b)!==-1){const m=h[b];typeof m=="object"&&!Array.isArray(m)&&(n(m,C),Object.keys(m).length===0&&delete h[b])}}function f(h,C,b){function m(l,M){let r=l;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const p=C.split("."),R=m(h,p);return typeof R=="undefined"?b:R}e.getConfigurationValue=f;function o(h,C,b){Object.keys(C).forEach(m=>{m!=="__proto__"&&(m in h?c.isObject(h[m])&&c.isObject(C[m])?o(h[m],C[m],b):b&&(h[m]=C[m]):h[m]=C[m])})}e.merge=o;function u(h,C,b){const m=h.inspect(C),p=h.inspect(b);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:m.defaultValue}e.getMigratedSettingValue=u}),define(Ee[44],_e([0,1,23,9,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=c.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",c.isMacintosh),t.set("isLinux",c.isLinux),t.set("isWindows",c.isWindows),t.set("isWeb",c.isWeb),t.set("isMacNative",c.isMacintosh&&!c.isWeb),t.set("isEdge",P.indexOf("Edg/")>=0),t.set("isFirefox",P.indexOf("Firefox")>=0),t.set("isChrome",P.indexOf("Chrome")>=0),t.set("isSafari",P.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(y){return o.create(y)}static equals(y,x){return u.create(y,x)}static notEquals(y,x){return b.create(y,x)}static regex(y,x){return i.create(y,x)}static in(y,x){return h.create(y,x)}static not(y){return m.create(y)}static and(...y){return s.create(y,null)}static or(...y){return v.create(y,null,!0)}static greater(y,x){return R.create(y,x)}static greaterEquals(y,x){return l.create(y,x)}static smaller(y,x){return M.create(y,x)}static smallerEquals(y,x){return r.create(y,x)}static deserialize(y,x=!1){if(!!y)return this._deserializeOrExpression(y,x)}static _deserializeOrExpression(y,x){let N=y.split("||");return v.create(N.map(z=>this._deserializeAndExpression(z,x)),null,!0)}static _deserializeAndExpression(y,x){let N=y.split("&&");return s.create(N.map(z=>this._deserializeOne(z,x)),null)}static _deserializeOne(y,x){if(y=y.trim(),y.indexOf("!=")>=0){let N=y.split("!=");return b.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("==")>=0){let N=y.split("==");return u.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("=~")>=0){let N=y.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(y.indexOf(" in ")>=0){let N=y.split(" in ");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const N=y.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const N=y.split(">");return R.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const N=y.split("<=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const N=y.split("<");return M.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(y)?m.create(y.substr(1).trim()):o.create(y)}static _deserializeValue(y,x){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let N=/^'([^']*)'$/.exec(y);return N?N[1].trim():y}static _deserializeRegexValue(y,x){if((0,F.isFalsyOrWhitespace)(y)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=y.indexOf("/"),z=y.lastIndexOf("/");if(N===z||N<0){if(x)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let H=y.slice(N+1,z),q=y[z+1]==="i"?"i":"";try{return new RegExp(H,q)}catch(ue){if(x)throw new Error(`bad regexp-value '${y}', parse error: ${ue}`);return console.warn(`bad regexp-value '${y}', parse error: ${ue}`),null}}}e.ContextKeyExpr=D;function A(L,y){const x=L?L.substituteConstants():void 0,N=y?y.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=A;function _(L,y){return L.cmp(y)}class n{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class o{constructor(y,x){this.key=y,this.negated=x,this.type=2}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?f.INSTANCE:n.INSTANCE:new o(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?f.INSTANCE:n.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class u{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=4}static create(y,x,N=null){if(typeof x=="boolean")return x?o.create(y,N):m.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?f.INSTANCE:n.INSTANCE:new u(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?f.INSTANCE:n.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class h{constructor(y,x){this.key=y,this.valueKey=x,this.type=10,this.negated=null}static create(y,x){return new h(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.valueKey),N=y.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?T.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this)),this.negated}}e.ContextKeyInExpr=h;class C{constructor(y){this._actual=y,this.type=11}static create(y){return new C(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new C(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class b{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=5}static create(y,x,N=null){if(typeof x=="boolean")return x?m.create(y,N):o.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?n.INSTANCE:f.INSTANCE:new b(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?n.INSTANCE:f.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class m{constructor(y,x){this.key=y,this.negated=x,this.type=3}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?n.INSTANCE:f.INSTANCE:new m(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?n.INSTANCE:f.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function p(L,y){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?y(L):n.INSTANCE}class R{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=12}static create(y,x,N=null){return p(x,z=>new R(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=R;class l{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=13}static create(y,x,N=null){return p(x,z=>new l(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=14}static create(y,x,N=null){return p(x,z=>new M(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=15}static create(y,x,N=null){return p(x,z=>new r(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:I(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(y,x){this.key=y,this.regexp=x,this.type=7,this.negated=null}static create(y,x){return new i(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return x<N?-1:x>N?1:0}equals(y){if(y.type===this.type){const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return this.key===y.key&&x===N}return!1}substituteConstants(){return this}evaluate(y){let x=y.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class g{constructor(y){this._actual=y,this.type=8}static create(y){return new g(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new g(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=g;function d(L){let y=null;for(let x=0,N=L.length;x<N;x++){const z=L[x].substituteConstants();if(L[x]!==z&&y===null){y=[];for(let H=0;H<x;H++)y[H]=L[H]}y!==null&&(y[x]=z)}return y===null?L:y}class s{constructor(y,x){this.expr=y,this.negated=x,this.type=6}static create(y,x){return s._normalizeArr(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=d(this.expr);return y===this.expr?this:s.create(y,this.negated)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(y))return!1;return!0}static _normalizeArr(y,x){const N=[];let z=!1;for(const H of y)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){N.push(...H.expr);continue}N.push(H)}if(N.length===0&&z)return f.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];for(;N.length>1;){const H=N[N.length-1];if(H.type!==9)break;N.pop();const q=N.pop(),ue=N.length===0,K=v.create(H.expr.map(ce=>s.create([ce,q],null)),null,ue);K&&(N.push(K),N.sort(_))}return N.length===1?N[0]:new s(N,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new s(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(let x of this.expr)y.push(x.negate());this.negated=v.create(y,this,!0)}return this.negated}}class v{constructor(y,x){this.expr=y,this.negated=x,this.type=9}static create(y,x,N){return v._normalizeArr(y,x,N)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=d(this.expr);return y===this.expr?this:v.create(y,this.negated,!1)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(y))return!0;return!1}static _normalizeArr(y,x,N){let z=[],H=!1;if(y){for(let q=0,ue=y.length;q<ue;q++){const K=y[q];if(!!K){if(K.type===0){H=!0;continue}if(K.type===1)return f.INSTANCE;if(K.type===9){z=z.concat(K.expr);continue}z.push(K)}}if(z.length===0&&H)return n.INSTANCE;z.sort(_)}if(z.length!==0){if(z.length===1)return z[0];for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];if(N){for(let q=0;q<z.length;q++)for(let ue=q+1;ue<z.length;ue++)k(z[q],z[ue])&&(z.splice(ue,1),ue--);if(z.length===1)return z[0]}return new v(z,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new v(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){let y=[];for(let x of this.expr)y.push(x.negate());for(;y.length>1;){const x=y.shift(),N=y.shift(),z=[];for(const q of B(x))for(const ue of B(N))z.push(s.create([q,ue],null));const H=y.length===0;y.unshift(v.create(z,null,H))}this.negated=y[0]}return this.negated}}class a extends o{constructor(y,x,N){super(y,null);this._defaultValue=x,typeof N=="object"?a._info.push({...N,key:y}):N!==!0&&a._info.push({key:y,description:N,type:x!=null?typeof x:void 0})}static all(){return a._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return u.create(this.key,y)}notEqualsTo(y){return b.create(this.key,y)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(L,y){return L<y?-1:L>y?1:0}function I(L,y,x,N){return L<x?-1:L>x?1:y<N?-1:y>N?1:0}function k(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const z of y.expr)if(L.equals(z))return!0}const x=L.negate(),N=B(x).concat(B(y));N.sort(_);for(let z=0;z<N.length;z++){const q=N[z].negate();for(let ue=z+1;ue<N.length;ue++){const K=N[ue];if(q.equals(K))return!0}}return!1}e.implies=k;function B(L){return L.type===9?L.expr:[L]}}),define(Ee[136],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],_e([0,1,21,17,9,11,2,117,4]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(N){return N.create===!0}e.isFileOpenForWriteOptions=D;var A;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function o(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function h(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=h;var C;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,H){super(z);this.code=H}}e.FileSystemProviderError=b;function m(N,z){const H=new b(N.toString(),z);return R(H,z),H}e.createFileSystemProviderError=m;function p(N){return N||m((0,T.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=p;function R(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=R;function l(N){if(!N)return C.Unknown;if(N instanceof b)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return C.Unknown;switch(z[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=l;function M(N){if(N instanceof v)return N.fileOperationResult;switch(l(N)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=M;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,H,q){this.resource=z,this.operation=H,this.target=q}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var g;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class d{constructor(z,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const ue of z){const K=q.get(ue.type);K?K.push([ue.resource,ue]):q.set(ue.type,[[ue.resource,ue]])}for(const[ue,K]of q)switch(ue){case 1:this.added=c.TernarySearchTree.forUris(()=>H),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>H),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>H),this.deleted.fill(K);break}}contains(z,...H){return this.doContains(z,{includeChildren:!1},...H)}affects(z,...H){return this.doContains(z,{includeChildren:!0},...H)}doContains(z,H,...q){if(!z)return!1;const ue=q.length>0;return!!((!ue||q.includes(1))&&(this.added?.get(z)||H.includeChildren&&this.added?.findSuperstr(z))||(!ue||q.includes(0))&&(this.updated?.get(z)||H.includeChildren&&this.updated?.findSuperstr(z))||(!ue||q.includes(2))&&(this.deleted?.findSubstr(z)||H.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function s(N,z,H){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),H?(0,w.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=s;class v extends Error{constructor(z,H,q){super(z);this.fileOperationResult=H,this.options=q}}e.FileOperationError=v;class a extends v{constructor(z,H,q){super(z,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=a;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=k;async function B(N,z){if(!z.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(H=>{const q=z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===N.scheme&&ue.added&&(q.dispose(),H())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(z){return(0,P.isNumber)(z)||(z=0),z<L.KB?(0,T.localize)(1,null,z.toFixed(0)):z<L.MB?(0,T.localize)(2,null,(z/L.KB).toFixed(2)):z<L.GB?(0,T.localize)(3,null,(z/L.MB).toFixed(2)):z<L.TB?(0,T.localize)(4,null,(z/L.GB).toFixed(2)):(0,T.localize)(5,null,(z/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(y=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(Ee[60],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...w){this._entries=new Map;for(let[P,t]of w)this.set(P,t)}set(w,P){const t=this._entries.get(w);return this._entries.set(w,P),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=c}),define(Ee[137],_e([0,1,14,15,80,133,4,60]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class D extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class A{constructor(o=new T.ServiceCollection,u=!1,h){this._activeInstantiations=new Set,this._services=o,this._strict=u,this._parent=h,this._services.set(t.IInstantiationService,this)}createChild(o){return new A(o,this._strict,this)}invokeFunction(o,...u){let h=n.traceInvocation(o),C=!1;try{return o({get:m=>{if(C)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(m,h);if(!p)throw new Error(`[invokeFunction] unknown service '${m}'`);return p}},...u)}finally{C=!0,h.stop()}}createInstance(o,...u){let h,C;return o instanceof w.SyncDescriptor?(h=n.traceCreation(o.ctor),C=this._createInstance(o.ctor,o.staticArguments.concat(u),h)):(h=n.traceCreation(o),C=this._createInstance(o,u,h)),h.stop(),C}_createInstance(o,u=[],h){let C=t._util.getServiceDependencies(o).sort((p,R)=>p.index-R.index),b=[];for(const p of C){let R=this._getOrCreateServiceInstance(p.id,h);if(!R&&this._strict&&!p.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${p.id}.`);b.push(R)}let m=C.length>0?C[0].index:u.length;if(u.length!==m){console.warn(`[createInstance] First service dependency of ${o.name} at position ${m+1} conflicts with ${u.length} static arguments`);let p=m-u.length;p>0?u=u.concat(new Array(p)):u=u.slice(0,m)}return new o(...[...u,...b])}_setServiceInstance(o,u){if(this._services.get(o)instanceof w.SyncDescriptor)this._services.set(o,u);else if(this._parent)this._parent._setServiceInstance(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let u=this._services.get(o);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):u}_getOrCreateServiceInstance(o,u){let h=this._getServiceInstanceOrDescriptor(o);return h instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,h,u.branch(o,!0)):(u.branch(o,!1),h)}_safeCreateAndCacheServiceInstance(o,u,h){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,u,h)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,u,h){const C=new P.Graph(p=>p.id.toString());let b=0;const m=[{id:o,desc:u,_trace:h}];for(;m.length;){const p=m.pop();if(C.lookupOrInsertNode(p),b++>1e3)throw new D(C);for(let R of t._util.getServiceDependencies(p.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(R.id);if(!l&&!R.optional&&console.warn(`[createInstance] ${o} depends on ${R.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:R.id,desc:l,_trace:p._trace.branch(R.id,!0)};C.insertEdge(p,M),m.push(M)}}}for(;;){const p=C.roots();if(p.length===0){if(!C.isEmpty())throw new D(C);break}for(const{data:R}of p){if(this._getServiceInstanceOrDescriptor(R.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(R.id,R.desc.ctor,R.desc.staticArguments,R.desc.supportsDelayedInstantiation,R._trace);this._setServiceInstance(R.id,M)}C.removeNode(R)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,u,h=[],C,b){if(this._services.get(o)instanceof w.SyncDescriptor)return this._createServiceInstance(u,h,C,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,u,h,C,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(o,u=[],h,C){if(h){const b=new c.IdleValue(()=>this._createInstance(o,u,C));return new Proxy(Object.create(null),{get(m,p){if(p in m)return m[p];let R=b.value,l=R[p];return typeof l!="function"||(l=l.bind(R),m[p]=l),l},set(m,p,R){return b.value[p]=R,!0}})}else return this._createInstance(o,u,C)}}e.InstantiationService=A;var _;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(_||(_={}));class n{constructor(o,u){this.type=o,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return S?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return S?new n(0,o.name):n._None}branch(o,u){let h=new n(2,o.toString());return this._dep.push([o,u,h]),h}stop(){let o=Date.now()-this._start;n._totals+=o;let u=!1;function h(b,m){let p=[],R=new Array(b+1).join("	");for(const[l,M,r]of m._dep)if(M&&r){u=!0,p.push(`${R}CREATES -> ${l}`);let i=h(b+1,r);i&&p.push(i)}else p.push(`${R}uses -> ${l}`);return p.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||u)&&console.log(C.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],_e([0,1,43,3,6,23,4]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function T(){return new Date().toISOString()}var S;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function D(M,r,i){switch(r){case S.Trace:M.trace(i);break;case S.Debug:M.debug(i);break;case S.Info:M.info(i);break;case S.Warning:M.warn(i);break;case S.Error:M.error(i);break;case S.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=D;function A(M){let r="";for(let i=0;i<M.length;i++){let g=M[i];if(typeof g=="object")try{g=JSON.stringify(g)}catch(d){}r+=(i>0?" ":"")+g}return r}e.format=A;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,A([r,...i]))}debug(r,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,A([r,...i]))}info(r,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,A([r,...i]))}warn(r,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,A([r,...i]))}error(r,...i){if(this.checkLogLevel(S.Error))if(r instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=r.stack,this.log(S.Error,A(g))}else this.log(S.Error,A([r,...i]))}critical(r,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,A([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class f extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!P.isWindows}trace(r,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}debug(r,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}info(r,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}warn(r,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,r,...i):console.warn(`[main ${T()}]`,r,...i))}error(r,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}critical(r,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class o extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class u extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,c.toErrorMessage)(r,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class h extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const g of this.logServices)g.trace(r,...i)}debug(r,...i){for(const g of this.logServices)g.debug(r,...i)}info(r,...i){for(const g of this.logServices)g.info(r,...i)}warn(r,...i){for(const g of this.logServices)g.warn(r,...i)}error(r,...i){for(const g of this.logServices)g.error(r,...i)}critical(r,...i){for(const g of this.logServices)g.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=h;class C extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=C;class b extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(g=>{this.logLevel=g,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(g))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let g=this.loggers.get(r.toString());return g||(g=this.doCreateLogger(r,i?.always?S.Trace:this.logLevel,i),this.loggers.set(r.toString(),g),i?.always||this.logLevelChangeableLoggers.push(g)),g}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class m{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(r){}getLevel(){return S.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=m;function p(M){if(M.verbose)return S.Trace;if(typeof M.logLevel=="string"){const r=R(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function R(M){switch(M){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=R;function l(M){switch(M){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],_e([0,1,34,118,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var t;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(o,u){return u-o}S.compare=D;const A=Object.create(null);A[S.Error]=(0,F.localize)(0,null),A[S.Warning]=(0,F.localize)(1,null),A[S.Info]=(0,F.localize)(2,null);function _(o){return A[o]||""}S.toString=_;function n(o){switch(o){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function f(o){switch(o){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=f}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const D="";function A(n){return _(n,!0)}S.makeKey=A;function _(n,f){let o=[D];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(D),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(D),n.severity!==void 0&&n.severity!==null?o.push(t.toString(n.severity)):o.push(D),n.message&&f?o.push(n.message.replace("\xA6","\\\xA6")):o.push(D),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(D),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(D),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(D),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(D),o.push(D),o.join("\xA6")}S.makeKeyOptionalMessage=_})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],_e([0,1,3,34,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,w.createDecorator)("notificationService");var P;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(Ee[139],_e([0,1,6,9,2,4]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function t(S,D){return w.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,D):(0,F.startsWithIgnoreCase)(S,D+":")}e.matchesScheme=t;function T(S,...D){return D.some(A=>t(S,A))}e.matchesSomeScheme=T});var xe=this&&this.__decorate||function(oe,e,c,F){var w=arguments.length,P=w<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,c):F,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(oe,e,c,F);else for(var T=oe.length-1;T>=0;T--)(t=oe[T])&&(P=(w<3?t(P):w>3?t(e,c,P):t(e,c))||P);return w>3&&P&&Object.defineProperty(e,c,P),P},$e=this&&this.__param||function(oe,e){return function(c,F){e(c,F,oe)}};define(Ee[140],_e([0,1,14,20,6,4]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var t;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends w.Disposable{constructor(_,n){super();this.deferred=new c.DeferredPromise,n.withProgress(_,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};S=xe([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,f=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ee[36],_e([0,1,41,11]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,T){c.ok(F.isString(t)),c.ok(F.isObject(T)),c.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,T)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(Ee[141],_e([0,1,3,36]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[w(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new P;F.Registry.add(e.Extensions.JSONContribution,t)}),define(Ee[83],_e([0,1,16,3,11,115,141,36]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=T.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(R,l=!0){this.registerConfigurations([R],l)}registerConfigurations(R,l=!0){const M=this.doRegisterConfigurations(R,l);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(R){const l=this.doDeregisterConfigurations(R);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:R,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(R,!1)),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(M)})}registerDefaultConfigurations(R){const l=[],M=[];for(const{overrides:r,source:i}of R)for(const g in r)if(l.push(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const d={...this.configurationDefaultsOverrides.get(g)?.value||{},...r[g]};this.configurationDefaultsOverrides.set(g,{source:i,value:d});const s={type:"object",default:d,description:P.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:w.isString(i)?void 0:i};M.push(...o(g)),this.configurationProperties[g]=s,this.defaultLanguageConfigurationOverridesNode.properties[g]=s}else{this.configurationDefaultsOverrides.set(g,{value:r[g],source:i});const d=this.configurationProperties[g];d&&(this.updatePropertyDefaultValue(g,d),this.updateSchema(g,d))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(R){const l=[];for(const{overrides:M,source:r}of R)for(const i in M){const g=this.configurationDefaultsOverrides.get(i),d=w.isString(r)?r:r?.id,s=w.isString(g?.source)?g?.source:g?.source?.id;if(d===s)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const l of R)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(R,l){const M=[];return R.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(R){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of R){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(R,l=!0,M,r,i=3){i=w.isUndefinedOrNull(R.scope)?i:R.scope;let g=[],d=R.properties;if(d)for(let v in d){if(l&&b(v)){delete d[v];continue}const a=d[v];if(a.source=M,a.defaultDefaultValue=d[v].default,this.updatePropertyDefaultValue(v,a),e.OVERRIDE_PROPERTY_REGEX.test(v)?a.scope=void 0:(a.scope=w.isUndefinedOrNull(a.scope)?i:a.scope,a.restricted=w.isUndefinedOrNull(a.restricted)?!!r?.includes(v):a.restricted),d[v].hasOwnProperty("included")&&!d[v].included){this.excludedConfigurationProperties[v]=d[v],delete d[v];continue}else this.configurationProperties[v]=d[v];!d[v].deprecationMessage&&d[v].markdownDeprecationMessage&&(d[v].deprecationMessage=d[v].markdownDeprecationMessage),g.push(v)}let s=R.allOf;if(s)for(let v of s)g.push(...this.validateAndRegisterProperties(v,l,M,r,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(R){const l=M=>{let r=M.properties;if(r)for(const g in r)this.updateSchema(g,r[g]);let i=M.allOf;i&&i.forEach(l)};l(R)}updateSchema(R,l){switch(e.allSettings.properties[R]=l,l.scope){case 1:e.applicationSettings.properties[R]=l;break;case 2:e.machineSettings.properties[R]=l;break;case 6:e.machineOverridableSettings.properties[R]=l;break;case 3:e.windowSettings.properties[R]=l;break;case 4:e.resourceSettings.properties[R]=l;break;case 5:e.resourceSettings.properties[R]=l,this.resourceLanguageSettingsSchema.properties[R]=l;break}}removeFromSchema(R,l){switch(delete e.allSettings.properties[R],l.scope){case 1:delete e.applicationSettings.properties[R];break;case 2:delete e.machineSettings.properties[R];break;case 6:delete e.machineOverridableSettings.properties[R];break;case 3:delete e.windowSettings.properties[R];break;case 4:case 5:delete e.resourceSettings.properties[R],delete this.resourceLanguageSettingsSchema.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const l=`[${R}]`,M={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const R={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=R,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,l){const M=this.configurationDefaultsOverrides.get(R);let r=M?.value,i=M?.source;w.isUndefined(r)&&(r=l.defaultDefaultValue,i=void 0),w.isUndefined(r)&&(r=h(l.type)),l.default=r,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",f=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(p){const R=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let l=f.exec(p);for(;l?.length;){const M=l[1].trim();M&&R.push(M),l=f.exec(p)}}return(0,c.distinct)(R)}e.overrideIdentifiersFromKey=o;function u(p){return p.reduce((R,l)=>`${R}[${l}]`,"")}e.keyFromOverrideIdentifiers=u;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const C=new _;T.Registry.add(e.Extensions.Configuration,C);function b(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?P.localize(7,null,p):C.getConfigurationProperties()[p]!==void 0?P.localize(8,null,p):null:P.localize(6,null)}e.validateProperty=b;function m(){const p=[],R=C.getConfigurationProperties();for(const l of Object.keys(R))p.push([l,R[l].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=m}),define(Ee[142],_e([0,1,16,3,100,6,21,27,11,2,81,83,36]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(r={},i=[],g=[]){this._contents=r,this._keys=i,this._overrides=g,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,A.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const g=this.getContentsForOverrideIdentifer(i);return g?r?(0,A.getConfigurationValue)(g,r):g:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const g of this.overrides)g.identifiers.includes(r)&&i.push(...g.keys);return c.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return c.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=T.deepClone(this.contents),g=T.deepClone(this.overrides),d=[...this.keys];for(const s of r){this.mergeContents(i,s.contents);for(const v of s.overrides){const[a]=g.filter(E=>c.equals(E.identifiers,v.identifiers));a?(this.mergeContents(a.contents,v.contents),a.keys.push(...v.keys),a.keys=c.distinct(a.keys)):g.push(T.deepClone(v))}for(const v of s.keys)d.indexOf(v)===-1&&d.push(v)}return new f(i,d,g)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let g={};for(const d of c.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[d],v=i[d];v&&(typeof s=="object"&&typeof v=="object"?(s=T.deepClone(s),this.mergeContents(s,v)):s=v),g[d]=s}return new f(g,this.keys,this.overrides)}mergeContents(r,i){for(const g of Object.keys(i)){if(g in r&&S.isObject(r[g])&&S.isObject(i[g])){this.mergeContents(r[g],i[g]);continue}r[g]=T.deepClone(i[g])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,g=null;const d=s=>{s&&(g?this.mergeContents(g,s):g=T.deepClone(s))};for(const s of this.overrides)c.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&d(s.contents);return d(i),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,A.addToValueTree)(this.contents,r,i,g=>{throw new Error(g)})}removeValue(r){this.removeKey(r)&&(0,A.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let g=0;g<i;g++)r.indexOf(this.keys[g])===0&&(i=g);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(r={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(i),d=Object.create(null),s=[];for(const v in i){const a=r[v],E=a!==void 0?a:i[v].default;(0,A.addToValueTree)(d,v,E,I=>console.error(`Conflict in default settings: ${I}`))}for(const v of Object.keys(d))_.OVERRIDE_PROPERTY_REGEX.test(v)&&s.push({identifiers:(0,_.overrideIdentifiersFromKey)(v),keys:Object.keys(d[v]),contents:(0,A.toValuesTree)(d[v],a=>console.error(`Conflict in default settings file: ${a}`))});super(d,g,s)}}e.DefaultConfigurationModel=o;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!S.isUndefinedOrNull(r)){const g=this.doParseContent(r);this.parseRaw(g,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:g,keys:d,overrides:s,restricted:v}=this.doParseRaw(r,i);this._configurationModel=new f(g,d,s),this._restrictedConfigurations=v||[]}doParseContent(r){let i={},g=null,d=[],s=[],v=[];function a(I){Array.isArray(d)?d.push(I):g!==null&&(d[g]=I)}let E={onObjectBegin:()=>{let I={};a(I),s.push(d),d=I,g=null},onObjectProperty:I=>{g=I},onObjectEnd:()=>{d=s.pop()},onArrayBegin:()=>{let I=[];a(I),s.push(d),d=I,g=null},onArrayEnd:()=>{d=s.pop()},onLiteralValue:a,onError:(I,k,B)=>{v.push({error:I,offset:k,length:B})}};if(r)try{w.visit(r,E),i=d[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(r,i){const g=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),d=this.filter(r,g,!0,i);r=d.raw;const s=(0,A.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),v=Object.keys(r),a=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:v,overrides:a,restricted:d.restricted}}filter(r,i,g,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:r,restricted:[]};const s={},v=[];for(let a in r)if(_.OVERRIDE_PROPERTY_REGEX.test(a)&&g){const E=this.filter(r[a],i,!1,d);s[a]=E.raw,v.push(...E.restricted)}else{const E=i[a],I=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&v.push(a),(I===void 0||d.scopes===void 0||d.scopes.includes(I))&&(d.skipRestricted&&E?.restricted||(s[a]=r[a]))}return{raw:s,restricted:v}}toOverrides(r,i){const g=[];for(const d of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(d)){const s={};for(const v in r[d])s[v]=r[d][v];g.push({identifiers:(0,_.overrideIdentifiersFromKey)(d),keys:Object.keys(s),contents:(0,A.toValuesTree)(s,i)})}return g}}e.ConfigurationModelParser=u;class h extends P.Disposable{constructor(r,i,g,d){super();this.userSettingsResource=r,this.scopes=i,this.fileService=d,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(g.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class C{constructor(r,i,g=new f,d=new f,s=new t.ResourceMap,v=new f,a=new t.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=g,this._workspaceConfiguration=d,this._folderConfigurations=s,this._memoryConfiguration=v,this._memoryConfigurationByResource=a,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,i,g){return this.getConsolidateConfigurationModel(i,g).getValue(r)}updateValue(r,i,g={}){let d;g.resource?(d=this._memoryConfigurationByResource.get(g.resource),d||(d=new f,this._memoryConfigurationByResource.set(g.resource,d))):d=this._memoryConfiguration,i===void 0?d.removeValue(r):d.setValue(r,i),g.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,g){const d=this.getConsolidateConfigurationModel(i,g),s=this.getFolderConfigurationModelForResource(i.resource,g),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,a=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),I=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),B=g?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,L=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,y=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(r):v.getValue(r),x=d.getValue(r),N=c.distinct(c.flatten(d.overrides.map(z=>z.identifiers))).filter(z=>d.getOverrideValue(r,z)!==void 0);return{defaultValue:a,userValue:E,userLocalValue:I,userRemoteValue:k,workspaceValue:B,workspaceFolderValue:L,memoryValue:y,value:x,default:a!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:v.getValue(r),override:i.overrideIdentifier?v.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r){const{added:i,updated:g,removed:d,overrides:s}=R(this._defaultConfiguration,r),v=[...i,...g,...d];return v.length&&this.updateDefaultConfiguration(r),{keys:v,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:g,removed:d,overrides:s}=R(this.localUserConfiguration,r),v=[...i,...g,...d];return v.length&&this.updateLocalUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:g,removed:d,overrides:s}=R(this.remoteUserConfiguration,r);let v=[...i,...g,...d];return v.length&&this.updateRemoteUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:g,removed:d,overrides:s}=R(this.workspaceConfiguration,r);let v=[...i,...g,...d];return v.length&&this.updateWorkspaceConfiguration(r),{keys:v,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const g=this.folderConfigurations.get(r),{added:d,updated:s,removed:v,overrides:a}=R(g,i);let E=[...d,...s,...v];return(E.length||!g)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:a}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:g,updated:d,removed:s,overrides:v}=R(i,void 0);return{keys:[...g,...d,...s],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let g=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?g.override(r.overrideIdentifier):g}getConsolidatedConfigurationModelForResource({resource:r},i){let g=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const d=i.getFolder(r);d&&(g=this.getFolderConsolidatedConfiguration(d.uri)||g);const s=this._memoryConfigurationByResource.get(r);s&&(g=g.merge(s))}return g}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const g=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(r);d?(i=g.merge(d),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=g}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const g=i.getFolder(r);if(g)return this._folderConfigurations.get(g.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:g,overrides:d,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:g,overrides:d,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(g=>r.add(g))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(g=>r.add(g))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(g=>i.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(g=>i.add(g)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.getKeysForOverrideIdentifier(r).forEach(d=>i.add(d))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),g=this.parseConfigurationModel(r.user),d=this.parseConfigurationModel(r.workspace),s=r.folders.reduce((v,a)=>(v.set(D.URI.revive(a[0]),this.parseConfigurationModel(a[1])),v),new t.ResourceMap);return new C(i,g,new f,d,s,new f,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=C;function b(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const d of M)d.keys.forEach(s=>r.add(s)),d.overrides.forEach(([s,v])=>{const a=(0,t.getOrSet)(i,s,new Set);v.forEach(E=>a.add(E))});const g=[];return i.forEach((d,s)=>g.push([s,[...d.values()]])),{keys:[...r.values()],overrides:g}}e.mergeChanges=b;class m{constructor(r,i,g,d){this.change=r,this.previous=i,this.currentConfiguraiton=g,this.currentWorkspace=d,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([,a])=>a.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const v=new f;this.affectedKeys.forEach(a=>v.setValue(a,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const g=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!T.equals(g,d)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let g=(0,A.toValuesTree)({[i]:!0},()=>{}),d;for(;typeof g=="object"&&(d=Object.keys(g)[0]);){if(r=r[d],!r)return!1;g=g[d]}return!0}}e.ConfigurationChangeEvent=m;class p extends m{constructor(r,i,g,d){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=g,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=p;function R(M,r){const{added:i,removed:g,updated:d}=l(r,M),s=[],v=M?.getAllOverrideIdentifiers()||[],a=r?.getAllOverrideIdentifiers()||[];if(r){const E=a.filter(I=>!v.includes(I));for(const I of E)s.push([I,r.getKeysForOverrideIdentifier(I)])}if(M){const E=v.filter(I=>!a.includes(I));for(const I of E)s.push([I,M.getKeysForOverrideIdentifier(I)])}if(r&&M){for(const E of v)if(a.includes(E)){const I=l({contents:M.getOverrideValue(void 0,E)||{},keys:M.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});s.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:g,updated:d,overrides:s}}function l(M,r){const i=M?r?M.keys.filter(s=>r.keys.indexOf(s)===-1):[...M.keys]:[],g=r?M?r.keys.filter(s=>M.keys.indexOf(s)===-1):[...r.keys]:[],d=[];if(M&&r){for(const s of r.keys)if(M.keys.indexOf(s)!==-1){const v=(0,A.getConfigurationValue)(r.contents,s),a=(0,A.getConfigurationValue)(M.contents,s);T.equals(v,a)||d.push(s)}}return{added:i,removed:g,updated:d}}}),define(Ee[84],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var F;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,T=F.Unknown,S){super(t);this._message=t,this._code=T,this._detail=S,this.isHandled=T===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===F.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===F.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],_e([0,1,10]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(D){return D.scheme===c.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=F;function w(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.getRemoteName=w;function P(D){return D.scheme!==c.Schemas.file&&D.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=P;function t(D){if(D.folders.length)return D.folders.every(A=>P(A.uri))?D.folders[0].uri:void 0;if(D.configuration&&P(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=t;function T(D){return t(D)?.scheme}e.getVirtualWorkspaceScheme=T;function S(D){return t(D)!==void 0}e.isVirtualWorkspace=S}),define(Ee[25],_e([0,1,9,4,61]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=P;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f=="undefined"||f===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){let u=typeof f=="string"?f:f.value,h=typeof o=="string"?o:o.value;return c.equalsIgnoreCase(u,h)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=S;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function A(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=A;function _(n,f){if(f){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(f)}`;return n.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],_e([0,1,9,25]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(o,u){return o.uuid&&u.uuid?o.uuid===u.uuid:o.id===u.id?!0:(0,c.compareIgnoreCase)(o.id,u.id)===0}e.areSameExtensions=w;class P{constructor(u,h){this.version=h,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof P?w(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=P;function t(o,u){return`${o}.${u}`}e.getExtensionId=t;function T(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function S(o,u){return T(t(o,u))}e.getGalleryExtensionId=S;function D(o,u){const h=[],C=b=>{for(const m of h)if(m.some(p=>w(u(p),u(b))))return m;return null};for(const b of o){const m=C(b);m?m.push(b):h.push([b])}return h}e.groupByExtension=D;function A(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function _(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(o){const u=new Set;if(o.malicious)for(const h of o.malicious)u.add(h.id);return u}e.getMaliciousExtensionsSet=n;function f(o,u){const h=[],C=u.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const b=C.shift();if(b&&h.every(m=>!w(m.identifier,{id:b}))){const m=o.filter(p=>w(p.identifier,{id:b}));m.length===1&&(h.push(m[0]),C.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.getExtensionDependencies=f}),define(Ee[144],_e([0,1,3,23,4,12]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(o){o.Http="http",o.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=_;function n(o,u){return u?u!==1&&o<1024:!F.isWindows&&o<1024}e.isPortPrivileged=n;let f=class{constructor(u){this.logService=u,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,h){return this._tunnelProvider=u,u?(this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],h=Array.from(this._tunnels.values());for(let C of h){const b=Array.from(C.values());for(let m of b){const p=await m.value;p&&u.push(p)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:h}of u.values())await h.then(C=>C?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,h,C,b,m=!1,p=T.Private,R){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${C} on local port ${b}.`),!u)return;h||(h="localhost");const l=this.retainOrCreateTunnel(u,h,C,b,m,p,R);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,C);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==h||M.tunnelRemotePort!==C)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const h=this._tunnels.get(u.tunnelRemoteHost);if(h){const C=h.get(u.tunnelRemotePort);C&&(C.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,C))}}}}async tryDisposeTunnel(u,h,C){if(C.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${h}.`);const b=C.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(h),b}}async closeTunnel(u,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${h} `);const C=this._tunnels.get(u);if(C&&C.has(h)){const b=C.get(h);b.refcount=0,await this.tryDisposeTunnel(u,h,b)}}addTunnelToMap(u,h,C){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(h,{refcount:1,value:C})}async removeEmptyTunnelFromMap(u,h){const C=this._tunnels.get(u);C&&(await C.get(h)||C.delete(h),C.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,h){let C=[u];A(u)?(C.push(...e.LOCALHOST_ADDRESSES),C.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&C.push(...e.ALL_INTERFACES_ADDRESSES);const b=C.map(m=>this._tunnels.get(m));for(const m of b){const p=m?.get(h);if(p)return p}}canTunnel(u){return!!D(u)}createWithProvider(u,h,C,b,m,p,R){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${C} on local port ${b}.`);const M={elevationRequired:m?n(b===void 0?C:b):!1},r={remoteAddress:{host:h,port:C},localAddressPort:b,privacy:p,public:p!==T.Private,protocol:R},i=u.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(h,C,i),i}};f=xe([$e(0,P.ILogService)],f),e.AbstractTunnelService=f}),define(Ee[145],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,P,t=5){let T;return T=P(S=>{const D=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(w);if(A){A.data.push(D);return}const _=setTimeout(()=>this.flushBuffer(w),t);A={data:[D],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),T.dispose()}},this._terminalBufferMap.set(w,A)}),T}stopBuffering(w){const P=this._terminalBufferMap.get(w);P&&P.dispose()}flushBuffer(w){const P=this._terminalBufferMap.get(w);P&&(this._terminalBufferMap.delete(w),this._callback(w,P.data.join("")))}}e.TerminalDataBufferer=c}),define(Ee[146],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],_e([0,1,53,3,6,4,36,146]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(h){function C(b){return b&&typeof b=="object"&&typeof b.id=="string"}h.isThemeColor=C})(S=e.ThemeColor||(e.ThemeColor={}));function D(h){return{id:h}}e.themeColorFromId=D;var A;(function(h){function C(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}h.isThemeIcon=C;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function m(r){const i=b.exec(r);if(!i)return;let[,g]=i;return{id:g}}h.fromString=m;function p(r,i){let g=r.id;const d=g.lastIndexOf("~");return d!==-1&&(g=g.substring(0,d)),i&&(g=`${g}~${i}`),{id:g}}h.modify=p;function R(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}h.getModifier=R;function l(r,i){return r.id===i.id&&r.color?.id===i.color?.id}h.isEqual=l;function M(r,i){return{id:r.id,color:i?D(i):void 0}}h.asThemeIcon=M,h.asClassNameArray=c.CSSIcon.asClassNameArray,h.asClassName=c.CSSIcon.asClassName,h.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function _(h){switch(h){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(C){return this.themingParticipants.push(C),this.onThemingParticipantAddedEmitter.fire(C),(0,w.toDisposable)(()=>{const b=this.themingParticipants.indexOf(C);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;t.Registry.add(e.Extensions.ThemingContribution,f);function o(h){return f.onColorThemeChange(h)}e.registerThemingParticipant=o;class u extends w.Disposable{constructor(C){super();this.themeService=C,this.theme=C.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(C){this.theme=C,this.updateStyles()}updateStyles(){}getColor(C,b){let m=this.theme.getColor(C);return m&&b&&(m=b(m,this.theme)),m?m.toString():null}}e.Themable=u}),define(Ee[46],_e([0,1,21,24,2,4]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=T;function S(n){const f=n;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class D{constructor(f,o,u,h,C){this._id=f,this._transient=u,this._configuration=h,this._ignorePathCasing=C,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class A{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,F.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function _(n){return new A({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const P=this._idPool++;return this._data.set(P,w),this.logDebugInfo(),P}get(w,P){return this._data.has(w)?this._data.get(w)[P]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(Ee[30],_e([0,1,10,24,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(T=>{const S=this._providerInfo.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this._providerInfo.delete(T):this._providerInfo.set(T,S)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Ee[147],_e([0,1,14]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(t,T,S){this._deferredPromises=new Map,this._id=t,this._shared=T,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of D.values())A.complete()}catch(A){for(const _ of D.values())_.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,T){let S=this._value[t];return typeof S=="undefined"&&(S=T),S}update(t,T){this._value[t]=T;let S=this._deferredPromises.get(t);if(S!==void 0)return S.p;const D=new c.DeferredPromise;return this._deferredPromises.set(t,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class w extends F{constructor(t,T){super(t.identifier.value,!0,T);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(Ee[148],_e([0,1,3,2,12]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let P=class{constructor(T,S){this._logService=T,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,S,D){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptModelChanged(S.value,D)}$acceptDirtyStateChanged(T,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptDirty(S)}$acceptModelSaved(T){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(T,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,S);const D=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T));D.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};P=xe([$e(0,w.ILogService)],P),e.ExtHostNotebookDocuments=P}),define(Ee[13],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class F{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=F});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[149],_e([0,1,25,3]),function(oe,e,c,F){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(T,S){w.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(T.identifier),Ze(this,w,S,"f"),Ae(this,w,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(T){return Ae(this,w,"f").get(this._id,T)}store(T,S){return Ae(this,w,"f").store(this._id,T,S)}delete(T){return Ae(this,w,"f").delete(this._id,T)}}e.ExtensionSecrets=P,w=new WeakMap}),define(Ee[85],_e([0,1,4,3]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Ee[47],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,w=(b,m)=>{const p={controllerId:m};return F.set(b,p),p};e.createPrivateApiFor=w;const P=b=>F.get(b);e.getPrivateApiFor=P;const t=(b,m,p,R)=>{let l=p;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!R(l,M)){const r=l;l=M,b.listener?.({op:3,key:m,value:M,previous:r})}}}},T=(b,m)=>b===m,S={range:(b,m)=>b===m?!0:!b||!m?!1:b.isEqual(m),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(b,m)=>!(b.length!==m.length||b.some(p=>!m.find(R=>p.id===R.id)))},D=Object.keys(S),A=(b,m)=>({range:t(b,"range",void 0,S.range),label:t(b,"label",m,S.label),description:t(b,"description",void 0,S.description),canResolveChildren:t(b,"canResolveChildren",!1,S.canResolveChildren),busy:t(b,"busy",!1,S.busy),error:t(b,"error",void 0,S.error),tags:t(b,"tags",[],S.tags)}),_=(b,m)=>{const p=new Map;for(const R of D)S[R](b[R],m[R])||p.set(R,m[R]);return p};e.diffTestItems=_;class n extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(m,p,R){super(`TestItem with ID "${m}" is from controller "${p}" and cannot be added as a child of an item from controller "${R}".`)}}e.MixedTestItemController=o;const u=b=>{const m=(0,e.getPrivateApiFor)(b);let p=new Map;return{get size(){return p.size},forEach(R,l){for(const M of p.values())R.call(l,M,this)},replace(R){const l=new Map,M=new Set(p.keys()),r={op:4,ops:[]};for(const i of R){if(!(i instanceof h))throw new f(i.id);const g=(0,e.getPrivateApiFor)(i).controllerId;if(g!==m.controllerId)throw new o(i.id,g,m.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});m.listener?.(r),p=l},add(R){if(!(R instanceof h))throw new f(R.id);p.set(R.id,R),m.listener?.({op:0,item:R})},delete(R){p.delete(R)&&m.listener?.({op:1,id:R})},get(R){return p.get(R)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class h{constructor(m,p,R,l){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const M=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof C?void 0:M.parent}},children:{value:u(this),enumerable:!0,writable:!1},...A(M,R)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=h;class C extends h{constructor(m,p){super(m,m,p,void 0)}}e.TestItemRootImpl=C}),define(Ee[64],_e([0,1,4,144,3,13]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(S){function D(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:_.protocol}}S.fromApiTunnel=D;function A(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==F.TunnelPrivacyId.ConstantPrivate&&_.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}S.fromServiceTunnel=A})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,_,n,f){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=xe([$e(0,P.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[7],_e([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n){"use strict";var f,o,u,h,C,b,m,p,R,l,M,r,i,g,d,s,v,a,E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=C=class{constructor(O){f.set(this,void 0),Ze(this,f,O,"f")}static from(...O){let ee=O;return new C(function(){if(ee){for(const ye of ee)ye&&typeof ye.dispose=="function"&&ye.dispose();ee=void 0}})}dispose(){typeof Ae(this,f,"f")=="function"&&(Ae(this,f,"f").call(this),Ze(this,f,void 0,"f"))}};f=new WeakMap,B=C=xe([k],B),e.Disposable=B;let L=b=class{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("line must be non-negative");if(ee<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=O,this._character=ee}static Min(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isBefore(ee)&&(ee=Ve)}return ee}static Max(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isAfter(ee)&&(ee=Ve)}return ee}static isPosition(O){if(!O)return!1;if(O instanceof b)return!0;let{line:ee,character:ye}=O;return typeof ee=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ee=0){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=0:typeof O=="number"?ye=O:(ye=typeof O.lineDelta=="number"?O.lineDelta:0,ee=typeof O.characterDelta=="number"?O.characterDelta:0),ye===0&&ee===0?this:new b(this.line+ye,this.character+ee)}with(O,ee=this.character){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=this.line:typeof O=="number"?ye=O:(ye=typeof O.line=="number"?O.line:this.line,ee=typeof O.character=="number"?O.character:this.character),ye===this.line&&ee===this.character?this:new b(ye,ee)}toJSON(){return{line:this.line,character:this.character}}};L=b=xe([k],L),e.Position=L;let y=m=class{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof m?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ee=L.Max(O.start,this._start),ye=L.Min(O.end,this._end);if(!ee.isAfter(ye))return new m(ee,ye)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ee=L.Min(O.start,this._start),ye=L.Max(O.end,this.end);return new m(ee,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ee=this.end){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return O?L.isPosition(O)?ye=O:(ye=O.start||this.start,ee=O.end||this.end):ye=this.start,ye.isEqual(this._start)&&ee.isEqual(this.end)?this:new m(ye,ee)}toJSON(){return[this.start,this.end]}};y=m=xe([k],y),e.Range=y;let x=p=class extends y{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof p?!0:O?y.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=p=xe([k],x),e.Selection=x;class N{constructor(O,ee,ye){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,F.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,F.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ee),this.connectionToken=ye}}e.ResolvedAuthority=N;class z extends Error{constructor(O,ee=n.RemoteAuthorityResolverErrorCode.Unknown,ye){super(O);this._message=O,this._code=ee,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(O,ee){return new z(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(O){return new z(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var q;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=R=class{constructor(O,ee){this._range=O,this._newText=ee}static isTextEdit(O){return O instanceof R?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ee){return new R(O,ee)}static insert(O,ee){return R.replace(new y(O,O),ee)}static delete(O){return R.replace(O,"")}static setEndOfLine(O){const ee=new R(new y(new L(0,0),new L(0,0)),"");return ee.newEol=O,ee}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,F.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,F.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,F.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=R=xe([k],ue),e.TextEdit=ue;var K;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let ce=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ee,ye,Ve){this._edits.push({_type:1,from:O,to:ee,options:ye,metadata:Ve})}createFile(O,ee,ye){this._edits.push({_type:1,from:void 0,to:O,options:ee,metadata:ye})}deleteFile(O,ee,ye){this._edits.push({_type:1,from:O,to:void 0,options:ee,metadata:ye})}replaceNotebookMetadata(O,ee,ye){this._edits.push({_type:3,metadata:ye,uri:O,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(O,ee,ye,Ve,nt){let at,ut,kt=[],Mt;if(Re.isNotebookRange(ee)&&Lt.isNotebookCellDataArray(ye)&&!Lt.isNotebookCellDataArray(Ve)?(at=ee.start,ut=ee.end,kt=ye,Mt=Ve):typeof ee=="number"&&typeof ye=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=ee,ut=ye,kt=Ve,Mt=nt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ut-at,cells:kt,metadata:Mt})}replaceNotebookCellMetadata(O,ee,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:ee,metadata:ye}})}replace(O,ee,ye,Ve){this._edits.push({_type:2,uri:O,edit:new ue(ee,ye),metadata:Ve})}insert(O,ee,ye,Ve){this.replace(O,new y(ee,ee),ye,Ve)}delete(O,ee,ye){this.replace(O,ee,"",ye)}has(O){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===O.toString())}set(O,ee){if(ee)for(const ye of ee)ye&&this._edits.push({_type:2,uri:O,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[ye]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const ee=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===O.toString()&&ee.push(ye.edit);return ee}entries(){const O=new P.ResourceMap;for(let ee of this._edits)if(ee._type===2){let ye=O.get(ee.uri);ye||(ye=[ee.uri,[]],O.set(ee.uri,ye)),ye[1].push(ee.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ce=xe([k],ce),e.WorkspaceEdit=ce;let de=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ee=this._tabstop++){if(typeof O=="function"){const ye=new l;ye._tabstop=this._tabstop,O(ye),this._tabstop=ye._tabstop,O=ye.value}else O=l._escape(O);return this.value+="${",this.value+=ee,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ee=this._tabstop++){const ye=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(O,ee){if(typeof ee=="function"){const ye=new l;ye._tabstop=this._tabstop,ee(ye),this._tabstop=ye._tabstop,ee=ye.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};de=l=xe([k],de),e.SnippetString=de;var Q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,ee){if(this.uri=O,ee)if(ee instanceof y)this.range=ee;else if(ee instanceof L)this.range=new y(ee,ee);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&D.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=xe([k],we),e.Location=we;let Me=class{constructor(O,ee){this.location=O,this.message=ee}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.location.range.isEqual(ee.location.range)&&O.location.uri.toString()===ee.location.uri.toString()}};Me=xe([k],Me),e.DiagnosticRelatedInformation=Me;let Fe=class{constructor(O,ee,ye=ie.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=O,this.message=ee,this.severity=ye}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.severity===ee.severity&&O.code===ee.code&&O.severity===ee.severity&&O.source===ee.source&&O.range.isEqual(ee.range)&&(0,c.equals)(O.tags,ee.tags)&&(0,c.equals)(O.relatedInformation,ee.relatedInformation,Me.isEqual)}};Fe=xe([k],Fe),e.Diagnostic=Fe;let Be=class{constructor(O,ee){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ee}};Be=xe([k],Be),e.Hover=Be;var Ge;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,ee=Ge.Text){this.range=O,this.kind=ee}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};je=xe([k],je),e.DocumentHighlight=je;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var $;(function(U){U[U.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.kind=ee,this.containerName=nt,typeof ye=="string"&&(this.containerName=ye),Ve instanceof we?this.location=Ve:ye instanceof y&&(this.location=new we(Ve,ye)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};G=r=xe([k],G),e.SymbolInformation=G;let X=i=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.detail=ee,this.kind=ye,this.range=Ve,this.selectionRange=nt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};X=i=xe([k],X),e.DocumentSymbol=X;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let j=class{constructor(O,ee){this.title=O,this.kind=ee}};j=xe([k],j),e.CodeAction=j;let Z=g=class{constructor(O){this.value=O}append(O){return new g(this.value?this.value+g.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+g.sep)}};Z.sep=".",Z=g=xe([k],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let fe=class{constructor(O,ee){if(this.range=O,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};fe=xe([k],fe),e.SelectionRange=fe;class Te{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=Te;class Ne{constructor(O,ee){this.fromRanges=ee,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,ee){this.fromRanges=ee,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ke;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(O,ee){this.range=O,this.command=ee}get isResolved(){return!!this.command}};tt=xe([k],tt),e.CodeLens=tt;let st=d=class{constructor(O,ee=!1){o.set(this,void 0),Ze(this,o,new w.MarkdownString(O,{supportThemeIcons:ee}),"f")}static isMarkdownString(O){return O instanceof d?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,o,"f").value}set value(O){Ae(this,o,"f").value=O}get isTrusted(){return Ae(this,o,"f").isTrusted}set isTrusted(O){Ae(this,o,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,o,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,o,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,o,"f").supportHtml}set supportHtml(O){Ae(this,o,"f").supportHtml=O}appendText(O){return Ae(this,o,"f").appendText(O),this}appendMarkdown(O){return Ae(this,o,"f").appendMarkdown(O),this}appendCodeblock(O,ee){return Ae(this,o,"f").appendCodeblock(ee??"",O),this}};o=new WeakMap,st=d=xe([k],st),e.MarkdownString=st;let Xe=class{constructor(O,ee){this.label=O,this.documentation=ee}};Xe=xe([k],Xe),e.ParameterInformation=Xe;let rt=class{constructor(O,ee){this.label=O,this.documentation=ee,this.parameters=[]}};rt=xe([k],rt),e.SignatureInformation=rt;let De=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};De=xe([k],De),e.SignatureHelp=De;var gt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var V;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(V=e.InlayHintKind||(e.InlayHintKind={}));let J=class{constructor(O,ee,ye){this.text=O,this.position=ee,this.kind=ye}};J=xe([k],J),e.InlayHint=J;var pe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(U){U[U.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(O,ee){this.label=O,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=xe([k],Je),e.CompletionItem=Je;let lt=class{constructor(O=[],ee=!1){this.items=O,this.isIncomplete=ee}};lt=xe([k],lt),e.CompletionList=lt;let Et=class{constructor(O,ee,ye){this.text=O,this.range=ee,this.command=ye}};Et=xe([k],Et),e.InlineSuggestion=Et;let It=class{constructor(O){this.items=O}};It=xe([k],It),e.InlineSuggestions=It;var et;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(et=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ae;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ae=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,ee){if(ee&&!D.URI.isUri(ee))throw(0,F.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.target=ee}};me=xe([k],me),e.DocumentLink=me;let Ie=class{constructor(O,ee,ye,Ve){this.red=O,this.green=ee,this.blue=ye,this.alpha=Ve}};Ie=xe([k],Ie),e.Color=Ie;let ze=class{constructor(O,ee){if(ee&&!(ee instanceof Ie))throw(0,F.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.color=ee}};ze=xe([k],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,F.illegalArgument)("label");this.label=O}};Oe=xe([k],Oe),e.ColorPresentation=Oe;var We;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(We=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor(O,ee,ye){if(this.startIndex=O,this.length=ee,this.tooltip=ye,typeof O!="number"||O<0)throw(0,F.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ot;var ne;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var te;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(O,ee){if(this.label=ee,typeof O!="string"||typeof ee!="string")throw(0,F.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=xe([k],be),e.TaskGroup=be;function ke(U){let O="";for(let ee=0;ee<U.length;ee++)O+=U[ee].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,ee,ye){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=O,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=ye):this._options=ee)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)O.push(ee);return ke(O)}};qe=xe([k],qe),e.ProcessExecution=qe;let Le=class{constructor(O,ee,ye){if(this._args=[],Array.isArray(ee)){if(!O)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O,this._args=ee,this._options=ye}else{if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)O.push(typeof ee=="string"?ee:ee.value);return ke(O)}};Le=xe([k],Le),e.ShellExecution=Le;var dt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ct;let pt=v=class{constructor(O,ee,ye,Ve,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=ye,this.execution=Ve,ut=nt,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at):(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ee=this._definition.type;(v.EmptyType===ee||v.ProcessType===ee||v.ShellType===ee||v.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=v=xe([k],pt),e.Task=pt;var ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(O,ee=_t.None){this.collapsibleState=ee,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};vt=xe([k],vt),e.TreeItem=vt;var _t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Ft=xe([k],Ft),e.TreeDataTransferItem=Ft;let yt=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,ee){this._items.set(O,ee)}forEach(O){this._items.forEach(O)}};yt=xe([k],yt),e.TreeDataTransfer=yt;let At=class{constructor(O,ee){this.id=O,this.color=ee}};At=xe([k],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let Ut=class{constructor(O){this.id=O}};Ut=xe([k],Ut),e.ThemeColor=Ut;var Pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(O,ee){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,F.illegalArgument)("base");if(typeof ee!="string")throw(0,F.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=D.URI.file(O),this.base=O):D.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ee}};Bt=xe([k],Bt),e.RelativePattern=Bt;let zt=class{constructor(O,ee,ye,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof ee=="string"&&(this.condition=ee),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};zt=xe([k],zt),e.Breakpoint=zt;let wt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);if(O===null)throw(0,F.illegalArgument)("location");this.location=O}};wt=xe([k],wt),e.SourceBreakpoint=wt;let Qt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);this.functionName=O}};Qt=xe([k],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends zt{constructor(O,ee,ye,Ve,nt,at,ut){super(Ve,nt,at,ut);if(!ee)throw(0,F.illegalArgument)("dataId");this.label=O,this.dataId=ee,this.canPersist=ye}};Vt=xe([k],Vt),e.DataBreakpoint=Vt;let oi=class{constructor(O,ee,ye){this.command=O,this.args=ee||[],this.options=ye}};oi=xe([k],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,ee){this.port=O,this.host=ee}};si=xe([k],si),e.DebugAdapterServer=si;let Rt=class{constructor(O){this.path=O}};Rt=xe([k],Rt),e.DebugAdapterNamedPipeServer=Rt;let Yt=class{constructor(O){this.implementation=O}};Yt=xe([k],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,ee){this.range=O,this.expression=ee}};ai=xe([k],ai),e.EvaluatableExpression=ai;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ee){this.range=O,this.text=ee}};Wt=xe([k],Wt),e.InlineValueText=Wt;let mt=class{constructor(O,ee,ye=!0){this.range=O,this.variableName=ee,this.caseSensitiveLookup=ye}};mt=xe([k],mt),e.InlineValueVariableLookup=mt;let ci=class{constructor(O,ee){this.range=O,this.expression=ee}};ci=xe([k],ci),e.InlineValueEvaluatableExpression=ci;let Ot=class{constructor(O,ee){this.frameId=O,this.stoppedLocation=ee}};Ot=xe([k],Ot),e.InlineValueContext=Ot;var jt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=a=class extends Error{constructor(O,ee=_.FileSystemProviderErrorCode.Unknown,ye){super(D.URI.isUri(O)?O.toString(!0):O);this.code=ye?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,a.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(O){return new a(O,_.FileSystemProviderErrorCode.FileExists,a.FileExists)}static FileNotFound(O){return new a(O,_.FileSystemProviderErrorCode.FileNotFound,a.FileNotFound)}static FileNotADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileNotADirectory,a.FileNotADirectory)}static FileIsADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileIsADirectory,a.FileIsADirectory)}static NoPermissions(O){return new a(O,_.FileSystemProviderErrorCode.NoPermissions,a.NoPermissions)}static Unavailable(O){return new a(O,_.FileSystemProviderErrorCode.Unavailable,a.Unavailable)}};Jt=a=xe([k],Jt),e.FileSystemError=Jt;let li=class{constructor(O,ee,ye){this.start=O,this.end=ee,this.kind=ye}};li=xe([k],li),e.FoldingRange=li;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ee=[]){this.tokenTypes=O,this.tokenModifiers=ee}}e.SemanticTokensLegend=Zt;function _i(U){return typeof U=="undefined"||(0,S.isStringArray)(U)}class qt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ee=0,ye=O.tokenTypes.length;ee<ye;ee++)this._tokenTypeStrToInt.set(O.tokenTypes[ee],ee);for(let ee=0,ye=O.tokenModifiers.length;ee<ye;ee++)this._tokenModifierStrToInt.set(O.tokenModifiers[ee],ee)}}push(O,ee,ye,Ve,nt){if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ee,ye,Ve,nt);if(y.isRange(O)&&typeof ee=="string"&&_i(ye))return this._push(O,ee,ye);throw(0,F.illegalArgument)()}_push(O,ee,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(ee);let kt=0;if(ye)for(const Mt of ye){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Mt);kt|=1<<Nt>>>0}this._pushEncoded(Ve,nt,at,ut,kt)}_pushEncoded(O,ee,ye,Ve,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Mt=0,Nt=0;for(let xt=0;xt<kt;xt++){let $t=this._data[5*xt],di=this._data[5*xt+1];$t===0?($t=Mt,di+=Nt):$t+=Mt,this._data[5*xt]=$t,this._data[5*xt+1]=di,Mt=$t,Nt=di}}let at=O,ut=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ee}static _sortAndDeltaEncode(O){let ee=[];const ye=O.length/5|0;for(let ut=0;ut<ye;ut++)ee[ut]=ut;ee.sort((ut,kt)=>{const Mt=O[5*ut],Nt=O[5*kt];if(Mt===Nt){const xt=O[5*ut+1],$t=O[5*kt+1];return xt-$t}return Mt-Nt});const Ve=new Uint32Array(O.length);let nt=0,at=0;for(let ut=0;ut<ye;ut++){const kt=5*ee[ut],Mt=O[kt+0],Nt=O[kt+1],xt=O[kt+2],$t=O[kt+3],di=O[kt+4],Hi=Mt-nt,Yi=Hi===0?Nt-at:Nt,hi=5*ut;Ve[hi+0]=Hi,Ve[hi+1]=Yi,Ve[hi+2]=xt,Ve[hi+3]=$t,Ve[hi+4]=di,nt=Mt,at=Nt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(qt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=qt;class Gt{constructor(O,ee){this.resultId=ee,this.data=O}}e.SemanticTokens=Gt;class yi{constructor(O,ee,ye){this.start=O,this.deleteCount=ee,this.data=ye}}e.SemanticTokensEdit=yi;class Si{constructor(O,ee){this.resultId=ee,this.edits=O}}e.SemanticTokensEdits=Si;var Kt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=xe([k],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,ee,ye){this.badge=O,this.tooltip=ee,this.color=ye}static validate(O){if(O.badge){let ee=(0,T.nextCharLength)(O.badge,0);if(ee<O.badge.length&&(ee+=(0,T.nextCharLength)(O.badge,ee)),O.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=xe([k],ti),e.ColorTheme=ti;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Re{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("start must be positive");if(ee<0)throw(0,F.illegalArgument)("end must be positive");O<=ee?(this._start=O,this._end=ee):(this._start=ee,this._end=O)}static isNotebookRange(O){return O instanceof Re?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ee=this._start,ye=this._end;return O.start!==void 0&&(ee=O.start),O.end!==void 0&&(ye=O.end),ee===this._start&&ye===this._end?this:new Re(ee,ye)}}e.NotebookRange=Re;class Lt{constructor(O,ee,ye,Ve,nt,at,ut){this.kind=O,this.value=ee,this.languageId=ye,this.mime=Ve,this.outputs=nt??[],this.metadata=at,this.executionSummary=ut,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ee=>Lt.isNotebookCellData(ee))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,ee){this.data=O,this.mime=ee;const ye=(0,t.normalizeMimeType)(ee,!0);if(!ye)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ee={name:O.name,message:O.message,stack:O.stack};return ft.json(ee,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ee="application/octet-stream"){return new ft(O,ee)}static text(O,ee=t.Mimes.text){const ye=Ae(ft,u,"f",h).encode(String(O));return new ft(ye,ee)}static json(O,ee="application/json"){const ye=JSON.stringify(O,void 0,"	");return ft.text(ye,ee)}}e.NotebookCellOutputItem=ft,u=ft,h={value:new TextEncoder};class ii{constructor(O,ee,ye){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof ee=="string"?(this.id=ee,this.metadata=ye):(this.id=(0,A.generateUuid)(),this.metadata=ee??ye)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,S.isArray)(O.items)}static ensureUniqueMimeTypes(O,ee=!1){const ye=new Set,Ve=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ut=(0,t.normalizeMimeType)(at.mime);if(!ye.has(ut)){ye.add(ut);continue}Ve.add(nt),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?O:O.filter((nt,at)=>!Ve.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,ee){this.text=O,this.alignment=ee}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,ee=[]){this.uri=O,this.provides=(0,c.asArray)(ee)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,ee){this.label=O,this.timestamp=ee}};ni=xe([k],ni),e.TimelineItem=ni;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,ee){this.ranges=O,this.wordPattern=ee}}e.LinkedEditingRanges=Li;class Ni{constructor(O,ee){this._port=O,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var le;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ce=class{constructor(O=void 0,ee=void 0,ye=void 0){this.include=O,this.exclude=ee,this.profile=ye}};Ce=xe([k],Ce),e.TestRunRequest=Ce;let ct=E=class{constructor(O){this.message=O}static diff(O,ee,ye){const Ve=new E(O);return Ve.expectedOutput=ee,Ve.actualOutput=ye,Ve}};ct=E=xe([k],ct),e.TestMessage=ct;let St=class{constructor(O){this.id=O}};St=xe([k],St),e.TestTag=St;let Dt=class{constructor(O,ee){this.covered=O,this.total=ee}};Dt=xe([k],Dt),e.CoveredCount=Dt;let xi=I=class{constructor(O,ee,ye,Ve){this.uri=O,this.statementCoverage=ee,this.branchCoverage=ye,this.functionCoverage=Ve}static fromDetails(O,ee){const ye=new Dt(0,0),Ve=new Dt(0,0),nt=new Dt(0,0);for(const ut of ee)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const kt of ut.branches)Ve.total+=1,Ve.covered+=kt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ut.executionCount>0?1:0;const at=new I(O,ye,Ve.total>0?Ve:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ee,at}};xi=I=xe([k],xi),e.FileCoverage=xi;let Ui=class{constructor(O,ee,ye=[]){this.executionCount=O,this.location=ee,this.branches=ye}};Ui=xe([k],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,ee){this.executionCount=O,this.location=ee}};Bi=xe([k],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,ee){this.executionCount=O,this.location=ee}};$i=xe([k],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],_e([0,1,41,10,9,223,114,7,16]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function A(o,u){u?D.set(o,u):D.delete(o)}e.setWordDefinitionFor=A;function _(o){return D.get(o)}e.getWordDefinitionFor=_;class n extends P.MirrorTextModel{constructor(u,h,C,b,m,p,R,l){super(h,C,b,m);this._proxy=u,this._languageId=p,this._isDirty=R,this._notebook=l,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,S.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===F.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(h){return h?u._getTextInRange(h):u.getText()},get eol(){return u._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(h){return u._lineAt(h)},offsetAt(h){return u._offsetAt(h)},positionAt(h){return u._positionAt(h)},validateRange(h){return u._validateRange(h)},validatePosition(h){return u._validatePosition(h)},getWordRangeAtPosition(h,C){return u._getWordRangeAtPosition(h,C)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,c.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,c.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const h=this._validateRange(u);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const C=this._eol,b=h.start.line,m=h.end.line,p=[];p.push(this._lines[b].substring(h.start.character));for(let R=b+1;R<m;R++)p.push(this._lines[R]);return p.push(this._lines[m].substring(0,h.end.character)),p.join(C)}_lineAt(u){let h;if(u instanceof T.Position?h=u.line:typeof u=="number"&&(h=u),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new f(h,this._lines[h],h===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(u),C=this._lines[h.index].length;return new T.Position(h.index,Math.min(h.remainder,C))}_validateRange(u){if(!(u instanceof T.Range))throw new Error("Invalid argument");const h=this._validatePosition(u.start),C=this._validatePosition(u.end);return h===u.start&&C===u.end?u:new T.Range(h.line,h.character,C.line,C.character)}_validatePosition(u){if(!(u instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:h,character:C}=u,b=!1;if(h<0)h=0,C=0,b=!0;else if(h>=this._lines.length)h=this._lines.length-1,C=this._lines[h].length,b=!0;else{const m=this._lines[h].length;C<0?(C=0,b=!0):C>m&&(C=m,b=!0)}return b?new T.Position(h,C):u}_getWordRangeAtPosition(u,h){const C=this._validatePosition(u);if(!h)h=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const b=(0,t.getWordAtText)(C.character+1,(0,t.ensureValidWordDefinition)(h),this._lines[C.line],0);if(b)return new T.Range(C.line,b.startColumn-1,C.line,b.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(u,h,C){this._line=u,this._text=h,this._isLastLine=C}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(Ee[150],_e([0,1,7,3,224,6,55,21,2,35]),function(oe,e,c,F,w,P,t,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(n,f,o,u){this._notebook=o,this._selector=u,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(C=>{const b=this._cellUris.get(C.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const h=C=>{C===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(C=>h(C.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const n=[],f=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let b="";for(const m of this._cells)b+=m.document.getText()+`
`;return b=b.slice(0,-1),b}if(n.isEmpty)return"";const f=this.locationAt(n.start),o=this.locationAt(n.end),u=this._cellUris.get(f.uri),h=this._cellUris.get(o.uri);if(u===void 0||h===void 0)return"";if(u===h)return this._cells[u].document.getText(new c.Range(f.range.start,o.range.end));const C=[this._cells[u].document.getText(new c.Range(f.range.start,new c.Position(this._cells[u].document.lineCount,0)))];for(let b=u+1;b<h;b++)C.push(this._cells[b].document.getText());return C.push(this._cells[h].document.getText(new c.Range(new c.Position(0,0),o.range.end))),C.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(f.index-1),u=this._cells[f.index].document.offsetAt(n.with(f.remainder));return o+u}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(u)}const f=this._cellUris.get(n.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new c.Position(o+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let o=f;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const u=new c.Position(f.remainder,n.start.character),h=new c.Position(o.remainder,n.end.character),C=new c.Range(u,h),b=this._cells[f.index];return new c.Location(b.document.uri,b.document.validateRange(C))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(f,o)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),o=new c.Position(f.remainder,n.character),u=this._cells[f.index].document.validatePosition(o),h=this._cellLines.getPrefixSum(f.index-1);return new c.Position(h+u.line,u.character)}}e.ExtHostNotebookConcatDocument=A}),define(Ee[151],_e([0,1,7,13,3]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(T){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let S=T==="light"?c.ColorThemeKind.Light:T==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=xe([$e(0,F.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ee[65],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class F{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=F}),define(Ee[152],_e([0,1,22]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function w(T,S){if(S.serializeBuffersForPostMessage){const D=new F,A=(f,o)=>{if(o instanceof ArrayBuffer){const u=D.add(o);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(o)){const u=P(o);if(u){const h=D.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:u,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},_=JSON.stringify(T,A),n=D.buffers.map(f=>{const o=new Uint8Array(f);return c.VSBuffer.wrap(o)});return{message:_,buffers:n}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=w;function P(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(T,S){const D=S.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),A=S.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:u}=o,h=D[u];if(o.view)switch(o.view.type){case 1:return new Int8Array(h,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return f}:void 0;return{message:JSON.parse(T,A),arrayBuffers:D}}e.deserializeWebviewMessage=t}),define(Ee[153],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(F){function w(t){const T=new Map;return t.types.forEach((S,D)=>{T.set(S,{asString:async()=>t.items[D].asString})}),T}F.toITreeDataTransfer=w;async function P(t){const T={types:[],items:[]},S=Array.from(t.entries());for(const D of S)T.types.push(D[0]),T.items.push({asString:await D[1].asString()});return T}F.toTreeDataTransferDTO=P})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],_e([0,1,10,2]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=F.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),F.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${P(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=w;function P(T){return T.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function t(T){return T.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=t}),define(Ee[154],_e([0,1,3,6,66]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(T,S,D){this._proxy=T,this._editors=S,this._initData=D,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const _ of this._insets.values())A.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,S,D,A,_){let n;for(const m of this._editors.getVisibleTextEditors(!0))if(m.value===T){n=m;break}if(!n)throw new Error("not a visible editor");const f=this,o=this._handlePool++,u=new c.Emitter,h=new c.Emitter,C=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(m){return(0,w.asWebviewUri)(m,f._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(m){this._options=m,f._proxy.$setOptions(o,m)}get options(){return this._options}set html(m){this._html=m,f._proxy.$setHtml(o,m)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(m){return f._proxy.$postMessage(o,m)}},b=new class{constructor(){this.editor=T,this.line=S,this.height=D,this.webview=C,this.onDidDispose=h.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),h.fire(),h.dispose(),u.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,S+1,D,A||{},_.identifier,_.extensionLocation),this._insets.set(o,{editor:T,inset:b,onDidReceiveMessage:u}),b}$onDidDispose(T){const S=this._insets.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){const D=this._insets.get(T);D&&D.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(Ee[155],_e([0,1,126,11,2,6,4,44,36,45,16,10]),function(oe,e,c,F,w,P,t,T,S,D,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,y,x){for(const N of x.visibleEditorPanes)if(N.group.id===y&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function f(L){if(R(L))return!1;const y=L;return w.URI.isUri(y?.resource)}e.isResourceEditorInput=f;function o(L){if(R(L))return!1;const y=L;return y?.original!==void 0&&y.modified!==void 0}e.isResourceDiffEditorInput=o;function u(L){if(R(L)||o(L))return!1;const y=L;return y?.primary!==void 0&&y.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function h(L){if(R(L))return!1;const y=L;return y?y.resource===void 0||y.resource.scheme===_.Schemas.untitled||y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;var C;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(C=e.Verbosity||(e.Verbosity={}));var b;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var m;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class p extends P.Disposable{}e.AbstractEditorInput=p;function R(L){return L instanceof p}e.isEditorInput=R;function l(L){const y=L;return w.URI.isUri(y?.preferredResource)}function M(L){const y=L;return R(y?.primary)&&R(y?.secondary)}e.isSideBySideEditorInput=M;function r(L){const y=L;return R(y?.modified)&&R(y?.original)}e.isDiffEditorInput=r;function i(L){return R(L?.editor)}e.isEditorInputWithOptions=i;function g(L){const y=L;return i(L)&&y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function d(L){const y=L;return typeof y?.groupId=="number"&&R(y.editor)}e.isEditorIdentifier=d;var s;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var v;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(v=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getOriginalUri(z,{filterByScheme:x.filterByScheme})??this.getOriginalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(o(y)||u(y))return;const N=l(y)?y.preferredResource:y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(y){return M(y)||u(y)?{primary:y.primary,secondary:y.secondary}:r(y)||o(y)?{primary:y.modified,secondary:y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===v.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===v.ANY)return this.getCanonicalUri(z,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===v.PRIMARY?z:H}}if(o(y)||u(y))return;const N=y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(y,x){if(Array.isArray(x)){if(x.some(N=>y.scheme===N))return y}else if(x===y.scheme)return y}}e.EditorResourceAccessor=new a;var E;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(y){const x=this.instantiationService=y.get(t.IInstantiationService);for(const[N,z]of this.editorSerializerConstructors)this.createEditorSerializer(N,z,x);this.editorSerializerConstructors.clear()}createEditorSerializer(y,x,N){const z=N.createInstance(x);this.editorSerializerInstances.set(y,z)}registerFileEditorFactory(y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=y}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(y,x){if(this.editorSerializerConstructors.has(y)||this.editorSerializerInstances.has(y))throw new Error(`A editor serializer with type ID '${y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(y,x,this.instantiationService):this.editorSerializerConstructors.set(y,x),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(y),this.editorSerializerInstances.delete(y)})}getEditorSerializer(y){return this.editorSerializerInstances.get(typeof y=="string"?y:y.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new I);async function k(L,y){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const z=w.URI.revive(N.fileUri);if(!z||!await y.canHandleResource(z))return;let q=N.exists,ue=N.type;if(typeof q!="boolean"||typeof ue!="number")try{ue=(await y.resolve(z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,q=!0}catch{q=!1}if(!q&&N.openOnlyIfExists||ue===D.FileType.Directory)return;const K={selection:q?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let ce;return q?ce={resource:z,options:K}:ce={resource:z,options:K,forceUntitled:!0},ce}));return(0,A.coalesce)(x)}e.pathsToEditors=k;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],_e([0,1,3,14,127]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,S,D,A){const _={command:T};if(S&&Object.keys(S).length>0&&(_.arguments=S),this.internalSend("request",_),typeof A=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(_.seq);if(f){this.pendingRequests.delete(_.seq);const o={type:"response",seq:0,request_seq:_.seq,success:!1,command:T,message:(0,w.localize)(0,null,A,T)};f(o)}},A)}return D&&this.pendingRequests.set(_.seq,D),_.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,S){return T.type!=="event"||S.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,F.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":const S=T,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}internalSend(T,S){S.type=T,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((S,D)=>T.set(D,S)),await(0,F.timeout)(500),T.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ee[157],_e([0,1,9,2,17,27,10]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(r,i,g){return r.replace(T,function(d,s){return i&&s.length>0&&s[0]!=="_"?d:g&&g.hasOwnProperty(s)?g[s]:d})}e.formatPII=S;function D(r){const i={};for(const g of Object.keys(r))g.startsWith("!")||(i[g]=r[g]);return i}e.filterExceptionsFromTelemetry=D;function A(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||A(r.parentSession))}e.isSessionAttach=A;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(i,"extensionhost")||(0,c.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,i,g){let d,s=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,a=null;for(;a=v.exec(r);){let E=a.index+1,I=E+a[0].length;if(E<=i&&I>=g){d=a[0],s=E;break}}if(d){let E=/\w+/g,I=null;for(;(I=E.exec(d))&&!(I.index+1+s+I[0].length>=g););I&&(d=d.substring(0,E.lastIndex))}return d?{start:s,end:s+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(r){return!!(r&&r.match(o))}e.isUri=u;function h(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(u(r.path))return F.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function C(r){if(typeof r.path=="object"){const i=F.URI.revive(r.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return r.path}function b(r,i){const g=i?h:C,d=(0,P.deepClone)(r);return p(d,(s,v)=>{s&&v&&(v.path=g(v))}),d}e.convertToDAPaths=b;function m(r,i){const g=i?h:C,d=(0,P.deepClone)(r);return p(d,(s,v)=>{!s&&v&&(v.path=g(v))}),d}e.convertToVSCPaths=m;function p(r,i){switch(r.type){case"event":const g=r;switch(g.event){case"output":i(!1,g.body.source);break;case"loadedSource":i(!1,g.body.source);break;case"breakpoint":i(!1,g.body.breakpoint.source);break;default:break}break;case"request":const d=r;switch(d.command){case"setBreakpoints":i(!0,d.arguments.source);break;case"breakpointLocations":i(!0,d.arguments.source);break;case"source":i(!0,d.arguments.source);break;case"gotoTargets":i(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const s=r;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":s.body.sources.forEach(v=>i(!1,v));break;case"scopes":s.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function R(r){return r.filter(i=>!i.presentation?.hidden).sort((i,g)=>i.presentation?g.presentation?i.presentation.group?g.presentation.group?i.presentation.group!==g.presentation.group?i.presentation.group.localeCompare(g.presentation.group):l(i.presentation.order,g.presentation.order):-1:g.presentation.group?1:l(i.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.getVisibleAndSorted=R;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const g=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(g!=="none"&&(await i.saveAll(),g==="allEditorsInActiveGroup")){const d=i.activeEditorPane;d&&await i.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],_e([0,1,29,158,78,10,17,23,44]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var C;(function(E){E.scheme=P.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function k(z,H){return z.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generate=k;function B(z){if(z.scheme!==E.scheme)return;const H=I.exec(z.fragment);return H?{handle:Number(H[1]),notebook:z.with({scheme:z.fragment.substr(H[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parse=B;function L(z,H,q){return z.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${H.toString().padStart(7,"0")},${q??""},${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generateCellOutputUri=L;function y(z){if(z.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const H=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!H)return;const q=Number(H[1]),ue=H[2]&&H[2]!==""?H[2]:void 0,K=H[3];return{handle:q,outputId:ue,notebook:z.with({scheme:K||P.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function x(z,H,q){return z.with({scheme:q,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==P.Schemas.file?z.scheme:""}`})}E.generateCellUri=x;function N(z,H){if(z.scheme!==H)return;const q=I.exec(z.fragment);return q?{handle:Number(q[1]),notebook:z.with({scheme:z.fragment.substr(q[0].length)||P.Schemas.file,fragment:null})}:void 0}E.parseCellUri=N})(C=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(E){return b.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=m;function p(E){return b.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function R(E){return b.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=R;const l=E=>T.isWindows?E.replace(/\//g,"\\"):E;class M{constructor(I=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(I)].map(B=>({pattern:B,matches:c.parse(l(B))}))}sort(I){const k=new Map(F.Iterable.map(I,L=>[L,l(L)]));let B=[];for(const{matches:L}of this.order)for(const[y,x]of k)if(L(x)){B.push(y),k.delete(y);break}return k.size&&(B=B.concat([...k.keys()].sort((L,y)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(y)))),B}prioritize(I,k){const B=this.findIndex(I);if(B===-1){this.order.unshift({pattern:I,matches:c.parse(l(I))});return}const L=new Set(k.map(x=>this.findIndex(x,B)));L.delete(-1);const y=Array.from(L).sort();this.order.splice(B+1,0,...y.map(x=>this.order[x]));for(let x=y.length-1;x>=0;x--)this.order.splice(y[x],1)}toArray(){return this.order.map(I=>I.pattern)}findIndex(I,k=this.order.length){const B=l(I);for(let L=0;L<k;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=M;function r(E,I,k,B=(L,y)=>L===y){const L=[];function y(z,H,q){if(H===0&&q.length===0)return;const ue=L[L.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=H,ue.toInsert.push(...q)):L.push({start:z,deleteCount:H,toInsert:q})}let x=0,N=0;for(;;){if(x===E.length){y(x,0,I.slice(N));break}if(N===I.length){y(x,E.length-x,[]);break}const z=E[x],H=I[N];if(B(z,H)){x+=1,N+=1;continue}k(H)?(y(x,1,[]),x+=1):(y(x,0,[H]),N+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function g(E){const I=E;return!!((typeof I.include=="string"||c.isRelativePattern(I.include))&&(typeof I.exclude=="string"||c.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=g;function d(E,I,k){if(Array.isArray(E.viewType)&&E.viewType.indexOf(I)>=0||E.viewType===I)return!0;if(E.filenamePattern){let B=g(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,L=g(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(c.match(B,(0,t.basename)(k.fsPath).toLowerCase()))return!(L&&c.match(L,(0,t.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class s{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)I[k]=this.textModel.cells[k].getHashValue();return I}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var v;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(I){return`${a._prefix}${I}`}static parse(I){if(I.startsWith(a._prefix))return I.substr(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/"}),define(Ee[159],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Ee[160],_e([0,1,4,44]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new F.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new F.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new F.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,c.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],_e([0,1,129,4,44]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=c;function F(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[88],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var P;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(P=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var T;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=D;class A{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const u=o[1];if(u.parent){if(this.items.has(u.parent)){const h=this.items.get(u.parent);h.children.add(u.item.extId);const C=this.createItem(u,h);this.items.set(u.item.extId,C),f.add(C)}}else{const h=this.createItem(u);this.roots.add(h),this.items.set(u.item.extId,h),f.add(h)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=o[1],h=this.items.get(u.extId);if(!h)break;u.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(h,u),f.update(h);break}case 2:{const u=this.items.get(o[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const h=[[o[1]]];for(;h.length;)for(const C of h.pop()){const b=this.items.get(C);b&&(h.push(b.children),this.items.delete(C),f.remove(b,b!==u),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=A}),define(Ee[67],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(P){P.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class w{constructor(t,T=t.length){if(this.path=t,this.viewEnd=T,t.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,T,S=t.parent){if(t.id===T)return new w([T]);let D=[t.id];for(let A=S;A&&A.id!==T;A=A.parent)D.push(A.id);return D.push(T),new w(D.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,T){return new w([...t.path,T])}static joinToString(t,T){return t.toString()+"\0"+T}static compare(t,T){return t===T?0:T.startsWith(t+"\0")?2:t.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let T=0;T<t.viewEnd&&T<this.viewEnd;T++)if(t.path[T]!==this.path[T])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(Ee[163],_e([0,1,17,89,11,27,23,77,130]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(_,n,f){this._contributedVariables=new Map,this._context=_,this._labelService=n,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(f=>{n[f.toLowerCase()]=_[f]}),n}return _}resolveWithEnvironment(_,n,f){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,f)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,f,o){const u=P.deepClone(n);return t.isWindows&&u.windows?Object.keys(u.windows).forEach(h=>u[h]=u.windows[h]):t.isMacintosh&&u.osx?Object.keys(u.osx).forEach(h=>u[h]=u.osx[h]):t.isLinux&&u.linux&&Object.keys(u.linux).forEach(h=>u[h]=u.linux[h]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,u,f,o)}async resolveAnyAsync(_,n,f){return this.resolveAnyBase(_,n,f)}async resolveAnyMap(_,n,f){const o=new Map;return{newConfig:await this.resolveAnyBase(_,n,f,o),resolvedVariables:o}}resolveWithInteractionReplace(_,n,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,f,o,u){if(w.isString(f))return this.resolveString(_,n,f,o,u);if(w.isArray(f))return f.map(h=>this.recursiveResolve(_,n,h,o,u));if(w.isObject(f)){let h=Object.create(null);return Object.keys(f).forEach(C=>{const b=this.resolveString(_,n,C,o,u);h[b]=this.recursiveResolve(_,n,f[C],o,u)}),h}return f}resolveString(_,n,f,o,u){return f.replace(D.VARIABLE_REGEXP,(C,b)=>{if(b.includes(D.VARIABLE_LHS))return C;let m=this.evaluateSingleVariable(_,C,b,n,o);return u&&u.set(b,m),m!==C&&w.isString(m)&&m.match(D.VARIABLE_REGEXP)&&(m=this.resolveString(_,n,m,o,u)),m})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,f,o,u){let h;const C=f.split(":");C.length>1&&(f=C[0],h=C[1]);const b=()=>{const R=this._context.getFilePath();if(R)return R;throw new Error((0,S.localize)(0,null,n))},m=()=>{const R=b();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,S.localize)(1,null,n,c.basename(R)))},p=()=>{if(h){const R=this._context.getFolderUri(h);if(R)return R;throw new Error((0,S.localize)(2,null,n,h))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(f){case"env":if(h){if(_){const R=_[t.isWindows?h.toLowerCase():h];if(w.isString(R))return R}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(h){const R=this._context.getConfigurationValue(o,h);if(w.isUndefinedOrNull(R))throw new Error((0,S.localize)(6,null,n,h));if(w.isObject(R))throw new Error((0,S.localize)(7,null,n,h));return R}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,h,u,"command");case"input":return this.resolveFromMap(n,h,u,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return o||h?(0,T.normalizeDriveLetter)(this.fsPath(p())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(p()));case"lineNumber":const R=this._context.getLineNumber();if(R)return R;throw new Error((0,S.localize)(9,null,n));case"selectedText":const l=this._context.getSelectedText();if(l)return l;throw new Error((0,S.localize)(10,null,n));case"file":return b();case"fileWorkspaceFolder":return m();case"relativeFile":return o||h?c.relative(this.fsPath(p()),b()):b();case"relativeFileDirname":const M=c.dirname(b());if(o||h){const d=c.relative(this.fsPath(p()),M);return d.length===0?".":d}return M;case"fileDirname":return c.dirname(b());case"fileExtname":return c.extname(b());case"fileBasename":return c.basename(b());case"fileBasenameNoExtension":const r=c.basename(b());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const g=this._context.getAppRoot();return g||n;case"pathSeparator":return c.sep;default:try{const d=h?`${f}:${h}`:f;return this.resolveFromMap(n,d,u,void 0)}catch(d){return n}}}}resolveFromMap(_,n,f,o){if(n&&f){const u=o===void 0?f[n]:f[o+":"+n];if(typeof u=="string")return u;throw new Error((0,S.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],_e([0,1,4,155]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var w;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var P;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var T;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(u){const h=u;return(0,F.isEditorInput)(h?.editor)&&(0,F.isEditorInput)(h?.replacement)}e.isEditorReplacement=D;var A;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(u){const h=u;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=f;function o(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(Ee[164],_e([0,1,4,90]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(P){const t=P;return typeof P=="number"||(0,F.isEditorGroup)(t)}e.isPreferredGroup=w}),define(Ee[8],_e([0,1,16,22,76,225,54,27,11,2,59,58,131,82,47,87,67,164,7]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(ne){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:ke,positionLineNumber:qe,positionColumn:Le}=W,dt=new b.Position(be-1,ke-1),bt=new b.Position(qe-1,Le-1);return new b.Selection(dt,bt)}ne.to=ge;function te(W){const{anchor:be,active:ke}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}ne.from=te})(m=e.Selection||(e.Selection={}));var p;(function(ne){function ge(W){if(!W)return;const{start:be,end:ke}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}ne.from=ge;function te(W){if(!W)return;const{startLineNumber:be,startColumn:ke,endLineNumber:qe,endColumn:Le}=W;return new b.Range(be-1,ke-1,qe-1,Le-1)}ne.to=te})(p=e.Range||(e.Range={}));var R;(function(ne){function ge(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ne.to=ge})(R=e.TokenType||(e.TokenType={}));var l;(function(ne){function ge(W){return new b.Position(W.lineNumber-1,W.column-1)}ne.to=ge;function te(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=te})(l=e.Position||(e.Position={}));var M;(function(ne){function ge(be,ke){return(0,c.coalesce)((0,c.asArray)(be).map(qe=>te(qe,ke)))}ne.from=ge;function te(be,ke){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,ke),pattern:typeof be.pattern=="undefined"?void 0:Ue.from(be.pattern),exclusive:be.exclusive}}function W(be,ke){return ke&&typeof be=="string"?ke.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function ge(W){switch(W){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ne.from=ge;function te(W){switch(W){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ne.to=te})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function ge(W){let be;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...p.from(W.range),message:W.message,source:W.source,code:be,severity:d.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(g.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(r.from)):void 0}}ne.from=ge;function te(W){const be=new b.Diagnostic(p.to(W),W.message,d.to(W.severity));return be.source=W.source,be.code=(0,S.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(g.to),be.tags=W.tags&&(0,c.coalesce)(W.tags.map(r.to)),be}ne.to=te})(i=e.Diagnostic||(e.Diagnostic={}));var g;(function(ne){function ge(W){return{...p.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=ge;function te(W){return new b.DiagnosticRelatedInformation(new b.Location(W.resource,p.to(W)),W.message)}ne.to=te})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ne){function ge(W){switch(W){case b.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ne.from=ge;function te(W){switch(W){case f.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ne.to=te})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ne){function ge(W){return typeof W=="number"&&W>=b.ViewColumn.One?W-1:W===b.ViewColumn.Beside?C.SIDE_GROUP:C.ACTIVE_GROUP}ne.from=ge;function te(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=te})(s=e.ViewColumn||(e.ViewColumn={}));function v(ne){return typeof ne.range!="undefined"}function a(ne){return ne.length===0?!0:!!v(ne[0])}e.isDecorationOptionsArr=a;var E;(function(ne){function ge(Le){return Le.map(ne.from)}ne.fromMany=ge;function te(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function W(Le){let dt;if(te(Le)){const{language:ht,value:vt}=Le;dt={value:"```"+ht+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Le)?dt={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons,supportHtml:Le.supportHtml}:typeof Le=="string"?dt={value:Le}:dt={value:""};const bt=Object.create(null);dt.uris=bt;const Ct=ht=>{try{let vt=D.URI.parse(ht,!0);vt=vt.with({query:be(vt.query,bt)}),bt[ht]=vt}catch(vt){}return""},pt=new P.Renderer;return pt.link=Ct,pt.image=ht=>Ct(w.parseHrefAndDimensions(ht).href),P(dt.value,{renderer:pt}),dt}ne.from=W;function be(Le,dt){if(!Le)return Le;let bt;try{bt=(0,t.parse)(Le)}catch(pt){}if(!bt)return Le;let Ct=!1;return bt=(0,T.cloneAndChange)(bt,pt=>{if(D.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ht]=pt,Ct=!0,ht}else return}),Ct?JSON.stringify(bt):Le}function ke(Le){const dt=new b.MarkdownString(Le.value,Le.supportThemeIcons);return dt.isTrusted=Le.isTrusted,dt.supportHtml=Le.supportHtml,dt}ne.to=ke;function qe(Le){if(!!Le)return typeof Le=="string"?Le:ne.from(Le)}ne.fromStrict=qe})(E=e.MarkdownString||(e.MarkdownString={}));function I(ne){return a(ne)?ne.map(ge=>({range:p.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?E.fromMany(ge.hoverMessage):ge.hoverMessage?E.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ne.map(ge=>({range:p.from(ge)}))}e.fromRangeOrRangeWithMessage=I;function k(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?D.URI.file(ne):ne}e.pathOrURIToURI=k;var B;(function(ne){function ge(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?k(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ne.from=ge})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ne){function ge(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?k(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ne){function ge(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=ge})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ne){function ge(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?y.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?L.from(te.light):void 0,dark:te.dark?L.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?k(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ne){function ge(W){return{text:W.newText,eol:W.newEol&&De.from(W.newEol),range:p.from(W.range)}}ne.from=ge;function te(W){const be=new b.TextEdit(p.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:De.to(W.eol),be}ne.to=te})(N=e.TextEdit||(e.TextEdit={}));var z;(function(ne){function ge(W,be,ke){const qe={edits:[]};if(W instanceof b.WorkspaceEdit)for(let Le of W._allEntries())if(Le._type===1)qe.edits.push({_type:1,oldUri:Le.from,newUri:Le.to,options:Le.options,metadata:Le.metadata});else if(Le._type===2){const dt=be?.getDocument(Le.uri);qe.edits.push({_type:2,resource:Le.uri,edit:N.from(Le.edit),modelVersionId:dt?.version,metadata:Le.metadata})}else Le._type===3?qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,edit:Le.edit,notebookMetadata:Le.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version}):Le._type===5&&qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Le.index,count:Le.count,cells:Le.cells.map(et.from)}});return qe}ne.from=ge;function te(W){const be=new b.WorkspaceEdit;for(const ke of W.edits)ke.edit?be.replace(D.URI.revive(ke.resource),p.to(ke.edit.range),ke.edit.text):be.renameFile(D.URI.revive(ke.oldUri),D.URI.revive(ke.newUri),ke.options);return be}ne.to=te})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ne){const ge=Object.create(null);ge[b.SymbolKind.File]=0,ge[b.SymbolKind.Module]=1,ge[b.SymbolKind.Namespace]=2,ge[b.SymbolKind.Package]=3,ge[b.SymbolKind.Class]=4,ge[b.SymbolKind.Method]=5,ge[b.SymbolKind.Property]=6,ge[b.SymbolKind.Field]=7,ge[b.SymbolKind.Constructor]=8,ge[b.SymbolKind.Enum]=9,ge[b.SymbolKind.Interface]=10,ge[b.SymbolKind.Function]=11,ge[b.SymbolKind.Variable]=12,ge[b.SymbolKind.Constant]=13,ge[b.SymbolKind.String]=14,ge[b.SymbolKind.Number]=15,ge[b.SymbolKind.Boolean]=16,ge[b.SymbolKind.Array]=17,ge[b.SymbolKind.Object]=18,ge[b.SymbolKind.Key]=19,ge[b.SymbolKind.Null]=20,ge[b.SymbolKind.EnumMember]=21,ge[b.SymbolKind.Struct]=22,ge[b.SymbolKind.Event]=23,ge[b.SymbolKind.Operator]=24,ge[b.SymbolKind.TypeParameter]=25;function te(be){return typeof ge[be]=="number"?ge[be]:6}ne.from=te;function W(be){for(const ke in ge)if(ge[ke]===be)return Number(ke);return b.SymbolKind.Property}ne.to=W})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(ne){function ge(W){switch(W){case b.SymbolTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return b.SymbolTag.Deprecated}}ne.to=te})(q=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function ge(W){return{name:W.name,kind:H.from(W.kind),tags:W.tags&&W.tags.map(q.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=ge;function te(W){const be=new b.SymbolInformation(W.name,H.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(q.to),be}ne.to=te})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:p.from(W.range),selectionRange:p.from(W.selectionRange),kind:H.from(W.kind),tags:W.tags?.map(q.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}ne.from=ge;function te(W){const be=new b.DocumentSymbol(W.name,W.detail,H.to(W.kind),p.to(W.range),p.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(q.to)),W.children&&(be.children=W.children.map(te)),be}ne.to=te})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(ne){function ge(W){const be=new b.CallHierarchyItem(H.to(W.kind),W.name,W.detail||"",D.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,name:W.name,detail:W.detail,kind:H.from(W.kind),uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ne){function ge(te){return new b.CallHierarchyIncomingCall(ce.to(te.from),te.fromRanges.map(W=>p.to(W)))}ne.to=ge})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ne){function ge(te){return new b.CallHierarchyOutgoingCall(ce.to(te.to),te.fromRanges.map(W=>p.to(W)))}ne.to=ge})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function ge(W){return{range:W.range&&p.from(W.range),uri:W.uri}}ne.from=ge;function te(W){return new b.Location(D.URI.revive(W.uri),p.to(W.range))}ne.to=te})(ie=e.location||(e.location={}));var we;(function(ne){function ge(W){const be=W,ke=W;return{originSelectionRange:be.originSelectionRange?p.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:ke.uri,range:p.from(be.targetRange?be.targetRange:ke.range),targetSelectionRange:be.targetSelectionRange?p.from(be.targetSelectionRange):void 0}}ne.from=ge;function te(W){return{targetUri:D.URI.revive(W.uri),targetRange:p.to(W.range),targetSelectionRange:W.targetSelectionRange?p.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?p.to(W.originSelectionRange):void 0}}ne.to=te})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function ge(W){return{range:p.from(W.range),contents:E.fromMany(W.contents)}}ne.from=ge;function te(W){return new b.Hover(W.contents.map(E.to),p.to(W.range))}ne.to=te})(Me=e.Hover||(e.Hover={}));var Fe;(function(ne){function ge(W){return{range:p.from(W.range),expression:W.expression}}ne.from=ge;function te(W){return new b.EvaluatableExpression(p.to(W.range),W.expression)}ne.to=te})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function ge(W){if(W instanceof b.InlineValueText)return{type:"text",range:p.from(W.range),text:W.text};if(W instanceof b.InlineValueVariableLookup)return{type:"variable",range:p.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=ge;function te(W){switch(W.type){case"text":return{range:p.to(W.range),text:W.text};case"variable":return{range:p.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:p.to(W.range),expression:W.expression}}}ne.to=te})(Be=e.InlineValue||(e.InlineValue={}));var Ge;(function(ne){function ge(W){return{frameId:W.frameId,stoppedLocation:p.from(W.stoppedLocation)}}ne.from=ge;function te(W){return new b.InlineValueContext(W.frameId,p.to(W.stoppedLocation))}ne.to=te})(Ge=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ne){function ge(W){return{range:p.from(W.range),kind:W.kind}}ne.from=ge;function te(W){return new b.DocumentHighlight(p.to(W.range),W.kind)}ne.to=te})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ne){function ge(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ne.to=ge})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function ge(te){return{triggerKind:Qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ne.to=ge})($=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function ge(W){switch(W){case b.CompletionItemTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return b.CompletionItemTag.Deprecated}}ne.to=te})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ne){const ge=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(ke){return ge.get(ke)??9}ne.from=te;const W=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function be(ke){return W.get(ke)??b.CompletionItemKind.Property}ne.to=be})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ne){function ge(te,W){const be=new b.CompletionItem(te.label);return be.insertText=te.insertText,be.kind=X.to(te.kind),be.tags=te.tags?.map(G.to),be.detail=te.detail,be.documentation=w.isMarkdownString(te.documentation)?E.to(te.documentation):te.documentation,be.sortText=te.sortText,be.filterText=te.filterText,be.preselect=te.preselect,be.commitCharacters=te.commitCharacters,A.Range.isIRange(te.range)?be.range=p.to(te.range):typeof te.range=="object"&&(be.range={inserting:p.to(te.range.insert),replacing:p.to(te.range.replace)}),be.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?be.insertText=new b.SnippetString(te.insertText):(be.insertText=te.insertText,be.textEdit=be.range instanceof b.Range?new b.TextEdit(be.range,be.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(be.additionalTextEdits=te.additionalTextEdits.map(ke=>N.to(ke))),be.command=W&&te.command?W.fromInternal(te.command):void 0,be}ne.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var j;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ne.to=te})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(j.from):[],activeParameter:W.activeParameter}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(j.to):[],activeParameter:W.activeParameter}}ne.to=te})(Z=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(ne){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.from):[]}}ne.from=ge;function te(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.to):[]}}ne.to=te})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(ne){function ge(W){return{text:W.text,position:l.from(W.position),kind:Ne.from(W.kind??b.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=ge;function te(W){const be=new b.InlayHint(W.text,l.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=te})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function ge(W){return W}ne.from=ge;function te(W){return W}ne.to=te})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function ge(W){return{range:p.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=ge;function te(W){let be;if(W.url)try{be=typeof W.url=="string"?D.URI.parse(W.url,!0):D.URI.revive(W.url)}catch(ke){}return new b.DocumentLink(p.to(W.range),be)}ne.to=te})(He=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(ne){function ge(W){const be=new b.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=N.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(ke=>N.to(ke))),be}ne.to=ge;function te(W){return{label:W.label,textEdit:W.textEdit?N.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>N.from(be)):void 0}}ne.from=te})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(ne){function ge(W){return new b.Color(W[0],W[1],W[2],W[3])}ne.to=ge;function te(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=te})(tt=e.Color||(e.Color={}));var st;(function(ne){function ge(W){return{range:p.from(W.range)}}ne.from=ge;function te(W){return new b.SelectionRange(p.to(W.range))}ne.to=te})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ne){function ge(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ne.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(ne){function ge(W){switch(W){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=ge;function te(W){switch(W){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ne.to=te})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(ne){function ge(W){if(W===b.EndOfLine.CRLF)return 1;if(W===b.EndOfLine.LF)return 0}ne.from=ge;function te(W){if(W===1)return b.EndOfLine.CRLF;if(W===0)return b.EndOfLine.LF}ne.to=te})(De=e.EndOfLine||(e.EndOfLine={}));var gt;(function(ne){function ge(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=ge})(gt=e.ProgressLocation||(e.ProgressLocation={}));var V;(function(ne){function ge(te){const W={start:te.start+1,end:te.end+1};return te.kind&&(W.kind=J.from(te.kind)),W}ne.from=ge})(V=e.FoldingRange||(e.FoldingRange={}));var J;(function(ne){function ge(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=ge})(J=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pe;(function(ne){function ge(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?p.from(te.selection):void 0,override:typeof te.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=ge})(pe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ue;(function(ne){function ge(W){return W instanceof b.RelativePattern||typeof W=="string"?W:te(W)?new b.RelativePattern(W.base,W.pattern):W}ne.from=ge;function te(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(Ue=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(ne){function ge(te){if(te){if(Array.isArray(te))return te.map(ge);if(typeof te=="string")return te;{const W=te;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Ue.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=ge})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var Je;(function(ne){function ge(W){return{start:W.start,end:W.end}}ne.from=ge;function te(W){return new b.NotebookRange(W.start,W.end)}ne.to=te})(Je=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ne){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=ge;function te(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=te})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Et;(function(ne){function ge(W){switch(W){case b.NotebookCellKind.Markup:return u.CellKind.Markup;case b.NotebookCellKind.Code:default:return u.CellKind.Code}}ne.from=ge;function te(W){switch(W){case u.CellKind.Markup:return b.NotebookCellKind.Markup;case u.CellKind.Code:default:return b.NotebookCellKind.Code}}ne.to=te})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ne){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let ke of W.cells)b.NotebookCellData.validate(ke),be.cells.push(et.from(ke));return be}ne.from=ge;function te(W){const be=new b.NotebookData(W.cells.map(et.to));return(0,S.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=te})(It=e.NotebookData||(e.NotebookData={}));var et;(function(ne){function ge(W){return{cellKind:Et.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:lt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Pe.from):[]}}ne.from=ge;function te(W){return new b.NotebookCellData(Et.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Pe.to):void 0,W.metadata,W.internalMetadata?lt.to(W.internalMetadata):void 0)}ne.to=te})(et=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(ne){function ge(W){return{mime:W.mime,valueBytes:F.VSBuffer.wrap(W.data)}}ne.from=ge;function te(W){return new b.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=te})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(ne){function ge(W){return{outputId:W.id,items:W.items.map(Tt.from),metadata:W.metadata}}ne.from=ge;function te(W){const be=W.items.map(Tt.to);return new b.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=te})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(ne){function ge(ke){if(ke!=null){if(ke instanceof b.RelativePattern||typeof ke=="string")return ke;if(be(ke))return new b.RelativePattern(ke.base,ke.pattern);if(W(ke))return{include:Ue.from(ke.include)||void 0,exclude:Ue.from(ke.exclude)||void 0}}}ne.from=ge;function te(ke){return typeof ke=="string"?ke:be(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}ne.to=te;function W(ke){const qe=ke,Le=Ue.from(qe.include);if(!(Le&&Le instanceof b.RelativePattern||typeof Le=="string"))return!1;const dt=Ue.from(qe.exclude);return!!(dt&&dt instanceof b.RelativePattern||typeof dt=="string")}function be(ke){const qe=ke;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function ge(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?B.from(te.top):void 0}}ne.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var re;(function(ne){function ge(te,W,be){const ke=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(ke,be),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ne.from=ge})(re=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ae;(function(ne){function ge(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ne.from=ge})(ae=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(ne){function ge(W){return{uri:W.uri,provides:W.provides}}ne.from=ge;function te(W){return new b.NotebookRendererScript(D.URI.revive(W.uri),W.provides)}ne.to=te})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ne){function ge(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=ge;function te(W){const be=new b.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=te})(me=e.TestMessage||(e.TestMessage={}));var Ie;(function(ne){let ge;(function(te){te.Delimiter="\0"})(ge||(ge={})),ne.namespace=(te,W)=>te+"\0"+W,ne.denamespace=te=>{const W=te.indexOf("\0");return{ctrlId:te.slice(0,W),tagId:te.slice(W+1)}}})(Ie=e.TestTag||(e.TestTag={}));var ze;(function(ne){function ge(ke){const qe=(0,o.getPrivateApiFor)(ke).controllerId;return{extId:h.TestId.fromExtHostTestItem(ke,qe).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(Le=>Ie.namespace(qe,Le.id)),range:p.from(ke.range)||null,description:ke.description||null,error:ke.error&&E.fromStrict(ke.error)||null}}ne.from=ge;function te(ke){return{parent:void 0,error:void 0,id:h.TestId.fromString(ke.extId).localId,label:ke.label,uri:D.URI.revive(ke.uri),tags:(ke.tags||[]).map(qe=>{const{tagId:Le}=Ie.denamespace(qe);return new b.TestTag(Le)}),range:p.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}ne.toPlain=te;function W(ke){const qe=h.TestId.fromString(ke.extId),Le=new o.TestItemImpl(qe.controllerId,qe.localId,ke.label,D.URI.revive(ke.uri));return Le.range=p.to(ke.range||void 0),Le.description=ke.description||void 0,Le}function be(ke){let qe;for(const Le of ke.tests){const dt=W(Le.item);(0,o.getPrivateApiFor)(dt).parent=qe,qe=dt}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function ge(W){return{id:W.id}}ne.from=ge;function te(W){return new b.TestTag(W.id)}ne.to=te}(Ie=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const ge=(W,be)=>{const ke={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(Le=>Le.type===0).map(me.to)})),children:W.children.map(qe=>be.get(qe)).filter(S.isDefined).map(qe=>ge(qe,be))};for(const qe of ke.children)qe.parent=ke;return ke};function te(W){const be=[],ke=new Map;for(const qe of W.items)ke.set(qe.item.extId,qe),W.request.targets.some(Le=>Le.controllerId===qe.controllerId&&Le.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>ge(qe,ke))}}ne.to=te})(Oe=e.TestResults||(e.TestResults={}));var We;(function(ne){function ge(ke){return{covered:ke.covered,total:ke.covered}}function te(ke){return"line"in ke?l.from(ke):p.from(ke)}function W(ke){return"branches"in ke?{count:ke.executionCount,location:te(ke.location),type:1,branches:ke.branches.length?ke.branches.map(qe=>({count:qe.executionCount,location:qe.location&&te(qe.location)})):void 0}:{type:0,count:ke.executionCount,location:te(ke.location)}}ne.fromDetailed=W;function be(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(W)}}ne.fromFile=be})(We=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function ge(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ne.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(ne){function ge(W){const be=new b.TypeHierarchyItem(H.to(W.kind),W.name,W.detail||"",D.URI.revive(W.uri),p.to(W.range),p.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,kind:H.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:p.from(W.range),selectionRange:p.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],_e([0,1,2,15,7,8,226]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(D,A,_,n={timeout:1500,errors:3}){this._logService=D,this._documents=A,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(A,_,n)=>{const o={dispose:this._callbacks.push([A,_,D])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(D,A){const _=c.URI.revive(D);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let u of[...this._callbacks]){if(n)break;const h=this._documents.getDocument(_),C=await this._deliverEventAsyncAndBlameBadListeners(u,{document:h,reason:P.TextDocumentSaveReason.to(A)});o.push(C)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([D,A,_],n){const f=this._badListeners.get(D);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,D,A,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const u=this._badListeners.get(D);this._badListeners.set(D,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,A,_,n){const f=[],o=Date.now(),{document:u,reason:h}=n,{version:C}=u,b=Object.freeze({document:u,reason:h,waitUntil(m){if(Object.isFrozen(f))throw(0,F.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(m))}});try{A.apply(_,[b])}catch(m){return Promise.reject(m)}return Object.freeze(f),new Promise((m,p)=>{const R=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(R),m(l)}).catch(l=>{clearTimeout(R),p(l)})}).then(m=>{const p={edits:[]};for(const R of m)if(Array.isArray(R)&&R.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:r}of R)p.edits.push({_type:2,resource:u.uri,edit:{range:r&&P.Range.from(r),text:l,eol:M&&P.EndOfLine.from(M)}});if(p.edits.length!==0)return C===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Ee[166],_e([0,1,3,29,2,8,7]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(A,_,n,f,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const u=(0,F.parse)(_),h=A(C=>{if(!n)for(let b of C.created){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidCreate.fire(m)}if(!f)for(let b of C.changed){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidChange.fire(m)}if(!o)for(let b of C.deleted){const m=w.URI.revive(b);u(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(A,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,_,n,f){return new T(this._onFileSystemEvent.event,A,_,n,f)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,_){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,_){return(n,f,o)=>{const u=function(C){n.call(f,C)};return u.extension=A,_.event(u,void 0,o)}}async $onWillRunFileOperation(A,_,n,f){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:w.URI.revive(o.source),newUri:w.URI.revive(o.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>w.URI.revive(o.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>w.URI.revive(o.target))},n,f)}}async _fireWillEvent(A,_,n,f){const o=new Set,u=[];if(await A.fireAsync(_,f,async(C,b)=>{const m=Date.now(),p=await Promise.resolve(C);p instanceof t.WorkspaceEdit&&(u.push(p),o.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-m>n&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||u.length===0)return;const h={edits:[]};for(let C of u){let{edits:b}=P.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);h.edits=h.edits.concat(b)}return{edit:h,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=S}),define(Ee[167],_e([0,1,10,27,2,8,7,87]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,f,o,u){this.start=n,this.deletedCount=f,this.deletedItems=o,this.items=u}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class D{constructor(n,f,o){this.notebook=n,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=w.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(P.NotebookCellOutput.to)}setOutputItems(n,f,o){const u=o.map(P.NotebookCellOutputItem.to),h=this._outputs.find(C=>C.id===n);h&&(f||(h.items.length=0),h.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=D;class A{constructor(n,f,o,u,h,C){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=u,this.uri=h,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=C.viewType,this._metadata=Object.freeze(C.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,C.cells]],!0),this._versionId=C.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const o of n.rawEvents)o.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===T.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,o=n.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),n.with({start:f,end:o})}_getCells(n){n=this._validateRange(n);const f=[];for(let o=n.start;o<n.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const o=[],u=[],h=[];n.reverse().forEach(C=>{const m=C[2].map(l=>{const M=new D(this,this._textDocumentsAndEditors,l);return f||u.push(D.asModelAddData(this.apiNotebook,l)),M}),p=new S(C[0],C[1],[],m),R=this._cells.splice(C[0],C[1],...m);for(const l of R)h.push(l.uri),p.deletedItems.push(l.apiCell);o.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:h}),f||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_moveCell(n,f){const o=this._cells.splice(n,1);this._cells.splice(f,0,...o);const u=[new S(n,1,o.map(h=>h.apiCell),[]),new S(f,0,[],o)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(u)}))}_setCellOutputs(n,f){const o=this._cells[n];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,f,o,u){const h=this._cells[n];h.setOutputItems(f,o,u),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_changeCellLanguage(n,f){const o=this._cells[n];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(n,f){const o=this._cells[n];o.apiCell.mime=f}_changeCellMetadata(n,f){const o=this._cells[n],u=o.apiCell.metadata;o.setMetadata(f);const h=o.apiCell.metadata;(0,F.equals)(u,h)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,f){const o=this._cells[n],u=o.internalMetadata;if(o.setInternalMetadata(f),u.runState!==f.runState){const h=f.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:h}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Ee[91],_e([0,1,7,8,15]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:D})}replaceCells(S,D,A){this._throwIfFinalized(),!(S===D&&A.length===0)&&this._collectedEdits.push({editType:1,index:S,count:D-S,cells:A.map(F.NotebookCellData.from)})}}class t{constructor(S,D,A,_,n,f){this.id=S,this._proxy=D,this.notebookData=A,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(D){if(!Array.isArray(D)||!D.every(c.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");S._selections=D,S._trySetSelections(D)},get visibleRanges(){return S._visibleRanges},revealRange(D,A){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(D),A??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(D){const A=new P(this.document.version);return D(A),S._applyEdit(A.finalize())},setDecorations(D,A){return S.setDecorations(D,A)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const D=[];let A=-1;for(let _=0;_<S.cellEdits.length;_++){if(A<0){D.push(S.cellEdits[_]),A++;continue}const f=D[A],o=S.cellEdits[_];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...S.cellEdits[_].cells),f.count+=S.cellEdits[_].count;continue}D.push(S.cellEdits[_]),A++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,D)}setDecorations(S,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return D.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(D),S.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(Ee[168],_e([0,1,8,140,121,20,51,15]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,f,o){const u=this._handles++,{title:h,location:C,cancellable:b}=f,m={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:c.ProgressLocation.from(C),title:h,source:m,cancellable:b},n).catch(T.onUnexpectedExternalError),this._withProgress(u,o,!!b)}_withProgress(n,f,o){let u;o&&(u=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const h=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),u&&u.dispose()};let C;try{C=f(new A(this._proxy,n),o&&u?u.token:P.CancellationToken.None)}catch(b){throw h(n),b}return C.then(b=>h(n),b=>h(n)),C}$acceptProgressCanceled(n){const f=this._mapHandleToCancellationSource.get(n);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function D(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class A extends F.Progress{constructor(n,f){super(o=>this.throttledReport(o));this._proxy=n,this._handle=f}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}xe([(0,t.throttle)(100,(_,n)=>D(_,n),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ee[92],_e([0,1,41,15,52,8,7]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(n,f,o){const u=T._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,u,P.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=T,T._Keys=new w.IdGenerator("TextEditorDecorationType");class S{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let o=null;if(n instanceof t.Position)o=new t.Range(n,n);else if(n instanceof t.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof t.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,o){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:f,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class D{constructor(n,f,o,u){this._proxy=n,this._id=f,this._accept(o),this._logService=u;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(C){h._setTabSize(C)},get insertSpaces(){return h._insertSpaces},set insertSpaces(C){h._setInsertSpaces(C)},get cursorStyle(){return h._cursorStyle},set cursorStyle(C){h._setCursorStyle(C)},get lineNumbers(){return h._lineNumbers},set lineNumbers(C){h._setLineNumbers(C)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let o=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(o=!0,f.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,o=!0,f.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(o=!0,f.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,o=!0,f.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,f.lineNumbers=P.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,f))}_warnOnError(n,f){f.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=D;class A{constructor(n,f,o,u,h,C,b,m){this.id=n,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new D(this._proxy,this.id,C,o),this._visibleRanges=b,this._viewColumn=m;const p=this;this.value=Object.freeze({get document(){return u.getValue()},set document(R){throw(0,F.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(R){if(!(R instanceof t.Selection))throw(0,F.illegalArgument)("selection");p._selections=[R],p._trySetSelection()},get selections(){return p._selections},set selections(R){if(!Array.isArray(R)||R.some(l=>!(l instanceof t.Selection)))throw(0,F.illegalArgument)("selections");p._selections=R,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(R){throw(0,F.readonly)("visibleRanges")},get options(){return p._options.value},set options(R){p._disposed||p._options.assign(R)},get viewColumn(){return p._viewColumn},set viewColumn(R){throw(0,F.readonly)("viewColumn")},edit(R,l={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new S(u.getValue(),l);return R(M),p._applyEdit(M)},insertSnippet(R,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=p._selections.map(i=>P.Range.from(i));else if(l instanceof t.Position){const{lineNumber:i,column:g}=P.Position.from(l);r=[{startLineNumber:i,startColumn:g,endLineNumber:i,endColumn:g}]}else if(l instanceof t.Range)r=[P.Range.from(l)];else{r=[];for(const i of l)if(i instanceof t.Range)r.push(P.Range.from(i));else{const{lineNumber:g,column:d}=P.Position.from(i);r.push({startLineNumber:g,startColumn:d,endLineNumber:g,endColumn:d})}}return f.$tryInsertSnippet(n,R.value,r,M)},setDecorations(R,l){const M=l.length===0;M&&!p._hasDecorationsForKey.has(R.key)||(M?p._hasDecorationsForKey.delete(R.key):p._hasDecorationsForKey.add(R.key),p._runOnProxy(()=>{if(P.isDecorationOptionsArr(l))return f.$trySetDecorations(n,R.key,P.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,g=l.length;i<g;i++){const d=l[i];r[4*i]=d.start.line+1,r[4*i+1]=d.start.character+1,r[4*i+2]=d.end.line+1,r[4*i+3]=d.end.character+1}return f.$trySetDecorationsFast(n,R.key,r)}}))},revealRange(R,l){p._runOnProxy(()=>f.$tryRevealRange(n,P.Range.from(R),l||t.TextEditorRevealType.Default))},show(R){f.$tryShowEditor(n,P.ViewColumn.from(R))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(h=>h.range);o.sort((h,C)=>h.end.line===C.end.line?h.end.character===C.end.character?h.start.line===C.start.line?h.start.character-C.start.character:h.start.line-C.start.line:h.end.character-C.end.character:h.end.line-C.end.line);for(let h=0,C=o.length-1;h<C;h++){const b=o[h].end;if(o[h+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=f.edits.map(h=>({range:P.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,u,{setEndOfLine:typeof f.setEndOfLine=="number"?P.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=A}),define(Ee[169],_e([0,1,124,24,2,3,6,14,7,11,16,8,20,153]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(C,b){if((0,D.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let m;return Array.isArray(C.highlights)&&(m=C.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),m=m.length?m:void 0),{label:C.label,highlights:m}}}class u{constructor(b,m,p){this._proxy=b,this.commands=m,this.logService=p,this.treeViews=new Map;function R(l){return l&&l.$treeViewId&&l.$treeItemHandle}m.registerArgumentProcessor({processArgument:l=>R(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>R(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(b,m,p){const R=this.createTreeView(b,{treeDataProvider:m},p);return{dispose:()=>R.dispose()}}createTreeView(b,m,p){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const R=m.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dragAndDropMimeTypes:R}),M=this.createExtHostTreeView(b,m,p);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await l,this.treeViews.delete(b),M.dispose()}}}$getChildren(b,m){const p=this.treeViews.get(b);return p?p.getChildren(m):Promise.reject(new Error((0,c.localize)(0,null,b)))}async $onDrop(b,m,p,R,l){const M=this.treeViews.get(b);if(!M)return Promise.reject(new Error((0,c.localize)(1,null,b)));const r=f.TreeDataTransferConverter.toITreeDataTransfer(m);if(R===b&&l){const i=await M.onWillDrop(l);i&&i.forEach((g,d)=>{g&&r.set(d,g)})}return M.onDrop(r,p)}async $hasResolve(b){const m=this.treeViews.get(b);if(!m)throw new Error((0,c.localize)(2,null,b));return m.hasResolve}$resolve(b,m,p){const R=this.treeViews.get(b);if(!R)throw new Error((0,c.localize)(3,null,b));return R.resolveTreeItem(m,p)}$setExpanded(b,m,p){const R=this.treeViews.get(b);if(!R)throw new Error((0,c.localize)(4,null,b));R.setExpanded(m,p)}$setSelection(b,m){const p=this.treeViews.get(b);if(!p)throw new Error((0,c.localize)(5,null,b));p.setSelection(m)}$setVisible(b,m){const p=this.treeViews.get(b);if(!p)throw new Error((0,c.localize)(6,null,b));p.setVisible(m)}createExtHostTreeView(b,m,p){const R=new h(b,m,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(b,R),R}convertArgument(b){const m=this.treeViews.get(b.$treeViewId);return m?m.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=u;class h extends t.Disposable{constructor(b,m,p,R,l,M){super();if(this.viewId=b,this.proxy=p,this.commands=R,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const g in M.contributes.views)for(const d of M.contributes.views[g])d.id===b&&(this._title=d.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(g=>this._onDidChangeData.fire({message:!1,element:g}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let r,i;this._register(P.Event.debounce(this._onDidChangeData.event,(g,d)=>(g||(g={message:!1,elements:[]}),d.element!==!1&&(r||(r=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(d.element)?g.elements.push(...d.element):g.elements.push(d.element)),d.message&&(g.message=!0),g),200,!0)(({message:g,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return r=null,this.refresh(d).then(()=>s())})),g&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,D.isUndefinedOrNull)(b))}async getChildren(b){const m=b?this.getExtensionElement(b):void 0;if(b&&!m)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(b);return p||(p=await this.fetchChildrenNodes(m)),p?p.map(R=>R.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,m){m=m||{select:!0,focus:!1};const p=(0,D.isUndefinedOrNull)(m.select)?!0:m.select,R=(0,D.isUndefinedOrNull)(m.focus)?!1:m.focus,l=(0,D.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(M=>this.resolveTreeNode(b,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:p,focus:R,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:R,expand:l})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,m){const p=this.getExtensionElement(b);p&&(m?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(b){(0,A.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const m=[];for(const p of b){const R=this.getExtensionElement(p);R&&m.push(R)}if(!(!this.dndController?.onWillDrop||m.length===0))return this.dndController.onWillDrop(m)}async onDrop(b,m){const p=this.getExtensionElement(m);if(!!p)return(0,T.asPromise)(()=>this.dndController?.onDrop(b,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,m){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(b);if(p){const R=this.nodes.get(p);if(R){const l=await this.dataProvider.resolveTreeItem(R.extensionItem,p,m)??R.extensionItem;return R.item.tooltip=this.getTooltip(l.tooltip),R.item.command=this.getCommand(R.disposableStore,l.command),R.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(m=>m?this.resolveUnknownParentChain(m).then(p=>this.resolveTreeNode(m,p[p.length-1]).then(R=>(p.push(R),p))):Promise.resolve([]))}resolveParent(b){const m=this.nodes.get(b);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,m){const p=this.nodes.get(b);return p?Promise.resolve(p):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(R=>this.createHandle(b,R,m,!0)).then(R=>this.getChildren(m?m.item.handle:void 0).then(()=>{const l=this.getExtensionElement(R);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${R}`)}))}getChildrenNodes(b){if(b){let m;if(typeof b=="string"){const p=this.getExtensionElement(b);m=p?this.nodes.get(p):void 0}else m=b;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const m=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=b?this.nodes.get(b):void 0,R=await this.dataProvider.getChildren(b);if(m.token.isCancellationRequested)return;const l=await Promise.all((0,A.coalesce)(R||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,p):null}));return m.token.isCancellationRequested?void 0:(0,A.coalesce)(l)}finally{m.dispose()}}refresh(b){if(b.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(b);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const m=new Set,p=b.map(l=>this.nodes.get(l));for(const l of p)if(l&&!m.has(l.item.handle)){let M=l;for(;M&&M.parent&&p.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&m.add(l.item.handle)}const R=[];return m.forEach(l=>{const M=this.elements.get(l);if(M){const r=this.nodes.get(M);r&&(!r.parent||!m.has(r.parent.item.handle))&&R.push(l)}}),R}refreshHandles(b){const m={};return Promise.all(b.map(p=>this.refreshNode(p).then(R=>{R&&(m[p]=R.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(b){const m=this.getExtensionElement(b);if(m){const p=this.nodes.get(m);if(p)return this.clearChildren(m),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(R=>{if(R){const l=this.createTreeNode(m,R,p.parent);return this.updateNodeCache(m,l,p,p.parent),p.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,m,p){const R=this.createTreeNode(b,m,p);if(m.id&&this.elements.has(R.item.handle))throw new Error((0,c.localize)(7,null,m.id));return this.addNodeToCache(b,R),this.addNodeToParentCache(R,p),R}getTooltip(b){return S.MarkdownString.isMarkdownString(b)?_.MarkdownString.from(b):b}getCommand(b,m){return m?this.commands.toInternal(m,b):void 0}createTreeNode(b,m,p){const R=new t.DisposableStore,l=this.createHandle(b,m,p),M=this.getLightIconPath(m);return{item:{handle:l,parentHandle:p?p.item.handle:void 0,label:o(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(R,m.command),contextValue:m.contextValue,icon:M,iconDark:this.getDarkIconPath(m)||M,themeIcon:this.getThemeIcon(m),collapsibleState:(0,D.isUndefinedOrNull)(m.collapsibleState)?S.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:p,children:void 0,disposableStore:R,dispose(){R.dispose()}}}getThemeIcon(b){return b.iconPath instanceof S.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:m,label:p,resourceUri:R},l,M){if(m)return`${h.ID_HANDLE_PREFIX}/${m}`;const r=o(p,this.extension),i=l?l.item.handle:h.LABEL_HANDLE_PREFIX;let g=r?r.label:R?(0,F.basename)(R):"";g=g.indexOf("/")!==-1?g.replace("/","//"):g;const d=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,s=this.getChildrenNodes(l)||[];let v,a=0;do{if(v=`${i}/${a}:${g}`,M||!this.elements.has(v)||d===v)break;a++}while(a<=s.length);return v}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon))return typeof b.iconPath=="string"||w.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return w.URI.isUri(b)?b:w.URI.file(b)}addNodeToCache(b,m){this.elements.set(m.item.handle,b),this.nodes.set(b,m)}updateNodeCache(b,m,p,R){this.elements.delete(m.item.handle),this.nodes.delete(b),m.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(b,m);const l=this.getChildrenNodes(R)||[],M=l.filter(r=>r.item.handle===p.item.handle)[0];M&&l.splice(l.indexOf(M),1,m)}addNodeToParentCache(b,m){m?(m.children||(m.children=[]),m.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const m=this.nodes.get(b);if(m){if(m.children)for(const p of m.children){const R=this.elements.get(p.item.handle);R&&this.clear(R)}m.children=void 0}}else this.clearAll()}clear(b){const m=this.nodes.get(b);if(m){if(m.children)for(const p of m.children){const R=this.elements.get(p.item.handle);R&&this.clear(R)}this.nodes.delete(b),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(Ee[170],_e([0,1,14,3,6,11,47,8,88,67]),function(oe,e,c,F,w,P,t,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class A extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const u=this.resolveChildren(o);return u.isOpen()?this.expandChildren(o,f-1):u.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const b of f.ops)this.onTestItemEvent(n,b);break;case 3:const{key:o,value:u,previous:h}=f,C=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,h,C);break;case"range":this.pushDiff([1,{extId:C,item:{range:T.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:C,item:{error:T.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:C,item:{[o]:u??null}}]);break}break;default:(0,P.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=D.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),u=(0,t.getPrivateApiFor)(n);u.parent&&u.parent!==f?.actual&&u.parent.children.delete(n.id);let h=this.tree.get(o.toString());if(!h){h={fullId:o,actual:n,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(h.fullId.toString(),h),this.setItemParent(n,f),this.pushDiff([0,{parent:h.parent&&h.parent.toString(),controllerId:this.controllerId,expand:h.expand,item:T.TestItem.from(n)}]),this.connectItemAndChildren(n,h,f);return}if(h.actual===n){this.connectItem(n,h,f);return}const C=h.actual.children,b=h.actual,m=(0,t.diffTestItems)(b,n);(0,t.getPrivateApiFor)(b).listener=void 0,h.actual=n,h.expand=0;for(const[p,R]of m)this.onTestItemEvent(h,{op:3,key:p,value:R,previous:b[p]});this.connectItemAndChildren(n,h,f);for(const p of C)n.children.get(p.id)||this.removeItem(D.TestId.joinToString(o,p.id))}diffTagRefs(n,f,o){const u=new Set(f.map(h=>h.id));for(const h of n)u.delete(h.id)||this.incrementTagRefs(h);this.pushDiff([1,{extId:o,item:{tags:n.map(h=>T.TestTag.namespace(this.controllerId,h.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,T.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,t.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,o){this.setItemParent(n,o);const u=(0,t.getPrivateApiFor)(n);u.parent=o?.actual,u.listener=h=>this.onTestItemEvent(f,h),this.updateExpandability(f)}connectItemAndChildren(n,f,o){this.connectItem(n,f,o);for(const u of n.children)this.upsertItem(u,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const o=[];for(const u of n.actual.children){const h=this.expand(D.TestId.joinToString(n.fullId,u.id),f);(0,c.isThenable)(h)&&o.push(h)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const h=new c.Barrier;return h.open(),h}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new c.Barrier,o=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=h.stack||h.message||String(h))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(h){o(h)}return(0,c.isThenable)(u)?u.catch(o).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[f];for(;o.length;){const u=o.pop();if(!!u){(0,t.getPrivateApiFor)(u.actual).listener=void 0;for(const h of u.actual.tags)this.decrementTagRefs(h.id);this.tree.delete(u.fullId.toString());for(const h of u.actual.children)o.push(this.tree.get(D.TestId.joinToString(u.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=A}),define(Ee[171],_e([0,1,4,136]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[172],_e([0,1,25,3,17]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class t{constructor(A){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let _ of A.activationEvents)_==="onUri"&&(_=`onUri:${c.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(A)}}keepOnly(A){const _=new Set;A.forEach(n=>_.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,_){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(f=>f.identifier)),_.length>0){const f=new Set;_.forEach(o=>f.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(n)}static _findLoopingExtensions(A){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,C){this.addNode(h),this.addNode(C),this._arcs.has(h)?this._arcs.get(h).push(C):this._arcs.set(h,[C])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,C){const b=_.getArcs(h);for(let m=0;m<b.length;m++)if(!C.has(b[m]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let h of A){const C=c.ExtensionIdentifier.toKey(h.identifier);if(n.set(C,h),h.extensionDependencies)for(let b of h.extensionDependencies){const m=c.ExtensionIdentifier.toKey(b);_.addArc(C,m)}}let f=new Set;_.getNodes().filter(h=>_.getArcs(h).length===0).forEach(h=>f.add(h));let o=_.getNodes().filter(h=>!f.has(h)),u;do{u=!1;for(let h=0;h<o.length;h++){const C=o[h];_.hasOnlyGoodArcs(C,f)&&(o.splice(h,1),h--,f.add(C),u=!0)}}while(u);return o.map(h=>n.get(h))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const _=this._activationMap.get(A);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const _=this._extensionsMap.get(c.ExtensionIdentifier.toKey(A));return _||void 0}}e.ExtensionDescriptionRegistry=t;var T;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(T||(T={}));function S(D,A){const _=D.isBuiltin?0:D.isUnderDevelopment?2:1,n=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(_!==n)return _-n;const f=w.posix.basename(D.extensionLocation.path),o=w.posix.basename(A.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(Ee[173],_e([0,1,22]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function P(T){const S=c.VSBuffer.alloc(1);switch(T){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=P;function t(T,S){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=t}),define(Ee[26],_e([0,1,3,2,4,25,143]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var T;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class D{constructor(R){this.dependency=R}}e.MissingExtensionDependency=D;var A;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(A=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(p,R){return p.enabledApiProposals?p.enabledApiProposals.includes(R):!1}e.isProposedApiEnabled=n;function f(p,R){if(!n(p,R))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${R}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${R}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=f;class o{constructor(R,l,M,r){this.codeLoadingTime=R,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class u{constructor(R,l){this.description=R,this.value=l}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var h;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function C(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=C;function b(p,R){return{identifier:new P.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!R,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=b;class m{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(R){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(R){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(R){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(R){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(R,l){return Promise.resolve()}_onWillActivateExtension(R){}_onDidActivateExtension(R,l,M,r,i){}_onDidActivateExtensionError(R,l){}_onExtensionRuntimeError(R,l){}_onExtensionHostExit(R){}}e.NullExtensionService=m}),define(Ee[174],_e([0,1,15,25,26,12]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const t=Promise.resolve(void 0);class T{constructor(u,h,C,b){this.startup=u,this.codeLoadingTime=h,this.activateCallTime=C,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,h){return u===-1||h===-1?-1:h-u}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(u,h,C,b,m,p){this.activationFailed=u,this.activationFailedError=h,this.activationTimes=C,this.module=b,this.exports=m,this.subscriptions=p}}e.ActivatedExtension=D;class A extends D{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class _ extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends D{constructor(u){super(!0,u,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let f=class{constructor(u,h,C,b,m){this._logService=m,this._isDisposed=!1,this._registry=u,this._resolvedExtensionsSet=new Set,h.forEach(p=>this._resolvedExtensionsSet.add(F.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,C.forEach(p=>this._hostExtensionsMap.set(F.ExtensionIdentifier.toKey(p),p)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(u){const h=F.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(h)}getActivatedExtension(u){const h=F.ExtensionIdentifier.toKey(u),C=this._activatedExtensions.get(h);if(!C)throw new Error("Extension `"+u.value+"` is not known or not activated");return C}activateByEvent(u,h){if(this._alreadyActivatedEvents[u])return t;const C=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(C.map(b=>({id:b.identifier,reason:{startup:h,extensionId:b.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,h){const C=this._registry.getExtensionDescription(u);if(!C)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:C.identifier,reason:h}])}_handleActivateRequest(u,h,C){if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(u.id))){h[F.ExtensionIdentifier.toKey(u.id)]=u;return}const b=this._registry.getExtensionDescription(u.id);if(!b){const R=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,R,new w.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(u.id),new n(R));return}const m=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let p=!0;for(let R=0,l=m.length;R<l;R++){const M=m[R];if(this._resolvedExtensionsSet.has(F.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(F.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const s=b.displayName||b.identifier.value,v=this._registry.getExtensionDescription(M),a=v&&v.displayName||M,E=new Error(`Cannot activate the '${s}' extension because its dependency '${a}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(E));return}if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(M))){p=!1,h[F.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(F.ExtensionIdentifier.toKey(M)),reason:u.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;p=!1,h[F.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:u.reason};continue}const g=b.displayName||b.identifier.value,d=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(b.identifier,d,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(b.identifier),new n(d));return}p?h[F.ExtensionIdentifier.toKey(b.identifier)]=u:C.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(m=>!this._activatedExtensions.has(F.ExtensionIdentifier.toKey(m.id))),u.length===0))return Promise.resolve(void 0);const h=Object.create(null),C=[];for(let m=0,p=u.length;m<p;m++)this._handleActivateRequest(u[m],h,C);for(let m=0,p=C.length;m<p;m++){const R=F.ExtensionIdentifier.toKey(C[m].id);h[R]&&delete h[R]}const b=Object.keys(h).map(m=>h[m]);return C.length===0?Promise.all(b.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(b).then(m=>this._activateExtensions(C))}_activateExtension(u,h){const C=F.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(C))return Promise.resolve(void 0);const b=this._activatingExtensions.get(C);if(b)return b;const m=this._host.actualActivateExtension(u,h).then(void 0,p=>{const R=new Error;return p&&p.name&&(R.name=p.name),p&&p.message?R.message=`Activating extension '${u.value}' failed: ${p.message}.`:R.message=`Activating extension '${u.value}' failed: ${p}.`,p&&p.stack&&(R.stack=p.stack),this._isDisposed&&c.isPromiseCanceledError(p)?new n(p):(this._host.onExtensionActivationError(u,R,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(p),new n(p))}).then(p=>{this._activatedExtensions.set(C,p),this._activatingExtensions.delete(C)});return this._activatingExtensions.set(C,m),m}};f=xe([$e(4,P.ILogService)],f),e.ExtensionsActivator=f}),define(Ee[175],_e([0,1,12,28,26]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:w.ExtensionHostLogFileName}))}};P=xe([$e(0,c.ILoggerService),$e(1,F.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ee[176],_e([0,1,15]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,t)=>{this._actualOk=P,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,c.onUnexpectedError)(P))}then(P,t){return this._ensureActual().then(P,t)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=F}),define(Ee[37],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(D,A){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=A,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const F=[];function w(S){const D=new c(!0,S);return F[D.nid]=D,D}e.createMainContextProxyIdentifier=w;function P(S){const D=new c(!1,S);return F[D.nid]=D,D}e.createExtHostContextProxyIdentifier=P;function t(S){return F[S].sid}e.getStringIdentifierForProxy=t;class T{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=T}),define(Ee[5],_e([0,1,54,2,37]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var t;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(m){m.name="$ident";function p(l,M){return Object.defineProperty(l,m.name,{value:M,enumerable:!0}),l}m.mixin=p;function R(l){return l[m.name]}m.of=R})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(p){return p._id=f._n++,p}}e.IdObject=f,f._n=0;var o;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.command="m",m.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(m){m[m.File=1]="File",m[m.Text=2]="Text",m[m.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function C(m){if(m&&m.edits)for(const p of m.edits)typeof p.resource=="object"?p.resource=F.URI.revive(p.resource):(p.newUri=F.URI.revive(p.newUri),p.oldUri=F.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,c.revive)(p.metadata));return m}e.reviveWorkspaceEditDto=C;var b;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],_e([0,1,5,3,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(T){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,S){return this._proxy.$getPassword(T,S)}store(T,S,D){return this._proxy.$setPassword(T,S,D)}delete(T,S){return this._proxy.$deletePassword(T,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],_e([0,1,4,12,5,13]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(w.MainContext.MainThreadTelemetry)}report(S,D,A){const _=this.getUsageKey(S,D);this._reportedUsages.has(_)||(this._reportedUsages.add(_),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};t=xe([$e(0,P.IExtHostRpcService),$e(1,F.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,D){}})}),define(Ee[177],_e([0,1,3,5,7,25]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,A,_={}){const n=P.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(n)||[],o=[...A].sort().join(" ");let u=f.find(h=>h.scopes===o);if(u)return u.result;{const h=this._getSession(S,n,D,A,_);u={scopes:o,result:h},f.push(u),this._inFlightRequests.set(n,f);try{await h}finally{const C=f.findIndex(b=>b.scopes===o);C>-1&&(f.splice(C),this._inFlightRequests.set(n,f))}return h}}async _getSession(S,D,A,_,n={}){await this._proxy.$ensureProvider(A);const f=S.displayName||S.name;return this._proxy.$getSession(A,_,D,f,n)}async removeSession(S,D){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,A,_){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:A,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:D});const n=A.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(o=>o.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(Ee[178],_e([0,1,5,13,8]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(T,S){this._extHostDocumentsAndEditors=S,this._proxy=T.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const S=w.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};P=xe([$e(0,F.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(Ee[179],_e([0,1,5]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(P){const t=P.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(T){return t.$writeText(T)}})}}e.ExtHostClipboard=F}),define(Ee[38],_e([0,1,11,7,8,27,5,16,12,54,59,227,2,6,4,13,47,22,37,43]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(g,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=g.getProxy(t.MainContext.MainThreadCommands),this._logService=d,this.converter=new R(this,s=>{const v=this._apiCommands.get(s);return v?.result===M.Void?v:void 0},d),this._argumentProcessors=[{processArgument(s){return(0,D.revive)(s)}},{processArgument(s){return(0,P.cloneAndChange)(s,function(v){if(A.Range.isIRange(v))return w.Range.to(v);if(_.Position.isIPosition(v))return w.Position.to(v);if(A.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return w.location.to(v);if(v instanceof C.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const d=this.registerCommand(!1,g.id,async(...s)=>{const v=g.args.map((E,I)=>{if(!E.validate(s[I]))throw new Error(`Invalid argument '${E.name}' when running '${g.id}', received: ${s[I]}`);return E.convert(s[I])}),a=await this.executeCommand(g.internalId,...v);return g.result.convert(a,s,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new F.Disposable(()=>{d.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,d,s,v,a,E){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:s,thisArg:v,description:a,extension:E}),g&&this._proxy.$registerCommand(d),new F.Disposable(()=>{this._commands.delete(d)&&g&&this._proxy.$unregisterCommand(d)})}executeCommand(g,...d){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,d,!0)}async _doExecuteCommand(g,d,s){if(this._commands.has(g))return this._executeContributedCommand(g,d,!1);{let v=!1;const a=(0,P.cloneAndChange)(d,function(E){if(E instanceof F.Position)return w.Position.from(E);if(E instanceof F.Range)return w.Range.from(E);if(E instanceof F.Location)return w.location.from(E);if(F.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return v=!0,C.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return v=!0,C.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(g,v?new b.SerializableObjectWithBuffers(a):a,s);return(0,D.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(g,d,!1);throw E}}}async _executeContributedCommand(g,d,s){const v=this._commands.get(g);if(!v)throw new Error("Unknown command");let{callback:a,thisArg:E,description:I}=v;if(I)for(let k=0;k<I.args.length;k++)try{(0,c.validateConstraint)(d[k],I.args[k].constraint)}catch(B){throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${I.args[k].name}' - ${I.args[k].description}`)}try{return await a.apply(E,d)}catch(k){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(g=B.command)}throw this._logService.error(k,g,v.extension?.identifier),s?new class extends Error{constructor(){super((0,m.toErrorMessage)(k));this.id=g,this.source=v.extension?.displayName??v.extension?.name}}:k}}$executeContributedCommand(g,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",g),this._commands.has(g)?(d=d.map(s=>this._argumentProcessors.reduce((v,a)=>a.processArgument(v),s)),this._executeContributedCommand(g,d,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),this._proxy.$getCommands().then(d=>(g&&(d=d.filter(s=>s[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(let[d,s]of this._commands){let{description:v}=s;v&&(g[d]=v)}return Promise.resolve(g)}};p=xe([$e(0,u.IExtHostRpcService),$e(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class R{constructor(g,d,s){this._commands=g,this._lookupApiCommand=d,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,d){if(!g)return;const s={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return s;const v=this._lookupApiCommand(g.command);if(v)s.id=v.internalId,s.arguments=v.args.map((a,E)=>a.convert(g.arguments&&g.arguments[E]));else if((0,T.isNonEmptyArray)(g.arguments)){const a=++this._cachIdPool;this._cache.set(a,g),d.add((0,f.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",g.command,a)}return s}fromInternal(g){const d=t.ObjectIdentifier.of(g);return typeof d=="number"?this._cache.get(d):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const d=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=R;class l{constructor(g,d,s,v){this.name=g,this.description=d,this.validate=s,this.convert=v}optional(){return new l(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,d){return new l(g??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>F.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>F.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>F.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof F.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof F.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof h.TestItemImpl,w.TestItem.from);class M{constructor(g,d){this.description=g,this.convert=d}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(g,d,s,v,a){this.id=g,this.internalId=d,this.description=s,this.args=v,this.result=a}}e.ApiCommand=r}),define(Ee[180],_e([0,1,8,7,58,38,16,79]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",A(c.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,t.isFalsyOrEmpty)(n))return;class o extends F.SymbolInformation{static to(h){const C=new o(h.name,c.SymbolKind.to(h.kind),h.containerName||"",new F.Location(f[0],c.Range.to(h.range)));return C.detail=h.detail,C.range=C.location.range,C.selectionRange=c.Range.to(h.selectionRange),C.children=h.children?h.children.map(o.to):[],C}}return n.map(o.to)})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new P.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",A(c.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",A(c.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>F.Position.isPosition(f)),n=>n.map(c.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let o;for(const u of f.reverse())o=new F.SelectionRange(c.Range.to(u),o);return o}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(c.WorkspaceSymbol.to))),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:c.Range.to(n.range),placeholder:n.text}})),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,T.decodeSemanticTokensDto)(n);if(f.type==="full")return new F.SemanticTokens(f.data,void 0)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range.optional()],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,T.decodeSemanticTokensDto)(n);if(f.type==="full")return new F.SemanticTokens(f.data,void 0)})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,o)=>{if(!n)return new F.CompletionList([]);const u=n.suggestions.map(h=>c.CompletionItem.to(h,o));return new F.CompletionList(u,n.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,o)=>A(u=>new F.CodeLens(c.Range.to(u.range),u.command&&o.fromInternal(u.command)))(n))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,o)=>A(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(u.command)}else{const h=new F.CodeAction(u.title,u.kind?new F.CodeActionKind(u.kind):void 0);return u.edit&&(h.edit=c.WorkspaceEdit.to(u.edit)),u.command&&(h.command=o.fromInternal(u.command)),h.isPreferred=u.isPreferred,h}})(n))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new F.ColorInformation(c.Range.to(f.range),c.Color.to(f.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,c.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",A(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>c.NotebookExclusiveDocumentPattern.to(f))})))),new P.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[P.ApiCommandArgument.TypeHierarchyItem],new P.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new P.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[P.ApiCommandArgument.TestItem],P.ApiCommandResult.Void)];class D{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=D;function A(n){return f=>{if(Array.isArray(f))return f.map(n)}}function _(n){if(!Array.isArray(n))return;const f=[];for(const o of n)w.isLocationLink(o)?f.push(c.DefinitionLink.to(o)):f.push(c.location.to(o));return f}}),define(Ee[181],_e([0,1,14,51,3,6,2,58,25,8,7,5]),function(oe,e,c,F,w,P,t,T,S,D,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,o,u){const h=f.getProxy(_.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const g=this._commentControllers.get(i.handle);return g||i}else if(i&&i.$mid===7){const g=this._commentControllers.get(i.commentControlHandle);if(!g)return i;const d=g.getCommentThread(i.commentThreadHandle);return d||i}else if(i&&i.$mid===8){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const d=g.getCommentThread(i.thread.commentThreadHandle);return d?{thread:d,text:i.text}:i}else if(i&&i.$mid===9){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const d=g.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.commentUniqueId,v=d.getCommentByUniqueId(s);return v||i}else if(i&&i.$mid===10){const g=this._commentControllers.get(i.thread.commentControlHandle);if(!g)return i;const d=g.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.text,v=i.commentUniqueId,a=d.getCommentByUniqueId(v);return a?(a.body=s,a):i}return i}})}createCommentController(i,g,d){const s=C.handlePool++,v=new m(i,s,g,d);this._commentControllers.set(v.handle,v);const a=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return a.push(v),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),a),v.value}$createCommentThreadTemplate(i,g,d){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(g,d)}async $updateCommentThreadTemplate(i,g,d){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(g,d)}$deleteCommentThread(i,g){const d=this._commentControllers.get(i);d&&d.$deleteCommentThread(g)}$provideCommentingRanges(i,g,d){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const v=u.getDocument(t.URI.revive(g));return(0,c.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(v,d)).then(a=>a?a.map(E=>D.Range.from(E)):void 0)}$toggleReaction(i,g,d,s,v){const a=this._commentControllers.get(i);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const E=a.getCommentThread(g);if(E){const I=E.getCommentByUniqueId(s.uniqueIdInThread);if(a!==void 0&&I&&a.reactionHandler)return a.reactionHandler(I,l(v))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class b{constructor(i,g,d,s,v,a,E){this._commentControllerHandle=g,this._id=d,this._uri=s,this._range=v,this._comments=a,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),h.$createCommentThread(g,this.handle,this._id,this._uri,D.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(g,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(k){I.range=k},get comments(){return I.comments},set comments(k){I.comments=k},get collapsibleState(){return I.collapsibleState},set collapsibleState(k){I.collapsibleState=k},get canReply(){return I.canReply},set canReply(k){I.canReply=k},get contextValue(){return I.contextValue},set contextValue(k){I.contextValue=k},get label(){return I.label},set label(k){I.label=k},dispose:()=>{I.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const i=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),g={};i("range")&&(g.range=D.Range.from(this._range)),i("label")&&(g.label=this.label),i("contextValue")&&(g.contextValue=this.contextValue??null),i("comments")&&(g.comments=this._comments.map(d=>p(this,d,this._commentsMap))),i("collapsibleState")&&(g.collapseState=M(this._collapseState)),i("canReply")&&(g.canReply=this.canReply),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(i){for(let g of this._commentsMap){let d=g[0],s=g[1];if(i===s)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,xe([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class m{constructor(i,g,d,s){this._extension=i,this._handle=g,this._id=d,this._label=s,this._threads=new Map,h.$registerCommentController(this.handle,d,s);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(a){v.options=a},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(a){v.commentingRangeProvider=a},get reactionHandler(){return v.reactionHandler},set reactionHandler(a){v.reactionHandler=a},createCommentThread(a,E,I){return v.createCommentThread(a,E,I).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,g,d,s){if(typeof i=="string"){const v=new b(this.id,this.handle,i,g,d,s,this._extension.identifier);return this._threads.set(v.handle,v),v}else{const v=new b(this.id,this.handle,void 0,i,g,d,this._extension.identifier);return this._threads.set(v.handle,v),v}}$createCommentThreadTemplate(i,g){const d=new b(this.id,this.handle,void 0,t.URI.revive(i),D.Range.to(g),[],this._extension.identifier);return d.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(i,g){let d=this._threads.get(i);d&&(d.range=D.Range.to(g))}$deleteCommentThread(i){let g=this._threads.get(i);g&&g.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(r,i,g){let d=g.get(i);d||(d=++r.commentHandle,g.set(i,d));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:d,body:D.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>R(v)):void 0}}function R(r){return{label:r.label,iconPath:r.iconPath?D.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?t.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case A.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=n}),define(Ee[93],_e([0,1,2,5,7,4,13,12,16,9,17]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const u=wi._handlePool++;this._provider.set(u,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(u,o.value);const h=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(C=>{if(!C){this._proxy.$onDidChange(u,null);return}let b=(0,S.asArray)(C);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(u,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,b.length);const m=b.map(l=>({uri:l,rank:(0,D.count)(l.path,"/")})),p=(0,S.groupBy)(m,(l,M)=>l.rank-M.rank||(0,D.compare)(l.uri.path,M.uri.path));let R=[];e:for(let l of p){let M;for(let r of l){let i=(0,A.dirname)(r.uri.path);if(M!==i&&(M=i,R.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(u,R)});return new w.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(f,o,u){if(!this._provider.has(f))return Object.create(null);const h=Object.create(null),{provider:C,extensionId:b}=this._provider.get(f);return await Promise.all(o.map(async m=>{try{const{uri:p,id:R}=m,l=await Promise.resolve(C.provideFileDecoration(c.URI.revive(p),u));if(!l)return;try{w.FileDecoration.validate(l),h[R]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${b.value}': ${M}`)}}catch(p){this._logService.error(p)}})),h}};_._handlePool=0,_._maxEventSize=250,_=xe([$e(0,t.IExtHostRpcService),$e(1,T.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[182],_e([0,1,119,82,2,5,7,8,3,12,21,30]),function(oe,e,c,F,w,P,t,T,S,D,A,_){"use strict";var n,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(b,m,p,R,l,M){this._name=b,this._owner=m,this._maxDiagnosticsPerFile=p,n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new A.ResourceMap(r=>R.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,f,M,"f")}dispose(){this._isDisposed||(Ae(this,f,"f").fire([...Ae(this,o,"f").keys()]),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner),Ae(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,m){if(!b){this.clear();return}this._checkDisposed();let p=[];if(w.URI.isUri(b)){if(!m){this.delete(b);return}Ae(this,o,"f").set(b,m.slice()),p=[b]}else if(Array.isArray(b)){p=[];let l;b=[...b].sort(u._compareIndexedTuplesByUri);for(const M of b){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Ae(this,o,"f").get(l).length===0&&Ae(this,o,"f").delete(l),l=r,p.push(r),Ae(this,o,"f").set(r,[])),i){const g=Ae(this,o,"f").get(r);g&&g.push(...i)}else{const g=Ae(this,o,"f").get(r);g&&(g.length=0)}}}if(Ae(this,f,"f").fire(p),!Ae(this,n,"f"))return;const R=[];for(let l of p){let M=[];const r=Ae(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(let d of r)if(d.severity===i[g]&&M.push(T.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;M.push({severity:F.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>T.Diagnostic.from(i));R.push([l,M])}Ae(this,n,"f").$changeMany(this._owner,R)}delete(b){this._checkDisposed(),Ae(this,f,"f").fire([b]),Ae(this,o,"f").delete(b),Ae(this,n,"f")&&Ae(this,n,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ae(this,f,"f").fire([...Ae(this,o,"f").keys()]),Ae(this,o,"f").clear(),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner)}forEach(b,m){this._checkDisposed();for(let p of Ae(this,o,"f").keys())b.apply(m,[p,this.get(p),this])}get(b){this._checkDisposed();const m=Ae(this,o,"f").get(b);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ae(this,o,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,m){return b[0].toString()<m[0].toString()?-1:b[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=u,n=new WeakMap,f=new WeakMap,o=new WeakMap;let h=class ri{constructor(b,m,p){this._logService=m,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:R=>R.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(b){const m=new A.ResourceMap;for(const p of b)m.set(p,p);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(b,m){const{_collections:p,_proxy:R,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(s,v){R.$changeMany(s,v),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,s,v.length===0?"CLEARING":v)}$clear(s){R.$clear(s),M.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,s)}dispose(){R.dispose()}};let g;if(!m)m="_generated_diagnostic_collection_name_#"+ri._idPool++,g=m;else if(!p.has(m))g=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do g=m+ri._idPool++;while(p.has(g))}return new class extends u{constructor(){super(m,g,ri._maxDiagnosticsPerFile,r.extUri,i,l);p.set(g,this)}dispose(){super.dispose(),p.delete(g)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const m=new Map,p=[];for(const R of this._collections.values())R.forEach((l,M)=>{let r=m.get(l.toString());typeof r=="undefined"&&(r=p.length,m.set(l.toString(),r),p.push([l,[]])),p[r][1]=p[r][1].concat(...M)});return p}}_getDiagnostics(b){let m=[];for(let p of this._collections.values())p.has(b)&&(m=m.concat(p.get(b)));return m}$acceptMarkersChange(b){if(!this._mirrorCollection){const m="_generated_mirror",p=new u(m,m,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,p),this._mirrorCollection=p}for(const[m,p]of b)this._mirrorCollection.set(w.URI.revive(m),p.map(T.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=xe([$e(1,D.ILogService),$e(2,_.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(Ee[183],_e([0,1,2,5]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],_e([0,1,15,2,7,5,10,20,9]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(_,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const f=D._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,_);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(u=>{if(u.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(f,u).then(h=>{if(!h&&typeof h!="string")return;const C=this._documentsAndEditors.getDocument(u);if(!C)return;const b=(0,S.splitLines)(h);if(!C.equalLines(b))return this._proxy.$onVirtualDocumentChange(u,h)},c.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(_,n){const f=this._documentContentProviders.get(_);return f?Promise.resolve(f.provideTextDocumentContent(F.URI.revive(n),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(Ee[185],_e([0,1,3,6,2,5,86,8,11,27,7]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(f,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const h of u)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const h of u)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let u=this._documentLoader.get(f.toString());return u||(u=this._proxy.$tryOpenDocument(f).then(h=>{this._documentLoader.delete(f.toString());const C=w.URI.revive(h);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(C))},h=>(this._documentLoader.delete(f.toString()),Promise.reject(h))),this._documentLoader.set(f.toString(),u)),u}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>w.URI.revive(o))}$acceptModelModeChanged(f,o){const u=w.URI.revive(f),h=this._documentsAndEditors.getDocument(u);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(o),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(f){const o=w.URI.revive(f),u=this._documentsAndEditors.getDocument(o);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(f,o){const u=w.URI.revive(f),h=this._documentsAndEditors.getDocument(u);if(!h)throw new Error("unknown document");h._acceptIsDirty(o),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,u){const h=w.URI.revive(f),C=this._documentsAndEditors.getDocument(h);if(!C)throw new Error("unknown document");C._acceptIsDirty(u),C.onEvents(o);let b;o.isUndoing?b=A.TextDocumentChangeReason.Undo:o.isRedoing&&(b=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:C.document,contentChanges:o.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:b}))}setWordDefinitionFor(f,o){(0,t.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=_}),define(Ee[48],_e([0,1,41,3,6,2,4,5,86,13,92,8,12,21,10,158,101]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class C{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(p,R){this._extHostRpc=p,this._logService=R,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const R=[],l=[],M=[];if(p.removedDocuments)for(const r of p.removedDocuments){const i=P.URI.revive(r),g=this._documents.get(i);g?.unref()&&(this._documents.delete(i),R.push(g.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const i=P.URI.revive(r.uri);let g=this._documents.get(i);if(g&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);g||(g=new C(new S.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,g),l.push(g.value)),g.ref()}if(p.removedEditors)for(const r of p.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(p.addedEditors)for(const r of p.addedEditors){const i=P.URI.revive(r.documentUri);c.ok(this._documents.has(i),`document '${i}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const g=this._documents.get(i).value,d=new A.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>g.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(s=>_.Range.to(s)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}p.newActiveEditor!==void 0&&(c.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,w.dispose)(R),(0,w.dispose)(M),p.removedDocuments&&this._onDidRemoveDocuments.fire(R),p.addedDocuments&&this._onDidAddDocuments.fire(l),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const R=this._editors.get(this._activeEditorId);return p?R:R?.value}allEditors(){return[...this._editors.values()]}};b=xe([$e(0,D.IExtHostRpcService),$e(1,n.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],_e([0,1,8,5,2,3,4,13,14]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let D=class{constructor(_){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new P.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((o,u)=>(o.isActive&&(n=u),Object.freeze({label:o.label,viewColumn:c.ViewColumn.to(o.viewColumn),index:u,resource:w.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:h,viewId:C})=>({resource:w.URI.revive(h),viewId:C})),viewId:o.editorId,isActive:o.isActive,move:async(h,C)=>{this._proxy.$moveTab(o,h,c.ViewColumn.from(C)),await(0,S.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,S.raceTimeout)(P.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,u)=>o.viewColumn===u.viewColumn?o.index-u.index:o.viewColumn-u.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=xe([$e(0,T.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(Ee[186],_e([0,1,2,5,6,7,8,228,9,22,26]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const u=this._schemes.indexOf(o);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),u=[];let h,C,b=14,m=14;for(const p of o){let R=h?(0,S.commonPrefixLength)(h,p):0;for(R===0?C=1:C=m;R<p.length;R++)R+1===p.length?(b=m,m=9):m+=1,u.push([C,p.toUpperCase().charCodeAt(R),m]),u.push([C,p.toLowerCase().charCodeAt(R),m]),C=m;h=p,m=b}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new T.StateMachine(u)}}provideDocumentLinks(o){this._initStateMachine();const u=[],h=T.LinkComputer.computeLinks({getLineContent(C){return o.lineAt(C-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const C of h){const b=t.DocumentLink.to(C);b.target&&u.push(b)}return u}}class n{constructor(o,u){this._extHostLanguageFeatures=u,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,u,h,C={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(b,h);let m=2;C.isCaseSensitive&&(m+=1024),C.isReadonly&&(m+=2048),typeof h.copy=="function"&&(m+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,A.checkProposedApiEnabled)(o,"fsChunks"),m+=4),this._proxy.$registerFileSystemProvider(b,u,m).catch(R=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${u}`),console.error(R)});const p=h.onDidChangeFile(R=>{const l=[];for(const M of R){let{uri:r,type:i}=M;if(r.scheme!==u)continue;let g;switch(i){case P.FileChangeType.Changed:g=0;break;case P.FileChangeType.Created:g=1;break;case P.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:g})}this._proxy.$onFileSystemChange(b,l)});return(0,w.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(o){const{type:u,ctime:h,mtime:C,size:b,permissions:m}=o;return{type:u,ctime:h,mtime:C,size:b,permissions:m}}$stat(o,u){return Promise.resolve(this._getFsProvider(o).stat(c.URI.revive(u))).then(h=>n._asIStat(h))}$readdir(o,u){return Promise.resolve(this._getFsProvider(o).readDirectory(c.URI.revive(u)))}$readFile(o,u){return Promise.resolve(this._getFsProvider(o).readFile(c.URI.revive(u))).then(h=>D.VSBuffer.wrap(h))}$writeFile(o,u,h,C){return Promise.resolve(this._getFsProvider(o).writeFile(c.URI.revive(u),h.buffer,C))}$delete(o,u,h){return Promise.resolve(this._getFsProvider(o).delete(c.URI.revive(u),h))}$rename(o,u,h,C){return Promise.resolve(this._getFsProvider(o).rename(c.URI.revive(u),c.URI.revive(h),C))}$copy(o,u,h,C){const b=this._getFsProvider(o);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(c.URI.revive(u),c.URI.revive(h),C))}$mkdir(o,u){return Promise.resolve(this._getFsProvider(o).createDirectory(c.URI.revive(u)))}$watch(o,u,h,C){const b=this._getFsProvider(o).watch(c.URI.revive(h),C);this._watches.set(u,b)}$unwatch(o,u){const h=this._watches.get(u);h&&(h.dispose(),this._watches.delete(u))}$open(o,u,h){const C=this._getFsProvider(o);if(!C.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(C.open(c.URI.revive(u),h))}$close(o,u){const h=this._getFsProvider(o);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(u))}$read(o,u,h,C){const b=this._getFsProvider(o);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const m=D.VSBuffer.alloc(C);return Promise.resolve(b.read(u,h,m.buffer,0,C)).then(p=>m.slice(0,p))}$write(o,u,h,C){const b=this._getFsProvider(o);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(u,h,C.buffer,0,C.byteLength))}_getFsProvider(o){const u=this._fsProvider.get(o);if(!u){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return u}}e.ExtHostFileSystem=n}),define(Ee[49],_e([0,1,5,45,7,22,4,13,30,6]),function(oe,e,c,F,w,P,t,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ht{constructor(n,f){this._fileSystemProvider=new Map,this._proxy=n.getProxy(c.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(u){try{const h=o._fileSystemProvider.get(u.scheme);if(!h)return await o._proxy.$stat(u);await o._proxy.$ensureActivation(u.scheme);const C=await h.stat(u);return{type:C.type,ctime:C.ctime,mtime:C.mtime,size:C.size,permissions:C.permissions}}catch(h){Ht._handleError(h)}},async readDirectory(u){try{const h=o._fileSystemProvider.get(u.scheme);return h?(await o._proxy.$ensureActivation(u.scheme),(await h.readDirectory(u)).slice()):await o._proxy.$readdir(u)}catch(h){return Ht._handleError(h)}},async createDirectory(u){try{return await o._proxy.$mkdir(u)}catch(h){return Ht._handleError(h)}},async readFile(u){try{const h=o._fileSystemProvider.get(u.scheme);return h?(await o._proxy.$ensureActivation(u.scheme),(await h.readFile(u)).slice()):(await o._proxy.$readFile(u)).buffer}catch(h){return Ht._handleError(h)}},async writeFile(u,h){try{return await o._proxy.$writeFile(u,P.VSBuffer.wrap(h))}catch(C){return Ht._handleError(C)}},async delete(u,h){try{const C=o._fileSystemProvider.get(u.scheme);return C?(await o._proxy.$ensureActivation(u.scheme),await C.delete(u,{recursive:!1,...h})):await o._proxy.$delete(u,{recursive:!1,useTrash:!1,...h})}catch(C){return Ht._handleError(C)}},async rename(u,h,C){try{return await o._proxy.$rename(u,h,{overwrite:!1,...C})}catch(b){return Ht._handleError(b)}},async copy(u,h,C){try{return await o._proxy.$copy(u,h,{overwrite:!1,...C})}catch(b){return Ht._handleError(b)}},isWritableFileSystem(u){const h=f.getCapabilities(u);if(typeof h=="number")return!(h&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case F.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,f){return this._fileSystemProvider.set(n,f),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(n))}};A=xe([$e(0,T.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],_e([0,1,2,38]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,T,S,D){this._extHostNotebooks=T,this._textDocumentsAndEditors=S,this._commands=D;const A=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(A)}$willAddInteractiveDocument(t,T,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(Ee[188],_e([0,1,6,5]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,t),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=w}),define(Ee[189],_e([0,1,2,27,8,7,5,9,59,16,11,229,6,79,52,63,190,15,3]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor($,G){this._documents=$,this._provider=G}async provideDocumentSymbols($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentSymbols(X,G);if(!(0,D.isFalsyOrEmpty)(se))return se[0]instanceof P.DocumentSymbol?se.map(w.DocumentSymbol.from):m._asDocumentSymbolTree(se)}static _asDocumentSymbolTree($){$=$.slice(0).sort((se,j)=>{let Z=se.location.range.start.compareTo(j.location.range.start);return Z===0&&(Z=j.location.range.end.compareTo(se.location.range.end)),Z});const G=[],X=[];for(const se of $){const j={name:se.name||"!!MISSING: name!!",kind:w.SymbolKind.from(se.kind),tags:se.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:w.Range.from(se.location.range),selectionRange:w.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(j),G.push(j);break}const Z=X[X.length-1];if(S.Range.containsRange(Z.range,j.range)&&!S.Range.equalsRange(Z.range,j.range)){Z.children&&Z.children.push(j),X.push(j);break}X.pop()}}return G}}class p{constructor($,G,X){this._documents=$,this._commands=G,this._provider=X,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const X=this._documents.getDocument($),se=await this._provider.provideCodeLenses(X,G);if(!se||G.isCancellationRequested)return;const j=this._cache.add(se),Z=new n.DisposableStore;this._disposables.set(j,Z);const fe={cacheId:j,lenses:[]};for(let Te=0;Te<se.length;Te++)fe.lenses.push({cacheId:[j,Te],range:w.Range.from(se[Te].range),command:this._commands.toInternal(se[Te].command,Z)});return fe}async resolveCodeLens($,G){const X=$.cacheId&&this._cache.get(...$.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,G),se||(se=X),G.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(se.command??p._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function R(Qe){return Array.isArray(Qe)?Qe.map(w.DefinitionLink.from):Qe?[w.DefinitionLink.from(Qe)]:[]}class l{constructor($,G){this._documents=$,this._provider=G}async provideDefinition($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDefinition(se,j,X);return R(Z)}}class M{constructor($,G){this._documents=$,this._provider=G}async provideDeclaration($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDeclaration(se,j,X);return R(Z)}}class r{constructor($,G){this._documents=$,this._provider=G}async provideImplementation($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideImplementation(se,j,X);return R(Z)}}class i{constructor($,G){this._documents=$,this._provider=G}async provideTypeDefinition($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideTypeDefinition(se,j,X);return R(Z)}}class g{constructor($,G){this._documents=$,this._provider=G}async provideHover($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideHover(se,j,X);if(!(!Z||(0,D.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=se.getWordRangeAtPosition(j)),Z.range||(Z.range=new P.Range(j,j)),w.Hover.from(Z)}}class d{constructor($,G){this._documents=$,this._provider=G}async provideEvaluatableExpression($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideEvaluatableExpression(se,j,X);if(Z)return w.EvaluatableExpression.from(Z)}}class s{constructor($,G){this._documents=$,this._provider=G}async provideInlineValues($,G,X,se){const j=this._documents.getDocument($),Z=await this._provider.provideInlineValues(j,w.Range.to(G),w.InlineValueContext.to(X),se);if(Array.isArray(Z))return Z.map(fe=>w.InlineValue.from(fe))}}class v{constructor($,G){this._documents=$,this._provider=G}async provideDocumentHighlights($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDocumentHighlights(se,j,X);if(Array.isArray(Z))return Z.map(w.DocumentHighlight.from)}}class a{constructor($,G){this._documents=$,this._provider=G}async provideLinkedEditingRanges($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideLinkedEditingRanges(se,j,X);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,D.coalesce)(Z.ranges.map(w.Range.from)),wordPattern:Z.wordPattern}}}class E{constructor($,G){this._documents=$,this._provider=G}async provideReferences($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=await this._provider.provideReferences(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.location.from)}}class I{constructor($,G,X,se,j,Z,fe){this._documents=$,this._commands=G,this._diagnostics=X,this._provider=se,this._logService=j,this._extension=Z,this._apiDeprecation=fe,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,G,X,se){const j=this._documents.getDocument($),Z=_.Selection.isISelection(G)?w.Selection.to(G):w.Range.to(G),fe=[];for(const st of this._diagnostics.getDiagnostics($))if(Z.intersection(st.range)&&fe.push(st)>I._maxCodeActionsPerFile)break;const Te={diagnostics:fe,only:X.only?new P.CodeActionKind(X.only):void 0,triggerKind:w.CodeActionTriggerKind.to(X.trigger)},Ne=await this._provider.provideCodeActions(j,Z,Te,se);if(!(0,D.isNonEmptyArray)(Ne)||se.isCancellationRequested)return;const He=this._cache.add(Ne),Ke=new n.DisposableStore;this._disposables.set(He,Ke);const tt=[];for(let st=0;st<Ne.length;st++){const Xe=Ne[st];!Xe||(I._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Ke)})):(Te.only&&(Xe.kind?Te.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[He,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Ke),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(w.Diagnostic.from),edit:Xe.edit&&w.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:He,actions:tt}}async resolveCodeAction($,G){const[X,se]=$,j=this._cache.get(X,se);if(!j||I._isCommand(j)||!this._provider.resolveCodeAction)return;const Z=await this._provider.resolveCodeAction(j,G)??j;return Z?.edit?w.WorkspaceEdit.from(Z.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}I._maxCodeActionsPerFile=1e3;class k{constructor($,G){this._documents=$,this._provider=G}async provideDocumentFormattingEdits($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(se,G,X);if(Array.isArray(j))return j.map(w.TextEdit.from)}}class B{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeFormattingEdits($,G,X,se){const j=this._documents.getDocument($),Z=w.Range.to(G),fe=await this._provider.provideDocumentRangeFormattingEdits(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.TextEdit.from)}}class L{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,G,X,se,j){const Z=this._documents.getDocument($),fe=w.Position.to(G),Te=await this._provider.provideOnTypeFormattingEdits(Z,fe,X,se,j);if(Array.isArray(Te))return Te.map(w.TextEdit.from)}}class y{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,G){const X=t.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols($,G);if((0,D.isNonEmptyArray)(se))for(const j of se){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const Z=t.IdObject.mixin(w.WorkspaceSymbol.from(j));this._symbolCache.set(Z._id,j),X.symbols.push(Z)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const X=this._symbolCache.get($._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,G);return se&&(0,F.mixin)($,w.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[X,se]=G;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete($)}}}class x{constructor($,G,X){this._documents=$,this._provider=G,this._logService=X}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G);try{const fe=await this._provider.provideRenameEdits(j,Z,X,se);return fe?w.WorkspaceEdit.from(fe):void 0}catch(fe){const Te=x._asMessage(fe);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation($,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),j=w.Position.to(G);try{const Z=await this._provider.prepareRename(se,j,X);let fe,Te;if(P.Range.isRange(Z)?(fe=Z,Te=se.getText(Z)):(0,A.isObject)(Z)&&(fe=Z.range,Te=Z.placeholder),!fe||!Te)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(fe),text:Te}}catch(Z){const fe=x._asMessage(Z);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class N{constructor($,G){this.resultId=$,this.tokens=G}}class z{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,G,X){const se=this._documents.getDocument($),j=G!==0?this._previousResults.get(G):null;let Z=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,j.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return j&&this._previousResults.delete(G),Z?(Z=z._fixProvidedSemanticTokens(Z),this._send(z._convertToEdits(j,Z),Z)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new P.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new P.SemanticTokensEdits($.edits.map(G=>new P.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!z._isSemanticTokens(G)||!$||!$.tokens)return G;const X=$.tokens,se=X.length,j=G.data,Z=j.length;let fe=0;const Te=Math.min(se,Z);for(;fe<Te&&X[fe]===j[fe];)fe++;if(fe===se&&fe===Z)return new P.SemanticTokensEdits([],G.resultId);let Ne=0;const He=Te-fe;for(;Ne<He&&X[se-Ne-1]===j[Z-Ne-1];)Ne++;return new P.SemanticTokensEdits([{start:fe,deleteCount:se-fe-Ne,data:j.subarray(fe,Z-Ne)}],G.resultId)}_send($,G){if(z._isSemanticTokens($)){const X=this._nextResultId++;return this._previousResults.set(X,new N($.resultId,$.data)),(0,f.encodeSemanticTokensDto)({id:X,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const X=this._nextResultId++;return z._isSemanticTokens(G)?this._previousResults.set(X,new N(G.resultId,G.data)):this._previousResults.set(X,new N($.resultId)),(0,f.encodeSemanticTokensDto)({id:X,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class H{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeSemanticTokens($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(se,w.Range.to(G),X);return j?this._send(j):null}_send($){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class q{constructor($,G,X,se,j){this._documents=$,this._commands=G,this._provider=X,this._apiDeprecation=se,this._extension=j,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=j.getWordRangeAtPosition(Z)||new P.Range(Z,Z),Te=fe.with({end:Z}),Ne=new h.StopWatch(!0),He=await this._provider.provideCompletionItems(j,Z,se,w.CompletionContext.to(X));if(!He||se.isCancellationRequested)return;const Ke=Array.isArray(He)?new P.CompletionList(He):He,tt=q.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(tt,st);const Xe=[],rt={x:tt,b:Xe,a:{replace:w.Range.from(fe),insert:w.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ne.elapsed()};for(let De=0;De<Ke.items.length;De++){const gt=Ke.items[De],V=this._convertCompletionItem(gt,[tt,De],Te,fe);Xe.push(V)}return rt}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveCompletionItem(X,G);if(!!se)return this._convertCompletionItem(se,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,X,se){const j=this._disposables.get(G[0]);if(!j)throw Error("DisposableStore is missing...");const Z={x:G,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Z.h=$.textEdit.newText):typeof $.insertText=="string"?Z.h=$.insertText:$.insertText instanceof P.SnippetString&&(Z.h=$.insertText.value,Z.i|=4);let fe;return $.textEdit?fe=$.textEdit.range:$.range&&(fe=$.range),P.Range.isRange(fe)?Z.j=w.Range.from(fe):fe&&(!X?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(Z.j={insert:w.Range.from(fe.inserting),replace:w.Range.from(fe.replacing)}),Z}}class ue{constructor($,G,X){this._documents=$,this._provider=G,this._commands=X,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=await this._provider.provideInlineCompletionItems(j,Z,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:w.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!fe||se.isCancellationRequested)return;const Te=(0,A.isArray)(fe)?{items:fe}:fe,Ne=this._cache.add(Te.items);let He;return{pid:Ne,items:Te.items.map((Ke,tt)=>{let st;return Ke.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ke.command,He)),{text:Ke.text,range:Ke.range?w.Range.from(Ke.range):void 0,command:st,idx:tt}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const X=this._cache.get($,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=K.map.get($);return G||(G=new K,K.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=K,K.map=new WeakMap;class ce{constructor($,G){this._documents=$,this._provider=G,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(j,Z,se,fe);if(Te){const Ne=this._cache.add([Te]);return{...w.SignatureHelp.from(Te),id:Ne}}}reviveContext($){let G;if($.activeSignatureHelp){const X=w.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...$,activeSignatureHelp:G}}releaseSignatureHelp($){this._cache.delete($)}}class de{constructor($,G){this._documents=$,this._provider=G}async provideInlayHints($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideInlayHints(se,w.Range.to(G),X);return j?{hints:j.map(w.InlayHint.from)}:void 0}}class Q{constructor($,G){this._documents=$,this._provider=G,this._cache=new u.Cache("DocumentLink")}async provideLinks($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(Q._validateLink).map(w.DocumentLink.from)};{const j=this._cache.add(se),Z={links:[],id:j};for(let fe=0;fe<se.length;fe++){if(!Q._validateLink(se[fe]))continue;const Te=w.DocumentLink.from(se[fe]);Te.cacheId=[j,fe],Z.links.push(Te)}return Z}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveDocumentLink(X,G);if(!(!se||!Q._validateLink(se)))return w.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,G){this._documents=$,this._provider=G}async provideColors($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentColors(X,G);return Array.isArray(se)?se.map(Z=>({color:w.Color.from(Z.color),range:w.Range.from(Z.range)})):[]}async provideColorPresentations($,G,X){const se=this._documents.getDocument($),j=w.Range.to(G.range),Z=w.Color.to(G.color),fe=await this._provider.provideColorPresentations(Z,{document:se,range:j},X);if(!!Array.isArray(fe))return fe.map(w.ColorPresentation.from)}}class we{constructor($,G){this._documents=$,this._provider=G}async provideFoldingRanges($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(se,G,X);if(!!Array.isArray(j))return j.map(w.FoldingRange.from)}}class Me{constructor($,G,X){this._documents=$,this._provider=G,this._logService=X}async provideSelectionRanges($,G,X){const se=this._documents.getDocument($),j=G.map(w.Position.to),Z=await this._provider.provideSelectionRanges(se,j,X);if(!(0,D.isNonEmptyArray)(Z))return[];if(Z.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Te=0;Te<j.length;Te++){const Ne=[];fe.push(Ne);let He=j[Te],Ke=Z[Te];for(;;){if(!Ke.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ke)),!Ke.parent)break;He=Ke.range,Ke=Ke.parent}}return fe}}class Fe{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.prepareCallHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideCallsTo($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!j)return j.map(Z=>({from:this._cacheAndConvertItem($,Z.from),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}async provideCallsFrom($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!j)return j.map(Z=>({to:this._cacheAndConvertItem($,Z.to),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const X=this._cache.get($),se=w.CallHierarchyItem.from(G,$,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Be{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.prepareTypeHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideSupertypes($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}async provideSubtypes($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const X=this._cache.get($),se=w.TypeHierarchyItem.from(G,$,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Ge{constructor($,G){this.adapter=$,this.extension=G}}class je{constructor($,G,X,se,j,Z,fe){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=j,this._logService=Z,this._apiDeprecation=fe}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new P.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,G,X,se,j=!1){const Z=this._adapter.get($);if(!Z)return Promise.resolve(se);if(Z.adapter instanceof G){let fe;Z.extension&&(fe=Date.now(),this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${G.name}'`));const Te=X(Z.adapter,Z.extension),Ne=Z.extension;return Ne&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-fe}ms`),He=>{j&&He instanceof C.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const X=this._nextHandle();return this._adapter.set(X,new Ge($,G)),X}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,X,se){const j=this._addNewAdapter(new m(this._documents,X),$),Z=se&&se.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(G),Z),this._createDisposable(j)}$provideDocumentSymbols($,G,X){return this._withAdapter($,m,se=>se.provideDocumentSymbols(c.URI.revive(G),X),void 0)}registerCodeLensProvider($,G,X){const se=this._nextHandle(),j=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new p(this._documents,this._commands.converter,X),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(j));Z=P.Disposable.from(Z,fe)}return Z}$provideCodeLenses($,G,X){return this._withAdapter($,p,se=>se.provideCodeLenses(c.URI.revive(G),X),void 0)}$resolveCodeLens($,G,X){return this._withAdapter($,p,se=>se.resolveCodeLens(G,X),void 0)}$releaseCodeLenses($,G){this._withAdapter($,p,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,X){const se=this._addNewAdapter(new l(this._documents,X),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition($,G,X,se){return this._withAdapter($,l,j=>j.provideDefinition(c.URI.revive(G),X,se),[])}registerDeclarationProvider($,G,X){const se=this._addNewAdapter(new M(this._documents,X),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration($,G,X,se){return this._withAdapter($,M,j=>j.provideDeclaration(c.URI.revive(G),X,se),[])}registerImplementationProvider($,G,X){const se=this._addNewAdapter(new r(this._documents,X),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation($,G,X,se){return this._withAdapter($,r,j=>j.provideImplementation(c.URI.revive(G),X,se),[])}registerTypeDefinitionProvider($,G,X){const se=this._addNewAdapter(new i(this._documents,X),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition($,G,X,se){return this._withAdapter($,i,j=>j.provideTypeDefinition(c.URI.revive(G),X,se),[])}registerHoverProvider($,G,X,se){const j=this._addNewAdapter(new g(this._documents,X),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideHover($,G,X,se){return this._withAdapter($,g,j=>j.provideHover(c.URI.revive(G),X,se),void 0)}registerEvaluatableExpressionProvider($,G,X,se){const j=this._addNewAdapter(new d(this._documents,X),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideEvaluatableExpression($,G,X,se){return this._withAdapter($,d,j=>j.provideEvaluatableExpression(c.URI.revive(G),X,se),void 0)}registerInlineValuesProvider($,G,X,se){const j=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new s(this._documents,X),$);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(G),j);let fe=this._createDisposable(Z);if(j!==void 0){const Te=X.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(j));fe=P.Disposable.from(fe,Te)}return fe}$provideInlineValues($,G,X,se,j){return this._withAdapter($,s,Z=>Z.provideInlineValues(c.URI.revive(G),X,se,j),void 0)}registerDocumentHighlightProvider($,G,X){const se=this._addNewAdapter(new v(this._documents,X),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights($,G,X,se){return this._withAdapter($,v,j=>j.provideDocumentHighlights(c.URI.revive(G),X,se),void 0)}registerLinkedEditingRangeProvider($,G,X){const se=this._addNewAdapter(new a(this._documents,X),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges($,G,X,se){return this._withAdapter($,a,async j=>{const Z=await j.provideLinkedEditingRanges(c.URI.revive(G),X,se);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?je._serializeRegExp(Z.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,X){const se=this._addNewAdapter(new E(this._documents,X),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences($,G,X,se,j){return this._withAdapter($,E,Z=>Z.provideReferences(c.URI.revive(G),X,se,j),void 0)}registerCodeActionProvider($,G,X,se){const j=new n.DisposableStore,Z=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,X,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},je._extLabel($),Boolean(X.resolveCodeAction)),j.add(this._createDisposable(Z)),j}$provideCodeActions($,G,X,se,j){return this._withAdapter($,I,Z=>Z.provideCodeActions(c.URI.revive(G),X,se,j),void 0)}$resolveCodeAction($,G,X){return this._withAdapter($,I,se=>se.resolveCodeAction(G,X),void 0)}$releaseCodeActions($,G){this._withAdapter($,I,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,X){const se=this._addNewAdapter(new k(this._documents,X),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,G,X,se){return this._withAdapter($,k,j=>j.provideDocumentFormattingEdits(c.URI.revive(G),X,se),void 0)}registerDocumentRangeFormattingEditProvider($,G,X){const se=this._addNewAdapter(new B(this._documents,X),$);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits($,G,X,se,j){return this._withAdapter($,B,Z=>Z.provideDocumentRangeFormattingEdits(c.URI.revive(G),X,se,j),void 0)}registerOnTypeFormattingEditProvider($,G,X,se){const j=this._addNewAdapter(new L(this._documents,X),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(G),se,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,G,X,se,j,Z){return this._withAdapter($,L,fe=>fe.provideOnTypeFormattingEdits(c.URI.revive(G),X,se,j,Z),void 0)}registerWorkspaceSymbolProvider($,G){const X=this._addNewAdapter(new y(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols($,G,X){return this._withAdapter($,y,se=>se.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol($,G,X){return this._withAdapter($,y,se=>se.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,y,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,X){const se=this._addNewAdapter(new x(this._documents,X,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),x.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits($,G,X,se,j){return this._withAdapter($,x,Z=>Z.provideRenameEdits(c.URI.revive(G),X,se,j),void 0)}$resolveRenameLocation($,G,X,se){return this._withAdapter($,x,j=>j.resolveRenameLocation(c.URI.revive(G),X,se),void 0)}registerDocumentSemanticTokensProvider($,G,X,se){const j=this._nextHandle(),Z=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Ge(new z(this._documents,X),$)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(G),se,Z);let fe=this._createDisposable(j);if(Z){const Te=X.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(Z));fe=P.Disposable.from(fe,Te)}return fe}$provideDocumentSemanticTokens($,G,X,se){return this._withAdapter($,z,j=>j.provideDocumentSemanticTokens(c.URI.revive(G),X,se),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,z,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,X,se){const j=this._addNewAdapter(new H(this._documents,X),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(G),se),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,G,X,se){return this._withAdapter($,H,j=>j.provideDocumentRangeSemanticTokens(c.URI.revive(G),X,se),null,!0)}registerCompletionItemProvider($,G,X,se){const j=this._addNewAdapter(new q(this._documents,this._commands.converter,X,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(G),se,q.supportsResolving(X),`${$.identifier.value}(${se.join("")})`),this._createDisposable(j)}$provideCompletionItems($,G,X,se,j){return this._withAdapter($,q,Z=>Z.provideCompletionItems(c.URI.revive(G),X,se,j),void 0)}$resolveCompletionItem($,G,X){return this._withAdapter($,q,se=>se.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems($,G){this._withAdapter($,q,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,X){const se=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions($,G,X,se,j){return this._withAdapter($,ue,Z=>Z.provideInlineCompletions(c.URI.revive(G),X,se,j),void 0)}$handleInlineCompletionDidShow($,G,X){this._withAdapter($,ue,async se=>{se.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,X,se){const j=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Z=this._addNewAdapter(new ce(this._documents,X),$);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(G),j),this._createDisposable(Z)}$provideSignatureHelp($,G,X,se,j){return this._withAdapter($,ce,Z=>Z.provideSignatureHelp(c.URI.revive(G),X,se,j),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,ce,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new de(this._documents,X),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(G),se);let Z=this._createDisposable(j);if(se!==void 0){const fe=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(se));Z=P.Disposable.from(Z,fe)}return Z}$provideInlayHints($,G,X,se){return this._withAdapter($,de,j=>j.provideInlayHints(c.URI.revive(G),X,se),void 0)}registerDocumentLinkProvider($,G,X){const se=this._addNewAdapter(new Q(this._documents,X),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,G,X){return this._withAdapter($,Q,se=>se.provideLinks(c.URI.revive(G),X),void 0)}$resolveDocumentLink($,G,X){return this._withAdapter($,Q,se=>se.resolveLink(G,X),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Q,X=>X.releaseLinks(G),void 0)}registerColorProvider($,G,X){const se=this._addNewAdapter(new ie(this._documents,X),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors($,G,X){return this._withAdapter($,ie,se=>se.provideColors(c.URI.revive(G),X),[])}$provideColorPresentations($,G,X,se){return this._withAdapter($,ie,j=>j.provideColorPresentations(c.URI.revive(G),X,se),void 0)}registerFoldingRangeProvider($,G,X){const se=this._nextHandle(),j=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new we(this._documents,X),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));Z=P.Disposable.from(Z,fe)}return Z}$provideFoldingRanges($,G,X,se){return this._withAdapter($,we,j=>j.provideFoldingRanges(c.URI.revive(G),X,se),void 0)}registerSelectionRangeProvider($,G,X){const se=this._addNewAdapter(new Me(this._documents,X,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges($,G,X,se){return this._withAdapter($,Me,j=>j.provideSelectionRanges(c.URI.revive(G),X,se),[])}registerCallHierarchyProvider($,G,X){const se=this._addNewAdapter(new Fe(this._documents,X),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy($,G,X,se){return this._withAdapter($,Fe,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),X,se)),void 0)}$provideCallHierarchyIncomingCalls($,G,X,se){return this._withAdapter($,Fe,j=>j.provideCallsTo(G,X,se),void 0)}$provideCallHierarchyOutgoingCalls($,G,X,se){return this._withAdapter($,Fe,j=>j.provideCallsFrom(G,X,se),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider($,G,X){const se=this._addNewAdapter(new Be(this._documents,X),$);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareTypeHierarchy($,G,X,se){return this._withAdapter($,Be,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),X,se)),void 0)}$provideTypeHierarchySupertypes($,G,X,se){return this._withAdapter($,Be,j=>j.provideSupertypes(G,X,se),void 0)}$provideTypeHierarchySubtypes($,G,X,se){return this._withAdapter($,Be,j=>j.provideSubtypes(G,X,se),void 0)}$releaseTypeHierarchy($,G){this._withAdapter($,Be,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,T.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,G,X){let{wordPattern:se}=X;if(se&&(0,T.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),Z={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?je._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?je._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?je._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,G,Z),this._createDisposable(j)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(Ee[191],_e([0,1,5,8,7,34,14,6]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,_,n,f){this._documents=_,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,_){await this._proxy.$changeLanguage(A,_);const n=this._documents.getDocumentData(A);if(!n)throw new Error(`document '${A.toString}' NOT found`);return n.document}async tokenAtPosition(A,_){const n=A.version,f=F.Position.from(_),o=await this._proxy.$tokensAtPosition(A.uri,f),u={type:w.StandardTokenType.Other,range:A.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!o)return u;const h={range:F.Range.to(o.range),type:F.TokenType.to(o.type)};return!h.range.contains(_)||n!==A.version?u:h}createLanguageStatusItem(A,_,n){const f=this._handlePool++,o=this._proxy,u=this._ids,h=`${A.identifier.value}/${_}`;if(u.has(h))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);u.add(h);const C={selector:n,id:_,name:A.displayName??A.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,m=new T.DisposableStore;const p=()=>{b?.dispose(),b=(0,t.disposableTimeout)(()=>{m.clear(),this._proxy.$setLanguageStatus(f,{id:h,name:C.name??A.displayName??A.name,source:A.displayName??A.name,selector:F.DocumentSelector.from(C.selector,this._uriTransformer),label:C.text,detail:C.detail??"",severity:C.severity===w.LanguageStatusSeverity.Error?P.default.Error:C.severity===w.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:C.command&&this._commands.toInternal(C.command,m),accessibilityInfo:C.accessibilityInformation,busy:C.busy})},0)},R={dispose(){m.dispose(),b?.dispose(),o.$removeLanguageStatus(f),u.delete(h)},get id(){return C.id},get name(){return C.name},set name(l){C.name=l,p()},get selector(){return C.selector},set selector(l){C.selector=l,p()},get text(){return C.text},set text(l){C.text=l,p()},get detail(){return C.detail},set detail(l){C.detail=l,p()},get severity(){return C.severity},set severity(l){C.severity=l,p()},get accessibilityInformation(){return C.accessibilityInformation},set accessibilityInformation(l){C.accessibilityInformation=l,p()},get command(){return C.command},set command(l){C.command=l,p()},get busy(){return C.busy},set busy(l){C.busy=l,p()}};return p(),R}}e.ExtHostLanguages=S}),define(Ee[192],_e([0,1,12,5,28,13,3]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends c.AbstractLoggerService{constructor(A,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=A.getProxy(F.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(A){this._onDidChangeLogLevel.fire(A)}doCreateLogger(A,_,n){return new S(this._proxy,A,_,n)}};T=xe([$e(0,P.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class S extends c.AbstractMessageLogger{constructor(A,_,n,f){super(f?.always);this.proxy=A,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,f).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(A,_){const n=[[A,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(A){this.proxy.$log(this.file,A)}}}),define(Ee[193],_e([0,1,5,12,26]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(T){return T&&T.title}let t=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,D,A,_,n){const f={extension:S};let o;typeof _=="string"||P(_)?o=[_,...n]:(f.modal=_?.modal,f.useCustom=_?.useCustom,f.detail=_?.detail,o=n),f.useCustom&&(0,w.checkProposedApiEnabled)(S,"resolvers");const u=[];for(let h=0;h<o.length;h++){const C=o[h];if(typeof C=="string")u.push({title:C,handle:h,isCloseAffordance:!1});else if(typeof C=="object"){let{title:b,isCloseAffordance:m}=C;u.push({title:b,isCloseAffordance:!!m,handle:h})}else this._logService.warn("Invalid message item:",C)}return this._proxy.$showMessage(D,A,f,u).then(h=>{if(typeof h=="number")return o[h]})}};t=xe([$e(1,F.ILogService)],t),e.ExtHostMessageService=t}),define(Ee[194],_e([0,1,22,3,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class C{constructor(m,p,R,l,M){this._textDocumentsAndEditors=R,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=m.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=m.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=m.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,g=r.cell.handle,s=this._documents.get(i)?.getCell(g);if(s)return s.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(m=>m.apiEditor)}getEditorById(m){const p=this._editors.get(m);if(!p)throw new Error(`unknown text editor: ${m}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(m){for(const[p,R]of this._editors)if(R.apiEditor===m)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(m,p){const R=this._documents.get(m);if(!R&&!p)throw new Error(`NO notebook document for '${m}'`);return R}_getProviderData(m){const p=this._notebookContentProviders.get(m);if(!p)throw new Error(`NO provider for '${m}'`);return p}registerNotebookContentProvider(m,p,R,l,M){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:m,provider:R});let r;return R.onDidChangeNotebookContentOptions&&(r=R.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(R.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:m.identifier,location:m.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),C._convertNotebookRegistrationData(m,M)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(m,p){if(!p)return;const R=p.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(p.filenamePattern&&!R){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:p.displayName,filenamePattern:R,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,p,R){const l=C._notebookStatusBarItemProviderHandlePool++,M=typeof R.onDidChangeCellStatusBarItems=="function"?C._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,R),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,p);let r;return M!==void 0&&(r=R.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(m){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:m.viewType,content:m.content&&n.NotebookData.from(m.content)});return D.URI.revive(p)}async openNotebookDocument(m){const p=this._documents.get(m);if(p)return p.apiNotebook;const R=await this._notebookDocumentsProxy.$tryOpenNotebook(m),l=this._documents.get(D.URI.revive(R));return(0,S.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(m,p){D.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let R;typeof p=="object"?R={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:R={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(m.uri,m.notebookType,R),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,p,R,l){const M=this._notebookStatusBarItemProviders.get(m),r=D.URI.revive(p),i=this._documents.get(r);if(!i||!M)return;const g=i.getCellFromIndex(R);if(!g)return;const d=await M.provideCellStatusBarItems(g.apiCell,l);if(!d)return;const s=new P.DisposableStore,v=this._statusBarCache.add([s]),E=(Array.isArray(d)?d:[d]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,s));return{cacheId:v,items:E}}$releaseNotebookCellStatusBarItems(m){this._statusBarCache.delete(m)}registerNotebookSerializer(m,p,R,l,M){if((0,T.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,R),this._notebookProxy.$registerNotebookSerializer(r,{id:m.identifier,location:m.extensionLocation},p,n.NotebookDocumentContentOptions.from(l),C._convertNotebookRegistrationData(m,M)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(m,p,R){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(p.buffer,R);return new o.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(m,p,R){const l=this._notebookSerializer.get(m);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(p.value),R);return c.VSBuffer.wrap(M)}async $openNotebook(m,p,R,l,M){const{provider:r}=this._getProviderData(m),i=await r.openNotebook(D.URI.revive(p),{backupId:R,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(m,p,R){const l=this.getNotebookDocument(D.URI.revive(p)),{provider:M}=this._getProviderData(m);return await M.saveNotebook(l.apiNotebook,R),!0}async $saveNotebookAs(m,p,R,l){const M=this.getNotebookDocument(D.URI.revive(p)),{provider:r}=this._getProviderData(m);return await r.saveNotebookAs(D.URI.revive(R),M.apiNotebook,l),!0}async $backupNotebook(m,p,R){const l=this.getNotebookDocument(D.URI.revive(p)),M=this._getProviderData(m),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),g=D.URI.joinPath(r,i),d=await M.provider.backupNotebook(l.apiNotebook,{destination:g},R);return l.updateBackup(d),d.id}_createExtHostEditor(m,p,R){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const l=new h.ExtHostNotebookEditor(p,this._notebookEditorsProxy,m,R.visibleRanges.map(n.NotebookRange.to),R.selections.map(n.NotebookRange.to),typeof R.viewColumn=="number"?n.ViewColumn.to(R.viewColumn):void 0);this._editors.set(p,l)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const R of m.value.removedDocuments){const l=D.URI.revive(R),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(m.value.addedDocuments){const R=[];for(const l of m.value.addedDocuments){const M=D.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(g){r._onDidChangeNotebookCells.fire(g)},emitCellOutputsChange(g){r._onDidChangeCellOutputs.fire(g)},emitCellMetadataChange(g){r._onDidChangeCellMetadata.fire(g)},emitCellExecutionStateChange(g){r._onDidChangeCellExecutionState.fire(g)}},M,l);R.push(...l.cells.map(g=>u.ExtHostCell.asModelAddData(i.apiNotebook,g))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(m.value.addedEditors)for(const R of m.value.addedEditors){if(this._editors.has(R.id))return;const l=D.URI.revive(R.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,R.id,R)}const p=[];if(m.value.removedEditors)for(const R of m.value.removedEditors){const l=this._editors.get(R);l&&(this._editors.delete(R),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),p.push(l))}if(m.value.visibleEditors){this._visibleNotebookEditors=m.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const R=new Set;this._visibleNotebookEditors.forEach(l=>R.add(l.id));for(const l of this._editors.values()){const M=R.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this._activeNotebookEditor=void 0:m.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=C,C._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],_e([0,1,3,52,12,5,13,8]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(_,n){const f=S._Keys.nextId();_.$registerNotebookEditorDecorationType(f,T.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){_.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(_,n,f){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new S(this._extHostRpc.getProxy(P.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const f=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(T.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(T.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(T.ViewColumn.to(_[n]))}};D=xe([$e(0,w.ILogService),$e(1,t.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(Ee[196],_e([0,1,16,14,20,3,6,21,2,25,12,5,38,8,7,66,159,26,37]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let m=class{constructor(r,i,g,d,s){this._initData=i,this._extHostNotebook=g,this._commands=d,this._logService=s,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const v=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",a=>!0,a=>{if(a&&"notebookEditor"in a&&"id"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);return{id:a.id,extension:a.extension,notebookEditorId:E}}else if(a&&"notebookEditor"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${a.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return a})],n.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(r,i,g,d,s,v){for(let ce of this._kernelData.values())if(ce.controller.id===i&&D.ExtensionIdentifier.equals(r.identifier,ce.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const a=this._handlePool++,E=this;this._logService.trace(`NotebookController[${a}], CREATED by ${r.identifier.value}, ${i}`);const I=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${r.identifier}'`);let k=!1;const B=new t.DisposableStore,L=new P.Emitter,y=new P.Emitter,x={id:`${r.identifier.value}/${i}`,notebookType:g,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:d||r.identifier.value,preloads:v?v.map(f.NotebookRendererScript.from):[]};let N=s??I,z;this._proxy.$addKernel(a,x).catch(ce=>{console.log(ce),k=!0});let H=0;const q=()=>{if(k)return;const ce=++H;Promise.resolve().then(()=>{ce===H&&this._proxy.$updateKernel(a,x)})},ue=new T.ResourceMap,K={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(ce){x.label=ce??r.displayName??r.name,q()},get detail(){return x.detail??""},set detail(ce){x.detail=ce,q()},get description(){return x.description??""},set description(ce){x.description=ce,q()},get kind(){return(0,C.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind??""},set kind(ce){(0,C.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind=ce,q()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(ce){x.supportedLanguages=ce,q()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){x.supportsExecutionOrder=ce,q()},get rendererScripts(){return x.preloads?x.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(ce){N=ce??I},get interruptHandler(){return z},set interruptHandler(ce){z=ce,x.supportsInterrupt=Boolean(ce),q()},createNotebookCellExecution(ce){if(k)throw new Error("notebook controller is DISPOSED");if(!ue.has(ce.notebook.uri))throw E._logService.trace(`NotebookController[${a}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return E._createNotebookCellExecution(ce)},dispose:()=>{k||(this._logService.trace(`NotebookController[${a}], DISPOSED`),k=!0,this._kernelData.delete(a),B.dispose(),L.dispose(),y.dispose(),this._proxy.$removeKernel(a))},updateNotebookAffinity(ce,de){E._proxy.$updateNotebookPriority(a,ce.uri,de)},onDidReceiveMessage:y.event,postMessage(ce,de){return(0,C.checkProposedApiEnabled)(r,"notebookMessaging"),E._proxy.$postMessage(a,de&&E._extHostNotebook.getIdByEditor(de),ce)},asWebviewUri(ce){return(0,C.checkProposedApiEnabled)(r,"notebookMessaging"),(0,u.asWebviewUri)(ce,E._initData.remote)}};return this._kernelData.set(a,{extensionId:r.identifier,controller:K,onDidReceiveMessage:y,onDidChangeSelection:L,associatedNotebooks:ue}),K}$acceptNotebookAssociation(r,i,g){const d=this._kernelData.get(r);if(d){const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));g?d.associatedNotebooks.set(s.uri,!0):d.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,s.uri.toString(),g),d.onDidChangeSelection.fire({selected:g,notebook:s.apiNotebook})}}async $executeCells(r,i,g){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),v=[];for(let a of g){const E=s.getCell(a);E&&v.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,s.uri.toString(),v.length),await d.controller.executeHandler.call(d.controller,v,s.apiNotebook,d.controller)}catch(a){this._logService.error(`NotebookController[${r}] execute cells FAILED`,a),console.error(a)}}async $cancelCells(r,i,g){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,s.apiNotebook);else for(let v of g){const a=s.getCell(v);a&&this._activeExecutions.get(a.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,g){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getEditorById(i);d.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:g}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!g)throw new Error("invalid cell");if(this._activeExecutions.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const d=new R(g.notebook,g,this._proxy);this._activeExecutions.set(g.uri,d);const s=d.onDidChangeState(()=>{d.state===p.Resolved&&(d.dispose(),s.dispose(),this._activeExecutions.delete(g.uri))});return d.asApiObject()}};m=xe([$e(4,A.ILogService)],m),e.ExtHostNotebookKernels=m;var p;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(p||(p={}));class R extends t.Disposable{constructor(r,i,g){super();this._document=r,this._cell=i,this._proxy=g,this._handle=R.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,d=>this.update(d)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const g=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return g===i.items?f.NotebookCellOutput.from(i):f.NotebookCellOutput.from({items:g,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,g){const d=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:g,outputs:s})}async updateOutputItems(r,i,g){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:i.id,append:g})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(g){r._executionOrder=g,r.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(g){if(r._state===p.Resolved||r._state===p.Started)throw new Error("Cannot call start again");r._state=p.Started,r._onDidChangeState.fire(),r.update({editType:h.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:g})},end(g,d){if(r._state===p.Resolved)throw new Error("Cannot call resolve twice");r._state=p.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:h.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:d,lastRunSuccess:g}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(g){return r.verifyStateForOutput(),r.updateOutputs([],g,!1)},appendOutput(g,d){return r.verifyStateForOutput(),r.updateOutputs(g,d,!0)},replaceOutput(g,d){return r.verifyStateForOutput(),r.updateOutputs(g,d,!1)},appendOutputItems(g,d){return r.verifyStateForOutput(),r.updateOutputItems(g,d,!0)},replaceOutputItems(g,d){return r.verifyStateForOutput(),r.updateOutputItems(g,d,!1)}})}}R.HANDLE=0;class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],_e([0,1,3,5,91,26]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(S,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,D,A){const _=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(D)?.fire({editor:_.apiEditor,message:A})}createRendererMessaging(S,D){if(!S.contributes?.notebookRenderer?.some(f=>f.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const A=(0,P.isProposedApiEnabled)(S,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(f,o,u)=>{const h=A?f:C=>{const b={};_.set(b,C.editor),f({editor:b,message:C.message})};return this.getOrCreateEmitterFor(D).event(h,o,u)},postMessage:(f,o)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(f)&&([f,o]=[o,f]);const u=A?o:_.get(o),h=u&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(h?.id,D,f)}}}getOrCreateEmitterFor(S){let D=this._rendererMessageEmitters.get(S);return D||(D=new c.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,D),D)}}e.ExtHostNotebookRenderers=t}),define(Ee[94],_e([0,1,5,6,4,13,12,160,49,28,30,110,22]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends F.Disposable{constructor(h,C,b,m){super();this.id=h,this.name=C,this.logger=b,this.proxy=m,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(h){this.append(h+`
`)}append(h){this.write(h),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const h=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,h)}replace(h){const C=this.offset;this.write(h),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,C),this.visible&&this.logger.flush()}show(h,C){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof h=="boolean"?h:C))}hide(){this.proxy.$close(this.id)}write(h){this.offset+=n.VSBuffer.fromString(h).byteLength,this.logger.info(h)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let o=class{constructor(h,C,b,m,p){this.extHostFileSystem=b,this.extHostFileSystemInfo=m,this.loggerService=p,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=h.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(C.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.visibleChannelId=h;for(const[C,b]of this.channels)b.visible=C===this.visibleChannelId}createOutputChannel(h,C){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(h,C);return b.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(h,b)}async doCreateOutputChannel(h,C){const b=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),R=await this.proxy.$register(h,!1,m,C.identifier.value);return new f(R,h,p,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(h,C){let b=!1;const m=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return h},append(p){m(),C.then(R=>R.append(p))},appendLine(p){m(),C.then(R=>R.appendLine(p))},clear(){m(),C.then(p=>p.clear())},replace(p){m(),C.then(R=>R.replace(p))},show(p,R){m(),C.then(l=>l.show(p,R))},hide(){m(),C.then(p=>p.hide())},dispose(){b=!0,C.then(p=>p.dispose())}}}};o=xe([$e(0,P.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,A.IExtHostFileSystemInfo),$e(4,t.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],_e([0,1,14,20,3,6,5,2,7,15,16,34,62,26]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(u,h,C){const b=u.getProxy(t.MainContext.MainThreadQuickOpen);class m{constructor(s,v){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=v}showQuickPick(s,v,a=F.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),I=++this._instances,k=b.$show(I,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},a),B={},L=k.then(()=>B);return Promise.race([L,E]).then(y=>{if(y!==B)return E.then(x=>{const N=[];for(let z=0;z<x.length;z++){const H=x[z];typeof H=="string"?N.push({label:H,handle:z}):H.kind===S.QuickPickItemKind.Separator?N.push({type:"separator",label:H.label}):N.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:z})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(x[z])}),b.$setItems(I,N),k.then(z=>{if(typeof z=="number")return x[z];if(Array.isArray(z))return z.map(H=>x[H])})})}).then(void 0,y=>{if(!(0,D.isPromiseCanceledError)(y))return b.$setError(I,y),Promise.reject(y)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,v=F.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,b.$input(s,typeof this._validateInput=="function",v).then(void 0,a=>{if(!(0,D.isPromiseCanceledError)(a))return Promise.reject(a)})}$validateInput(s){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,v=F.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!a)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(I=>I.uri.toString()===a.uri.toString())}createQuickPick(s){const v=new i(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const v=new g(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(s,v){const a=this._sessions.get(s);a&&a._fireDidChangeValue(v)}$onDidAccept(s){const v=this._sessions.get(s);v&&v._fireDidAccept()}$onDidChangeActive(s,v){const a=this._sessions.get(s);a instanceof i&&a._fireDidChangeActive(v)}$onDidChangeSelection(s,v){const a=this._sessions.get(s);a instanceof i&&a._fireDidChangeSelection(v)}$onDidTriggerButton(s,v){const a=this._sessions.get(s);a&&a._fireDidTriggerButton(v)}$onDidTriggerItemButton(s,v,a){const E=this._sessions.get(s);E instanceof i&&E._fireDidTriggerItemButton(v,a)}$onDidHide(s){const v=this._sessions.get(s);v&&v._fireDidHide()}}class p{constructor(s,v){this._extensionId=s,this._onDidDispose=v,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((v,a)=>{const E=v===S.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(E,v)}),this.update({buttons:s.map((v,a)=>({...r(v),tooltip:v.tooltip,handle:v===S.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const v=this._handlesToButtons.get(s);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(s){if(!this._disposed){for(const v of Object.keys(s)){const a=s[v];this._pendingUpdate[v]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function R(d){if(d instanceof S.ThemeIcon)return{id:d.id};const s=M(d),v=l(d);return{dark:typeof s=="string"?T.URI.file(s):s,light:typeof v=="string"?T.URI.file(v):v}}function l(d){return typeof d=="object"&&"light"in d?d.light:d}function M(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const s=R(d.iconPath);let v,a;return"id"in s?a=n.ThemeIcon.asClassName(s):v=s,{iconPath:v,iconClass:a}}class i extends p{constructor(s,v){super(s.identifier,v);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(a=>a.kind!==void 0)&&(0,f.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((a,E)=>{this._handlesToItems.set(E,a),this._itemsToHandles.set(a,E)});const v=[];for(let a=0;a<s.length;a++){const E=s[a];E.kind===S.QuickPickItemKind.Separator?v.push({type:"separator",label:E.label}):v.push({handle:a,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((I,k)=>({...r(I),tooltip:I.tooltip,handle:k}))})}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(s){const v=(0,A.coalesce)(s.map(a=>this._handlesToItems.get(a)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(s){const v=(0,A.coalesce)(s.map(a=>this._handlesToItems.get(a)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(s,v){const a=this._handlesToItems.get(s);if(!a||!a.buttons||!a.buttons.length)return;const E=a.buttons[v];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:a})}}class g extends p{constructor(s,v){super(s,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new m(h,C)}e.createExtHostQuickOpen=o}),define(Ee[199],_e([0,1,2,3,51,6,14,5,16,105,12,25,62,8,26]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(d){if(d)return typeof d.iconPath=="string"?c.URI.file(d.iconPath):c.URI.isUri(d.iconPath)||n.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function h(d,s){if(!d.iconPath&&!s.iconPath)return 0;if(d.iconPath){if(!s.iconPath)return 1}else return-1;const v=typeof d.iconPath=="string"?d.iconPath:c.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,a=typeof s.iconPath=="string"?s.iconPath:c.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,D.comparePaths)(v,a)}function C(d,s){let v=0;if(d.strikeThrough!==s.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==s.faded)return d.faded?1:-1;if(d.tooltip!==s.tooltip)return(d.tooltip||"").localeCompare(s.tooltip||"");if(v=h(d,s),v!==0)return v;if(d.light&&s.light)v=h(d.light,s.light);else{if(d.light)return 1;if(s.light)return-1}if(v!==0)return v;if(d.dark&&s.dark)v=h(d.dark,s.dark);else{if(d.dark)return 1;if(s.dark)return-1}return v}function b(d,s){if(d.command!==s.command)return d.command<s.command?-1:1;if(d.title!==s.title)return d.title<s.title?-1:1;if(d.tooltip!==s.tooltip){if(d.tooltip!==void 0&&s.tooltip!==void 0)return d.tooltip<s.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(d.arguments===s.arguments)return 0;if(d.arguments)if(s.arguments){if(d.arguments.length!==s.arguments.length)return d.arguments.length-s.arguments.length}else return 1;else return-1;for(let v=0;v<d.arguments.length;v++){const a=d.arguments[v],E=s.arguments[v];if(a!==E)return a<E?-1:1}return 0}function m(d,s){let v=(0,D.comparePaths)(d.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(v!==0)return v;if(d.command&&s.command)v=b(d.command,s.command);else{if(d.command)return 1;if(s.command)return-1}if(v!==0)return v;if(d.decorations&&s.decorations)v=C(d.decorations,s.decorations);else{if(d.decorations)return 1;if(s.decorations)return-1}return v}function p(d,s){for(let v=0;v<d.length;v++)if(d[v]!==s[v])return!1;return!0}function R(d,s){return d.command===s.command&&d.title===s.title&&d.tooltip===s.tooltip&&(d.arguments&&s.arguments?p(d.arguments,s.arguments):d.arguments===s.arguments)}function l(d,s){return(0,S.equals)(d,s,R)}class M{constructor(s,v,a){this._extension=s,this._proxy=v,this._sourceControlHandle=a,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,v){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,v)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=M;class r{constructor(s,v,a,E,I){this._proxy=s,this._commands=v,this._sourceControlHandle=a,this._id=E,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,v){const a=this._resourceStatesCommandsMap.get(s);return a?(0,t.asPromise)(()=>this._commands.executeCommand(a.command,...a.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(m),a=(0,S.sortedDiff)(this._resourceSnapshot,s,m).map(k=>{const B=k.toInsert.map(L=>{const y=this._resourceHandlePool++;this._resourceStatesMap.set(y,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const we=new P.DisposableStore;N=this._commands.converter.toInternal(L.command,we),this._resourceStatesDisposablesMap.set(y,we)}else this._resourceStatesCommandsMap.set(y,L.command);const z=u(L.decorations),H=L.decorations&&u(L.decorations.light)||z,q=L.decorations&&u(L.decorations.dark)||z,ue=[H,q],K=L.decorations&&L.decorations.tooltip||"",ce=L.decorations&&!!L.decorations.strikeThrough,de=L.decorations&&!!L.decorations.faded,Q=L.contextValue||"";return{rawResource:[y,x,ue,K,ce,de,Q,N],handle:y}});return{start:k.start,deleteCount:k.deleteCount,toInsert:B}}),E=a.map(({start:k,deleteCount:B,toInsert:L})=>[k,B,L.map(y=>y.rawResource)]),I=a.reverse();for(const{start:k,deleteCount:B,toInsert:L}of I){const y=L.map(N=>N.handle),x=this._handlesSnapshot.splice(k,B,...y);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=s,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(s,v,a,E,I,k){this._extension=s,this._proxy=v,this._commands=a,this._id=E,this._label=I,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,I,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=s;const v=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=s;const v=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&l(this._statusBarCommands,s))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=s;const v=(s||[]).map(a=>this._commands.converter.toInternal(a,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(s,v){const a=new r(this._proxy,this._commands,this.handle,s,v),E=F.Event.once(a.onDidDispose)(()=>this.createdResourceGroups.delete(a));return this.createdResourceGroups.set(a,E),this.eventuallyAddResourceGroups(),a}eventuallyAddResourceGroups(){const s=[],v=[];for(const[a,E]of this.createdResourceGroups){E.dispose();const I=a.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(a),this.eventuallyUpdateResourceStates()});F.Event.once(a.onDidDispose)(()=>{this.updatedResourceGroups.delete(a),I.dispose(),this._groups.delete(a.handle),this._proxy.$unregisterGroup(this.handle,a.handle)}),s.push([a.handle,a.id,a.label,a.features]);const k=a._takeResourceStateSnapshot();k.length>0&&v.push([a.handle,k]),this._groups.set(a.handle,a)}this._proxy.$registerGroups(this.handle,s,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(v=>{const a=v._takeResourceStateSnapshot();a.length!==0&&s.push([v.handle,a])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,xe([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),xe([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let g=class zi{constructor(s,v,a){this._commands=v,this.logService=a,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=s.getProxy(T.MainContext.MainThreadSCM),this._telemetry=s.getProxy(T.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const I=this._sourceControls.get(E.sourceControlHandle);if(!I)return E;const k=I.getResourceGroup(E.groupHandle);return k?k.getResourceState(E.handle):E}else if(E&&E.$mid===4){const I=this._sourceControls.get(E.sourceControlHandle);return I?I.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const I=this._sourceControls.get(E.handle);return I||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,v,a,E){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,v,a,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const I=zi._handlePool++,k=new i(s,this._proxy,this._commands,v,a,E);this._sourceControls.set(I,k);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return B.push(k),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),B),k}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const v=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),a=v&&v[v.length-1];return a&&a.inputBox}$provideOriginalResource(s,v,a){const E=c.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,E.toString());const I=this._sourceControls.get(s);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(E,a)).then(k=>k||null)}$onInputBoxValueChange(s,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const a=this._sourceControls.get(s);return a&&a.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(s,v,a,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,v,a);const I=this._sourceControls.get(s);if(!I)return Promise.resolve(void 0);const k=I.getResourceGroup(v);return k?k.$executeResourceCommand(a,E):Promise.resolve(void 0)}$validateInput(s,v,a){this.logService.trace("ExtHostSCM#$validateInput",s);const E=this._sourceControls.get(s);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(v,a)).then(I=>{if(!I)return Promise.resolve(void 0);const k=f.MarkdownString.fromStrict(I.message);return k?Promise.resolve([k,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};g._handlePool=0,g=xe([$e(2,A.ILogService)],g),e.ExtHostSCM=g});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[200],_e([0,1,7,5,122,6,8,11]),function(oe,e,c,F,w,P,t,T){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(o,u,h,C,b=c.StatusBarAlignment.Left,m){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,Ze(this,S,o,"f"),Ze(this,D,u,"f"),this._entryId=A.ID_GEN++,this._extension=h,this._id=C,this._alignment=b,this._priority=this.validatePriority(m)}validatePriority(o){if(!!(0,T.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!A.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ae(this,D,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ae(this,D,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let u;this._name?u=this._name:u=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const C=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,S,"f").$setEntry(this._entryId,o,u,this._text,C,this._command?.internal,h,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const u={message:o};return this._messages.unshift(u),this._update(),new c.Disposable(()=>{const h=this._messages.indexOf(u);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,u){this._proxy=o.getProxy(F.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new _(this)}createStatusBarEntry(o,u,h,C){return new A(this._proxy,this._commands,o,u,h,C)}setStatusBarMessage(o,u){const h=this._statusMessage.setMessage(o);let C;return typeof u=="number"?C=setTimeout(()=>h.dispose(),u):typeof u!="undefined"&&u.then(()=>h.dispose(),()=>h.dispose()),new c.Disposable(()=>{h.dispose(),clearTimeout(C)})}}e.ExtHostStatusBar=n}),define(Ee[71],_e([0,1,5,3,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(T){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this._proxy.$registerExtensionStorageKeysToSync(T,S)}getValue(T,S,D){return this._proxy.$getValue(T,S).then(A=>A||D)}setValue(T,S,D){return this._proxy.$setValue(T,S,D)}$acceptValue(T,S,D){this._onDidChangeStorage.fire({shared:T,key:S,value:D})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],_e([0,1,4,28,12,49,2]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(D,A,_){this._logService=A,this._extHostFileSystem=_,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(D){return t.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,A=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(D){if(this._value)return t.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return t.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=xe([$e(0,F.IExtHostInitDataService),$e(1,w.ILogService),$e(2,P.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Ee[39],_e([0,1,3,5,4,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class b{constructor(d,s,v,a){this._proxy=d,this._id=s,this._creationOptions=v,this._name=a,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(I,k=!0){E._checkDisposed(),E._proxy.$sendText(E._id,I,k)},show(I){E._checkDisposed(),E._proxy.$show(E._id,I)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(d,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,h.withNullAsUndefined)(d.shellPath),shellArgs:(0,h.withNullAsUndefined)(d.shellArgs),cwd:(0,h.withNullAsUndefined)(d.cwd),env:(0,h.withNullAsUndefined)(d.env),icon:(0,h.withNullAsUndefined)(r(d.iconPath)),color:u.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,h.withNullAsUndefined)(d.message),strictEnv:(0,h.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(d.location,s?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,s,v,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:u.ThemeColor.isThemeColor(a)?a.id:void 0,location:this._serializeParentTerminal(d,s)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,s){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,s){return d===this._cols&&s===this._rows||d===0||s===0?!1:(this._cols=d,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=b;class m{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,s){this._pty.setDimensions?.({columns:d,rows:s})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=m;let p=1,R=class extends T.Disposable{constructor(d,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[v,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,s){const v=new b(this._proxy,(0,f.generateUuid)(),d,d.name),a=new m(d.pty);return v.createExtensionTerminal(d.location,this._serializeParentTerminal(d,s).resolvedExtHostIdentifier,r(d.iconPath),i(d.color)).then(E=>{const I=this._setupExtHostProcessListeners(E,a);this._terminalProcessDisposables[E]=I}),this._terminals.push(v),v.value}_serializeParentTerminal(d,s){if(s=s||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const v=d.location.parentTerminal;if(v){const a=this._terminals.find(E=>E.value===v);a&&(s.resolvedExtHostIdentifier=a._id)}}else d.location&&typeof d.location!="object"?s.location=d.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(d,s){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const a=new m(s),E=this._setupExtHostProcessListeners(d,a);this._terminalProcessDisposables[d]=E}async $acceptActiveTerminalChanged(d){const s=this._activeTerminal;if(d===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(d);v&&(this._activeTerminal=v,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,s){const v=this._getTerminalById(d);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:s})}async $acceptTerminalDimensions(d,s,v){const a=this._getTerminalById(d);a&&a.setDimensions(s,v)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(d,s,v){this._terminalProcesses.get(d)?.resize(s,v)}async $acceptTerminalTitleChange(d,s){const v=this._getTerminalById(d);v&&(v.name=s)}async $acceptTerminalClosed(d,s){const v=this._getTerminalObjectIndexById(this._terminals,d);if(v!==null){const a=this._terminals.splice(v,1)[0];a.setExitCode(s),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(d,s,v,a){if(s){const k=this._getTerminalObjectIndexById(this._terminals,s);if(k!==null){this._terminals[k]._id=d,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const E={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:P.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},I=new b(this._proxy,d,E,v);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(d,s){const v=this._getTerminalById(d);v&&v._setProcessId(s)}async $startExtensionTerminal(d,s){const v=this._getTerminalById(d);if(!v)return{message:(0,D.localize)(0,null,d)};v.isOpen||await new Promise(E=>{const I=this.onDidOpenTerminal(async k=>{k===v.value&&(I.dispose(),E())})});const a=this._terminalProcesses.get(d);a?a.startSendingEvents(s):this._extensionTerminalAwaitingStart[d]={initialDimensions:s}}_setupExtHostProcessListeners(d,s){const v=new T.DisposableStore;v.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(d,E.pid,E.cwd))),v.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(d,E))),this._bufferer.startBuffering(d,s.onProcessData),v.add(s.onProcessExit(E=>this._onProcessExit(d,E))),this._terminalProcesses.set(d,s);const a=this._extensionTerminalAwaitingStart[d];return a&&s instanceof m&&(s.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),v}$acceptProcessAckDataEvent(d,s){this._terminalProcesses.get(d)?.acknowledgeDataEvent(s)}$acceptProcessInput(d,s){this._terminalProcesses.get(d)?.input(s)}$acceptTerminalInteraction(d){const s=this._getTerminalById(d);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(d,s,v){try{this._terminalProcesses.get(d)?.resize(s,v)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(d,s){this._terminalProcesses.get(d)?.shutdown(s)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:s}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,s,v){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,v),this._proxy.$registerProfileProvider(s,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(d,s){const v=new n.CancellationTokenSource().token;let a=await this._profileProviders.get(d)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(a&&!("options"in a)&&(a={options:a}),!a||!("options"in a))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in a.options){this.createExtensionTerminal(a.options,s);return}this.createTerminalFromOptions(a.options,s)}}async $provideLinks(d,s){const v=this._getTerminalById(d);if(!v)return[];this._terminalLinkCache.delete(d);const a=this._terminalLinkCancellationSource.get(d);a&&a.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,E);const I=[],k={terminal:v.value,line:s},B=[];for(const x of this._linkProviders)B.push(C.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const z=await x.provideTerminalLinks(k,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:z})}));const L=await Promise.all(B);if(E.token.isCancellationRequested)return[];const y=new Map;for(const x of L)x&&x.links.length>0&&I.push(...x.links.map(N=>{const z={id:p++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return y.set(z.id,{provider:x.provider,link:N}),z}));return this._terminalLinkCache.set(d,y),I}$activateLink(d,s){const v=this._terminalLinkCache.get(d)?.get(s);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(d,s){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const v=this._terminalProcessDisposables[d];v&&(v.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,s)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,s){const v=this._getTerminalObjectIndexById(d,s);return v!==null?d[v]:null}_getTerminalObjectIndexById(d,s){let v=null;return d.some((a,E)=>a._id===s?(v=E,!0):!1),v}getEnvironmentVariableCollection(d){let s=this._environmentVariableCollections.get(d.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(d.identifier.value,s)),s}_syncEnvironmentVariableCollection(d,s){const v=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(d,s.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(d){d.forEach(s=>{const v=s[0],a=new l(s[1]);this._setEnvironmentVariableCollection(v,a)})}$acceptDefaultProfile(d,s){this._defaultProfile=d,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(d,s){this._environmentVariableCollections.set(d,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,s)})}};R=xe([$e(1,t.IExtHostRpcService)],R),e.BaseExtHostTerminalService=R;class l{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Replace})}append(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,s){const v=this.map.get(d);(!v||v.value!==s.value||v.type!==s.type)&&(this.map.set(d,s),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,s){this.map.forEach((v,a)=>d.call(s,a,v,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends R{constructor(d){super(!1,d)}createTerminal(d,s,v){throw new A.NotSupportedError}createTerminalFromOptions(d,s){throw new A.NotSupportedError}};M=xe([$e(0,t.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function i(g){return u.ThemeColor.isThemeColor(g)?g:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[201],_e([0,1,16,22,20,3,230,57,6,27,11,35,5,13,47,8,7,170,88,67]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let R=class{constructor(k,B){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(n.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new M(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?u.TestItem.toItemFromContext(L):L})}createTestController(k,B){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const L=new S.DisposableStore,y=L.add(new C.SingleUseTestCollection(k));y.root.label=B;const x=new Map,N=this.proxy,z={items:y.root.children,get label(){return B},set label(q){B=q,y.root.label=q,N.$updateControllerLabel(k,B)},get id(){return k},createRunProfile:(q,ue,K,ce,de)=>{let Q=(0,T.hash)(q);for(;x.has(Q);)Q++;const ie=new a(this.proxy,k,Q,q,ue,K,ce,de);return x.set(Q,ie),ie},createTestItem(q,ue,K){return new o.TestItemImpl(k,q,ue,K)},createTestRun:(q,ue,K=!0)=>this.runTracker.createTestRun(k,y,q,ue,K),set resolveHandler(q){y.resolveHandler=q},get resolveHandler(){return y.resolveHandler},dispose:()=>{L.dispose()}};z.createRunConfiguration=z.createRunProfile,N.$registerTestController(k,B),L.add((0,S.toDisposable)(()=>N.$unregisterTestController(k)));const H={controller:z,collection:y,profiles:x};return this.controllers.set(k,H),L.add((0,S.toDisposable)(()=>this.controllers.delete(k))),L.add(y.onDidGenerateDiff(q=>N.$publishDiff(k,q))),z}createTestObserver(){return this.observer.checkout()}async runTests(k,B=w.CancellationToken.None){const L=r(k);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(L.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(x=>x.id)??[y.collection.root.id],profileGroup:E[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:k.exclude?.map(x=>x.id)},B)}$provideFileCoverage(k,B,L){return(0,c.mapFind)(this.runTracker.trackers,x=>x.id===k?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(k,B,L,y){return(0,c.mapFind)(this.runTracker.trackers,N=>N.id===k?N.getCoverage(B):void 0)?.resolveFileCoverage(L,y)??Promise.resolve([])}$configureRunProfile(k,B){this.controllers.get(k)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(k){this.results=Object.freeze(k.map(B=>(0,D.deepFreeze)(u.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,B){const L=this.controllers.get(m.TestId.fromString(k).controllerId)?.collection;L&&(await L.expand(k,B<0?Infinity:B),L.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,B){const L=this.controllers.get(k.controllerId);if(!L)return;const{collection:y,profiles:x}=L,N=x.get(k.profileId);if(!N)return;const z=k.testIds.map(K=>y.tree.get(K)).filter(A.isDefined),H=k.excludeExtIds.map(K=>L.collection.tree.get(K)).filter(A.isDefined).filter(K=>z.some(ce=>ce.fullId.compare(K.fullId)===2));if(!z.length)return;const q=new h.TestRunRequest(z.some(K=>K.actual instanceof o.TestItemRootImpl)?void 0:z.map(K=>K.actual),H.map(K=>K.actual),N),ue=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(k,L.collection),B);try{await N.runHandler(q,B)}finally{ue.isRunning&&!B.isCancellationRequested&&await P.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};R=xe([$e(0,f.IExtHostRpcService)],R),e.ExtHostTesting=R;class l extends S.Disposable{constructor(k,B,L){super();this.dto=k,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const B=this.dto.id,L=this.dto.controllerId,y=(0,_.generateUuid)(),x=new g(this.proxy,B,y),N=ue=>(K,...ce)=>{if(H){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...ce))},z=(ue,K)=>{const ce=K instanceof Array?K.map(u.TestMessage.from):[u.TestMessage.from(K)];if(ue.uri&&ue.range){const de={range:u.Range.from(ue.range),uri:ue.uri};for(const Q of ce)Q.location=Q.location||de}this.proxy.$appendTestMessagesInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),ce)};let H=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return x.coverageProvider},set coverageProvider(ue){x.coverageProvider=ue},enqueued:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),1)}),skipped:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),5)}),started:N(ue=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),2)}),errored:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),6,ce)}),failed:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,L).toString(),4,ce)}),passed:N((ue,K)=>{this.proxy.$updateTestStateInRun(B,y,m.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,ce)=>{H||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(B,y,F.VSBuffer.fromString(ue),K&&u.location.from(K),ce&&m.TestId.fromExtHostTestItem(ce,L).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(B,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:x}),this.proxy.$startedTestRunTask(B,{id:y,name:k,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof o.TestItemImpl))throw new o.InvalidTestItemError(k.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const y=u.TestItem.from(k);if(B.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),k===L))break;k=k.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class M{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,B,L){return this.getTracker(k,B,L)}cancelRunById(k){for(const B of this.tracked.values())if(B.id===k){B.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,B,L,y,x){const N=this.tracked.get(L);if(N)return N.createRun(y);const z=i.fromPublic(k,B,L,x),H=r(L);this.proxy.$startedExtensionTestRun({controllerId:k,profile:H&&{group:E[H.kind],id:H.profileId},exclude:L.exclude?.map(ue=>ue.id)??[],id:z.id,include:L.include?.map(ue=>ue.id)??[B.root.id],persist:x});const q=this.getTracker(L,z);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),q.createRun(y)}getTracker(k,B,L){const y=new l(B,this.proxy,L);return this.tracked.set(k,y),y.onEnd(()=>this.tracked.delete(k)),y}}e.TestRunCoordinator=M;const r=I=>{if(!!I.profile){if(!(I.profile instanceof a))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class i{constructor(k,B,L,y,x,N){this.controllerId=k,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(z=>z+"\0"),this.excludePrefix=y.map(z=>z+"\0")}static fromPublic(k,B,L,y){return new i(k,(0,_.generateUuid)(),L.include?.map(x=>m.TestId.fromExtHostTestItem(x,k).toString())??[k],L.exclude?.map(x=>m.TestId.fromExtHostTestItem(x,k).toString())??[],y,B)}static fromInternal(k,B){return new i(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,B)}isIncluded(k){const B=m.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=i;class g{constructor(k,B,L){this.proxy=k,this.runId=B,this.taskId=L}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(k,B){const L=await this.fileCoverage;let y=L?.[k];return!this._coverageProvider||!L||!y?[]:(y.detailedCoverage||(y=L[k]=await this._coverageProvider.resolveFileCoverage?.(y,B)??y),y.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class d extends b.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,u.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:B,removed:L}=this;return{get added(){return[...k].map(y=>y.revived)},get updated(){return[...B].map(y=>y.revived)},get removed(){return[...L].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,B){return{...k,revived:u.TestItem.toPlain(k.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=s;class v{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class a{constructor(k,B,L,y,x,N,z=!1,H=void 0){this.controllerId=B,this.profileId=L,this._label=y,this.kind=x,this.runHandler=N,this._isDefault=z,this._tag=H,p.set(this,void 0),Ze(this,p,k,"f");const q=E[x];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,p,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:y,group:q,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?u.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ae(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ae(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=a,p=new WeakMap;const E={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ee[202],_e([0,1,3,16,5,92,8,7]),function(oe,e,c,F,w,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const _=this._extHostDocumentsAndEditors.allEditors();return A?_:_.map(n=>n.value)}async showTextDocument(A,_,n){let f;typeof _=="number"?f={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?f={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(A.uri,f),u=o&&this._extHostDocumentsAndEditors.getEditor(o);if(u)return u.value;throw o?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,_){return new P.TextEditorDecorationType(this._proxy,A,_).value}$acceptEditorPropertiesChanged(A,_){const n=this._extHostDocumentsAndEditors.getEditor(A);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const f=_.selections.selections.map(t.Selection.to);n._acceptSelections(f)}if(_.visibleRanges){const f=F.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(f)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const f=T.TextEditorSelectionChangeKind.fromValue(_.selections.source),o=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:f})}if(_.visibleRanges){const f=F.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(A){for(const _ in A){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const f=t.ViewColumn.to(A[_]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(Ee[203],_e([0,1,2,4,5,6,7]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class T{constructor(A,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(f))?.get(n.handle)}return n}})}async $getTimeline(A,_,n,f,o){return this._providers.get(A)?.provideTimeline(c.URI.revive(_),n,f,o)}registerTimelineProvider(A,_,n,f){const o=new P.DisposableStore,u=this.convertTimelineItem(_.id,f,o).bind(this);let h;_.onDidChange&&(h=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:A,onDidChange:void 0,async provideTimeline(b,m,p,R){R?.resetCache&&(o.clear(),C.get(_.id)?.clear());const l=await _.provideTimeline(b,m,p);if(l==null)return;const M=u(b,R);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const b of C.values())b.get(_.id)?.clear();h?.dispose(),o.dispose()}})}convertTimelineItem(A,_,n){return(f,o)=>{let u;if(o?.cacheResults){let h=this._itemsBySourceAndUriMap.get(A);h===void 0&&(h=new Map,this._itemsBySourceAndUriMap.set(A,h));const C=S(f);u=h.get(C),u===void 0&&(u=new Map,h.set(C,u))}return h=>{const{iconPath:C,...b}=h,m=`${A}|${h.id??h.timestamp}`;u?.set(m,h);let p,R,l;return h.iconPath&&(C instanceof t.ThemeIcon?l={id:C.id,color:C.color}:c.URI.isUri(C)?(p=C,R=C):{light:p,dark:R}=C),{...b,id:b.id??void 0,handle:m,source:A,command:h.command?_.toInternal(h.command,n):void 0,icon:p,iconDark:R,themeIcon:l,accessibilityInformation:h.accessibilityInformation}}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(A.id)?.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=T;function S(D){return D?.toString()}}),define(Ee[204],_e([0,1,6,10,2,5]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,A,_){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const n=_.schemes.find(f=>!t.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,A),this._proxy.$registerUriOpener(D,_.schemes,S,_.label),(0,c.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,A){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener with id: ${S}`);const n=w.URI.revive(D);return _.canOpenExternalUri(n,A)}async $openUri(S,D,A){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener id: '${S}'`);return _.openExternalUri(w.URI.revive(D.resolvedUri),{sourceUri:w.URI.revive(D.sourceUri)},A)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[205],_e([0,1,5,2,6,15,25]),function(oe,e,c,F,w,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(D,A){if(this.handles.has(t.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const _=T.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(D)),this.handlers.set(_,A),this._proxy.$registerUriHandler(_,D),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(D)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(D,A){const _=this.handlers.get(D);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(A))}catch(n){(0,P.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(D){return F.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[50],_e([0,1,3,10,2,132,152,66,5]),function(oe,e,c,F,w,P,t,T,S){"use strict";var D,A,_,n,f,o,u,h,C,b,m,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class R{constructor(v,a,E,I,k,B,L){D.set(this,void 0),A.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),u.set(this,""),h.set(this,void 0),C.set(this,!1),b.set(this,!1),m.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new c.Emitter),this._onDidDispose=Ae(this,p,"f").event,Ze(this,D,v,"f"),Ze(this,A,a,"f"),Ze(this,h,E,"f"),Ze(this,n,I,"f"),Ze(this,f,k,"f"),Ze(this,o,B,"f"),Ze(this,m,l(B),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,C,!0,"f"),Ae(this,p,"f").fire(),Ae(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Ze(this,b,!0,"f"),(0,T.asWebviewUri)(v,Ae(this,n,"f").remote)}get cspSource(){const v=Ae(this,o,"f").extensionLocation;if(v.scheme===F.Schemas.https||v.scheme===F.Schemas.http){let a=v.toString();return a.endsWith("/")||(a+="/"),a+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,u,"f")}set html(v){this.assertNotDisposed(),Ae(this,u,"f")!==v&&(Ze(this,u,v,"f"),!Ae(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Ze(this,b,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,A,"f").$setHtml(Ae(this,D,"f"),v))}get options(){return this.assertNotDisposed(),Ae(this,h,"f")}set options(v){this.assertNotDisposed(),Ae(this,A,"f").$setOptions(Ae(this,D,"f"),i(Ae(this,o,"f"),Ae(this,f,"f"),v)),Ze(this,h,v,"f")}async postMessage(v){if(Ae(this,C,"f"))return!1;const a=(0,t.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ae(this,m,"f")});return Ae(this,A,"f").$postMessage(Ae(this,D,"f"),a.message,...a.buffers)}assertNotDisposed(){if(Ae(this,C,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=R,D=new WeakMap,A=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,u=new WeakMap,h=new WeakMap,C=new WeakMap,b=new WeakMap,m=new WeakMap,p=new WeakMap;function l(s){try{const v=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(v,a,E,I,k){this.initData=a,this.workspace=E,this._logService=I,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,a,...E){const I=this.getWebview(v);if(I){const{message:k}=(0,t.deserializeWebviewMessage)(a,E);I._onMessageEmitter.fire(k)}}$onMissingCsp(v,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,a,E){const I=new R(v,this._webviewProxy,g(a),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(v,I),I._onDidDispose(()=>{this._webviews.delete(v)}),I}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=M;function r(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=r;function i(s,v,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||d(s,v)}}e.serializeWebviewOptions=i;function g(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(v=>w.URI.from(v))}}e.reviveOptions=g;function d(s,v){return[...(v?.getWorkspaceFolders()||[]).map(a=>a.uri),s.extensionLocation]}}),define(Ee[206],_e([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=p(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const g=new f(M,r);return this._documents.set(i,g),g}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var u;(function(R){R[R.Text=0]="Text",R[R.Custom=1]="Custom"})(u||(u={}));class h{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class C{constructor(l,M,r,i,g){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=g,this._editorProviders=new h,this._documents=new o,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const g=new w.DisposableStore;return b(r)?(g.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(l))):(g.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&g.add(r.onDidChangeCustomDocument(d=>{const s=this.getCustomDocumentEntry(M,d.document.uri);if(m(d)){const v=s.addEdit(d);this._proxy.$onDidEdit(d.document.uri,M,v,d.label)}else this._proxy.$onContentChange(d.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(g,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,g){const d=this._editorProviders.get(M);if(!d)throw new Error(`No provider found for '${M}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${M}'`);const s=T.URI.revive(l),v=await d.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:i?.buffer},g);let a;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(a=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(M,v,a),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=T.URI.revive(l),{document:g}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,g),g.dispose()}async $resolveWebviewEditor(l,M,r,i,g,d){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const v=S.ViewColumn.to(g),a=this._extHostWebview.createNewWebview(M,i.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,v,i.panelOptions,a),I=T.URI.revive(l);switch(s.type){case 1:{const{document:k}=this.getCustomDocumentEntry(r,I);return s.provider.resolveCustomEditor(k,E,d)}case 0:{const k=this._extHostDocuments.getDocument(I);return s.provider.resolveCustomTextEditor(k,E,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const g=this._extHostWebviewPanels.getWebviewPanel(l);if(!g)throw new Error("No webview found");const d=T.URI.revive(M),s=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(s,g,c.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const g=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(g.document,T.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),d=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(d),d.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,T.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=C;function b(R){return typeof R.resolveCustomTextEditor=="function"}function m(R){return typeof R.undo=="function"&&typeof R.redo=="function"}function p(R){const l=R.scheme===P.Schemas.file||R.scheme===P.Schemas.untitled?R.fsPath:R.toString();return(0,F.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[207],_e([0,1,3,6,2,35,8,50,5,7]),function(oe,e,c,F,w,P,t,T,S,D){"use strict";var A,_,n,f,o,u,h,C,b,m,p,R,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends F.Disposable{constructor(d,s,v,a,E,I,k){super();A.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),u.set(this,void 0),h.set(this,void 0),C.set(this,void 0),b.set(this,!0),m.set(this,!0),p.set(this,!1),R.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,R,"f").event,l.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ae(this,l,"f").event,Ze(this,A,d,"f"),Ze(this,_,s,"f"),Ze(this,n,v,"f"),Ze(this,o,I,"f"),Ze(this,C,E,"f"),Ze(this,u,a,"f"),Ze(this,f,k,"f")}dispose(){Ae(this,p,"f")||(Ze(this,p,!0,"f"),Ae(this,R,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,A,"f")),Ae(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(d){this.assertNotDisposed(),Ae(this,u,"f")!==d&&(Ze(this,u,d,"f"),Ae(this,_,"f").$setTitle(Ae(this,A,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ae(this,h,"f")}set iconPath(d){this.assertNotDisposed(),Ae(this,h,"f")!==d&&(Ze(this,h,d,"f"),Ae(this,_,"f").$setIconPath(Ae(this,A,"f"),w.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ae(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,C,"f")=="number"&&Ae(this,C,"f")<0))return Ae(this,C,"f")}get active(){return this.assertNotDisposed(),Ae(this,m,"f")}get visible(){return this.assertNotDisposed(),Ae(this,b,"f")}_updateViewState(d){Ae(this,p,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Ze(this,m,d.active,"f"),Ze(this,b,d.visible,"f"),Ze(this,C,d.viewColumn,"f"),Ae(this,l,"f").fire({webviewPanel:this}))}reveal(d,s){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,A,"f"),{viewColumn:d?t.ViewColumn.from(d):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Ae(this,p,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,u=new WeakMap,h=new WeakMap,C=new WeakMap,b=new WeakMap,m=new WeakMap,p=new WeakMap,R=new WeakMap,l=new WeakMap;class r{constructor(d,s,v){this.webviews=s,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(d,s,v,a,E={}){const I=typeof a=="object"?a.viewColumn:a,k={viewColumn:t.ViewColumn.from(I),preserveFocus:typeof a=="object"&&!!a.preserveFocus},B=(0,T.shouldSerializeBuffersForPostMessage)(d),L=r.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(d),L,s,{title:v,panelOptions:i(E),webviewOptions:(0,T.serializeWebviewOptions)(d,this.workspace,E),serializeBuffersForPostMessage:B},k);const y=this.webviews.createNewWebview(L,E,d);return this.createNewWebviewPanel(L,s,v,I,E,y)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((v,a)=>{const E=d[v],I=d[a];return E.active?1:I.active?-1:+E.visible-+I.visible});for(const v of s){const a=this.getWebviewPanel(v);if(!a)continue;const E=d[v];a._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,s,v){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:v,extension:d}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,v,a){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:I,extension:k}=E,B=this.webviews.createNewWebview(d,v.webviewOptions,k),L=this.createNewWebviewPanel(d,s,v.title,a,v.panelOptions,B);await I.deserializeWebviewPanel(L,v.state)}createNewWebviewPanel(d,s,v,a,E,I){const k=new M(d,this._proxy,s,v,a,E,I);return this._webviewPanels.set(d,k),k}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function i(g){return{enableFindWidget:g.enableFindWidget,retainContextWhenHidden:g.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[208],_e([0,1,3,6,50,5,7]),function(oe,e,c,F,w,P,t){"use strict";var T,S,D,A,_,n,f,o,u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends F.Disposable{constructor(p,R,l,M,r,i){super();T.set(this,void 0),S.set(this,void 0),D.set(this,void 0),A.set(this,void 0),_.set(this,!1),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),u.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ae(this,u,"f").event,h.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,h,"f").event,Ze(this,D,l,"f"),Ze(this,f,M,"f"),Ze(this,T,p,"f"),Ze(this,S,R,"f"),Ze(this,A,r,"f"),Ze(this,n,i,"f")}dispose(){Ae(this,_,"f")||(Ze(this,_,!0,"f"),Ae(this,h,"f").fire(),Ae(this,A,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,f,"f")}set title(p){this.assertNotDisposed(),Ae(this,f,"f")!==p&&(Ze(this,f,p,"f"),Ae(this,S,"f").$setWebviewViewTitle(Ae(this,T,"f"),p))}get description(){return this.assertNotDisposed(),Ae(this,o,"f")}set description(p){this.assertNotDisposed(),Ae(this,o,"f")!==p&&(Ze(this,o,p,"f"),Ae(this,S,"f").$setWebviewViewDescription(Ae(this,T,"f"),p))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,A,"f")}get viewType(){return Ae(this,D,"f")}_setVisible(p){p===Ae(this,n,"f")||Ae(this,_,"f")||(Ze(this,n,p,"f"),Ae(this,u,"f").fire())}show(p){this.assertNotDisposed(),Ae(this,S,"f").$show(Ae(this,T,"f"),!!p)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,S=new WeakMap,D=new WeakMap,A=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,u=new WeakMap,h=new WeakMap;class b{constructor(p,R){this._extHostWebview=R,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,R,l,M){if(this._viewProviders.has(R))throw new Error(`View provider for '${R}' already registered`);return this._viewProviders.set(R,{provider:l,extension:p}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(p),R,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(R),this._proxy.$unregisterWebviewViewProvider(R)})}async $resolveWebviewView(p,R,l,M,r){const i=this._viewProviders.get(R);if(!i)throw new Error(`No view provider found for '${R}'`);const{provider:g,extension:d}=i,s=this._extHostWebview.createNewWebview(p,{},d),v=new C(p,this._proxy,R,l,s,!0);this._webviewViews.set(p,v),await g.resolveWebviewView(v,{state:M},r)}async $onDidChangeWebviewViewVisibility(p,R){this.getWebviewView(p)._setVisible(R)}async $disposeWebviewView(p){const R=this.getWebviewView(p);this._webviewViews.delete(p),R.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const R=this._webviewViews.get(p);if(!R)throw new Error("No webview found");return R}}e.ExtHostWebviewViews=b}),define(Ee[95],_e([0,1,3,5,2,10,9,4,13]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class Wi{constructor(_){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let f;if(typeof _=="string"){f=_;try{_=w.URI.parse(_)}catch(o){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,f,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(_,n);return w.URI.from(f)}};D.InitialState={focused:!0},D=xe([$e(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Ee[209],_e([0,1,14,22,20,15,3,6,106,176,37]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,I){try{return JSON.stringify(E,I)}catch(k){return"null"}}const f="$$ref$$",o={[f]:-1};class u{constructor(I,k){this.jsonString=I,this.referencedBuffers=k}}function h(E,I=null,k=!1){const B=[];return{jsonString:(k?n:JSON.stringify)(E,(y,x)=>{if(typeof x=="undefined")return o;if(typeof x=="object"){if(x instanceof F.VSBuffer){const N=B.push(x)-1;return{[f]:N}}if(I)return I(y,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=h;function C(E,I,k){return JSON.parse(E,(B,L)=>{if(L){const y=L[f];if(typeof y=="number")return I[y];if(k&&L.$mid===1)return k.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=C;function b(E,I){return JSON.stringify(E,I)}function m(E){return E?(I,k)=>k&&k.$mid===1?E.transformOutgoing(k):k:null}var p;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var R;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(R=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(I,k=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=k,this._uriTransformer=B,this._uriReplacer=m(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,y=A.ProxyIdentifier.count;L<y;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,S.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:k,sid:B}=I;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,B)),this._proxies[k]}_createProxy(I,k){let B={get:(L,y)=>(typeof y=="string"&&!L[y]&&y.charCodeAt(0)===36&&(L[y]=(...x)=>this._remoteCall(I,y,x)),y===r?k:L[y])};return new Proxy(Object.create(null),B)}set(I,k){return this._locals[I.nid]=k,k}assertRegistered(I){for(let k=0,B=I.length;k<B;k++){const L=I[k];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const k=I.byteLength,B=g.read(I,0),L=B.readUInt8(),y=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:z}=s.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(k,y,x,N,z,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:z}=s.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(k,y,x,N,z,L===4);break}case 5:{this._logger&&this._logger.logIncoming(k,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(k,y);break}case 7:{this._receiveReply(k,y,void 0);break}case 9:{let x=s.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(k,y,x);break}case 10:{const x=s.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(k,y,x);break}case 8:{let x=s.deserializeReplyOKVSBuffer(B);this._receiveReply(k,y,x);break}case 11:{let x=s.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(k,y,x);break}case 12:{this._receiveReplyErr(k,y,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,k,B,L,y,x){this._logger&&this._logger.logIncoming(I,k,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(B)}.${L}(`,y);const N=String(k);let z,H;if(x){const ue=new w.CancellationTokenSource;y.push(ue.token),z=this._invokeHandler(B,L,y),H=()=>ue.cancel()}else z=this._invokeHandler(B,L,y),H=l;this._cancelInvokedHandlers[N]=H;const q=s.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"ack"),this._protocol.send(q),z.then(ue=>{delete this._cancelInvokedHandlers[N];const K=s.serializeReplyOK(k,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,k,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[N];const K=s.serializeReplyErr(k,ue);this._logger&&this._logger.logOutgoing(K.byteLength,k,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(I,k){this._logger&&this._logger.logIncoming(I,k,1,"receiveCancel");const B=String(k);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(I,k,B){this._logger&&this._logger.logIncoming(I,k,0,"receiveReply:",B);const L=String(k);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],y.resolveOk(B)}_receiveReplyErr(I,k,B){this._logger&&this._logger.logIncoming(I,k,0,"receiveReplyErr:",B);const L=String(k);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),y.resolveErr(x)}_invokeHandler(I,k,B){try{return Promise.resolve(this._doInvokeHandler(I,k,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(I,k,B){const L=this._locals[I];if(!L)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(I));let y=L[k];if(typeof y!="function")throw new Error("Unknown method "+k+" on actor "+(0,A.getStringIdentifierForProxy)(I));return y.apply(L,B)}_remoteCall(I,k,B){if(this._isDisposed)return Promise.reject(P.canceled());let L=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(P.canceled());const y=s.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),z=new D.LazyPromise;L&&L.onCancellationRequested(()=>{const q=s.serializeCancel(x);this._logger&&this._logger.logOutgoing(q.byteLength,x,0,"cancel"),this._protocol.send(s.serializeCancel(x))}),this._pendingRPCReplies[N]=z,this._onWillSendRequest(x);const H=s.serializeRequest(x,I,k,y,!!L);return this._logger&&this._logger.logOutgoing(H.byteLength,x,0,`request: ${(0,A.getStringIdentifierForProxy)(I)}.${k}(`,B),this._protocol.send(H),z}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class g{constructor(I,k){this._buff=I,this._offset=k}static alloc(I,k,B){let L=new g(F.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(I),L.writeUInt32(k),L}static read(I,k){return new g(I,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,B}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,k}static sizeMixedArray(I){let k=0;k+=1;for(let B=0,L=I.length;B<L;B++){const y=I[B];switch(k+=1,y.type){case 1:k+=this.sizeLongString(y.value);break;case 2:k+=this.sizeVSBuffer(y.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(y.value);for(let x=0;x<y.buffers.length;++x)k+=this.sizeVSBuffer(y.buffers[x]);break;case 4:break}}return k}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let k=0,B=I.length;k<B;k++){const L=I[k];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let y=0;y<L.buffers.length;++y)this.writeBuffer(L.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(I);for(let B=0;B<I;B++)switch(this.readUInt8()){case 1:k[B]=this.readLongString();break;case 2:k[B]=this.readVSBuffer();break;case 3:const y=this.readUInt32(),x=this.readLongString(),N=[];for(let z=0;z<y;++z)N.push(this.readVSBuffer());k[B]=new A.SerializableObjectWithBuffers(C(x,N,null));break;case 4:k[B]=void 0;break}return k}}g.sizeUInt32=4;var d;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(d||(d={}));class s{static _useMixedArgSerialization(I){for(let k=0,B=I.length;k<B;k++)if(I[k]instanceof F.VSBuffer||I[k]instanceof A.SerializableObjectWithBuffers||typeof I[k]=="undefined")return!0;return!1}static serializeRequestArguments(I,k){if(this._useMixedArgSerialization(I)){const B=[];for(let L=0,y=I.length;L<y;L++){const x=I[L];if(x instanceof F.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof A.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=h(x.value,k);B[L]={type:3,value:F.VSBuffer.fromString(N),buffers:z}}else B[L]={type:1,value:F.VSBuffer.fromString(b(x,k))}}return{type:1,args:B}}return{type:0,args:b(I,k)}}static serializeRequest(I,k,B,L,y){switch(L.type){case 0:return this._requestJSONArgs(I,k,B,L.args,y);case 1:return this._requestMixedArgs(I,k,B,L.args,y)}}static _requestJSONArgs(I,k,B,L,y){const x=F.VSBuffer.fromString(B),N=F.VSBuffer.fromString(L);let z=0;z+=g.sizeUInt8(),z+=g.sizeShortString(x),z+=g.sizeLongString(N);let H=g.alloc(y?2:1,I,z);return H.writeUInt8(k),H.writeShortString(x),H.writeLongString(N),H.buffer}static deserializeRequestJSONArgs(I){const k=I.readUInt8(),B=I.readShortString(),L=I.readLongString();return{rpcId:k,method:B,args:JSON.parse(L)}}static _requestMixedArgs(I,k,B,L,y){const x=F.VSBuffer.fromString(B);let N=0;N+=g.sizeUInt8(),N+=g.sizeShortString(x),N+=g.sizeMixedArray(L);let z=g.alloc(y?4:3,I,N);return z.writeUInt8(k),z.writeShortString(x),z.writeMixedArray(L),z.buffer}static deserializeRequestMixedArgs(I){const k=I.readUInt8(),B=I.readShortString(),L=I.readMixedArray(),y=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const z=L[x];typeof z=="string"?y[x]=JSON.parse(z):y[x]=z}return{rpcId:k,method:B,args:y}}static serializeAcknowledged(I){return g.alloc(5,I,0).buffer}static serializeCancel(I){return g.alloc(6,I,0).buffer}static serializeReplyOK(I,k,B){if(typeof k=="undefined")return this._serializeReplyOKEmpty(I);if(k instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(I,k);if(k instanceof A.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:y}=h(k.value,B,!0);return this._serializeReplyOKJSONWithBuffers(I,L,y)}else return this._serializeReplyOKJSON(I,n(k,B))}static _serializeReplyOKEmpty(I){return g.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,k){let B=0;B+=g.sizeVSBuffer(k);let L=g.alloc(8,I,B);return L.writeVSBuffer(k),L.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,k){const B=F.VSBuffer.fromString(k);let L=0;L+=g.sizeLongString(B);let y=g.alloc(9,I,L);return y.writeLongString(B),y.buffer}static _serializeReplyOKJSONWithBuffers(I,k,B){const L=F.VSBuffer.fromString(k);let y=0;y+=g.sizeUInt32,y+=g.sizeLongString(L);for(const N of B)y+=g.sizeVSBuffer(N);let x=g.alloc(10,I,y);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(I){const k=I.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(I,k){const B=I.readUInt32(),L=I.readLongString(),y=[];for(let x=0;x<B;++x)y.push(I.readVSBuffer());return new A.SerializableObjectWithBuffers(C(L,y,k))}static serializeReplyErr(I,k){return k?this._serializeReplyErrEror(I,k):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,k){const B=F.VSBuffer.fromString(n(P.transformErrorForSerialization(k),null));let L=0;L+=g.sizeLongString(B);let y=g.alloc(11,I,L);return y.writeLongString(B),y.buffer}static deserializeReplyErrError(I){const k=I.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(I){return g.alloc(12,I,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var a;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(a||(a={}))}),define(Ee[210],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(P){const t=T=>{self.removeEventListener("message",t);const S=T.data;Object.defineProperties(self,{postMessage:{value(D,A){S.postMessage(D,A)}},onmessage:{get(){return S.onmessage},set(D){S.onmessage=D}}}),S.addEventListener("message",D=>{self.dispatchEvent(new MessageEvent("message",{data:D.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",t)}.toString();class F extends EventTarget{constructor(P,t,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${t}'))`,D=new Blob([S],{type:"application/javascript"}),A=URL.createObjectURL(D),_=new MessageChannel,n=A,f={type:"_newWorker",id:n,port:_.port2,url:A,options:T};P(f,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};_.port1.postMessage(o),URL.revokeObjectURL(A),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(o){_.port1.onmessage=o}},onmessageerror:{get(){return _.port1.onmessageerror},set(o){_.port1.onmessageerror=o}}}),_.port1.addEventListener("messageerror",o=>{const u=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(u)}),_.port1.addEventListener("message",o=>{const u=new MessageEvent("message",{data:o.data});this.dispatchEvent(u)}),_.port1.start()}}e.NestedWorker=F}),define(Ee[211],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Ee[212],_e([0,1,10,17,23,2,4,61,46,171,211]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Vi{constructor(f,o,u,h){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=u,this.contextService=h,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome||f})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return c.Schemas.vscodeRemote;const u=(0,T.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const h=o.getWorkspace().folders[0];if(h)return h.uri.scheme;const C=o.getWorkspace().configuration;return C?C.scheme:c.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?F.win32:F.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const h=f.indexOf("/",2);h===-1?(o=f.substring(2),f="/"):(o=f.substring(2,h),f=f.substring(h)||"/")}return P.URI.from({scheme:c.Schemas.file,authority:o,path:f,query:"",fragment:""})}};_=xe([$e(1,A.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(t,T){this.line=t,this.character=T}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,T){return new c(0,0)}with(t){return new c(0,0)}}e.Position=c;class F{constructor(t,T,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(t,T),this.end=new c(S,D)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new F(0,0,0,0)}with(t){return new F(0,0,0,0)}}e.Range=F;var w;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],_e([0,1,16,29,27,42,9,4,17,15,96,11]),function(oe,e,c,F,w,P,t,T,S,D,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",o=(n.length+f.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var u;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function C(q){return!!q.preview}e.resultIsMatch=C;function b(q){return!!q.resource}e.isFileMatch=b;function m(q){return!!q.message}e.isProgressMessage=m;var p;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class R{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=R;class l{constructor(ue,K,ce){this.ranges=K;const de=Array.isArray(K)?K:[K];if(ce&&ce.matchLines===1&&M(de)){ue=(0,t.getNLines)(ue,ce.matchLines);let Q="",ie=0,we=0;const Me=Math.floor(ce.charsPerLine/5),Fe=[];for(const Be of de){const Ge=Math.max(Be.startColumn-Me,0),je=Be.startColumn+ce.charsPerLine;if(Ge>we+Me+o){const Qe=n+(Ge-we)+f;Q+=Qe+ue.slice(Ge,je),ie+=Ge-(we+Qe.length)}else Q+=ue.slice(we,je);Fe.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=je}this.preview={text:Q,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const Q=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,c.mapArrayOrNot)(K,ie=>new r(ie.startLineNumber-Q,ie.startColumn,ie.endLineNumber-Q,ie.endColumn))}}}}e.TextSearchMatch=l;function M(q){const ue=q[0].startLineNumber;for(const K of q)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,K,ce,de){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=ce,this.endColumn=de}}e.SearchRange=r;class i extends r{constructor(ue,K,ce){super(ue,K,ue,ce)}}e.OneLineRange=i;var g;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function d(q,ue=!0){const K=q&&q.files&&q.files.exclude,ce=ue&&q&&q.search&&q.search.exclude;if(!K&&!ce)return;if(!K||!ce)return K||ce;let de=Object.create(null);return de=w.mixin(de,w.deepClone(K)),de=w.mixin(de,w.deepClone(ce),!0),de}e.getExcludes=d;function s(q,ue){return q.excludePattern&&F.match(q.excludePattern,ue)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.match(q.includePattern,ue)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(K=>{const ce=K.folder.fsPath;if(P.isEqualOrParent(ue,ce)){const de=S.relative(ce,ue);return!K.includePattern||!!F.match(K.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var v;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class a extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=a;function E(q){const ue=q.message;if((0,D.isPromiseCanceledError)(q))return new a(ue,v.canceled);try{const K=JSON.parse(ue);return new a(K.message,K.code)}catch(K){return new a(ue,v.other)}}e.deserializeSearchError=E;function I(q){const ue={message:q.message,code:q.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=I;function k(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=k;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function L(q){return!!q.path}e.isSerializedFileMatch=L;function y(q,ue){const K=q.searchPath?q.searchPath:q.relativePath;return(0,t.fuzzyContains)(K,ue)}e.isFilePatternMatch=y;class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(q,ue){const K={...q||{},...ue||{}};return Object.keys(K).filter(ce=>{const de=K[ce];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=N;class z{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=ue.includePattern;K.includePattern&&(ce?ce={...ce,...K.includePattern}:ce=K.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}matchesExcludesSync(ue,K,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce))}includedInQuerySync(ue,K,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,ce))}includedInQuery(ue,K,ce){const de=this._parsedExcludeExpression(ue,K,ce),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,ce):!0;return(0,_.isPromise)(de)?de.then(ie=>ie?!1:Q()):Q()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(q){for(const ue in q)if(typeof q[ue]!="boolean")return!0;return!1}}),define(Ee[31],_e([0,1,16,14,20,3,21,10,75,24,9,11,2,125,4,12,138,46,30,28,13,7,40,5]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m,p,R,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(I,k,B){return new D.ExtUri(L=>s(L,B)).isEqual(I,k)}function i(I,k,B){return r(I.uri,k.uri,B)?0:(0,A.compare)(I.uri.toString(),k.uri.toString())}function g(I,k,B){return I.index!==k.index?I.index<k.index?-1:1:r(I.uri,k.uri,B)?(0,A.compare)(I.name,k.name):(0,A.compare)(I.uri.toString(),k.uri.toString())}function d(I,k,B,L){const y=I.slice(0).sort((N,z)=>B(N,z,L)),x=k.slice(0).sort((N,z)=>B(N,z,L));return(0,c.delta)(y,x,(N,z)=>B(N,z,L))}function s(I,k){const B=k.getCapabilities(I.scheme);return!(B&&B&1024)}class v extends C.Workspace{constructor(k,B,L,y,x,N,z){super(k,L.map(H=>new C.WorkspaceFolder(H)),y,x,z);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(z),L.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(k,B,L,y){if(!k)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:z,configuration:H,transient:q,isUntitled:ue}=k,K=[],ce=B;B?z.forEach((we,Me)=>{const Fe=n.URI.revive(we.uri),Be=v._findFolder(L||B,Fe,y);Be?(Be.name=we.name,Be.index=we.index,K.push(Be)):K.push({uri:Fe,name:we.name,index:Me})}):K.push(...z.map(({uri:we,name:Me,index:Fe})=>({uri:n.URI.revive(we),name:Me,index:Fe}))),K.sort((we,Me)=>we.index<Me.index?-1:1);const de=new v(x,N,K,!!q,H?n.URI.revive(H):null,!!ue,we=>s(we,y)),{added:Q,removed:ie}=d(ce?ce.workspaceFolders:[],de.workspaceFolders,i,y);return{workspace:de,added:Q,removed:ie}}static _findFolder(k,B,L){for(let y=0;y<k.folders.length;y++){const x=k.workspaceFolders[y];if(r(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(k,B){return B&&this._structure.get(k)&&(k=(0,D.dirname)(k)),this._structure.findSubstr(k)}resolveWorkspaceFolder(k){return this._structure.get(k)}}let a=class{constructor(k,B,L,y){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=L,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=k.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=k.getProxy(M.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new v(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>s(N,L)):void 0}$initializeWorkspace(k,B){this._trusted=B,this.$acceptWorkspaceData(k),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:T.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(k,B,L,...y){const x=[];if(Array.isArray(y)&&y.forEach(ue=>{n.URI.isUri(ue.uri)&&!x.some(K=>r(K.uri,ue.uri,this._extHostFileSystemInfo))&&x.push({uri:ue.uri,name:ue.name||(0,D.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[B,L].some(ue=>typeof ue!="number"||ue<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const z=N.slice(0);z.splice(B,L,...x.map(ue=>({uri:ue.uri,name:ue.name||(0,D.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<z.length;ue++){const K=z[ue];if(z.some((ce,de)=>de!==ue&&r(K.uri,ce.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ue,K)=>ue.index=K);const{added:H,removed:q}=d(N,z,g,this._extHostFileSystemInfo);if(H.length===0&&q.length===0)return!1;if(this._proxy){const ue=k.displayName||k.name;this._proxy.$updateWorkspaceFolders(ue,B,L,x).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(h.Severity.Error,(0,f.localize)(0,null,ue,K.toString()),{extension:k},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(k,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,B)}async getWorkspaceFolder2(k,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,B)}async resolveWorkspaceFolder(k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(k)}getPath(){if(!this._actualWorkspace)return;const{folders:k}=this._actualWorkspace;if(k.length!==0)return k[0].uri.fsPath}getRelativePath(k,B){let L,y="";if(typeof k=="string"?(L=n.URI.file(k),y=k):typeof k!="undefined"&&(L=k,y=k.fsPath),!L)return y;const x=this.getWorkspaceFolder(L,!0);if(!x)return y;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,D.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(k){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:k,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(k){const{workspace:B,added:L,removed:y}=v.toExtHostWorkspace(k,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:y}))}findFiles(k,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:H}=E(k);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then(q=>Array.isArray(q)?q.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(k,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:q}=E(B.include),ue=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,K={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:ue},ce=!1;if(this._activeSearchCallbacks[N]=de=>{if(ce)return;const Q=n.URI.revive(de.resource);de.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?L({uri:Q,preview:{text:ie.preview.text,matches:(0,c.mapArrayOrNot)(ie.preview.matches,we=>new R.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,c.mapArrayOrNot)(ie.ranges,we=>new R.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):L({uri:Q,text:ie.text,lineNumber:ie.lineNumber})})},x.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(k,(0,_.withUndefinedAsNull)(q),K,N,x);return delete this._activeSearchCallbacks[N],de||{}}catch(de){throw delete this._activeSearchCallbacks[N],de}}$handleTextSearchResult(k,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](k)}saveAll(k){return this._proxy.$saveAll(k)}resolveProxy(k){return this._proxy.$resolveProxy(k)}get trusted(){return this._trusted}requestWorkspaceTrust(k){return this._proxy.$requestWorkspaceTrust(k)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};a=xe([$e(0,p.IExtHostRpcService),$e(1,m.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,u.ILogService)],a),e.ExtHostWorkspace=a,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function E(I){let k,B;return I&&(typeof I=="string"?k=I:(k=I.pattern,B=I.baseFolder||n.URI.file(I.base))),{includePattern:k,folder:B}}}),define(Ee[32],_e([0,1,27,3,31,5,7,142,83,11,14,4,13,12,2]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(M,r){if(r){const i=r.split(".");let g=M;for(let d=0;g&&d<i.length;d++)g=g[i[d]];return g}}function h(M){return M instanceof o.URI}function C(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function b(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function m(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function p(M){if(h(M))return{resource:M};if(C(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(b(M))return{overrideIdentifier:M.languageId};if(m(M))return{resource:M.uri};if(M===null)return{resource:null}}let R=class{constructor(r,i,g){this._proxy=r.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=g,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(r,i))}};R=xe([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,f.ILogService)],R),e.ExtHostConfiguration=R;class l{constructor(r,i,g,d){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(g),this._configurationScopes=this._toMap(g.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const g={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,g))}getConfiguration(r,i,g){const d=p(i)||{},s=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,g?.identifier);function v(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const a={has(E){return typeof u(s,E)!="undefined"},get:(E,I)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,d,g?.identifier);let k=u(s,E);if(typeof k=="undefined")k=I;else{let B;const L=(y,x)=>{let N;const z=()=>{B=B||(0,c.deepClone)(s),N=N||u(B,x)};return(0,D.isObject)(y)?new Proxy(y,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return z(),()=>N;if(B)return N=N||u(B,x),N[q];const ue=H[q];return typeof q=="string"?L(ue,`${x}.${q}`):ue},set:(H,q,ue)=>(z(),N&&(N[q]=ue),!0),deleteProperty:(H,q)=>(z(),N&&delete N[q],!0),defineProperty:(H,q,ue)=>(z(),N&&Object.defineProperty(N,q,ue),!0)}):y};k=L(k,E)}return k},update:(E,I,k,B)=>{E=r?`${r}.${E}`:E;const L=v(k);return I!==void 0?this._proxy.$updateConfigurationOption(L,E,I,d,B):this._proxy.$removeConfigurationOption(L,E,d,B)},inspect:E=>{E=r?`${r}.${E}`:E;const I=(0,c.deepClone)(this._configuration.inspect(E,d,this._extHostWorkspace.workspace));if(I)return{key:E,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof s=="object"&&(0,c.mixin)(a,s,!1),Object.freeze(a)}_toReadonlyValue(r){const i=g=>(0,D.isObject)(g)?new Proxy(g,{get:(d,s)=>i(d[s]),set:(d,s,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(d,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(d,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return i(r)}_validateConfigurationAccess(r,i,g){const d=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=g?`[${g.value}] `:"";if(d===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const g=new T.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,s)=>g.affectsConfiguration(d,p(s))})}_toMap(r){return r.reduce((i,g)=>(i.set(g[0],g[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[97],_e([0,1,2,14,3,5,7,31,48,32,20,39,13,28,4,10,23,12,69,161,15]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m,p){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(q){if(q){const ue=q;return ue&&!!ue.process}else return!1}x.is=N;function z(q){if(q==null)return;const ue={process:q.process,args:q.args};return q.options&&(ue.options=r.from(q.options)),ue}x.from=z;function H(q){if(q!=null)return new t.ProcessExecution(q.process,q.args,q.options)}x.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var g;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(g=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(x){function N(q){if(q){const ue=q;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}x.is=N;function z(q){if(q==null)return;const ue={};return q.commandLine!==void 0?ue.commandLine=q.commandLine:(ue.command=q.command,ue.args=q.args),q.options&&(ue.options=g.from(q.options)),ue}x.from=z;function H(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new t.ShellExecution(q.commandLine,q.options):new t.ShellExecution(q.command,q.args?q.args:[],q.options)}x.to=H})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(x){function N(q){if(q){let ue=q;return ue&&ue.customExecution==="customExecution"}else return!1}x.is=N;function z(q){return{customExecution:"customExecution"}}x.from=z;function H(q,ue){return ue.get(q)}x.to=H})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(x){function N(z,H){let q;return z.scope!==void 0&&typeof z.scope!="number"?q=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===t.TaskScope.Workspace&&H&&H.workspaceFile?q=H.workspaceFile:q=m.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:q}}x.from=N})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var a;(function(x){function N(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}x.from=N})(a=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(q,ue){if(q==null)return[];const K=[];for(let ce of q){const de=z(ce,ue);de&&K.push(de)}return K}x.fromMany=N;function z(q,ue){if(q==null)return;let K;q.execution instanceof t.ProcessExecution?K=i.from(q.execution):q.execution instanceof t.ShellExecution?K=d.from(q.execution):q.execution&&q.execution instanceof t.CustomExecution&&(K=s.from(q.execution));const ce=l.from(q.definition);let de;return q.scope?typeof q.scope=="number"?de=q.scope:de=q.scope.uri:de=t.TaskScope.Workspace,!ce||!de?void 0:{_id:q._id,definition:ce,name:q.name,source:{extensionId:ue.identifier.value,label:q.source,scope:de},execution:K,isBackground:q.isBackground,group:a.from(q.group),presentationOptions:M.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}x.from=z;async function H(q,ue,K){if(q==null)return;let ce;i.is(q.execution)?ce=i.to(q.execution):d.is(q.execution)?ce=d.to(q.execution):s.is(q.execution)&&(ce=s.to(q._id,K));const de=l.to(q.definition);let Q;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?Q=q.source.scope:Q=await ue.resolveWorkspaceFolder(c.URI.revive(q.source.scope)):Q=t.TaskScope.Workspace),!de||!Q)return;const ie=new t.Task(de,Q,q.name,q.source.label,ce,q.problemMatchers);return q.isBackground!==void 0&&(ie.isBackground=q.isBackground),q.group!==void 0&&(ie.group=t.TaskGroup.from(q.group._id),ie.group&&q.group.isDefault&&(ie.group=new t.TaskGroup(ie.group.id,ie.group.label),q.group.isDefault&&(ie.group.isDefault=q.group.isDefault))),q.presentationOptions&&(ie.presentationOptions=M.to(q.presentationOptions)),q._id&&(ie._id=q._id),q.detail&&(ie.detail=q.detail),ie}x.to=H})(E=e.TaskDTO||(e.TaskDTO={}));var I;(function(x){function N(H){return H}x.from=N;function z(H){if(!!H)return Object.assign(Object.create(null),H)}x.to=z})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(N,z,H){this._id=z,this._task=H,R.set(this,void 0),Ze(this,R,N,"f")}get task(){return this._task}terminate(){Ae(this,R,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}R=new WeakMap;var B;(function(x){function N(z){return{id:z._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,z,H,q,ue,K,ce,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=q,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,z,H){if(!H)return new t.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:z,provider:H,extension:N}),this._proxy.$registerTaskProvider(q,z),new t.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(N,z){this._proxy.$registerTaskSystem(N,z)}fetchTasks(N){return this._proxy.$fetchTasks(I.from(N)).then(async z=>{const H=[];for(let q of z){const ue=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ue&&H.push(ue)}return H})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(z=>N.push(z)),N}terminateTask(N){if(!(N instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,z,H){const q=this._providedCustomExecutions2.get(N.id);q&&(this._activeCustomExecutions2.set(N.id,q),this._terminalService.attachPtyToTerminal(z,await q.callback(H))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const z=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:z,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:N.exitCode})}$provideTasks(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));const q=[],ue=(0,F.asPromise)(()=>H.provider.provideTasks(A.CancellationToken.None)).then(K=>this.provideTasksInternal(z,q,H,K));return new Promise(K=>{ue.then(ce=>{Promise.all(q).then(()=>{K(ce)})})})}async $resolveTask(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));if(z.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${H.type}].`);const q=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ue=await H.provider.resolveTask(q,A.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,H);const K=E.from(ue,H.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,z,H){const q=await this._proxy.$createTaskId(N);!H&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,z.execution)),this._providedCustomExecutions2.set(q,z.execution)}async getTaskExecution(N,z){if(typeof N=="string"){const ue=this._taskExecutionPromises.get(N);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let H=this._taskExecutionPromises.get(N.id);if(H)return H;const q=new Promise((ue,K)=>{function ce(de,Q,ie){ie?ue(new k(de,Q.id,ie)):K("Unexpected: Task does not exist.")}z?ce(this,N,z):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>ce(this,N,de))});return this._taskExecutionPromises.set(N.id,q),q.then(ue=>(this._taskExecutions.set(N.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(N,z){N._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let H=this._notProvidedCustomExecutions.values(),q=H.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=H.next()}};L=xe([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,C.ILogService),$e(7,b.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let y=class extends L{constructor(N,z,H,q,ue,K,ce,de){super(N,z,H,q,ue,K,ce,de);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(N,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const H=E.from(z,N);if(H===void 0)throw new Error("Task is not valid");if(s.is(H.execution))await this.addCustomExecution(H,z,!1);else throw new p.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),z);return this._proxy.$executeTask(H).catch(ue=>{throw new Error(ue)}),q}provideTasksInternal(N,z,H,q){const ue=[];if(q)for(let K of q){this.checkDeprecation(K,H),(!K.definition||!N[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ce=E.from(K,H.extension);ce&&s.is(ce.execution)?(ue.push(ce),z.push(this.addCustomExecution(ce,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:H.extension}}async resolveTaskInternal(N){if(s.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,z,H){}};y=xe([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,T.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,C.ILogService),$e(7,b.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(Ee[213],_e([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,46,90,212,40]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(v,a,E,I){this.configurationService=v,this.workspaceContextService=a,this.editorGroupsService=E,this.pathService=I}text(v,a,E={}){v=this.getContentPattern(v,E);const I=this.configurationService.getValue(),k=a&&a.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(a?.map(h.toWorkspaceFolder),E),type:2,contentPattern:v,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:I.search.usePCRE2||k||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(v,a){const E=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const I={...v,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(v,a)&&(I.isCaseSensitive=!0),this.isMultiline(v)&&(I.isMultiline=!0),I}file(v,a={}){return{...this.commonQuery(v,a),type:1,filePattern:a.filePattern?a.filePattern.trim():a.filePattern,exists:a.exists,sortByScore:a.sortByScore,cacheKey:a.cacheKey}}handleIncludeExclude(v,a){return v?(v=Array.isArray(v)?v.map(i):i(v),a?this.parseSearchPaths(v):{pattern:l(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],a={}){const E=this.handleIncludeExclude(a.includePattern,a.expandPatterns),I=this.handleIncludeExclude(a.excludePattern,a.expandPatterns),k=v.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,a,I)):v.map(x=>this.getFolderQueryForRoot(x,a,I,k))).filter(x=>!!x),L={_reason:a._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:a.extraFileResources,excludePattern:I.pattern,includePattern:E.pattern,onlyOpenEditors:a.onlyOpenEditors,maxResults:a.maxResults};if(a.onlyOpenEditors){const N=c.coalesce(c.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(q=>q.resource)))).filter(H=>(0,m.pathIncludedInQuery)(L,H.fsPath)),z=this.commonQueryFromFileList(N);return{...L,...z}}const y=a.extraFileResources&&a.extraFileResources.filter(x=>(0,m.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=y&&y.length?y:void 0,L}commonQueryFromFileList(v){const a=[],E=new t.ResourceMap,I={};let k=!1;return v.forEach(B=>{if(B.scheme===T.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(B)){const y=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:S.dirname(B.fsPath)});let x=E.get(y);x||(k=!0,x={folder:y,includePattern:{}},a.push(x),E.set(y,x));const N=S.relative(y.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(k=!0,I[B.fsPath]=!0)}),{folderQueries:a,includePattern:I,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(v,a){if(a.isSmartCase){if(v.isRegExp){if(A.containsUppercaseCharacter(v.pattern,!0))return!0}else if(A.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,f.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const a=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),I=(Array.isArray(v)?v:M(v)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,P.untildify)(z,H.scheme===T.Schemas.file?H.fsPath:H.path):z}),k=F.groupBy(I,z=>a(z)?"searchPaths":"exprSegments"),B=(k.exprSegments||[]).map(z=>A.rtrim(z,"/")).map(z=>A.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),L={},y=this.expandSearchPathPatterns(k.searchPaths||[]);y&&y.length&&(L.searchPaths=y);const x=c.flatten(B),N=l(...x);return N&&(L.pattern=N),L}getExcludesForFolder(v,a){return a.disregardExcludeSettings?void 0:(0,m.getExcludes)(v,!a.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const a=c.flatten(v.map(I=>{let{pathPortion:k,globPortion:B}=R(I);B&&(B=g(B));const L=this.expandOneSearchPath(k);return c.flatten(L.map(y=>this.resolveOneSearchPathPattern(y,B)))})),E=new Map;return a.forEach(I=>{const k=I.searchPath.toString(),B=E.get(k);B?I.pattern&&(B.pattern=B.pattern||{},B.pattern[I.pattern]=!0):E.set(k,{searchPath:I.searchPath,pattern:I.pattern?l(I.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(v){if(S.isAbsolute(v)){const a=this.workspaceContextService.getWorkspace().folders;return a[0]&&a[0].uri.scheme!==T.Schemas.file?[{searchPath:a[0].uri.with({path:v})}]:[{searchPath:n.URI.file(S.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const a=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const I=S.posix.resolve(a.path,v);return[{searchPath:a.with({path:I})}]}const E=g(v);return[{searchPath:a,pattern:E}]}else{if(v==="./"||v===".\\")return[];{const a=v.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(k=>{const B=a.match(new RegExp(`^${A.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return B?{match:B,folder:k}:null}).filter(_.isDefined);if(I.length)return I.map(k=>{const B=k.match[1];return{searchPath:k.folder.uri,pattern:B&&g(B)}});{const k=v.match(/\.[\/\\](.+)[\/\\]?/),B=k?k[1]:v,L=o.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(v,a){const E=v.pattern&&a?`${v.pattern}/${a}`:v.pattern||a,I=[{searchPath:v.searchPath,pattern:E}];return E&&!E.endsWith("**")&&I.push({searchPath:v.searchPath,pattern:E+"/**"}),I}getFolderQueryForSearchPath(v,a,E){const I=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(v.searchPath),a,E,!1);return I?{...I,includePattern:v.pattern}:null}getFolderQueryForRoot(v,a,E,I){let k;const B=n.URI.isUri(v)?v:v.uri;if(E.searchPaths){const z=E.searchPaths.filter(H=>(0,D.isEqual)(H.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(k=z.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,a)||{},...k||{}},N=n.URI.isUri(v)?(0,D.basename)(v):v.name;return{folder:B,folderName:I?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof a.disregardIgnoreFiles=="boolean"?a.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof a.disregardGlobalIgnoreFiles=="boolean"?a.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof a.ignoreSymlinks=="boolean"?a.ignoreSymlinks:!L.search.followSymlinks}}};p=xe([$e(0,u.IConfigurationService),$e(1,h.IWorkspaceContextService),$e(2,C.IEditorGroupsService),$e(3,b.IPathService)],p),e.QueryBuilder=p;function R(s){const v=s.match(/[\*\{\}\(\)\[\]\?]/);if(v){const a=v.index,E=s.substr(0,a).match(/[/|\\][^/\\]*$/);if(E){let I=s.substr(0,E.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((v,a)=>(v[a]=!0,v),Object.create(null)):void 0}function M(s){return w.splitGlobAware(s,",").map(v=>v.trim()).filter(v=>!!v.length)}function r(s){return[`**/${s}/**`,`**/${s}`].map(a=>a.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function g(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(s,v){s=c.distinct(s,I=>I.toString());const a=[],E=v.getWorkspace();return s&&s.forEach(I=>{let k;if(v.getWorkbenchState()===2)k=(0,D.relativePath)(E.folders[0].uri,I),k&&k!=="."&&(k="./"+k);else{const B=v.getWorkspaceFolder(I);if(B){const L=B.name;if(E.folders.filter(x=>x.name===L).length===1){const x=(0,D.relativePath)(B.uri,I);x===""?k=`./${B.name}`:k=`./${B.name}/${x}`}else k=I.fsPath}}k&&a.push(k)}),a}e.resolveResourcesForSearchIncludes=d}),define(Ee[214],_e([0,1,24,2,20,15,4,213,40,46]),function(oe,e,c,F,w,P,t,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function _(u,h){const C=h.activationEvents;if(!C)return Promise.resolve(void 0);const b=[],m=[];for(const i of C)if(/^workspaceContains:/.test(i)){const g=i.substr("workspaceContains:".length);g.indexOf("*")>=0||g.indexOf("?")>=0||u.forceUsingSearch?m.push(g):b.push(g)}if(b.length===0&&m.length===0)return Promise.resolve(void 0);let p;const R=new Promise((i,g)=>{p=i}),l=i=>p({activationEvent:i}),M=Promise.all(b.map(i=>n(u,i,l))).then(()=>{}),r=f(u,h.identifier,m,l);return Promise.all([M,r]).then(()=>{p(void 0)}),R}e.checkActivateWorkspaceContainsExtension=_;async function n(u,h,C){for(const b of u.folders)if(await u.exists(c.joinPath(F.URI.revive(b),h))){C(`workspaceContains:${h}`);return}}async function f(u,h,C,b){if(C.length===0)return Promise.resolve(void 0);const m=new w.CancellationTokenSource,p=u.checkExists(u.folders,C,m.token),R=setTimeout(async()=>{m.cancel(),u.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${C.join(",")}`)},A);let l=!1;try{l=await p}catch(M){P.isPromiseCanceledError(M)||P.onUnexpectedError(M)}m.dispose(),clearTimeout(R),l&&b(`workspaceContains:${C.join(",")}`)}function o(u,h,C,b){const m=u.get(t.IInstantiationService),p=u.get(S.ISearchService),l=m.createInstance(T.QueryBuilder).file(h.map(M=>(0,D.toWorkspaceFolder)(F.URI.revive(M))),{_reason:"checkExists",includePattern:C,exists:!0});return p.fileSearch(l,b).then(M=>!!M.limitHit,M=>P.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[33],_e([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,26,172,15,25,22,147,7,84,4,28,72,13,60,64,39,3,214,68,149,10]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m,p,R,l,M,r,i,g,d,s,v,a,E,I,k,B,L){"use strict";var y,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class ji extends T.Disposable{constructor(K,ce,de,Q,ie,we,Me,Fe,Be,Ge){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ce,this._extHostContext=de,this._initData=Me,this._extHostWorkspace=Q,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new C.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=K.createChild(new s.ServiceCollection([o.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Qe=>je.add(m.ExtensionIdentifier.toKey(Qe))),this._activator=this._register(new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,$,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,b.transformErrorForSerialization($),G)},actualActivateExtension:async(Qe,$)=>{if(je.has(m.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,$),new f.HostExtension;const G=this._registry.getExtensionDescription(Qe);return this._activateExtension(G,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){b.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch(ce){}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,ce){return this._activator.activateByEvent(K,ce)}_activateById(K,ce){return this._activator.activateById(K,ce)}activateByIdWithErrors(K,ce){return this._activateById(K,ce).then(()=>{const de=this._activator.getActivatedExtension(K);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==L.Schemas.file)return K;const ce=await this._hostUtils.realpath(K.fsPath);return D.URI.file(ce)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=S.TernarySearchTree.forUris(ce=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ce));for(const ce of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ce)){const de=await this._realPathExtensionUri(ce.extensionLocation);K.set(de,ce)}return K})()),this._extensionPathIndex}_deactivate(K){let ce=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return ce;const de=this._activator.getActivatedExtension(K);if(!de)return ce;try{typeof de.module.deactivate=="function"&&(ce=Promise.resolve(de.module.deactivate()).then(void 0,Q=>(this._logService.error(Q),Promise.resolve(void 0))))}catch(Q){this._logService.error(Q)}try{(0,T.dispose)(de.subscriptions)}catch(Q){this._logService.error(Q)}return ce}async _activateExtension(K,ce){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,ce).then(de=>{const Q=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,ce),this._logExtensionActivationTimes(K,ce,"success",Q),de},de=>{throw this._logExtensionActivationTimes(K,ce,"failure"),de})}_logExtensionActivationTimes(K,ce,de,Q){const ie=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Q||{},outcome:de})}_doActivateExtension(K,ce){const de=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const Q=this._getEntryPoint(K);if(!Q)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${K.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this._logService.flush();const ie=new f.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,P.joinPath)(K.extensionLocation,Q),ie),this._loadExtensionContext(K)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),we))}_loadExtensionContext(K){const ce=new R.ExtensionGlobalMemento(K,this._storage),de=new R.ExtensionMemento(K.identifier.value,!1,this._storage),Q=new B.ExtensionSecrets(K,this._secretState),ie=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,we=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([ce.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Fe;return Object.freeze({globalState:ce,workspaceState:de,secrets:Q,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Be){return F.join(K.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(K).fsPath},get logPath(){return F.join(Me._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return D.URI.joinPath(Me._initData.logsLocation,K.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(K)},get globalStorageUri(){return Me._storagePath.globalValue(K)},get extensionMode(){return ie},get extension(){return Fe===void 0&&(Fe=new q(Me,K.identifier,K,we)),Fe},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(K,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,ce,de,Q,ie){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,ce,de,Q,ie).then(we=>new f.ActivatedExtension(!1,null,ie.build(),de,we,Q.subscriptions))}static _callActivateOptional(K,ce,de,Q,ie){if(typeof de.activate=="function")try{ie.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const we=typeof global=="object"?global:self,Me=de.activate.apply(we,[Q]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Fe=>(ie.activateResolveStop(),Fe))}catch(we){return Promise.reject(we)}else return Promise.resolve(de)}_activateOneStartupFinished(K,ce){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:ce}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const ce of K.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(K,ce)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const ce=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(ce),Q=Promise.all([K,de]).then(()=>{});return Promise.race([Q,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ce=>this._handleWorkspaceContainsEagerExtension(K,ce))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,ce){if(this.isActivated(ce.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={logService:this._logService,folders:K.map(we=>we.uri),forceUsingSearch:de,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Fe)},ie=await(0,I.checkActivateWorkspaceContainsExtension)(Q,ce);if(!!ie)return this._activateById(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:ce}=this._initData.environment;if(!K||!ce)throw new Error(c.localize(0,null));const de=await this._loadCommonJSModule(null,ce,new f.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(c.localize(1,null,ce.toString()));return new Promise((Q,ie)=>{const we=(Be,Ge)=>{Be?ie(Be):Q(typeof Ge=="number"&&Ge>0?1:0)},Me=(0,P.originalFSPath)(ce),Fe=de.run(Me,we);Fe&&Fe.then&&Fe.then(()=>{Q(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,ce){return this._resolvers[K]=ce,(0,T.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const ce=K.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const de=K.substr(0,ce);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(K,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(K);if(!Q)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),w.mark(`code/extHost/willResolveAuthority/${de}`);const ie=await Q.resolve(K,{resolveAttempt:ce});w.mark(`code/extHost/didResolveAuthorityOK/${de}`);const we={authority:K,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${de}`),ie instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(K,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(K);if(!Q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ie=D.URI.revive(ce);if(typeof Q.getCanonicalURI=="undefined")return ie;const we=await(0,t.asPromise)(()=>Q.getCanonicalURI(ie));return we||ie}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,ce){return ce===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(K,!1))}async $activate(K,ce){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,ce),!0):!1}async $deltaExtensions(K,ce){K.forEach(Q=>Q.extensionLocation=D.URI.revive(Q.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(ce.map(async Q=>{const ie=this._registry.getExtensionDescription(Q);ie&&de.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(K.map(async Q=>{const ie=await this._realPathExtensionUri(Q.extensionLocation);de.set(ie,Q)})),this._registry.deltaExtensions(K,ce),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let ce=p.VSBuffer.alloc(K),de=Math.random()%256;for(let Q=0;Q<K;Q++)ce.writeUInt8(de,Q);return ce}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};z=xe([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,u.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,A.ILogService),$e(6,i.IExtHostInitDataService),$e(7,g.IExtensionStoragePaths),$e(8,v.IExtHostTunnelService),$e(9,a.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function H(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(K,ce,de,Q){y.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,y,K,"f"),Ze(this,x,ce,"f"),Ze(this,N,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,P.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Q}get isActive(){return Ae(this,y,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,y,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,y,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,x=new WeakMap,N=new WeakMap}),define(Ee[98],_e([0,1,17,2,3,14,5,7,156,31,33,48,163,32,157,13,4,11,89,70]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,h.createDecorator)("IExtHostDebugService");let p=class{constructor(s,v,a,E,I,k){this._workspaceService=v,this._extensionService=a,this._editorsService=E,this._configurationService=I,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,v){const a=s;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let E=`debug:${encodeURIComponent(a.path||"")}`,I="?";return v&&(E+=`${I}session=${encodeURIComponent(v.id)}`,I="&"),E+=`${I}ref=${a.sourceReference}`,F.URI.parse(E)}else{if(a.path)return F.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const v=[];for(const a of s.getAllExtensionDescriptions())if(a.contributes){const E=a.contributes.debuggers;if(E&&E.length>0)for(const I of E)(0,o.isDebuggerMainContribution)(I)&&v.push(I.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(v=>s.push(v)),s}addBreakpoints(s){this.startBreakpoints();const v=s.filter(I=>{const k=I.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,I),!0)});this.fireBreakpointChanges(v,[],[]);const a=[],E=new Map;for(const I of v)if(I instanceof T.SourceBreakpoint){let k=E.get(I.location.uri.toString());k||(k={type:"sourceMulti",uri:I.location.uri,lines:[]},E.set(I.location.uri.toString(),k),a.push(k)),k.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof T.FunctionBreakpoint&&a.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(s){this.startBreakpoints();const v=s.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],v,[]);const a=v.filter(k=>k instanceof T.SourceBreakpoint).map(k=>k.id),E=v.filter(k=>k instanceof T.FunctionBreakpoint).map(k=>k.id),I=v.filter(k=>k instanceof T.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(a,E,I)}startDebugging(s,v,a){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,v,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,debugUI:a.debugUI,suppressSaveBeforeStart:a.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,v,a){if(!v)return new T.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,a,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,E),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,v,a){if(!a)return new T.Disposable(()=>{});if(!this.definesDebugType(s,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:E,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,E),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,v){if(!v)return new T.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:a,factory:v}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==v)})}async $runInTerminal(s,v){return Promise.resolve(void 0)}async $substituteVariables(s,v){if(!this._variableResolver){const[I,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,k)}let a;const E=await this.getFolder(s);return E&&(a={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(a,v)}createDebugAdapter(s,v){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,v){const a=this,E=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const k=this.convertToDto(I),B=this.createDebugAdapter(k,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const L=B;return this._debugAdapters.set(s,L),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(s,y),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,z={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(N.arguments.value);z.body={signature:H},L.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,L.sendResponse(z)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(x),x=(0,o.convertToVSCPaths)(x,!0),a._debugServiceProxy.$acceptDAMessage(s,x)}),L.onError(x=>{y&&y.onError&&y.onError(x),this._debugServiceProxy.$acceptDAError(s,x.name,x.message,x.stack)}),L.onExit(x=>{y&&y.onExit&&y.onExit((0,C.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,C.withNullAsUndefined)(x),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),L.startSession()))})}$sendDAMessage(s,v){v=(0,o.convertToDAPaths)(v,!1);const a=this._debugAdaptersTrackers.get(s);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(v);const E=this._debugAdapters.get(s);E&&E.sendMessage(v)}$stopDASession(s){const v=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),v&&v.onWillStopSession&&v.onWillStopSession();const a=this._debugAdapters.get(s);return this._debugAdapters.delete(s),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const v=[],a=[],E=[];if(s.added)for(const I of s.added){const k=I.id;if(k&&!this._breakpoints.has(k)){let B;if(I.type==="function")B=new T.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")B=new T.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const L=F.URI.revive(I.uri);B=new T.SourceBreakpoint(new T.Location(L,new T.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}B._id=k,this._breakpoints.set(k,B),v.push(B)}}if(s.removed)for(const I of s.removed){const k=this._breakpoints.get(I);k&&(this._breakpoints.delete(I),a.push(k))}if(s.changed){for(const I of s.changed)if(I.id){const k=this._breakpoints.get(I.id);if(k){if(k instanceof T.FunctionBreakpoint&&I.type==="function"){const B=k;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.functionName=I.functionName}else if(k instanceof T.SourceBreakpoint&&I.type==="source"){const B=k;B.enabled=I.enabled,B.condition=I.condition,B.hitCondition=I.hitCondition,B.logMessage=I.logMessage,B.location=new T.Location(F.URI.revive(I.uri),new T.Position(I.line,I.character))}E.push(k)}}}this.fireBreakpointChanges(v,a,E)}$provideDebugConfigurations(s,v,a){return(0,P.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(v);return E.provideDebugConfigurations(I,a)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,v,a,E){return(0,P.asPromise)(async()=>{const I=this.getConfigProviderByHandle(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(v);return I.resolveDebugConfiguration(k,a,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,v,a,E){return(0,P.asPromise)(async()=>{const I=this.getConfigProviderByHandle(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(v);return I.resolveDebugConfigurationWithSubstitutedVariables(k,a,E)})}async $provideDebugAdapter(s,v){const a=this.getAdapterDescriptorFactoryByHandle(s);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(v);return this.getAdapterDescriptor(a,E).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(s){const v=await this.getSession(s);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(s){const v=await this.getSession(s);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,v){const a=await this.getSession(s);a&&a._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(s,v){const E={session:await this.getSession(s),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof T.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof T.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const v=this._adapterFactories.filter(a=>a.type===s);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(s){const v=this._adapterFactories.filter(a=>a.handle===s);if(v.length>0)return v[0].factory}getConfigProviderByHandle(s){const v=this._configProviders.filter(a=>a.handle===s);if(v.length>0)return v[0].provider}definesDebugType(s,v){if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0){for(const E of a)if(E.label&&E.type&&E.type===v)return!0}}return!1}getDebugAdapterTrackers(s){const a=s.configuration.type,E=this._trackerFactories.filter(I=>I.type===a||I.type==="*").map(I=>(0,P.asPromise)(()=>I.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(E).then(I=>{const k=I.filter(B=>!!B);if(k.length>0)return new r(k)}),new Promise((I,k)=>{const B=setTimeout(()=>{clearTimeout(B),k(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(s,v){const a=v.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new T.DebugAdapterServer(a));if(s){const I=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>s.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,I))).then(k=>{if(k)return k})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,E))}daExecutableFromPackage(s,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,v,a){(s.length>0||v.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:v,changed:a}))}async getSession(s){if(s)if(typeof s=="string"){const v=this._debugSessions.get(s);if(v)return v}else{let v=this._debugSessions.get(s.id);if(!v){const a=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;v=new R(this._debugServiceProxy,s.id,s.type,s.name,a,s.configuration,E),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(s){if(s){const v=F.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};p=xe([$e(0,u.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class R{constructor(s,v,a,E,I,k,B){this._debugServiceProxy=s,this._id=v,this._type=a,this._name=E,this._workspaceFolder=I,this._configuration=k,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,v)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=R;class l{constructor(s){this.value=Object.freeze({append(v){s.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(s,v,a,E,I){function k(){if(v){const B=v.activeEditor();if(B)return B.document.uri;const L=E.tabs.filter(y=>y.isActive);if(L.length>0){const y=L[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=s.filter(y=>y.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(B,L)=>a.getConfiguration(void 0,B).get(L),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=k();if(B)return c.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const B=k();if(B){const L=I.getWorkspaceFolder(B);if(L)return c.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(v){const B=v.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(v){const B=v.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=M;class r{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(v=>v.onError?v.onError(s):void 0)}onExit(s,v){this.trackers.forEach(a=>a.onExit?a.onExit(s,v):void 0)}}class i extends S.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let g=class extends p{constructor(s,v,a,E,I,k){super(s,v,a,E,I,k)}createVariableResolver(s,v,a){return new M(s,v,a,this._editorTabs)}};g=xe([$e(0,u.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,m.IExtHostEditorTabs)],g),e.WorkerExtHostDebugService=g}),define(Ee[215],_e([0,1,73,2,5,32,26,25,13,28,4,33,89,12]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(m,p,R,l,M,r,i){this._apiFactory=m,this._extensionRegistry=p,this._instaService=R,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,p,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(h,p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,p,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let p of m.nodeModuleName)this._factories.set(p,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(p=>m.alternativeModuleName(p))}};o=xe([$e(2,A.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,f.ILogService)],o),e.RequireInterceptor=o;class u{constructor(m,p,R,l,M){this._apiFactory=m,this._extensionPaths=p,this._extensionRegistry=R,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,p){const R=this._extensionPaths.findSubstr(p);if(R){let l=this._extApiImpl.get(T.ExtensionIdentifier.toKey(R.identifier));return l||(l=this._apiFactory(R,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(R.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let h=class{constructor(m,p,R){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=p.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=R,M=p.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,g)=>M.$setPassword(r,i,g),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(m,p){const R=this._extensionPaths.findSubstr(p);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:R?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const p=m.length;if(p<=7||!this.alternativeNames)return;const R=p-7;if((m.charAt(R)==="/"||m.charAt(R)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};h=xe([$e(1,S.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],h);let C=class{constructor(m,p,R){this._extensionPaths=m,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=R.getProxy(w.MainContext.MainThreadTelemetry);const l=R.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=F.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(m,p,R){const l=this._extensionPaths.findSubstr(p);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=R(m),this._impl}callOriginal(m,p){return this.sendNoForwardTelemetry(),this._original(m,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=xe([$e(2,S.IExtHostRpcService)],C)}),define(Ee[216],_e([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(p,R,l,M){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new S.RPCProtocol(p,null,M),R=b._transform(R,this._rpcProtocol);const r=new _.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...R}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(u.IURITransformerService,new u.URITransformerService(M)),r.set(h.IHostUtils,l);const i=new f.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(v=>v.get(C.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(v=>v.get(h.IExtHostExtensionService))),this._logService=i.invokeFunction(v=>v.get(D.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",R),this._extensionService=i.invokeFunction(v=>v.get(h.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(a,E)=>{let I="",k,B;for(const L of E)I+=`
	at ${L.toString()}`,B=L.getFileName(),!k&&B&&(k=v.findSubstr(t.URI.file(B)));return g.set(a,k),`${a.name||"Error"}: ${a.message||""}${I}`}});const d=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(v=>{const a=F.transformErrorForSerialization(v),E=g.get(v);E?d.$onExtensionRuntimeError(E.identifier,a):s.$onUnexpectedError(a)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const R=this._extensionService.deactivateAll();Promise.race([(0,c.timeout)(5e3),R]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,R){p.extensions.forEach(M=>M.extensionLocation=t.URI.revive(R.transformIncomingURIs(M.extensionLocation))),p.environment.appRoot=t.URI.revive(R.transformIncomingURIs(p.environment.appRoot));const l=p.environment.extensionDevelopmentLocationURI;return l&&(p.environment.extensionDevelopmentLocationURI=l.map(M=>t.URI.revive(R.transformIncomingURIs(M)))),p.environment.extensionTestsLocationURI=t.URI.revive(R.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=t.URI.revive(R.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=t.URI.revive(R.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=t.URI.revive(R.transformIncomingURIs(p.logsLocation)),p.logFile=t.URI.revive(R.transformIncomingURIs(p.logFile)),p.workspace=R.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=b}),define(Ee[217],_e([0,1,17,20,43,29,24,190,40]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(n,f,o){this.config=n,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&P.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&P.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((o,u)=>{const h=C=>{this.resultCount++,n(C)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(C=>{const b=C.toString(),m=c.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,m)||this.matchFile(h,{base:C,basename:m})}),Promise.all(f.map(C=>this.searchInFolder(C,h))).then(C=>{o({limitHit:this.isLimitHit,stats:C[0]||void 0})},C=>{u(new Error((0,w.toErrorMessage)(C)))})})}async searchInFolder(n,f){const o=new F.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),h=this.initDirectoryTree(),C=new S.QueryGlobTester(this.config,n),b=!C.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(o),m=T.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,o.token),R=m.elapsed(),l=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(M=>{const r=c.posix.relative(n.folder.path,M.path);if(b){const i=c.basename(M.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(h,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,C,f),{providerTime:R,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,o,u){if(o===this.filePattern){const C=c.basename(this.filePattern);this.matchFile(u,{base:f,relativePath:this.filePattern,basename:C})}function h(C){const b=c.basename(C),m=c.dirname(C);let p=n[m];p||(p=n[m]=[],h(m)),p.push({base:f,relativePath:C,basename:b})}h(o)}matchDirectoryTree({rootEntries:n,pathToEntries:f},o,u){const h=this,C=this.filePattern;function b(m){const p=P.hasSiblingFn(()=>m.map(R=>R.basename));for(let R=0,l=m.length;R<l;R++){const M=m[R],{relativePath:r,basename:i}=M;if(o.matchesExcludesSync(r,i,C!==i?p:void 0))continue;const g=f[r];if(g)b(g);else{if(r===C)continue;h.matchFile(u,M)}if(h.isLimitHit)break}}b(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class A{constructor(){this.sessions=new Map}fileSearch(n,f,o,u){const h=this.getSessionTokenSource(n.cacheKey),C=new D(n,f,h&&h.token);let b=0;const m=p=>{b+=p.length,o(p.map(R=>this.rawMatchToSearchItem(R)))};return this.doSearch(C,A.BATCH_SIZE,m,u).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,o,u){u.onCancellationRequested(()=>{n.cancel()});const h=b=>{b&&(C.push(b),f>0&&C.length>=f&&(o(C),C=[]))};let C=[];return n.search(h).then(b=>(C.length&&o(C),b),b=>(C.length&&o(C),Promise.reject(b)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(Ee[218],_e([0,1,16,20,43,29,10,17,24,11,2,40]),function(oe,e,c,F,w,P,t,T,S,D,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(m,p,R,l){this.query=m,this.provider=p,this.fileUtils=R,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(m,p){const R=this.query.folderQueries||[],l=new F.CancellationTokenSource;return p.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(m);let i=!1;const g=(d,s)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(d);h(d)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const a=this.resultSize(d);this.resultCount+=a,(a>0||!h(d))&&this.collector.add(d,s)}};Promise.all(R.map((d,s)=>this.searchInFolder(d,v=>g(v,s),l.token))).then(d=>{l.dispose(),this.collector.flush();const s=d.some(v=>!!v&&!!v.limitHit);M({limitHit:this.isLimitHit||s,messages:(0,c.flatten)(d.map(v=>v?.message?(0,D.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},d=>{l.dispose();const s=(0,w.toErrorMessage)(d);r(new Error(s))})})}resultSize(m){return h(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}trimResultToSize(m,p){const R=Array.isArray(m.ranges)?m.ranges:[m.ranges],l=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:R.slice(0,p),preview:{matches:l.slice(0,p),text:m.preview.text},uri:m.uri}}async searchInFolder(m,p,R){const l=new _.QueryGlobTester(this.query,m),M=[],r={report:d=>{if(!this.validateProviderResult(d))return;const s=m.folder.scheme===t.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,v=S.relativePath(m.folder,d.uri);if(v){const a=l.includedInQuery(v,T.basename(v),s);(0,D.isPromise)(a)?M.push(a.then(E=>{E&&p(d)})):a&&p(d)}}},i=this.getSearchOptionsForFolder(m),g=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,R);return M.length&&await Promise.all(M),g}validateProviderResult(m){if(h(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(m){const p=(0,_.resolvePatternsForProvider)(this.query.includePattern,m.includePattern),R=(0,_.resolvePatternsForProvider)(this.query.excludePattern,m.excludePattern),l={folder:A.URI.from(m.folder),excludes:R,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.fileUtils.toCanonicalName(m.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class o{constructor(m){this._onResult=m,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,p=>this.sendItems(p))}add(m,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!S.isEqual(this._currentUri,m.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:m.uri,results:[]}),this._currentFileMatch.results.push(u(m))}pushToCollector(){const m=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,m)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(m){this._onResult(m)}}e.TextSearchResultsCollector=o;function u(b){return h(b)?{preview:{matches:(0,c.mapArrayOrNot)(b.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:b.preview.text},ranges:(0,c.mapArrayOrNot)(b.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function h(b){return!!b.preview}e.extensionResultIsMatch=h;class C{constructor(m,p){this.maxBatchSize=m,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(m,p){!m||this.addItemToBatch(m,p)}addItems(m,p){!m||this.addItemsToBatch(m,p)}addItemToBatch(m,p){this.batch.push(m),this.batchSize+=p,this.onUpdate()}addItemsToBatch(m,p){this.batch=this.batch.concat(m),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(Ee[99],_e([0,1,6,5,4,217,13,65,12,2,218]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(u,h,C){this.extHostRpc=u,this._uriTransformer=h,this._logService=C,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,h){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const C=this._handlePool++;return this._textSearchProvider.set(C,h),this._proxy.$registerTextSearchProvider(C,this._transformScheme(u)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}registerFileSearchProvider(u,h){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const C=this._handlePool++;return this._fileSearchProvider.set(C,h),this._proxy.$registerFileSearchProvider(C,this._transformScheme(u)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(u,h,C,b){const m=n(C),p=this._fileSearchProvider.get(u);if(p)return this._fileSearchManager.fileSearch(m,p,R=>{this._proxy.$handleFileMatch(u,h,R.map(l=>l.resource))},b);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,h,C,b){const m=this._textSearchProvider.get(u);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const p=n(C);return this.createTextSearchManager(p,m).search(l=>this._proxy.$handleTextMatch(u,h,l),b)}$enableExtensionHostSearch(){}createTextSearchManager(u,h){return new A.TextSearchManager(u,h,{readdir:C=>Promise.resolve([]),toCanonicalName:C=>C},"textSearchProvider")}};_=xe([$e(0,t.IExtHostRpcService),$e(1,T.IURITransformerService),$e(2,S.ILogService)],_),e.ExtHostSearch=_;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(u=>D.URI.revive(u))}}e.reviveQuery=n;function f(o){return{...o,folder:D.URI.revive(o.folder)}}}),define(Ee[219],_e([0,1,20,15,3,34,2,113,232,107,55,45,5,180,179,38,181,32,182,183,184,165,185,48,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,50,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,49,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,26]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m,p,R,l,M,r,i,g,d,s,v,a,E,I,k,B,L,y,x,N,z,H,q,ue,K,ce,de,Q,ie,we,Me,Fe,Be,Ge,je,Qe,$,G,X,se,j,Z,fe,Te,Ne,He,Ke,tt,st,Xe,rt,De,gt,V,J,pe,Ue,Ye,Je,lt,Et,It,et,Tt,Pe,Se,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function re(ae){const he=ae.get(G.IExtHostInitDataService),me=ae.get(De.IExtHostFileSystemInfo),Ie=ae.get(Ke.IExtHostConsumerFileSystem),ze=ae.get(r.IExtHostExtensionService),Oe=ae.get(ce.IExtHostWorkspace),We=ae.get(Ue.IExtHostTelemetry),it=ae.get(C.IExtHostConfiguration),ot=ae.get(Qe.IURITransformerService),ne=ae.get($.IExtHostRpcService),ge=ae.get(L.IExtHostStorage),te=ae.get(He.IExtensionStoragePaths),W=ae.get(je.ILoggerService),be=ae.get(je.ILogService),ke=ae.get(j.IExtHostTunnelService),qe=ae.get(Z.IExtHostApiDeprecationService),Le=ae.get(K.IExtHostWindow),dt=ae.get(J.IExtHostSecretState),bt=ae.get(pe.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,me),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,ge),ne.set(n.ExtHostContext.ExtHostTunnelService,ke),ne.set(n.ExtHostContext.ExtHostWindow,Le),ne.set(n.ExtHostContext.ExtHostSecretState,dt),ne.set(n.ExtHostContext.ExtHostTelemetry,We),ne.set(n.ExtHostContext.ExtHostEditorTabs,bt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,ae.get(Me.IExtHostDecorations)),pt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ae.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,ae.get(u.IExtHostCommands)),vt=ne.set(n.ExtHostContext.ExtHostTerminalService,ae.get(y.IExtHostTerminalService)),_t=ne.set(n.ExtHostContext.ExtHostDebugService,ae.get(Be.IExtHostDebugService)),Ft=ne.set(n.ExtHostContext.ExtHostSearch,ae.get(Ge.IExtHostSearch)),yt=ne.set(n.ExtHostContext.ExtHostTask,ae.get(Fe.IExtHostTask)),At=ne.set(n.ExtHostContext.ExtHostOutputService,ae.get(a.IExtHostOutputService)),Ut=ne.set(n.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(ne)),Pt=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,pt)),Bt=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ne,pt,be)),zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new R.ExtHostDocumentSaveParticipant(be,Pt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ne,ht,pt,Pt,te)),Qt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(be,wt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new et.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(ne,he,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new lt.ExtHostNotebookRenderers(ne,wt)),Rt=ne.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(ne,pt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Rt,he)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(ne,be,me)),Wt=ne.set(n.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(ne,Pt,ht.converter,ot)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ne,ot,Pt,ht,Xt,be,qe)),ci=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),Ot=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(ne,be,pt)),jt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(ne,ht,be)),li=ne.set(n.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(ne,ht,Pt)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new fe.ExtHostAuthentication(ne)),_i=ne.set(n.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(ne,ht)),qt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:he.remote},Oe,be,qe)),Gt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(ne,qt,Oe)),yi=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Pt,te,qt,Gt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(ne,qt)),Kt=ne.set(n.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(ne,ht)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new V.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(ne,wt,pt,ht));const ei=(0,de.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new rt.ExtHostBulkEdits(ne,pt),ki=new o.ExtHostClipboard(ne),ui=new v.ExtHostMessageService(ne,be),ti=new m.ExtHostDialogs(ne),gi=new B.ExtHostStatusBar(ne,ht.converter);return f.ExtHostApiCommands.register(ht),function(Re,Lt,pi){const ft=function(){let Y=!Re.isUnderDevelopment;function le(){Y||(be.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Ce(ct){if(Array.isArray(ct))ct.forEach(Ce);else if(typeof ct=="string")le();else{const St=ct;typeof St.scheme=="undefined"&&le(),typeof St.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Re,"documentFiltersExclusive")}return ct}}(),ii={getSession(Y,le,Ce){return Zt.getSession(Re,Y,le,Ce)},async hasSession(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"authSession"),!!await Zt.getSession(Re,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Ce,ct){return Zt.registerAuthenticationProvider(Y,le,Ce,ct)}},Ii={registerCommand(Y,le,Ce){return ht.registerCommand(!0,Y,le,Ce,void 0,Re)},registerTextEditorCommand(Y,le,Ce){return ht.registerCommand(!0,Y,(...ct)=>{const St=Rt.getActiveTextEditor();if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}return St.edit(Dt=>{le.apply(Ce,[St,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+Y+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Re)},registerDiffInformationCommand:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"diffCommand"),ht.registerCommand(!0,Y,async(...ct)=>{const St=pt.activeEditor(!0);if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Rt.getDiffInformation(St.id);le.apply(Ce,[Dt,...ct])},void 0,void 0,Re)),executeCommand(Y,...le){return ht.executeCommand(Y,...le)},getCommands(Y=!1){return ht.getCommands(Y)}},vi={get machineId(){return he.telemetryInfo.machineId},get sessionId(){return he.telemetryInfo.sessionId},get language(){return he.environment.appLanguage},get appName(){return he.environment.appName},get appRoot(){return he.environment.appRoot?.fsPath??""},get appHost(){return he.environment.appHost},get uriScheme(){return he.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return We.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return We.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(he.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Le.openUri(Y,{allowTunneling:!!he.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===he.environment.appUriScheme)return Ut.createAppUri(Y);try{return await Le.asExternalUri(Y,{allowTunneling:!!he.remote.authority})}catch(le){if((0,It.matchesScheme)(Y,Et.Schemas.http)||(0,It.matchesScheme)(Y,Et.Schemas.https))return Y;throw le}},get remoteName(){return(0,we.getRemoteName)(he.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),he.remote.authority},get uiKind(){return he.uiKind}};he.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=he.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Pi={createTestController(Y,le){return Kt.createTestController(Y,le)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.results}},Ti={getExtension(Y){const le=Lt.getExtensionDescription(Y);if(le)return new r.Extension(ze,Re.identifier,le,bi)},get all(){return Lt.getAllExtensionDescriptions().map(Y=>new r.Extension(ze,Re.identifier,Y,bi))},get onDidChange(){return Lt.onDidChange}},Ai={createDiagnosticCollection(Y){return Xt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:Y=>Xt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,le){return Wt.changeLanguage(Y.uri,le)},match(Y,le){return(0,A.score)(z.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Ce){return mt.registerCodeActionProvider(Re,ft(Y),le,Ce)},registerCodeLensProvider(Y,le){return mt.registerCodeLensProvider(Re,ft(Y),le)},registerDefinitionProvider(Y,le){return mt.registerDefinitionProvider(Re,ft(Y),le)},registerDeclarationProvider(Y,le){return mt.registerDeclarationProvider(Re,ft(Y),le)},registerImplementationProvider(Y,le){return mt.registerImplementationProvider(Re,ft(Y),le)},registerTypeDefinitionProvider(Y,le){return mt.registerTypeDefinitionProvider(Re,ft(Y),le)},registerHoverProvider(Y,le){return mt.registerHoverProvider(Re,ft(Y),le,Re.identifier)},registerEvaluatableExpressionProvider(Y,le){return mt.registerEvaluatableExpressionProvider(Re,ft(Y),le,Re.identifier)},registerInlineValuesProvider(Y,le){return mt.registerInlineValuesProvider(Re,ft(Y),le,Re.identifier)},registerDocumentHighlightProvider(Y,le){return mt.registerDocumentHighlightProvider(Re,ft(Y),le)},registerLinkedEditingRangeProvider(Y,le){return mt.registerLinkedEditingRangeProvider(Re,ft(Y),le)},registerReferenceProvider(Y,le){return mt.registerReferenceProvider(Re,ft(Y),le)},registerRenameProvider(Y,le){return mt.registerRenameProvider(Re,ft(Y),le)},registerDocumentSymbolProvider(Y,le,Ce){return mt.registerDocumentSymbolProvider(Re,ft(Y),le,Ce)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,le){return mt.registerDocumentFormattingEditProvider(Re,ft(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return mt.registerDocumentRangeFormattingEditProvider(Re,ft(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Ce,...ct){return mt.registerOnTypeFormattingEditProvider(Re,ft(Y),le,[Ce].concat(ct))},registerDocumentSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentSemanticTokensProvider(Re,ft(Y),le,Ce)},registerDocumentRangeSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentRangeSemanticTokensProvider(Re,ft(Y),le,Ce)},registerSignatureHelpProvider(Y,le,Ce,...ct){return typeof Ce=="object"?mt.registerSignatureHelpProvider(Re,ft(Y),le,Ce):mt.registerSignatureHelpProvider(Re,ft(Y),le,typeof Ce=="undefined"?[]:[Ce,...ct])},registerCompletionItemProvider(Y,le,...Ce){return mt.registerCompletionItemProvider(Re,ft(Y),le,Ce)},registerInlineCompletionItemProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),mt.registerInlineCompletionsProvider(Re,ft(Y),le)},registerDocumentLinkProvider(Y,le){return mt.registerDocumentLinkProvider(Re,ft(Y),le)},registerColorProvider(Y,le){return mt.registerColorProvider(Re,ft(Y),le)},registerFoldingRangeProvider(Y,le){return mt.registerFoldingRangeProvider(Re,ft(Y),le)},registerSelectionRangeProvider(Y,le){return mt.registerSelectionRangeProvider(Re,Y,le)},registerCallHierarchyProvider(Y,le){return mt.registerCallHierarchyProvider(Re,Y,le)},registerTypeHierarchyProvider(Y,le){return mt.registerTypeHierarchyProvider(Re,Y,le)},setLanguageConfiguration:(Y,le)=>mt.setLanguageConfiguration(Re,Y,le),getTokenInformationAtPosition(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"tokenInformation"),Wt.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlayHints"),mt.registerInlayHintsProvider(Re,Y,le)},createLanguageStatusItem(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"languageStatus"),Wt.createLanguageStatusItem(Re,Y,le)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(Y,le,Ce){const ct=await(t.URI.isUri(Y)?Promise.resolve(ni.openTextDocument(Y)):Promise.resolve(Y));return Rt.showTextDocument(ct,le,Ce)},createTextEditorDecorationType(Y){return Rt.createTextEditorDecorationType(Re,Y)},onDidChangeActiveTextEditor(Y,le,Ce){return Rt.onDidChangeActiveTextEditor(Y,le,Ce)},onDidChangeVisibleTextEditors(Y,le,Ce){return Rt.onDidChangeVisibleTextEditors(Y,le,Ce)},onDidChangeTextEditorSelection(Y,le,Ce){return Rt.onDidChangeTextEditorSelection(Y,le,Ce)},onDidChangeTextEditorOptions(Y,le,Ce){return Rt.onDidChangeTextEditorOptions(Y,le,Ce)},onDidChangeTextEditorVisibleRanges(Y,le,Ce){return Rt.onDidChangeTextEditorVisibleRanges(Y,le,Ce)},onDidChangeTextEditorViewColumn(Y,le,Ce){return Rt.onDidChangeTextEditorViewColumn(Y,le,Ce)},onDidCloseTerminal(Y,le,Ce){return vt.onDidCloseTerminal(Y,le,Ce)},onDidOpenTerminal(Y,le,Ce){return vt.onDidOpenTerminal(Y,le,Ce)},onDidChangeActiveTerminal(Y,le,Ce){return vt.onDidChangeActiveTerminal(Y,le,Ce)},onDidChangeTerminalDimensions(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDimensions"),vt.onDidChangeTerminalDimensions(Y,le,Ce)},onDidChangeTerminalState(Y,le,Ce){return vt.onDidChangeTerminalState(Y,le,Ce)},onDidWriteTerminalData(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(Y,le,Ce)},get state(){return Le.state},onDidChangeWindowState(Y,le,Ce){return Le.onDidChangeWindowState(Y,le,Ce)},showInformationMessage(Y,...le){return ui.showMessage(Re,P.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return ui.showMessage(Re,P.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return ui.showMessage(Re,P.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Ce){return Array.isArray(Y)&&Y.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Re,"quickPickSeparators"),jt.showQuickPick(Y,le,Ce)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return jt.showInput(Y,le)},showOpenDialog(Y){return ti.showOpenDialog(Y)},showSaveDialog(Y){return ti.showSaveDialog(Y)},createStatusBarItem(Y,le,Ce){let ct,St,Dt;return typeof Y=="string"?(ct=Y,St=le,Dt=Ce):(St=Y,Dt=le),gi.createStatusBarEntry(Re,ct,St,Dt)},setStatusBarMessage(Y,le){return gi.setStatusBarMessage(Y,le)},withScmProgress(Y){return qe.report("window.withScmProgress",Re,"Use 'withProgress' instead."),fi.withProgress(Re,{location:H.ProgressLocation.SourceControl},(le,Ce)=>Y({report(ct){}}))},withProgress(Y,le){return fi.withProgress(Re,Y,le)},createOutputChannel(Y){return At.createOutputChannel(Y,Re)},createWebviewPanel(Y,le,Ce,ct){return Gt.createWebviewPanel(Re,Y,le,Ce,ct)},createWebviewTextEditorInset(Y,le,Ce,ct){return(0,ve.checkProposedApiEnabled)(Re,"editorInsets"),ai.createWebviewEditorInset(Y,le,Ce,ct,Re)},createTerminal(Y,le,Ce){return typeof Y=="object"?("location"in Y&&(0,ve.checkProposedApiEnabled)(Re,"terminalLocation"),"pty"in Y?vt.createExtensionTerminal(Y):vt.createTerminalFromOptions(Y)):vt.createTerminal(Y,le,Ce)},registerTerminalLinkProvider(Y){return vt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return vt.registerProfileProvider(Re,Y,le)},registerTreeDataProvider(Y,le){return Yt.registerTreeDataProvider(Y,le,Re)},createTreeView(Y,le){return Yt.createTreeView(Y,le,Re)},registerWebviewPanelSerializer:(Y,le)=>Gt.registerWebviewPanelSerializer(Re,Y,le),registerCustomEditorProvider:(Y,le,Ce={})=>yi.registerCustomEditorProvider(Re,Y,le,Ce),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return Ut.registerUriHandler(Re.identifier,Y)},createQuickPick(){return jt.createQuickPick(Re)},createInputBox(){return jt.createInputBox(Re.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Ce){return mi.onDidChangeActiveColorTheme(Y,le,Ce)},registerWebviewViewProvider(Y,le,Ce){return Si.registerWebviewViewProvider(Re,Y,le,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,le,Ce)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,le,Ce)},onDidChangeNotebookEditorVisibleRanges(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,le,Ce)},showNotebookDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"externalUriOpener"),Ci.registerExternalUriOpener(Re.identifier,Y,le,Ce)},get tabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),d.InlineCompletionController.get(Y)}},ni={get rootPath(){return qe.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(Y){throw F.readonly()},getWorkspaceFolder(Y){return Oe.getWorkspaceFolder(Y)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(Y){throw F.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(Y){throw F.readonly()},updateWorkspaceFolders:(Y,le,...Ce)=>Oe.updateWorkspaceFolders(Re,Y,le||0,...Ce),onDidChangeWorkspaceFolders:function(Y,le,Ce){return Oe.onDidChangeWorkspace(Y,le,Ce)},asRelativePath:(Y,le)=>Oe.getRelativePath(Y,le),findFiles:(Y,le,Ce,ct)=>Oe.findFiles(z.GlobPattern.from(Y),z.GlobPattern.from(le),Ce,Re.identifier,ct),findTextInFiles:(Y,le,Ce,ct)=>{(0,ve.checkProposedApiEnabled)(Re,"findTextInFiles");let St,Dt;return typeof le=="object"?(St=le,Dt=Ce):(St={},Dt=le,ct=Ce),Oe.findTextInFiles(Y,St||{},Dt,Re.identifier,ct)},saveAll:Y=>Oe.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Ce,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(Y),le,Ce,ct),get textDocuments(){return Pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw F.readonly()},openTextDocument(Y){let le;const Ce=Y;if(typeof Y=="string")le=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))le=Promise.resolve(Y);else if(!Ce||typeof Ce=="object")le=Pt.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ct=>Pt.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(Y,le,Ce)=>Pt.onDidAddDocument(Y,le,Ce),onDidCloseTextDocument:(Y,le,Ce)=>Pt.onDidRemoveDocument(Y,le,Ce),onDidChangeTextDocument:(Y,le,Ce)=>Pt.onDidChangeDocument(Y,le,Ce),onDidSaveTextDocument:(Y,le,Ce)=>Pt.onDidSaveDocument(Y,le,Ce),onWillSaveTextDocument:(Y,le,Ce)=>zt.getOnWillSaveTextDocumentEvent(Re)(Y,le,Ce),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Ce;if(t.URI.isUri(Y))Ce=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Ce=t.URI.revive(await wt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Ce,ct){return wt.registerNotebookSerializer(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,le,Ce,ct)=>((0,ve.checkProposedApiEnabled)(Re,"notebookContentProvider"),wt.registerNotebookContentProvider(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,le,Ce)=>pi.onDidChangeConfiguration(Y,le,Ce),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,pi.getConfiguration(Y,le,Re)},registerTextDocumentContentProvider(Y,le){return Bt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(qe.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Re,Y,le)),registerFileSystemProvider(Y,le,Ce){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Re,Y,le,Ce),Ie.addFileSystemProvider(Y,le))},get fs(){return Ie.value},registerFileSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"fileSearchProvider"),Ft.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"textSearchProvider"),Ft.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ze.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Ce)=>Ot.onDidCreateFile(Y,le,Ce),onDidDeleteFiles:(Y,le,Ce)=>Ot.onDidDeleteFile(Y,le,Ce),onDidRenameFiles:(Y,le,Ce)=>Ot.onDidRenameFile(Y,le,Ce),onWillCreateFiles:(Y,le,Ce)=>Ot.getOnWillCreateFileEvent(Re)(Y,le,Ce),onWillDeleteFiles:(Y,le,Ce)=>Ot.getOnWillDeleteFileEvent(Re)(Y,le,Ce),onWillRenameFiles:(Y,le,Ce)=>Ot.getOnWillRenameFileEvent(Re)(Y,le,Ce),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.openTunnel(Re,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.onDidChangeTunnels(Y,le,Ce)),registerPortAttributesProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"portsAttributes"),ke.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"timeline"),_i.registerTimelineProvider(Y,le,Re.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Re,"workspaceTrust"),Oe.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Ce)=>Oe.onDidGrantWorkspaceTrust(Y,le,Ce)},Fi={get inputBox(){return qe.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(Y,le,Ce){return Jt.createSourceControl(Re,Y,le,Ce)}},Mi={createCommentController(Y,le){return li.createCommentController(Re,Y,le)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,le,Ce){return _t.onDidStartDebugSession(Y,le,Ce)},onDidTerminateDebugSession(Y,le,Ce){return _t.onDidTerminateDebugSession(Y,le,Ce)},onDidChangeActiveDebugSession(Y,le,Ce){return _t.onDidChangeActiveDebugSession(Y,le,Ce)},onDidReceiveDebugSessionCustomEvent(Y,le,Ce){return _t.onDidReceiveDebugSessionCustomEvent(Y,le,Ce)},onDidChangeBreakpoints(Y,le,Ce){return _t.onDidChangeBreakpoints(Y,le,Ce)},registerDebugConfigurationProvider(Y,le,Ce){return _t.registerDebugConfigurationProvider(Y,le,Ce||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return _t.registerDebugAdapterDescriptorFactory(Re,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return _t.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?_t.startDebugging(Y,le,{parentSession:Ce}):_t.startDebugging(Y,le,Ce||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return _t.asDebugSourceUri(Y,le)}},Li={registerTaskProvider:(Y,le)=>yt.registerTaskProvider(Re,Y,le),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Re,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,le,Ce)=>yt.onDidStartTask(Y,le,Ce),onDidEndTask:(Y,le,Ce)=>yt.onDidEndTask(Y,le,Ce),onDidStartTaskProcess:(Y,le,Ce)=>yt.onDidStartTaskProcess(Y,le,Ce),onDidEndTaskProcess:(Y,le,Ce)=>yt.onDidEndTaskProcess(Y,le,Ce)},Ni={createNotebookController(Y,le,Ce,ct,St){return oi.createNotebookController(Re,Y,le,Ce,ct,(0,ve.isProposedApiEnabled)(Re,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>wt.registerNotebookCellStatusBarItemProvider(Re,Y,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Re,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,le,Ce)},onDidChangeNotebookCells(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeNotebookCells(Y,le,Ce)},onDidChangeNotebookCellExecutionState(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,le,Ce)},onDidChangeCellOutputs(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellOutputs(Y,le,Ce)},onDidChangeCellMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellMetadata(Y,le,Ce)},createConcatTextDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Pt,Y,le)}};return{version:he.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:D.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Je.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=re}),define(Ee[220],_e([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,192,12,175]),function(oe,e,c,F,w,P,t,T,S,D,A,_,n,f,o,u,h,C,b,m,p,R,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,c.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,c.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,c.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,c.registerSingleton)(C.IExtHostConsumerFileSystem,C.ExtHostConsumerFileSystem),(0,c.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,c.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,c.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,c.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,c.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,c.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,c.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,c.registerSingleton)(R.IExtHostEditorTabs,R.ExtHostEditorTabs)}),define(Ee[221],_e([0,1,219,33,215,7,14,5,10]),function(oe,e,c,F,w,P,t,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var D;(function(o){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(C,...b)=>{b.forEach(l=>{if(!self.trustedTypes?.isScript(l))throw new Error("TrustedScripts only, please")});const m=b.slice(0,-1).join(","),p=b.pop().toString();return`(function anonymous(${m}) {${p}
})`}});function h(...C){return u?self.eval(u.createScript("",...C)):new Function(...C)}o.create=h})(D||(D={}));class A extends w.RequireInterceptor{_installInterceptor(){}getModule(u,h){for(let C of this._alternatives){let b=C(u);if(b){u=b;break}}if(this._factories.has(u))return this._factories.get(u).load(u,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);f(u,this._initData.environment.isExtensionDevelopmentDebug);const h=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,h,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,h,C){h=h.with({path:n(h.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const b=await fetch(S.FileAccess.asBrowserUri(h).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),b.status!==200)throw new Error(b.statusText);const m=await b.text(),p=`${h.toString(!0)}#vscode-extension`,R=`${m}
//# sourceURL=${p}`;let l;try{l=D.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(R)??R)}catch(g){throw console.error(u?`Loading code for extension ${u.value} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${h.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}const M={},r={exports:M},i=g=>{const d=this._fakeModules.getModule(g,h);if(d===void 0)throw new Error(`Cannot load module '${g}'`);return d};try{return C.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),l(r,M,i),r.exports!==M?r.exports:M}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),C.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+u;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,u){return o.endsWith(u)?o:o+u}function f(o,u){h("info","log"),h("log","log"),h("warn","warn"),h("error","error");function h(m,p){const R=console[m];console[m]=function(){o.$logExtensionHostMessage({type:"__$console",severity:p,arguments:b(arguments)}),u&&R.apply(console,arguments)}}const C=1e5;function b(m){const p=[],R=[];if(m.length)for(let l=0;l<m.length;l++){if(typeof m[l]=="undefined")m[l]="undefined";else if(m[l]instanceof Error){const M=m[l];M.stack?m[l]=M.stack:m[l]=M.toString()}R.push(m[l])}try{const l=JSON.stringify(R,function(M,r){if(r&&typeof r=="object"){if(p.indexOf(r)!==-1)return"[Circular]";p.push(r)}return r});return l.length>C?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}}),define(Ee[222],_e([0,1,56,33,72,221]),function(oe,e,c,F,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(F.IExtHostExtensionService,P.ExtHostExtensionService),(0,c.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],_e([0,1,22,3,173,216,210,17,73,10,2,220,222]),function(oe,e,c,F,w,P,t,T,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(m,p){return m instanceof Request||/^file:/i.test(String(m))&&(m=D.FileAccess.asBrowserUri(A.URI.parse(String(m))).toString(!0)),f(m,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,p,R,l,M){return/^file:/i.test(p.toString())&&(p=D.FileAccess.asBrowserUri(A.URI.parse(p.toString())).toString(!0)),super.open(m,p,R??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const m=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:R=>R}),p=self.Worker;Worker=function(R,l){/^file:/i.test(R.toString())&&(R=D.FileAccess.asBrowserUri(A.URI.parse(R.toString())).toString(!0));const r=`(${function(s){function v(k){return typeof k=="string"||k instanceof URL?String(k).replace(/^file:\/\//i,"vscode-file://vscode-app"):k}const a=fetch.bind(self);self.fetch=function(k,B){return k instanceof Request?a(k,B):a(v(k),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,B,L,y,x){return super.open(k,v(B),L??!0,y,x)}};const E=importScripts.bind(self);self.importScripts=(...k)=>{E(...k.map(v))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:k=>k}):void 0;E(I?I.createScriptURL(s):s)}.toString()}('${R}'))`;l=l||{},l.name=l.name||T.basename(R.toString());const i=new Blob([r],{type:"application/javascript"}),g=URL.createObjectURL(i);return new p(m?m.createScriptURL(g):g,l)}}else self.Worker=class extends t.NestedWorker{constructor(m,p){super(n,m,{name:T.basename(m.toString()),...p})}};const o=new class{constructor(){this.pid=void 0}exit(m){_()}async exists(m){return!0}async realpath(m){return m}};class u{constructor(){const p=new MessageChannel,R=new F.Emitter;let l=!1;n(p.port2,[p.port2]),p.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,C("received terminate message from renderer");return}R.fire(i)},this.protocol={onMessage:R.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);p.port1.postMessage(r,[r])}}}}}function h(m){return new Promise(p=>{const R=m.onMessage(l=>{R.dispose();const M=JSON.parse(l.toString());m.send((0,w.createMessageOfType)(0)),p({protocol:m,initData:M})});m.send((0,w.createMessageOfType)(1))})}let C=m=>_();function b(){const m=new u;S.mark("code/extHost/willConnectToRenderer"),h(m.protocol).then(p=>{S.mark("code/extHost/didWaitForInitData");const R=new P.ExtensionHostMain(p.protocol,p.initData,o,null);C=l=>R.terminate(l)})}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c56f0cae849839138fbd83fe4d5c7219c7ff806/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
